// 设置密码
//@版本: 2.0 
define(function(require, exports, module) {
	var appUtils = require("appUtils"),
	dateUtils = require("dateUtils"), 
	layerUtils = require("layerUtils"), 
	validatorUtil = require("validatorUtil"),
	nativePluginService = require("nativePluginService"), 
	service = require("investService"), 
	common = require("common"),
	endecryptUtils = require("endecryptUtils"),
	external = require("external"),
	_pageId = "#account_setPassword ";
	var gconfig = require("gconfig");
	var	platform = gconfig.platform;
	var curInputId = null;

	function init() {
		window.customKeyboardEvent = {
			keyBoardInputFunction : inputEvent
		};
	}

	// 绑定事件
	function bindPageEvent() {

		/* 点击页面隐藏键盘 */
		appUtils.bindEvent($(_pageId), function(e) {
			hideKeyboard();
		});
		/* 点击密码框统一调用密码键盘 */
		appUtils.bindEvent($(_pageId + " input[keyboard-plugin='true']"), function(e) {
			if(platform != "0"){
				callKeyboard($(this)); // 调用键盘
		    	e.stopPropagation();
			}
		});
		
		appUtils.bindEvent($(_pageId + " .icon_back"), function() {
			appUtils.pageBack();
		});
		appUtils.bindEvent($(_pageId + " .ce_btn"), function() {
			//友盟统计
			var yCount = $(this).attr("yCount");
			yCount?common.onEvent('click',yCount):"";
			var pws_one = $(_pageId + " #pwsOne").val();
			var pws_two = $(_pageId + " #pwsTwo").val();
			if (validatorUtil.isEmpty(pws_one)) {
				layerUtils.iAlert("交易密码不能为空！");
				return;
			}
			if (validatorUtil.isEmpty(pws_two)) {
				layerUtils.iAlert("重复密码不能为空！");
				return;
			}
			if (!validatorUtil.isNumeric(pws_one)) {
				layerUtils.iAlert("请输入6-8位数字密码！");
				return;
			}
			// 判断顺序递增或者递减
			var orderArray = [012345,123456,234567,345678,456789,987654,876543,765432,654321,543210];
			if(orderArray.indexOf(pws_one) != -1)
			{
				layerUtils.iAlert("密码不能是顺序递增或者递减！",-1);
				// 将密码清除
				obj.val("");
				return;
			}
			//判断弱密码库
			var weakpwdArr=['111111','222222','333333','444444','555555','666666','777777','888888','999999','101010','202020','303030',
						'404040','505050','606060','707070','808080','909090','101010','121212','131313','141414','151515','161616',
						'171717','181818','191919','202020','212121','232323','242424','252525','262626','272727','282828','292929',
						'303030','313131','323232','343434','353535','363636','373737','383838','393939','404040','414141','424242',
						'434343','454545','464646','474747','484848','494949','505050','515151','525252','535353','545454','565656',
						'575757','585858','595959','606060','616161','626262','636363','646464','656565','676767','686868','696969',
						'707070','717171','727272','737373','747474','757575','767676','787878','797979','808080','818181','828282',
						'838383','848484','858585','868686','878787','898989','909090','919191','929292','939393','949494','959595',
						'969696','979797','989898','123412','234523','345634','456745','567856','678967','123012','123123','234234',
						'345345','456456','567567','678678','789789','112233','111222','123412','123443','234567','123456','876543',
						'111122','222233','333344','444455','555566','666677','777788','888899','999900','111111','111122','111133',
						'111144','111155','111166','111177','111188','111199','111100'];
			if(weakpwdArr.indexOf(pws_one) != -1)
			{
				layerUtils.iAlert("请勿输入简单组合的密码！",-1);
				// 将密码清除
				obj.val("");
				return;
			}
			
			if (pws_one == pws_two) {
				if (pws_one.length < 6) {
					layerUtils.iAlert("密码不足六位数！");
				} else {
					rsaEncrypt(pws_one);
				}

			} else {
				layerUtils.iAlert("两次密码输入不一致！");
			}

		});
	}

	/**
	 * 加密
	 */
	function rsaEncrypt(pwd) {

		service.getRSAKey({}, function(data) {

			if (data.error_no == "0") {
				modulus = data.results[0].modulus;
				publicExponent = data.results[0].publicExponent;
				zc_pwd = endecryptUtils
						.rsaEncrypt(modulus, publicExponent, pwd);
				mima(zc_pwd);
			} else {
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	function mima(mima_one) {

		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"trade_pwd" : mima_one
		};
		service.savePassword(param, function(data) {
			if (data.error_no == "0") {

				appUtils.pageInit("account/setPassword", "account/agreement",
						{});

			} else {
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	/**
	 * 原生键盘的输入事件
	 * 
	 * @param curKeyCode
	 *            当前输入值
	 */
	function inputEvent(curKeyCode) {
		var $curInput = $(_pageId + "#" + curInputId);
		var pwd = $curInput.val();
		if(pwd.length<=8){
			
		}else{
			pwd = pwd.substring(0,8);
			$curInput.val(pwd);
		}
	}

	/**
	 * 调用原生键盘
	 * 
	 * @param $input
	 *            显示在页面的输入框
	 */
	function callKeyboard($input) {
		curInputId = $input.attr("id");
		var invokeParam = {
			moduleName : "open", // String 目标模块名 N
			funcNo : "50210", // String 功能号 Y
			pageId : "account_setPassword", // String 页面Id Y
			eleId : curInputId, // String 元素Id Y
			doneLable : "done", // String 完成按钮显示字符
			keyboardType : "3" // 1：英文键盘，2：股票键盘，3：数字键盘，4：随机数字键盘，9：系统键盘
		};
		nativePluginService.function50210(invokeParam);
	}

	/**
	 * 隐藏原生键盘
	 */
	function hideKeyboard() {
		var invokeParam = {
			funcNo : "50211", // String 功能号 Y
			moduleName : "common"
		};
		nativePluginService.function50211(invokeParam);
	}
	function destroy() {

	}

	var setPassword = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	// 暴露对外的接口
	module.exports = setPassword;
});