/**
 * 投顾模块公用 js
 */
define(function(require, exports, module) {
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig"); 
    var global = gconfig.global;
    var validata = require("validatorUtil");
    var external = require("external");
	
	/**
	 * 每个页面校验
	 */
	function checkPermission(checkInParam)
	{
		return true;
	}
	
	/**
	 * 首次进入模块的时候，调用
	 */
	function firstLoadFunc()
	{
		var unityURL = external.callMessage({"moduleName":"mall","serverName":"MALL_SERVER_URL","funcNo": "50112"});
		var mallTradeURL = external.callMessage({"moduleName":"mall","serverName":"MALL_TRADE_SERVER_URL","funcNo": "50112"});
		if(unityURL && (unityURL.error_no == 0)){
			var result = unityURL.results[0].url;
			global.serverPath = result+"/servlet/json";//获取壳子里面的地址
			global.url = result;
			global.mobile = result+"/servlet/SmsAction";
		}
		if(mallTradeURL && (mallTradeURL.error_no == 0)){
			var result = mallTradeURL.results[0].url;
			global.beachPath = result+"/servlet/json";
		}
	}
	
	 /**
     * 保存用户信息
     */
    function saveSessionUserInfo(userInfo)
    {
//    	appUtils.setSStorageInfo("userInfo", JSON.stringify(userInfo));  // 重新设置 session 中的 userInfo
    	saveDataToSession(userInfo);
    }
    
    /*将数据保存到 session 中*/
	function saveDataToSession(loginResults)
	{
		var fund_account = loginResults[0].fund_account; 
		var mobile = loginResults[0].mobile_phone; 
		var client_id = loginResults[0].client_id;
		var login_pwd = loginResults[0].login_pwd;
		var user_name = loginResults[0].user_name;
		var identity_num = loginResults[0].identity_num;
		var isOpenMallContor = loginResults[0].isOpenMallContor;
		appUtils.setSStorageInfo("fund_account", fund_account);
		appUtils.setSStorageInfo("mobile", mobile);
		appUtils.setSStorageInfo("client_id", client_id);  
		appUtils.setSStorageInfo("login_pwd", login_pwd);  
		appUtils.setSStorageInfo("user_name", user_name);  
		appUtils.setSStorageInfo("identity_num", identity_num);
		appUtils.setSStorageInfo("isOpenMallContor", isOpenMallContor);
		
	}
	
	 /**
     * 删除用户信息
     */
    function clearSessionUserInfo()
    {
        appUtils.clearSStorage();
    }
       
    /**
     *处理模拟登陆失败
     */
	function ssoLoginFailed(data)
    {
       //这里可以加一些逻辑处理，根据返回的错误号，目前，我这里默认处理是：弹出提示信息，跳到登陆页面
       //弹出提示信息，跳到登陆页面
       layerUtils.iAlert(data.error_info);
       require.async("sso",function(module){
            if(module.checkLoginRight())
            {
                module.goTologin();
            }
        });
    }
	
	/**
	 * 友盟统计
	 */
	function onEvent(tag,label,duration){
		external.callMessage({"funcNo": "70007","label":label});
	}
	
    var base = {
    	"firstLoadFunc" : firstLoadFunc,
    	"checkPermission":checkPermission,
    	"saveSessionUserInfo": saveSessionUserInfo,
        "clearSessionUserInfo": clearSessionUserInfo,
    	"ssoLoginFailed": ssoLoginFailed,
    	"onEvent":onEvent
    };

    module.exports = base;
});