/**
 * 手机前端service层调用接口
 **/
define(function(require,exports,module){
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service = require("service");
	var serviceSingleton = new service.Service();
	
	/********************************公共代码部分********************************/
    function commonInvoke(paraMap, callback, ctrlParam, reqParamVo){
		reqParamVo.setReqParam(paraMap);
		ctrlParam = ctrlParam?ctrlParam:{};
		reqParamVo.setIsLastReq(ctrlParam.isLastReq);
		reqParamVo.setIsAsync(ctrlParam.isAsync);
		reqParamVo.setIsShowWait(ctrlParam.isShowWait);
		reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
		reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
		reqParamVo.setTipsWords(ctrlParam.tipsWords);
		reqParamVo.setDataType(ctrlParam.dataType);
		reqParamVo.setIsGlobal(ctrlParam.isGlobal);
		reqParamVo.setProtocol(ctrlParam.protocol);
		serviceSingleton.invoke(reqParamVo, callback);
	}
	function destroy(){
		serviceSingleton.destroy();
	}
	var mobileService = {
		"getInstance": getInstance, //为了避免以前调用getInstance方法报错
		"destroy": destroy
	};
	function getInstance(){
		return mobileService;
	}
	module.exports = mobileService;
	
	/********************************应用接口开始********************************/
	/**
	 * 功能 发送验证码
	 * @param type	短信发送类型 （0更换手机验证码，1委托成功 2注册的手机验证码 3 忘记手机验证嘛）
	 * @param mobile 验证的手机号码
	 */
	mobileService.verificationCode = function(param,callback,ctrlParam)
    {
	    var paraMap = {};
		paraMap["function"] = "SmsSend";
		paraMap["mobile"] = param.mobile;
		paraMap["type"] = param.type;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.mobile);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    }
	
	/**
	 * 功能 验证手机是否存在
	 * @param input_value 手机号
	 * @param input_type  2表示检测手机号是否存在
	 */
	mobileService.mobilePhone = function(param,callback,ctrlParam)
    {
	    var paraMap = {};
		paraMap["funcNo"] = "1000009";
		paraMap["mobile_phone"] = param.mobile_phone;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    }
	
	/**
	 * 功能 手机验证码正确与否
	 */
	mobileService.checkVerificationCode = function(param,callback,ctrlParam)
    {
	    var paraMap = {};
		paraMap["function"] = "SmsVerify";
		paraMap["mobile_vf_code"] = param.mobile_vf_code;
		paraMap["mobile"] = param.mobile;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.mobile);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    }
	
	
	/**
	 * 功能 银行卡查询
	 */
	mobileService.bankInquiry = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000188";
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能 风险测评题目
	 */
	mobileService.riskTopics = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000150";
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能 风险测评题目提交
	 */
	mobileService.riskTopicsSubmit = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000020";
		paraMap["user_id"] = param.user_id;
		paraMap["paper_answer"] =param.paper_answer;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能 账号注册
	 */
	mobileService.registeredAccountnumber = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000011";
		paraMap["input_value"] = param.input_value;
		paraMap["channel_code"] = param.channel_code;
		paraMap["login_pwd"] = param.login_pwd;
		paraMap["input_type"] = param.input_type;
		
		addOpStation(paraMap);//添加站点参数
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能 营业部信息查询
	 */
	mobileService.salesDepartmentInquiry = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "401503";
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.beachPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能  加密(1000000)
	 */
	mobileService.getRSAKey = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000000";
		var reqParamVo = new service.ReqParamVo();
		
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能 保存支付密码
	 */
	mobileService.savePassword = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000018";
		paraMap["user_id"] = param.user_id;
		paraMap["trade_pwd"] = param.trade_pwd;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 功能 用户登陆
	 */
	mobileService.loginyanzhen = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000010";
		paraMap["login_value"] = param.login_value;
		paraMap["login_pwd"] = param.login_pwd;
		paraMap["login_type"] = param.login_type;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能 存储用户信息
	 */
	mobileService.storageUser = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000019";
		paraMap["user_id"] = param.user_id;
		paraMap["user_name"] = param.user_name;
		paraMap["id_kind"] = param.id_kind;
		paraMap["id_no"] = param.id_no;

		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	

	/**
	 * 功能 存储银行卡
	 */
	mobileService.bankxingxi = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000012";
		paraMap["user_id"] = param.user_id;
		paraMap["cardName"] = param.cardName;
		paraMap["bank_account"] = param.bank_account;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	

	/**
	 * 功能 查询系统时间
	 */
	mobileService.systemTime = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000021";

		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }


	/**
	 * 功能 是否认证过
	 */
	mobileService.renzheng = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000192";
		paraMap["user_name"] = param.user_name;
		paraMap["id_no"] = param.id_no;
		paraMap["type"] = param.type;
		paraMap["mobile_phone"] = param.mobile_phone;

		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	
	/**
	 * 功能 调用协议
	 */
	mobileService.yonghuxieyi = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000202";
		paraMap["agreement_type"] = param.agreement_type;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 功能 绑定银行卡
	 */
	mobileService.bundBankCard = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000203";
		paraMap["client_id"] = param.client_id;
		paraMap["bank_account"] = param.bank_account;
		paraMap["identity_num"] = param.identity_num;
		paraMap["login_pwd"] = param.login_pwd;
		paraMap["identity_type"] = param.identity_type;
		paraMap["cardName"] = param.cardName;

		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 功能 查询已绑定的银行卡
	 */
	mobileService.queryBankCard = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000016";
		paraMap["fund_account"] = param.fundAccount;
		paraMap["login_pwd"] = param.login_pwd;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 功能 解除已绑定的银行卡
	 */
	mobileService.unbindBankCard = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000196";
		paraMap["client_id"] = param.client_id;
		paraMap["bank_no"] = param.bank_no;
		paraMap["bank_account"] = param.bank_account;
		paraMap["trade_pwd"] = param.trade_pwd;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 功能 保存营业部信息
	 */
	mobileService.addBranch = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000022";
		paraMap["user_id"] = param.user_id;
		paraMap["province_name"] = param.province_name;
		paraMap["province_no"] = param.province_no;
		paraMap["city_name"] = param.city_name;
		paraMap["city_no"] = param.city_no;
		paraMap["branch_name"] = param.branch_name;
		paraMap["branch_code"] = param.branch_code;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 发送手机验证码
	 */
	mobileService.sendMassage= function(param,callback,ctrlParam){ 
		var paraMap = {};
		paraMap["function"] = "SmsSend";
		paraMap["mobile"] = param.mobile;
		paraMap["type"] = param.type;
		paraMap["client_id"] = param.client_id;//开户成功发客户号给手机
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.mobile);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 验证手机验证码
	 */
	mobileService.checkMassage= function(param,callback,ctrlParam){ 
		var paraMap = {};
		paraMap["function"] = "SmsVerify";
		paraMap["mobile_vf_code"] = param.mobile_vf_code;
		paraMap["mobile"] = param.mobile;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.mobile);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 签署协议
	 */
	mobileService.Sign = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000155";
		paraMap["user_id"] = param.user_id;
		paraMap["agreement_id"] = param.agreement_id;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 检验老客户是否激活
	 */
	mobileService.isActivtion = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000204";
		paraMap["client_id"] = param.client_id;
		paraMap["trade_pwd"] = param.trade_pwd;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 老客户签约激活
	 */
	mobileService.activtion = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1000205";
		paraMap["client_id"] = param.client_id;
		paraMap["trade_pwd"] = param.trade_pwd;
		paraMap["fund_account"] = param.fund_account;
		paraMap["mobile_phone"] = param.mobile_phone;
		
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 检验客户客户已绑定银行卡是否已达上限
	 */
	mobileService.checkBankNum = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1001502";
		paraMap["account_no"] = param.account_no;
	
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	
	/**
	 * 检验是否展示删除银行卡按钮
	 */
	mobileService.checkRemoveBank = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "1001503";
	
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		
    }
	/**
	 * 添加OpStation
	 * */
	function addOpStation(param){
		var channelNo = " "; // 通道编号
		var ipAddr = " "; // ip 
		var macAddr = " "; // mac
		var hardId = " "; // 硬盘序列号（硬件id）
		var cpuId = " "; // cpu 序列号
		var mobileNo = " "; // 手机号
		var hardIdentifier = " "; //硬件特征码
		var source = " "; // 来源
		var other = " "; // 其他
 
		if(iBrowser.android){
			channelNo = "1";
		}else if(iBrowser.iPad || iBrowser.iPhone || iBrowser.ios){
			channelNo = "2";
		}else if(iBrowser.pc){
			channelNo = "0";
		}
		if(gconfig.platform != "0"){
			var external = require("external");
			var mobileNoInfo = external.callMessage({"funcNo":"50043","key":"mobilePhone"}); // 电话号码
			if(mobileNoInfo.error_no == "0"){
				mobileNo = mobileNoInfo.results[0].value;
			}
			var hardIdInfo = external.callMessage({"funcNo": "50022"}); //设备唯一码
			if(hardIdInfo.error_no ==  "0"){
				hardIdentifier = hardIdInfo.results[0].deviceToken;
			}
			var ipAddrInfo = external.callMessage({"funcNo": "50023"}); //设备IP地址
			if(ipAddrInfo.error_no ==  "0"){
				ipAddr = ipAddrInfo.results[0].ip;	
			}
			var macAddrInfo = external.callMessage({"funcNo": "50024"}); //设备MAC地址 
			if(macAddrInfo.error_no ==  "0"){
				macAddr = macAddrInfo.results[0].mac;
			}
			var versionInfo = external.callMessage({"funcNo": "50010"}); //应用版本号
			if(versionInfo.error_no ==  "0"){
				other = versionInfo.results[0].version;
			}
		}
		source = global.opStationInfo; //来源
		var aOpStation = [];
		aOpStation.push(channelNo);
		aOpStation.push("|");
		aOpStation.push(ipAddr);
		aOpStation.push("|");
		aOpStation.push(macAddr);
		aOpStation.push("|");
		aOpStation.push(hardId);
		aOpStation.push("|");
		aOpStation.push(cpuId);
		aOpStation.push("|");
		aOpStation.push(mobileNo);
		aOpStation.push("|");
		aOpStation.push(hardIdentifier);
		aOpStation.push("|");
		aOpStation.push(source);
		aOpStation.push("|");
		aOpStation.push(other);
		console.log(aOpStation.join(""));
		param.op_station = aOpStation.join(""); // 通道编号|IP地址|MAC地址|硬盘序列号|CPU序列号|手机号码|硬件特征码|来源|其他
	}
    /********************************应用接口结束********************************/
});