/**
 * 这里写模块内部的消息处理函数，供原生回调H5
 */
define(function(require, exports, module){
	
    var  dateUtils = require("dateUtils");
	var validatorUtil = require("validatorUtil");
	var service = require("investService");
	var	gconfig = require("gconfig");
    var	 platform = require("gconfig").platform;
	var	global = gconfig.global;
	var appUtils = require("appUtils");
	var endecryptUtils = require("endecryptUtils");
	var	layerUtils = require("layerUtils");
	var oMyMsgFunction = {}; // 暴露给外部的对象
	var external = require("external");
	var msgFunction = require("msgFunction"); // 加载 plugins 目录里面公用的 msgFunction
	
	/*将本文件里面的函数和 plugins 目录里面公用的 msgFunction 中的函数进行合并操作*/
	msgFunction.conbine(oMyMsgFunction);
	/*将本文件里面的函数和 plugins 目录里面公用的 msgFunction 中的函数进行合并操作，请务必将这句代码放在模块最前面*/
	
	/**
	 * 公用		
	 * 弹出通讯录，用于选择联系人的信息，选择完毕后回调H5
	 * 说明：通讯录插件的调用必须要写在页面UI的事件处理函数中，否则多模块开发原生无法获取到当前激活的模块从而导致无法回调H5
	 * @param funcNo 50223
	 * @param name String 名称 Y
	 * @param phone String 手机号码 Y
	 */
	oMyMsgFunction.function50223 = function(paramMap) 
	{
		var selPhoneCallback = window.selPhoneCallback; // 选择电话联系人的回调函数
		if(selPhoneCallback)
		{
			selPhoneCallback(paramMap);
		}
	}
	
	/**
	 * 公用		
	 * 日期控件回调H5
	 * 说明：日期控件的调用必须要写在页面UI的事件处理函数中，否则多模块开发原生无法获取到当前激活的模块从而导致无法回调H5
	 * @param funcNo 50251
	 * @param date String 日期 Y
	 * @param selector String H5的元素选择器 N
	 */
	oMyMsgFunction.function50251 = function(paramMap) 
	{
		paramMap = paramMap || {};
		var selDateCallback = window.selDateCallback; // 选择日期的回调函数
		if(selDateCallback)
		{
			selDateCallback(paramMap);
		}
	}
	
	/**
	 * 公用		
	 * 设置系统软件的主题风格
	 * @param funcNo 50104
	 * @param theme String 主题颜色(见数据字典) Y 0：红色，1：蓝色，2：黑色，3：黄色，9：绿色
	 */
	oMyMsgFunction.function50104 = function(paramMap) 
	{
		if(paramMap)
		{
			var $appCss = $("head>link[href*='" + gconfig.firstLoadCss[0] + "']");
			var skinMap = {0: "red", 1: "blue", 2: "black", 3: "yellow", 9: "green"};
			var href = gconfig.cssPath + "style_" + skinMap[paramMap.theme] + ".css";
			gconfig.firstLoadCss[0] = href; // 修改当前皮肤对应的 css
			$appCss.attr("href", href);
			var originalOverflow = $("body").css("overflow");
			$("body").css("overflow", "auto"); // 强制浏览器重绘
			$("body").css("overflow", originalOverflow);
		}
	}

	/**
	 * 公用		
	 * 原生的信息提示框回调H5
	 * @param funcNo 50111
	 * @param flag	String	业务标志	N
	 */
	oMyMsgFunction.function50111 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert(paramMap.flag);
		}
	}

	/**
	 * 公用		
	 * 通知H5分享后的状态
	 * @param funcNo 50232
	 * @param shareType	String	分享平台（数据字典）	Y
	 * @param flag	String	分享状态（0：失败，1：成功)	Y
	 * @param info	String	备注信息	N
	 */
	oMyMsgFunction.function50232 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert("通知H5分享后的状态50232" + JSON.stringify(paramMap));
		}
	}
	
	/**
	 * 公用		
	 * 验证手势密码中忘记密码，修改账号回调H5
	 * @param funcNo 50262
	 * @param type	String	类型(0：忘记密码，1：修改账号）	N
	 */
	oMyMsgFunction.function50262 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert("验证手势密码中忘记密码，修改账号回调H550262" + JSON.stringify(paramMap));
		}
	}
	
	/**
	 * 		
	 * 接收银行认证返回
	 * @param function60301
	 * @param 
	 */
	oMyMsgFunction.function60301 = function(paramMap) 
	{
	   	if(paramMap){
			if(paramMap.respCode=="0000"){
//				layerUtils.iAlert(paramMap.cardNo);
				
				var param={
						"user_id":appUtils.getSStorageInfo("user_id"),
				        "user_name":paramMap.cerName,
				        "id_kind":"0",
				        "id_no":paramMap.cerNo
					};
				    appUtils.setSStorageInfo("idCard",paramMap.cerNo);
				    var isFirst = appUtils.getSStorageInfo("isFirst");
				    if(isFirst == "0"){//是否第一次绑卡
						appUtils.setSStorageInfo("isFirst","");
						var login_pwd = appUtils.getSStorageInfo("login_pwd");
						service.getRSAKey({},function(data){//如果是为开通理财功能，就在我们系统里面注册一个，以便后面签约
							if (data.error_no == "0"){
						            var modulus =  data.results[0].modulus;
								    var publicExponent = data.results[0].publicExponent;
									var zc_pwd = endecryptUtils.rsaEncrypt(modulus, publicExponent, login_pwd);
									var param={
											"client_id":appUtils.getSStorageInfo("client_id"),
											"cardName":paramMap.cardName,
											"bank_account":paramMap.cardNo,
											"identity_num":appUtils.getSStorageInfo("identity_num"),
											"login_pwd":zc_pwd,
											"identity_type":appUtils.getSStorageInfo("identity_type")
									};
									service.bundBankCard(param,function(data){
										if(data.error_no==0){
											appUtils.pageInit(null, "bankCardOperation/bankAddok",{});
											}else{
												layerUtils.iAlert(data.error_info,"",function(){
													appUtils.pageInit(null, "bankCardOperation/PersonalData",{});
												});
											}
									},{"isAsync":false});
							}else{
								layerUtils.iAlert(data.error_info);
							}
						});
					}else{
						service.storageUser(param,function(data){
							if(data.error_no==0){
								var openBranch = data.results[0].openBranch;
								var para={
//										"bank_no":appUtils.getSStorageInfo("xuandin_yh_no"),
								        "user_id":appUtils.getSStorageInfo("user_id"),
								        "bank_account":paramMap.cardNo,
								        "cardName":paramMap.cardName
									};
									service.bankxingxi(para,function(data){     
										if(data.error_no==0){
											if(openBranch=="1"){//判断是否需要选择营业部
												appUtils.pageInit("userCenter/PersonalData", "account/riskTesting",{});
											}else{
												appUtils.pageInit("userCenter/PersonalData", "account/businessDepartment",{});
											}
											}else{
												layerUtils.iAlert(data.error_info,"",function(){
													appUtils.pageInit(null, "userCenter/PersonalData",{});
												});
											}
									},{"isAsync":false});
								
								}else{
									layerUtils.iAlert(data.error_info,"",function(){
										appUtils.pageInit(null, "userCenter/PersonalData",{});
									});
								}
						},{"isAsync":false});
					}
					
				
			}else{
				appUtils.pageBack();
			}
		}else{
			layerUtils.iAlert("认证失败");
		}                    
			
		
	}


	/**
	 * 公用		
	 * 扫描图片二维码的内容回调给H5页面	
	 * @param funcNo 50272
	 * @param content	String	内容	Y
	 */
	oMyMsgFunction.function50272 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert("扫描图片二维码的内容回调给H5页面	50272" + JSON.stringify(paramMap));
		}
	}
	
	/**
	    *模块切换初始化
	    */
	    oMyMsgFunction.function50113 = function(param)
	    {
	    	require.async("sso",function(module){
	           var toPage = param.toPage;
	           if(toPage && toPage == "default"){
                   toPage = gconfig.defaultPage.pageCode;
                   }
	           var result =  external.callMessage({"key":"isMyfinal","funcNo": "50041"});
	           var isMyfinal = result.results[0].value;
	           if(toPage!="" && toPage!=undefined && toPage!=null){
		           if(toPage.indexOf(".html") != -1)
		           {
		        	   toPage = toPage.substring(0,toPage.indexOf(".html"));
		           }
		           if(isMyfinal=="1"){
		        	   appUtils.clearSStorage("_isLoginIn");
		           }
	           		appUtils.pageInit(null, toPage,param);
	           }else{
	        	   module.reloadPageInit();
	           }
	       });
	    }

	    /**
	     *统一退出回调
	     */
	    oMyMsgFunction.function60401 = function(param)
	    {
	       if(param.error_no == 0)
	       {
	          require.async("sso",function(module){
	             module.goTologin();
	          });
	       }
	       else
	       {
	          layerUtils.iAlert(param.error_info);
	       }
	    }
	
	    /**
	        *  系统退出
	        */
	       oMyMsgFunction.function60403 = function(param)
	       {
	           appUtils.clearSStorage("_isLogin");
	           appUtils.clearSStorage(gconfig.projName + "_login_token");
	           require.async("common",function(module){
	                module.clearSessionUserInfo();
	           });
	           //调用退出登录接口，请求服务器，失效session
	           
	       }
	       
	       /**
	        * 安卓物理返回
	        * 模块内返回
	        */
	       oMyMsgFunction.function50107 = function(param){
	    	   
	    	   //模块当前的 _curPageCode
	    	   var _curPageCode = appUtils.getSStorageInfo("_curPageCode");
	    	   //获取当前 模块的 页面 ，自动触发 h5的返回 按键，如果没有就不执行操作
	    	   if(_curPageCode){
	    		   _curPageCode = _curPageCode.replaceAll("/","_") + "";
	    		   $("#" + _curPageCode + " .icon_back").trigger("mousedown");
	    		   console.info("自动触发H5页面的返回键事件成功");
	    	   }else{
	    		   console.warn("当前模块的_curPageCode：" + _curPageCode + "H5返回键失败");
	    	   }
	    	   
	       }
	    
	module.exports = oMyMsgFunction;
});