/**
 * 开|转|理财户结果
 */
define(function(require,exports,module){
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		  gconfig = require("gconfig"),
		  layerUtils = require("layerUtils"),
		  validatorUtil = require("validatorUtil"),
		  global = gconfig.global,
		  platform = require("gconfig").platform,
		  service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		  _pageId = "#account_lucky";
	var external = require("external");
	var md5 = require("md5");
	var imei="";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{	
		initPage();
	}

	//页面初始化处理
	function initPage(){
		var window_height = $(window).height();
		var main_height = window_height;
		$(_pageId).height(main_height);
		if($(_pageId+" #luckContentDiv").hasClass("pattern")){
			$(_pageId).removeClass("pattern");
		}
		if(!$(_pageId +" #luckContentDiv").hasClass("red")){
			$(_pageId).addClass("red");
		}
		$(_pageId+" #checkMobile01").show();  //抽奖前输入手机号div
		$(_pageId+" #checkMobile02").show();  //抽奖前输入手机号div
		$(_pageId+" #lottery").hide();  //转盘 div
		$(_pageId+" .ly_shadow").hide(); //中奖提示div
		$(_pageId+" .ly_shadow .je span").html("0");  //中奖金额初始化为0元
		$(_pageId+" .phoneNum").val("");
		tokenId();
		getContent();
	}

	function getContent(){
		var param={
			"sys_variable_name":"ActivityInfo"
		};
		service.getisNeedCert(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				var result=data.results[0];
				var content=result.cur_value.split("@");
				$(_pageId+" .tips li:eq(0)").html(content[0]);
				$(_pageId+" .tips li:eq(1)").html(content[1]);
			}
			else
			{
				layerUtils.iAlert(error_info,-1);
			}
		},true);
	}

	//获取设备唯一码 功能号 50022
	function tokenId(){
		var param = {
			"funcNo": "50022"
		};
		var result = external.callMessage(param);
		if(result.error_no=="0"){
			imei=result.results[0].deviceToken;
		}
	}

	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			if(global.isZhongheApp=="0"){
				appUtils.pageInit("account/lucky","account/accountResult",{});  // 直接跳到结果页 单独开户
			}else{ //综合app
			    var param = {"funcNo": "50101","moduleName":"home"};
                external.callMessage(param);
			}
		});
		
		/*抽奖权限检测*/
		appUtils.bindEvent($(_pageId+" .btn a"),function(){
			var phoneNum=$(_pageId+" .phoneNum").val();
			if(validatorUtil.isMobile(phoneNum))
			{
				
				lotteryPermissions(phoneNum);   //抽奖事件
			}
			else
			{
				if(validatorUtil.isNotEmpty(phoneNum)){
					// 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
					var times = phoneNum.length - 11;
					if(phoneNum.length > 11)
					{
						layerUtils.iMsg(-1,"您多输入&nbsp;"+times+"&nbsp;位电话号码，请重新输入！");
					}
					else if(phoneNum.length < 11)
					{
						layerUtils.iMsg(-1,"您少输入&nbsp;"+Math.abs(times)+"&nbsp;位电话号码，请重新输入！");
					}else{
						layerUtils.iMsg(-1,"请输入正确的手机号！");
					}
				}else{
					layerUtils.iAlert("请输入手机号！",-1);
				}
				return false;
			}
		});
		
		/*抽奖*/
		appUtils.bindEvent($(_pageId+" .zp_btn a"),function(){
			luckActivity();
		});
		
		appUtils.bindEvent($(_pageId+" .ly_shadow .btn"),function(){
            if(global.isZhongheApp=="0"){
				appUtils.pageInit("account/lucky","account/accountResult",{});  // 直接跳到结果页 单独开户
			}else{//综合app
			     var param = {"funcNo": "50101","moduleName":"home"};
            	 external.callMessage(param);
			}
		});
		
	}
	
	function destroy()
	{
		if($(_pageId+" #luckContentDiv").hasClass("pattern")){
			$(_pageId+" #luckContentDiv").removeClass("pattern");
		}
		if(!$(_pageId).hasClass("red")){
			$(_pageId).addClass("red");
		}
		appUtils.clearSStorage();  // 清空所有的session
	}
	
	//抽奖权限检测，通过后才能进行抽奖
	function lotteryPermissions(phone_num){
	    var platforms="ANDROID";
    	    if(platform=="2"){
    	       platforms="IOS";
    	    };
		var param={
			"mobileno":phone_num,
			"hardsn":imei,
			"type":"0",
			"platform":platforms,
            "ck":hex_md5($(_pageId+" .phoneNum").val().trim()+"deb37d8fbd1f4a0d9fe4cce177fd2321")
		};
		service.luckyActivity(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				$(_pageId +" #luckContentDiv").removeClass("red");
				$(_pageId +" #luckContentDiv").addClass("pattern");
				$(_pageId+" #checkMobile01").hide();
				$(_pageId+" #checkMobile02").hide();
				$(_pageId+" #lottery").show();
			}
			else
			{
				layerUtils.iAlert(error_info,-1,function(){
				 if(global.isZhongheApp=="0"){
						appUtils.pageInit("account/lucky","account/accountResult",{});  // 直接跳到结果页 单独开户
					}else{//综合app
						 var param = {"funcNo": "50101","moduleName":"home"};
						 external.callMessage(param);
					}
				});
			}
		},true);
	}
	
	/*抽奖*/
	function luckActivity()
	{
	    var platforms="ANDROID";
	    if(platform=="2"){
	       platforms="IOS";
	    };
		var param={
			"mobileno":$(_pageId+" .phoneNum").val(),
			"hardsn":imei,
			"type":"1",
			"platform":platforms,
			"ck":hex_md5($(_pageId+" .phoneNum").val().trim()+"deb37d8fbd1f4a0d9fe4cce177fd2321")
		};
		$(_pageId+" .ly_shadow").hide();
		$(_pageId+" .ly_shadow .je span").html("0");
		$(_pageId+" #lottery .zp_img").addClass("active");
		service.luckyActivity(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)
			{
				setTimeout(function(){
					var res = data.results[0];
					var result_activity = res.awardid;
					if(result_activity == "1001")//一等奖 20
					{
						$(_pageId+" #lottery .zp_img img").removeClass();
						$(_pageId+" #lottery .zp_img img").addClass("luck20");
						$(_pageId+" #lottery .zp_img").removeClass("active");
						$(_pageId+" .ly_shadow .je span").html("20");
						setTimeout(function(){
				            $(_pageId+" .ly_shadow").show();
						},1500);
					}
					else if(result_activity == "1002")//二等奖 15
					{
						$(_pageId+" #lottery .zp_img img").removeClass();
						$(_pageId+" #lottery .zp_img img").addClass("luck15");
						$(_pageId+" #lottery .zp_img").removeClass("active");
						$(_pageId+" .ly_shadow .je span").html("15");
						setTimeout(function(){
				            $(_pageId+" .ly_shadow").show();
						},1500);
					}
					else if(result_activity == "1003")//三等奖 10
					{
						$(_pageId+" #lottery .zp_img img").removeClass();
						$(_pageId+" #lottery .zp_img img").addClass("luck10");
						$(_pageId+" #lottery .zp_img").removeClass("active");
						$(_pageId+" .ly_shadow .je span").html("10");
						setTimeout(function(){
				            $(_pageId+" .ly_shadow").show();
						},1500);
					}
					else if(result_activity == "1004")//四等奖 8
					{
						$(_pageId+" #lottery .zp_img img").removeClass();
						$(_pageId+" #lottery .zp_img img").addClass("luck08");
						$(_pageId+" #lottery .zp_img").removeClass("active");
						$(_pageId+" .ly_shadow .je span").html("8");
						setTimeout(function(){
				            $(_pageId+" .ly_shadow").show();
						},1500);
					}else if(result_activity == "1005"){
						$(_pageId+" #lottery .zp_img img").removeClass();
						$(_pageId+" #lottery .zp_img img").addClass("luck05");
						$(_pageId+" #lottery .zp_img").removeClass("active");
						$(_pageId+" .ly_shadow .je span").html("5");
						setTimeout(function(){
				            $(_pageId+" .ly_shadow").show();
						},1500);
					}
				},3000);
			}
			else
			{
				$(_pageId+" #lottery .zp_img").removeClass("active");
				layerUtils.iAlert(error_info,-1,function(){
				if(global.isZhongheApp=="0"){
						appUtils.pageInit("account/lucky","account/accountResult",{});  // 直接跳到结果页 单独开户
					}else{ //综合app
					     var param = {"funcNo": "50101","moduleName":"home"};
                    	 external.callMessage(param);
					}
				});
			}
		},true,false);
	}
	
	var lucky = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	/**
	 * 清除项目中的html
	 */
	/*$("#bodyContent .page").each(function(){
		$(this).remove();
	});*/
	module.exports = lucky;
});