/**
 * 准备页
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		   service = require("serviceImp").getInstance(),  //业务层接口，请求数据
	       global = require("gconfig").global,
	       layerUtils = require("layerUtils"),
	       shellPlugin = require("shellPlugin"),
		   _pageId = "#account_preparePage";
    var common=require("common");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		initPage();  // 初始化页面
	}
	
	function bindPageEvent()
	{
	/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
//			if(global.isZhongheApp=="1"){ 
//			    appUtils.pageInit("account/preparePage","business/index");   //  综合app版本
//			}else{                        
			appUtils.pageInit("account/preparePage","account/msgVerify");   //单独开户（渠道版本）
//			}
		});
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
            common.onEvent("click","stock_account_3"); //友盟统计
			appUtils.pageInit("account/preparePage","account/selDepartment");
		});
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	function initPage(){
		var queryParam = {"bindtype" : "", "ispwd" : ""};
		service.queryBankList(queryParam,function(data){
			//alert(data);
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			console.log("aaaaaaaaaaaa"+JSON.stringify(data));
			var tsinfo=appUtils.getSStorageInfo("bankSourceRemark")
			//alert(data.tsinfo);
			$(_pageId+" .clearfix").html("");  // 清除页面的银行列表
			if(errorNo==0 && data.results.length != 0)
			{
				var bankInfo = "";
				var results = data.results;
				for(var i =0; i<results.length; i++){
					var appimg = results[i].appimg,
						appimgtype = results[i].appimgtype,
						bankname = results[i].bankname;
					var domClass = "";
					if(appimgtype == 1){
						domClass = "tel";
					}
					if(appimgtype == 2){
						domClass = "spel";
					}
					if(appimg.substr(0,4)=="http"){
						console.log("appimg--"+appimg);
						bankInfo +="<li><img src=\""+appimg+"\"><span class=\""+domClass+"\">"+bankname+"</span></li>";
					}else{
						bankInfo +="<li><img src=\"images/banksmall/"+appimg+"\"><span class=\""+domClass+"\">"+bankname+"</span></li>";
					}
				}
				$(_pageId + " .clearfix").html(bankInfo);
				$(_pageId + " #prompt p").html(tsinfo);
			}
			else
			{
				layerUtils.iAlert(errorInfo,-1);
			}
		},true,true,handleTimeout);	
		
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			initPage();  // 再次获取银行列表
		});
	}
	
	/* 清理界面元素 */
	function cleanPageElement()
	{
	}
	var preparePage = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = preparePage;
});