/**
* 风险测评结果
*/
define(function(require,exports,module){
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		_pageId = "#account_riskAssessmentResult";
	
	function init()
	{
		
		// 只有从 riskAssessment 跳转过来时，才设置页面的填充数据
		if(appUtils.getSStorageInfo("_prePageCode") == "account/riskAssessment")
		{
			var remark  = appUtils.getPageParam("remark");  //风险等级
			var riskdesc = appUtils.getPageParam("riskdesc"); //风险等级描述
			var showStr = riskdesc;
			// 清空原有内容
			$(_pageId+" div[class='test_level']").text("");
			$(_pageId+" div[class='test_level']").append(showStr);
			if(riskdesc=="保守型")
				{
				  $(_pageId+" .test_result p:eq(1)").html("“保守型”等级客户---国债、保本型基金、货币型基金");
				}
			if(riskdesc=="稳健型")
				{
				  $(_pageId+" .test_result p:eq(1)").html("“稳健型”等级客户---国债、保本型基金、货币型基金、公司债、企业债券、可转换企业债券、债券型基金、债券型资产管理产品");
				}
			if(riskdesc=="积极型")
				{
				  $(_pageId+" .test_result p:eq(1)").html("“积极型”等级客户---国债、保本型基金、货币型基金、公司债、企业债券、可转换企业债券、债券型基金、配置型基金、债券型资产管理产品、配置型资产管理产品、配置型基金、配置型资产管理产品、QDII基金、国债回购、股票（A股、B股）");
				}
			if(riskdesc=="进取型")
				{
				  $(_pageId+" .test_result p:eq(1)").html("“进取型”等级客户---国债、保本型基金、货币型基金、公司债、企业债券、可转换企业债券、债券型基金、配置型基金、债券型资产管理产品、配置型资产管理产品、QDII基金、国债回购、股票（A股、B股）、创业板股票、三板股票、融资融券");
				}
			if(riskdesc=="激进型")
				{
				  $(_pageId+" .test_result p:eq(1)").html("“激进型”等级客户--国债、保本型基金、货币型基金、公司债、企业债券、可转换企业债券、债券型基金、配置型基金、债券型资产管理产品、配置型资产管理产品、QDII基金、国债回购、股票（A股、B股）、创业板股票、三板股票、融资融券、期货、权证等金融衍生品");
				}
		}
	}
	
	function bindPageEvent()
	{
		// 重新测评绑定事件
		appUtils.bindEvent($(_pageId+" .test_result p:eq(2) a"),function(){
			appUtils.pageInit("account/riskAssessmentResult","account/riskAssessment",{});
		});
		// 确认书勾选
		appUtils.bindEvent($(_pageId+" .mt15"),function(){
			$(_pageId+" .mt15 a").toggleClass("checked");
		});
		/**
		 * 9.1
		 * 风险测评结果页面进入问卷回访页面
		 */
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
			if(!$(_pageId+" .mt15 a").hasClass("checked"))
				{
				  layerUtils.iMsg(-1,"请确认并勾选投资者事项！");
				  return;
				}
			if(global.needConfirm)
			{
				appUtils.pageInit("account/riskAssessmentResult","account/openConfirm",{});
			}
			else
			{
				appUtils.pageInit("account/riskAssessmentResult","account/accountResult",{});
			}
		});
	}
	
	function destroy(){}
	
	var riskAssessmentResult = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = riskAssessmentResult;
});