/**
 * 视频见证注意事项
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	      service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		  gconfig = require("gconfig"),
		  global = gconfig.global,
		  layerUtils = require("layerUtils"),
		  needVideo = "",
		  common=require("appUtils"),
		  _pageId = "#account_videoNotice";
	var external = require("external");
	var netWorkStatus = "NONE";
	var vadioFlag=false;
	var passCount=0;
	/* 私有业务模块的全局变量 end */

	function init()
	{
		passCount=0;
		_pageId = "#account_videoNotice";
	    initPage();  // 初始化页面
	    layerUtils.iLoading(false);  //关闭等待层
    }

	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			pageBack();
		});

		/* 重新上传照片 */
		appUtils.bindEvent($(_pageId+" .photo_again"),function(){
			var param = {
				user_id : appUtils.getSStorageInfo("user_id"),
				lastcomplete_step : "0",
				opacctkind_flag : ""
			};
			service.queryChangeState(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == 0)
				{
					appUtils.setSStorageInfo("idInfo","exist");
					appUtils.pageInit("account/videoNotice","account/uploadPhoto",{});
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iMsg(-1,error_info);
				}
			});
		});

		/* 重新提交资料 */
		appUtils.bindEvent($(_pageId+" .info_again"),function(){
			var Flag = false;
			var currentStep = appUtils.getSStorageInfo("currentStep");
			if(currentStep == "uploadimg" || currentStep == null)
			{
				Flag = true;
			}
			else
			{
				Flag = false;
			}
			var param = {
				user_id : appUtils.getSStorageInfo("user_id"),
				lastcomplete_step : "uploadimg",
				opacctkind_flag : ""
			};
			service.queryChangeState(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == 0)
				{
				console.log("进入信息页面-----");
					appUtils.pageInit("account/videoNotice","account/personInfo",{});
					//pageBack();
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iMsg(-1,error_info);
				}
			}, Flag);
		});

		/* 申请QQ预约 */
		appUtils.bindEvent($(_pageId+" .c_link"),function(){
			appUtils.pageInit("account/videoNotice","account/orderQq",{});
		});

		/* 在线视频视频见证 */
		appUtils.bindEvent($(_pageId+" .ct_btn:eq(0)"),function(){
			//common.onEvent("click","stock_account_7"); //友盟统计
		    var param = {
				"funcNo":"50030"
			};
			var result = external.callMessage(param);
		    var netWorkStatus = "";
			network = result.results[0].network;
			if(network == "0") {
				netWorkStatus = "断网";
			} else if (network == "1") {
				netWorkStatus = "2G";
			} else if (network == "2") {
				netWorkStatus = "3G";
			} else if (network == "3") {
				netWorkStatus = "4G";
			} else if (network == "4") {
				netWorkStatus = "WIFI";
			} else if (network == "9") {
				netWorkStatus = "未定义";
			}
			// 如果网络是2G，给出提示
			if(netWorkStatus == "2G" || netWorkStatus == "未定义")
			{
				layerUtils.iAlert("你当前使用的网络网速较慢，请在3G,4G或者wifi等网路状态下进行视频见证",-1,function(){
					//申请anychat视频见证
					anychatVideoApply();
				});
			}else{
				//申请anychat视频见证
				anychatVideoApply();
			}
		});

		/* 继续开户 */
		appUtils.bindEvent($(_pageId+" .ct_btn:eq(1)"),function(){
			queryQQOfflineState();  // 查询视频通过状态
		});
	}

	function destroy()
	{
		// 页面初始化样式重置
		$(_pageId+" .header h3:eq(0)").show();
		$(_pageId+" .header h3:eq(1)").hide();
		$(_pageId+" .error_notice:eq(0)").hide();
		$(_pageId+" .error_notice:eq(1)").hide();
		$(_pageId+" .camera_notice:eq(0)").show();
		$(_pageId+" .camera_notice:eq(1)").hide();
		$(_pageId+" .photo_again").hide();
		$(_pageId+" .info_again").hide();
		$(_pageId+" .c_link").show();
		$(_pageId+" .fix_bot").show();
		$(_pageId+" .fix_bot .ct_btn:eq(0)").show();
		$(_pageId+" .fix_bot .ct_btn:eq(1)").hide();
		service.destroy();
	}

	//调用anychat视频见证
	function anychatVideoApply(){
		//判断URL是否为空
		var param = {
			"url":global.serverPath+"?",   //ios传接入层地址
            "userId":appUtils.getSStorageInfo("user_id"),
            "userName":appUtils.getSStorageInfo("custname"),
            "orgId":appUtils.getSStorageInfo("branchno"),
            "jsessionId":appUtils.getSStorageInfo("jsessionid"),
            "userType":"1",  //开户标识
            "netWorkStatus":netWorkStatus,
			"funcNo":"60005",
			"moduleName":"open"
        };
        external.callMessage(param);
		//require("shellPlugin").callShellMethod("videoWitnessPlugin",null,null,param);
	}

	/* 处理返回按钮 */
	function pageBack()
	{
		var currentStep = appUtils.getSStorageInfo("currentStep");
		// 从短信登陆进入(当前完成步骤为：已提交资料)，处理返回按钮
		if(currentStep == "idconfirm")
		{
			appUtils.setSStorageInfo("currentStep","uploadimg");
			appUtils.setSStorageInfo("personInfo","exist");  // 标记完成资料填写步骤
			appUtils.pageInit("account/videoNotice","account/personInfo",{});
		}
		// 从短信登陆进入，在personInfo提交资料后，处理返回按钮
		else if(appUtils.getSStorageInfo("currentStep") == "uploadimg")
		{
			appUtils.setSStorageInfo("personInfo","exist");  // 标记完成资料填写步骤
			appUtils.pageBack();
		}
		// 正常开户流程处理返回按钮
		else
		{
			appUtils.pageBack();
		}
	}

	/* 初始化页面 */
	function initPage()
	{
		var videoParam = appUtils.getSStorageInfo("videoParam");
		videoParam = JSON.parse(videoParam);
		if(videoParam)
			{
			  needVideo = videoParam.need_video;
			}
		else
			{
			  needVideo = "0";
			}
		if(needVideo == "1")
		{
			videoReject();
		}
		//否则查询视频状态
		else{
			getVedioport();
		}
	}

	/* 获取营业部视频端口 */
	function getVedioport()
	{
		//获取营业部视频端口
		/*var param={
			"branchno":appUtils.getSStorageInfo("branchno"),
			"user_id":appUtils.getSStorageInfo("user_id")
		};
		alert(JSON.stringify(param));
		service.queryVideoAddress(param,function(data){
			alert(JSON.stringify(data));
			 if(data.error_no=="0" && data.results.length != 0)
			 {
				appUtils.setSStorageInfo("branch_id",data.results[0].branch_id);
				appUtils.setSStorageInfo("branch_url",data.results[0].url);
				// 如果是从短信验证码页面跳转过来的，从 session 中取 QQ 号并填充
				if(appUtils.getSStorageInfo("_prePageCode") == "account/msgVerify")
				{
					 queryQQOfflineState();  // 查询视频通过状态
				}
			 }
			 else
			 {
				 layerUtils.iMsg(-1,"获取视频服务器IP端口异常");  //提示错误信息
			 }
		 },true,true,handleTimeout);*/
		if(appUtils.getSStorageInfo("_prePageCode") == "account/msgVerify")
		{
			 queryQQOfflineState();  // 查询视频通过状态
		}else{
			layerUtils.iLoading(false);  //关闭等待层
		}
	}

	/* 处理请求超时 */
	/*function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getVedioport();  // 再次获取视频端口
		});
	}*/

	/* 查询离线视频通过状态 */
	function queryQQOfflineState()
	{
		var lookVedioStateParam = {
			"user_id" : appUtils.getSStorageInfo("user_id")
		};
		service.queryQQOfflineState(lookVedioStateParam,function(data){
			var error_no = data.error_no+"";
			var error_info = data.error_info;
			if(error_no == "0" && data.results.length != 0)
			{
				// 视频通过状态，0：未见证、2：已预约离线见证未完成见证、1：视频见证完成、3：见证失败
				// 未见证不需要做处理
				var witnessFlag = data.results[0].witness_flag+"";
				if(witnessFlag == "1")
				{
					//是否需要证书
					if(appUtils.getSStorageInfo("signFlag") == 1){

						layerUtils.iConfirm("您的视频审核已通过，接下来即将为您安装数字证书...", function(){
							appUtils.pageInit("account/videoNotice","account/digitalCertificate",{});
						},function(){return false;});
					}else{
						//跳转到开立账户页面
						layerUtils.iLoading(true);
						window.setTimeout(function(){
							layerUtils.iLoading(false);
						     appUtils.pageInit("account/videoNotice","account/signProtocol",{});
						},300);
					}
				}
				else if(witnessFlag == "2")
				{
					layerUtils.iAlert("您的预约信息已经提交，我们的客服将尽快联系您！",0);
				}
				else if(witnessFlag == "3")
				{
					$(_pageId+" .c_link").show();
					$(_pageId+" .fix_bot .ct_btn:eq(0)").show();
					$(_pageId+" .fix_bot .ct_btn:eq(1)").hide();
					layerUtils.iAlert("视频见证失败，请重新申请见证！");
				}
				else if(witnessFlag == "4")
				{
					layerUtils.iAlert("资料审核中，工作人员会尽快给您回复，请耐心等候！");
				}else{
					if(vadioFlag){
						layerUtils.iAlert("视频见证未通过！");
					}
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		},false);
	}

	/* 重新提交视频  */
	function aginSubmitVideo()
	{
		//调用提交补全资料接口
		var param = {
			"userid" : appUtils.getSStorageInfo("user_id"),
			"fieldname" : "video"
		};
		//如果视频被驳回
		if(needVideo == "1"){
			service.rejectStep(param,function(data){
				if(data.error_no == 0||data.error_no == "0")
				{
					appUtils.setSStorageInfo("isBack", "backInfo");  //标志重新提交资料成功
					var accountParam = appUtils.getSStorageInfo("accountParam");
					var pwdParam = appUtils.getSStorageInfo("pwdParam");
					var thirdParam = appUtils.getSStorageInfo("thirdParam");
					accountParam = JSON.parse(accountParam);
					pwdParam = JSON.parse(pwdParam);
					thirdParam = JSON.parse(thirdParam);
					// 需要继续驳回到开股东卡
					if(accountParam.need_account == 1)
					{
						appUtils.pageInit("account/videoNotice","account/backSignProtocol",{});
					}
					// 需要驳回资金或交易密码
					else if(pwdParam.needBusinessPwd ==1 || pwdParam.needFundPwd == 1)
					{
						appUtils.pageInit("account/videoNotice","account/backSetPwd",{});  //跳转设置密码页面
					}
					// 需要驳回到三方存管
					else if(thirdParam.needThirdDeposit == 1)
					{
						appUtils.pageInit("account/videoNotice","account/backThirdDepository",{});  //返回结果页
					}
					else
					{
						appUtils.pageInit("account/videoNotice","account/accountResult",{});
					}
				}else
				{
					layerUtils.iAlert(data.error_info);
				}
			});
		}
		else{
			//跳转到开立账户页面
			$(_pageId+" .fix_bot .ct_btn:eq(0)").hide();
            $(_pageId+" .fix_bot .ct_btn:eq(1)").show();
			layerUtils.iLoading(true);
			window.setTimeout(function(){
				layerUtils.iLoading(false);
				 appUtils.pageInit("account/videoNotice","account/signProtocol",{});
			},300);
		//queryQQOfflineState();  // 查询视频通过状态
		}
	}

	/* 见证通过 */
	function videoSuccess()
	{
//		$(_pageId+" .fix_bot .ct_btn:eq(0)").hide();
//		$(_pageId+" .fix_bot .ct_btn:eq(1)").show();
//		$(_pageId+" .c_link").hide();
//		queryQQOfflineState();  // 查询视频通过状态
		//判断是第一次视频见证还是驳回重新视频见证
		aginSubmitVideo();
	}

	/* 见证不通过 */
	function videoFail(){}

	/* 见证被驳回  201502031740*/
	function videoReject()
	{
		$(_pageId+" .header h3:eq(0)").hide();
		$(_pageId+" .header h3:eq(1)").show();
		$(_pageId+" .main .step_box").hide();
		$(_pageId+" .main .error_notice:eq(0)").hide();
		$(_pageId+" .main .error_notice:eq(1)").show();
		$(_pageId+" .camera_notice:eq(0)").show();
		$(_pageId+" .camera_notice:eq(1)").show();
		$(_pageId+" .fix_bot").show();
		$(_pageId+" .fix_bot .ct_btn a").html("重新进行视频见证");
	}

	/* 见证被驳回 */
//	function videoReject()
//	{
//		$(_pageId+" .header h3:eq(0)").hide();
//		$(_pageId+" .header h3:eq(1)").show();
//		$(_pageId+" .error_notice:eq(0)").hide();
//		$(_pageId+" .error_notice:eq(1)").show();
//		$(_pageId+" .camera_notice:eq(0)").hide();
//		$(_pageId+" .camera_notice:eq(1)").show();
//		$(_pageId+" .photo_again").show();
//		$(_pageId+" .info_again").show();
//		$(_pageId+" .c_link").hide();
//		$(_pageId+" .fix_bot").hide();
//	}

	/* QQ预约 */
	function qqApplay()
	{
		appUtils.pageInit("account/videoNotice","account/orderQq",{});
	}

	//视频见证判断
	function videoFlag(param) {
		var vidFlag = param.videoFlag+"";
        if (vidFlag == "0") {
        	if(passCount==0){
            	passCount++;
				//见证通过
				$(_pageId+" .fix_bot .ct_btn:eq(0)").hide();
				$(_pageId+" .fix_bot .ct_btn:eq(1)").show();
				$(_pageId+" .c_link").hide();
				vadioFlag=true;
				layerUtils.iLoading(true);
				window.setTimeout(function(){
					layerUtils.iLoading(false);
					aginSubmitVideo();
				},400);
			}
		} else if (vidFlag == "1") {
			//见证失败
		} else if (vidFlag == "2") {
			//见证驳回
			$(_pageId+" .header h3:eq(0)").hide();
			$(_pageId+" .header h3:eq(1)").show();
			$(_pageId+" .error_notice:eq(0)").hide();
			$(_pageId+" .error_notice:eq(1)").show();
			$(_pageId+" .camera_notice:eq(0)").hide();
			$(_pageId+" .camera_notice:eq(1)").show();
			$(_pageId+" .photo_again").show();
			$(_pageId+" .info_again").show();
			$(_pageId+" .c_link").hide();
			$(_pageId+" .fix_bot").hide();
		}
	}
	
	var videoNotice = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy,
		"videoFlag" : videoFlag
	};
	
	// 暴露对外的接口
	module.exports = videoNotice;
});