﻿/**
 * 投顾模块公用 js
 */
define(function(require, exports, module){
    
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig"); 
    var global = gconfig.global;
    var nativePluginService = require("nativePluginService");
    var common = require("common");
    var external = require("external");
    var isSsoLoading = false;
       
    /**
     * 首次进入模块的时候，调用
     */
    function firstLoadFunc()
    {
       nativePluginService.function50100({"moduleName":gconfig.projName});
       common.firstLoadFunc();
    }
    
    /**
     *  处理会话失效
     */
    function filterLoginOut(data)
    {
       if(data.error_no == "-999"|| data.error_no == "-9999")
       {
          if(!isSsoLoading)
          {
             isSsoLoading = true;
             nativePluginService.function50040({"key":"temp_token_" + gconfig.projName,"value":""});
             reloadPageInit();
          }
       }
    }
    
    /**
     * 重新初始化js模块
     */
    function reloadPageInit()
    {
       var pageCode = getCurrentPageCode();
       hidePageContent(pageCode);
       appUtils.pageInit("",pageCode);
    }
       
	/**
	 * 每个页面校验
	 */
	function checkPermission(checkInParam)
	{
	  common.checkPermission(checkInParam);
       //进行登陆检测
       var resultVo;
       //获取需要登陆判断的页面编码
       var checkLoginPage = gconfig.global.checkLoginPageCode;
       //获取不需要登陆判断的页面编码
       var notCheckLoginPage = gconfig.global.notCheckLoginPageCode;
       if(gconfig.platform != "0")
       {
			resultVo = nativePluginService.function50041({"key":"app_login_state"});
			
			
	       // 判断当前页面是否需要激活才能进入
	       if( (checkLoginPage && checkLoginPage.indexOf(checkInParam.pageCode) > -1) || (notCheckLoginPage && notCheckLoginPage.indexOf(checkInParam.pageCode) < 0))
	       {
	          // 获取壳子里的全局登陆状态，1:已经登陆； 0:代表退出
	    	   var login_state = resultVo.results[0].value;
	         
	          // 已经统一登陆
	          if(login_state == "1")
	          {
                 var isLoginIn = appUtils.getSStorageInfo("_isLoginIn");
	             // 本地session为空，需要进行模拟登陆
	             resultVo = nativePluginService.function50041({"key":"temp_token_" + gconfig.projName});
	             var token = resultVo.results[0].value;
	             if(!token || token.length == 0)
	             {
                     appUtils.clearSStorage("_isLoginIn");
	                 reBuildSsoToken(checkInParam.pageCode);
	                 return false;
	             }
	             if(isLoginIn!="true")
	             {
	                 return ssoLogin(token,checkInParam.pageCode,checkInParam.param); // 模拟登陆
	             }
	             else
	             {
                     return true;
                     /**
	                 // 比较本地token值与壳子token值是否相同
                     var session_token = appUtils.getSStorageInfo(gconfig.projName + "_login_token") || "";
	                 if(token == session_token)
	                 {
	                     return true;
	                 }
	                 else
	                 {
	                    return ssoLogin(token,checkInParam.pageCode); // 模拟登陆
	                 }
                     **/
	            }
	         }
	         // 未登录状态，需清理session并且跳到登陆页面
	         else
	         {
	            goTologin(checkInParam.pageCode);
	            return false;
	         }
	      }
       }
      return true;
	}
	
    /**
     *  模拟登陆
     */
    function ssoLogin(token,pageCode,param)
    {
       appUtils.invokeServer(global.serverPath, {"funcNo":"600001","temp_token":token}, function(data){
            if(data.error_no == 0)
            {
                appUtils.setSStorageInfo(gconfig.projName + "_login_token",token);
                appUtils.setSStorageInfo("_isLoginIn","true");
                common.saveSessionUserInfo(data.results);
                if(pageCode)
                {
                     appUtils.pageInit("",pageCode,param);
                }
                else
                {
                     reloadPageInit();
                }
                isSsoLoading = false;
            }
            else if(data.error_no == -501031)
            {

                reBuildSsoToken();
            }
            else
            {
                nativePluginService.function50040({"key":"temp_token_" + gconfig.projName,"value":""});
                common.ssoLoginFailed(data);
            }
       },true,true);
       return false;
    }
    
    /**
    *  @Author 刘宝, 2015-07-28 21:07:11
    *
    *
    *  @return 重构SSO的Token
    */
    function reBuildSsoToken(pageCode)
    {
       var param = {};
       param["funcNo"] = "60402";
       param["moduleName"] = gconfig.projName;
       if(pageCode)
       {
          param["toPage"] = pageCode;
       }
       external.callMessage(param);
    }
       
    /**
     * 统一退出
     */
    function ssoLoginOut()
    {
       var param = {};
       param["funcNo"] = "60400";
       param["moduleName"] = gconfig.projName;
       external.callMessage(param);
    }
       
    /**
     * 切换到登陆页面
     */
    function goTologin(pageCode)
    {
       appUtils.clearSStorage("_isLoginIn");
       appUtils.clearSStorage(gconfig.projName + "_login_token");
       //发消息给原生，通知打开登陆页面重新登陆
       var url = getPageUrl(pageCode);
       hidePageContent(getPageCode(url));
       var param_login = {"moduleName":"sso", "params":{"moduleName":gconfig.projName,"toPage":url,"isLoad":"0"}};
       nativePluginService.function50101(param_login);
    }
    
    //获取url
    function getPageUrl(pageCode)
    {
       var url = window.location.href;
       var pageCodeStr = "";
       var index = url.indexOf("#!/");
       if(url.indexOf("#!/") > 0)
       {
            pageCodeStr = url.substring(index,url.length);
       }
       if(pageCode)
       {
             pageCodeStr = ("#!/" + pageCode +".html");
       }
       if(pageCodeStr.length == 0)
       {
             pageCodeStr = ("#!/" + gconfig.defaultPage.pageCode +".html");
       }
       if(index > 0)
       {
             url = url.substring(0,index);
       }
       url += pageCodeStr;
       return url;
    }
    
    //获取页面编码
    function getPageCode(url)
    {
       var pageCode;
       if(url.split("#!/").length > 0)
       {
         pageCode = url.split("#!/")[1];
         var index = pageCode.indexOf(".");
         if(index > 0)
         {
           pageCode = pageCode.substring(0,index);
         }
       }
       return pageCode;
    }
    
    //隐藏内容
    function hidePageContent(pageCode)
    {
       var pageId = pageCode.split("/").join("_");
       $("#"+pageId).hide();
    }
    
    //检测是否要登录
    function checkLoginRight(pageCode)
    {
       var url = getPageUrl(pageCode);
       pageCode = getPageCode(url);
       // 判断当前页面是否需要激活才能进入
       //获取需要登陆判断的页面编码
       var checkLoginPage = gconfig.global.checkLoginPageCode;
       //获取不需要登陆判断的页面编码
       var notCheckLoginPage = gconfig.global.notCheckLoginPageCode;
       return((checkLoginPage && checkLoginPage.indexOf(pageCode) > -1) || (notCheckLoginPage && notCheckLoginPage.indexOf(pageCode) < 0) );
    }
    
    //获取当前的页面pageCode
    function getCurrentPageCode()
    {
       var url = getPageUrl();
       var pageCode = getPageCode(url);
       return pageCode;
    }
       
    var sso =
    {
    	"firstLoadFunc" : firstLoadFunc,
    	"checkPermission":checkPermission,
      "filterLoginOut" :filterLoginOut,
      "goTologin": goTologin,
      "ssoLoginOut": ssoLoginOut,
      "reloadPageInit": reloadPageInit,
      "checkLoginRight":checkLoginRight,
      "getCurrentPageCode":getCurrentPageCode,
      "hidePageContent":hidePageContent
    };
    
    module.exports = sso;
});