/**
 * 密码修改
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var validator = require("validatorUtil");
	var external = require("external");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_common = require("service_common");
	var common = require("common");
	var _pageId = "#account_changePassword ";
    var userInfo = null;
    var password_new ="";
    var witchAccount ="";
    
    /**
     * 初始化
     */
	function init() {
//		witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
//		if(witchAccount){
//			//从session中获取客户的信息
//			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
//		}else{
//			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
//		}
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		if(gconfig.platform=="0"){ //方便pc端调试
			$(_pageId+"input").attr("readonly",false);
		}
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("account/changePassword","account/index",{});
		});
		//密码修改
		appUtils.bindEvent($(_pageId + ".input_form .ce_btn"), function(e){
			//密码修改校验
			if(!checkInput()){
				return false;
			};
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			common.btnConfirm("<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>您是否确认修改密码?</div></div>",changePassword,null);
			$("#pop_tip_confirm").find("p").css("padding","15px");//修改提示框的边框高度
		});
		//原来密码
		appUtils.bindEvent($(_pageId+"#oldPassword"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"account_changePassword", "eleId":"oldPassword", "doneLable":"done", "keyboardType":"5"});
			e.stopPropagation();
		},"click");
		//关闭原生键盘
//		appUtils.bindEvent($(_pageId+"#oldPassword"),function(e){
//			external.callMessage({"funcNo": "50211"});
//			e.stopPropagation();
//		},"blur");
		//新密码
		appUtils.bindEvent($(_pageId+"#newPassword"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"account_changePassword", "eleId":"newPassword", "doneLable":"done", "keyboardType":"5"});
			e.stopPropagation();
		},"click");
		//关闭原生键盘
//		appUtils.bindEvent($(_pageId+"#newPassword"),function(e){
//			external.callMessage({"moduleName":"common","funcNo": "50211"});
//			e.stopPropagation();
//		},"blur");
		//新密码确认
		appUtils.bindEvent($(_pageId+"#confirmPassword"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"account_changePassword", "eleId":"confirmPassword", "doneLable":"done", "keyboardType":"5"});
			e.stopPropagation();
		},"click");
		//关闭原生键盘
//		appUtils.bindEvent($(_pageId+"#confirmPassword"),function(e){
//			external.callMessage({"moduleName":"common","funcNo": "50211"});
//			e.stopPropagation();
//		},"blur");
		appUtils.bindEvent($(_pageId),function(e){
		    var tag = e.srcElement || e.target;
		    if(tag.id!="oldPassword" && tag.id!="newPassword" && tag.id!="confirmPassword"){
		    	external.callMessage({"moduleName":"trade","funcNo": "50211"});
		    }
          e.stopPropagation();
		},"click");
	}
    
	/**
	 * 密码修改校验
	 */
	function checkInput(){
		
		var password_old = $(_pageId + "#oldPassword").val();
		password_new = $(_pageId + "#newPassword").val();
		var password_confirm = $(_pageId + "#confirmPassword").val();
		if(validator.isEmpty(password_old)){
			layerUtils.iAlert("原密码不能为空 ");
			return false;
		}
		if(validator.isEmpty(password_new)){
			layerUtils.iAlert("新密码不能为空 ");
			return false;
		}
		if(validator.isEmpty(password_confirm)){
			layerUtils.iAlert("确认密码不能为空 ");
			return false;
		}
		if(!/^[0-9a-zA-Z]{6,12}$/.test(password_old)){
			layerUtils.iAlert("原密码只允许输入0-9、a-z、A-Z且长度为6-12位");
			return false;
		}
		if(!/^[0-9a-zA-Z]{6,12}$/.test(password_new)){
			layerUtils.iAlert("新密码只允许输入0-9、a-z、A-Z且长度为6-12位");
			return false;
		}
		if(!/^[0-9a-zA-Z]{6,12}$/.test(password_confirm))
		{
			layerUtils.iAlert("确认密码只允许输入0-9、a-z、A-Z且长度为6-12位");
			return false;
		}
//		if(password_old.length != 6 || password_new.length != 6 || password_confirm.length != 6){
//			layerUtils.iAlert("密码长度必须为6位 ");
//			return false;
//		}
		if(password_new == password_old){
			layerUtils.iAlert("新密码与原密码不能相同 ");
			return false;
		}
		if(password_new != password_confirm){
			layerUtils.iAlert("新密码与确认密码请保持一致 ");
			return false;
		}
		return true;
	}

	
	/**
	 * 密码修改
	 */
	function changePassword(){
		//密码加密
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				//将isShowWait关闭掉(圈)
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				$(_pageId + "#oldPassword").val("");
				$(_pageId + "#newPassword").val("");
			    $(_pageId + "#confirmPassword").val("");
				return false;
			}else{
				//获得旧密码和新密码
				var password_old = $(_pageId + "#oldPassword").val();
				password_new = $(_pageId + "#newPassword").val();
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				//为旧密码和新密码加密
				if(password_old){
					password_old = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(password_old));
				}
				if(password_new){
					password_new = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(password_new));
				}
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var branch_no = userInfo.branch_no;	//分支机构 
				var fund_account = userInfo.fund_account;	//资产账户
				var cust_code = userInfo.cust_code;	//客户代码
				var password_type = "1";//交易密码
				var password = userInfo.password;
				var sessionid = userInfo.session_id;
				var param = {
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"password":password,
						"password_new":password_new,
						"password_old":password_old,
						"passowrd_type":password_type
//						"account_type":witchAccount 
				};
				//发送修改密码请求
				service_common.updatePassword(param,updatePasswordCallBack);
			}
		},{"isLastReq":false});
		
	}
	function updatePasswordCallBack(data){
		if(data.error_no == 0){
			//需求:当客户点击确定时,才跳转到登陆页面,注意:此处的reSetting不可写为reSetting() 否则会立刻执行
			layerUtils.iAlert("密码修改成功,请重新登录",0,reSetting,"确定");
		}else{
			layerUtils.iAlert(data.error_info);
			clearBuyMsg();
		}

	}
	
	/**
	 * 重置session
	 */
	function reSetting(){
		//关闭弹出框
		layerUtils.iTipsClose();
		//清空客户登陆信息

//		if(witchAccount=="credit_userInfo"){
//			appUtils.clearSStorage(witchAccount);
//			appUtils.pageInit("account/changePassword","account/index",{});
//		}else{
//        	appUtils.clearSStorage("stock_userInfo");
//        	require("sso").ssoLoginOut();
//        	if(gconfig.platform != "0"){
//            	var param_login = {"moduleName":"sso", "params":{"moduleName":"trade","toPage":"account/index","isLoad":"0"}};
//                require("nativePluginService").function50101(param_login);
//        	}else{
//        		appUtils.pageInit("account/changePassword","account/index",{});
//        	}
//		}
    	appUtils.clearSStorage("stock_userInfo");
    	$("#account_index .top_title .logout").hide();
    	appUtils.pageInit("account/changePassword","account/index",{});
    	require("sso").goTologin("account/index");
    	require("sso").ssoLoginOut();
//    	if(gconfig.platform != "0"){
//        	var param_login = {"moduleName":"sso", "params":{"moduleName":"trade","toPage":"account/index","isLoad":"0"}};
//            require("nativePluginService").function50101(param_login);
//    	}else{
//    		appUtils.pageInit("account/changePassword","account/index",{});
//    	} 
		clearBuyMsg();
	}
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId + "#oldPassword").val("");
		$(_pageId + "#newPassword").val("");
	    $(_pageId + "#confirmPassword").val("");
	}
	
	function destroy(){
		clearBuyMsg();
		external.callMessage({"moduleName":"trade","funcNo": "50211"});
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("account/changePassword","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});