/**
 * 交易主界面
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
    var _pageId = "#account_index ";
    var external = require("external");
    var common = require("common");
    var commonFunc = require("commonFunc");
    var nativePluginService = require("nativePluginService");
    var topage ="";
    var stock_userInfo = null;
    var credit_userInfo = null;
    var service_common = require("service_common");
    var service_stock = require("service_stock");
    var height_Up = ""; //注销
    var height_Down = ""; //登录
    /**
     * 初始化
     */
	function init(){
		common.loadBus();
		// 初始化首页高度
		height_Up = $(window).height() - $(_pageId+".header").height() - $(_pageId+".trade_nav").height() - $(_pageId+".user_value").height()-15;
		height_Down = $(window).height() - $(_pageId+".header").height() - $(_pageId+".trade_nav").height() - $(_pageId+".user_value2").height()-55;
        var height_meau = height_Up;
		$(_pageId+".user_value2").hide();
		$(_pageId+".user_value").show();
		$(_pageId).css("overflow-x","hidden");
		var isFinance = appUtils.getSStorageInfo("isFinance");
		if(isFinance){
			$(_pageId+".main .trade_nav2").scrollTop(0);
			$(_pageId+".main .trade_nav2").css("overflow-y","auto");
			$(_pageId+".main .trade_nav2").height(height_meau); //查询目录添加高度
			$(_pageId+" #version").html("version："+_sysVersion);
			return false;
		}
		// 初始化用户信息
		stock_userInfo = appUtils.getSStorageInfo("stock_userInfo");
		credit_userInfo = appUtils.getSStorageInfo("credit_userInfo");
		
		// 获取壳子里的全局登陆状态，1:已经登陆； 0:代表退出
		if(gconfig.platform != "0"){
		    var resultVo = nativePluginService.function50041({"key":"app_login_state"});
		    var login_state = resultVo.results[0].value;
			if(login_state){  // 是否登录
				clearMSG(); // 清空数据
				$(_pageId+".user_value2").show();
				$(_pageId+".user_value").hide();
				height_meau = height_Down;
				if(!stock_userInfo){
					common.ssoLogin("",queryCapital); //查询资金账户
				}else{
					queryCapital();
				}
			}else{
				$(_pageId+".user_value2").hide();
				$(_pageId+".user_value").show();
				stock_userInfo = null;
				credit_userInfo = null;
				appUtils.clearSStorage("stock_userInfo");
				appUtils.clearSStorage("credit_userInfo");
				height_meau = height_Up;
			}
		}else{
			if(stock_userInfo || credit_userInfo){
				$(_pageId+".user_value2").show();
				$(_pageId+".user_value").hide();
				height_meau = height_Down;
				//查询资金账户
				queryCapital();
			}
		}
		var items=global["tradeList"];
		for(var i=0;i<items.length;i++){   //根据配置隐藏相应的菜单项
			if(items[i].isShow=="false"){
				$(_pageId + "#"+items[i].id).hide(); 
			}
		}
		$(_pageId+".main .trade_nav2").scrollTop(0);
		$(_pageId+".main .trade_nav2").css("overflow-y","auto");
		$(_pageId+".main .trade_nav2").height(height_meau); //查询目录添加高度
		$(_pageId+" #version").html("version："+_sysVersion);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//主页菜单事件绑定
		appUtils.bindEvent($(_pageId + ".main ul li a"), function(e){
			//友盟统计事件
			var yCount = $(this).attr("yCount");
			yCount?external.callMessage({"funcNo": "70007","label":yCount}):"";
			topage = $(this).attr("to-page").replaceAll("_","/"); //获取跳转的页面
			var param =  $(this).attr("param"); //获取跳转页面参数
			stock_userInfo = appUtils.getSStorageInfo("stock_userInfo");
			credit_userInfo = appUtils.getSStorageInfo("credit_userInfo");
			if(stock_userInfo && credit_userInfo){ //当信用和普通账户都登录时
				var fund_account_credit = JSON.parse(credit_userInfo).fund_account;
				var fund_account_stock = JSON.parse(stock_userInfo).fund_account;
				$(_pageId+".pop_box .pop_main dd:eq(0) label span").text("("+fund_account_stock+")");
				$(_pageId+".pop_box .pop_main dd:eq(1) label span").text("("+fund_account_credit+")");
				if(topage=="newshare/apply"){
					$(_pageId+".pop_box .pop_main h4 span").text("新股申购操作");
					$(_pageId + ".backdrop").show();
					$(_pageId + ".pop_box").show();
				}else if(topage=="banking/transfer"){
					$(_pageId+".pop_box .pop_main h4 span").text("银证转账操作");
					$(_pageId + ".backdrop").show();
					$(_pageId + ".pop_box").show();
					appUtils.setSStorageInfo("whichPage","account/index");
				}else if(topage == "ggt/ggtBuy"){
					commonFunc.checkGGTPermission(1); // 港股通权限校验
				}else if(topage == "yyh/signProtocol"){
						commonFunc.checkYYHOpen();
				}else{
					appUtils.pageInit("account/index",topage,{"param":param}); 
				}
			}else if(stock_userInfo){  // 仅普通账户都登录时
				if(topage == "credit/asset/asset"){
					//appUtils.pageInit("account/index",topage,{"topage":topage});
					commonFunc.creditLogin(1); // 融资融券权限校验
				}else if(topage == "ggt/ggtBuy"){
					commonFunc.checkGGTPermission(1); // 港股通权限校验
				}else if(topage == "yyh/signProtocol"){
						commonFunc.checkYYHOpen();					
				}else{
					appUtils.setSStorageInfo("whichAccount","stock_userInfo");
					appUtils.setSStorageInfo("whichPage","account/index");
					appUtils.pageInit("account/index",topage,{"param":param}); 
				}
			}else if(credit_userInfo){ //仅信用账户都登录时
				var arr = ["credit/asset/asset","newshare/apply","banking/transfer"];
				if(arr.indexOf(topage) != -1){
					appUtils.setSStorageInfo("whichAccount","credit_userInfo");
					appUtils.setSStorageInfo("whichPage","account/index");
					appUtils.pageInit("account/index",topage,{"param":param}); 
				}else{
					appUtils.pageInit("account/index","account/login",{"topage":topage});
				}
			}else{  //都未登录时 客户选择操作站点不需要登陆
				if(topage == "account/changeStockStation"){
					appUtils.pageInit("account/index","account/changeStockStation");
				}else{
					if(gconfig.platform != "0"){
						appUtils.pageInit("account/index",topage,{"topage":topage});
					}else{
						appUtils.pageInit("account/index","account/login",{"topage":topage});
					}
				}
			}
			e.stopPropagation();
		});
		//账户选择事件
		appUtils.bindEvent($(_pageId + ".pop_box .pop_main dd"), function(e){
			$(this).find("input").attr("checked","checked");
			$(this).siblings().find("input").attr("checked",false);
		});
		//账户选择确认事件
		appUtils.bindEvent($(_pageId + ".pop_box #sureBtn"), function(e){
			var whichAccount = "stock_userInfo";
			$(_pageId + ".backdrop").hide();
			$(_pageId + ".pop_box").hide();
			if($(_pageId+".pop_box .pop_main dd:eq(1)").find("input").attr("checked")){
				whichAccount = "credit_userInfo";
			}
			appUtils.setSStorageInfo("whichAccount",whichAccount);
			appUtils.pageInit("account/index",topage,{}); 
			e.stopPropagation();
		});
		//注销事件
		appUtils.bindEvent($(_pageId + ".logout"), function(e){
			console.log("@@@@@");
			var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>确定退出当前登录账号?</div></div>";
			common.btnConfirm(tipStr,function success(){
				 loginOut();
				 stock_userInfo = null;
				 credit_userInfo =null;
				 appUtils.clearSStorage();
				 $(_pageId+".main .trade_nav2").height(height_Up); //查询目录添加高度
				 $(_pageId+".user_value2").hide();
				 $(_pageId+".user_value").show();
			},function fail(){
			} );
			e.stopPropagation();
		});
		// 登录事件
		appUtils.bindEvent($(_pageId + ".user_value h5"), function(e){
			var topage = "stock/stockBuy";
			if(gconfig.platform != "0"){
				appUtils.pageInit("account/index",topage,{"topage":topage});
			}else{
				appUtils.pageInit("account/index","account/login",{"topage":topage});
			}
			var yCount = $(this).attr("yCount");
			yCount?external.callMessage({"funcNo": "70007","label":yCount}):"";
			e.stopPropagation();
		});
	}

	
	//融资融券模拟登录
	function loginOut(){
	    var stock_userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
	    if(stock_userInfo){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = stock_userInfo.branch_no;	//分支机构
			var fund_account = stock_userInfo.fund_account;	//资产账户
			var cust_code = stock_userInfo.cust_code;	//客户代码
			var param = {			
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
				};
			service_common.loginOut(param,function(data){
				if(data.error_no == 0){
					require("sso").ssoLoginOut();
				}else{
					layerUtils.iAlert(data.error_info);
	        	}
			});
	    }else{
			stock_userInfo = null;
			credit_userInfo =null;
			appUtils.clearSStorage();
			$(_pageId+".user_value2").hide();
			$(_pageId+".user_value").show();
			require("sso").ssoLoginOut();
	    }
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		if(userInfo){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var password = userInfo.password;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var money_type = "0";  //  0：人民币，1：美元，2：港币
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "password":password,
				    "cust_code":cust_code,
				    "money_type":money_type
			};
			$(_pageId+ ".no_data").hide();
			//最后一个为超时处理函数
			service_stock.queryFundSelect(param,queryCapitalCallback);
		}
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
					$(_pageId+".user_value2 .mobile_num").text(userInfo.cust_code); // 客户号
					$(_pageId+".user_value2 strong:eq(0)").text(common.numToMoneyType(""+Number(results[0].assert_val).toFixed(2)+"")); // 总资产
					$(_pageId+".user_value2 .more_info ul li:eq(0) strong").text(common.numToMoneyType(""+Number(results[0].daily_income_balance).toFixed(2)+""));  // 当日盈亏 
					$(_pageId+".user_value2 .more_info ul li:eq(1) strong").text(common.numToMoneyType(""+Number(results[0].total_income_balance).toFixed(2)+""));  // 总盈亏
				}else{
					$(_pageId+".user_value2 .mobile_num").text("--");
					$(_pageId+".user_value2 strong:eq(0)").text("--"); // 总资产
					$(_pageId+".user_value2 .more_info ul li:eq(0) strong").text("--");  // 当日盈亏 
					$(_pageId+".user_value2 .more_info ul li:eq(1) strong").text("--");  // 总盈亏
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	function clearMSG(){
		$(_pageId+".user_value2 .mobile_num").text("--");
		$(_pageId+".user_value2 strong:eq(0)").text("--"); // 总资产
		$(_pageId+".user_value2 .more_info ul li:eq(0) strong").text("--");  // 当日盈亏 
		$(_pageId+".user_value2 .more_info ul li:eq(1) strong").text("--");  // 总盈亏
	}
	/**
	 * 销毁
	 */
	function destroy(){
		clearMSG();
		$(_pageId+".pop_box .pop_main dd:eq(0) input").attr("checked","checked");
		$(_pageId+".pop_box .pop_main dd:eq(1) input").attr("checked",false);
		$(_pageId + " #blacCover").hide();
		$(_pageId + " #noAcc").hide();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});