/**
 * 一键归集
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var validatorUtil = require("validatorUtil");
	var service_common = require("service_common");
	var service_stock = require("service_stock");
	var external = require("external");
    var _pageId = "#banking_collection ";
    var action = "#collection ";
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		common.systemKeybord(); // 解禁系统键盘
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryAccountInfos();
		if(gconfig.platform=="0"){ //方便pc端调试
			$(_pageId+"#stock_password").attr("readonly",false);
		}
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("banking/collection","account/index",{});
			e.stopPropagation();	// 阻止冒泡
		});
		//流水查询
		appUtils.bindEvent($(_pageId +".top_title .noicon_text"), function(e){
			appUtils.pageInit("banking/collection","banking/collectionHistory");
			e.stopPropagation();	// 阻止冒泡
		});
		//页面切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			//resetBuyForm();
			$(this).addClass("active").siblings().removeClass("active");
			var showPage = "#"+$(this).attr("show-page");
			var hidePage = "#"+$(this).siblings().attr("show-page");
			action = showPage+" ";
			$(_pageId + hidePage).hide();
			$(_pageId + showPage).show();
			bindPageEvent(); //重新绑定事件
			resetBuyForm();
			e.stopPropagation(); // 阻止冒泡
		});
		//主
		appUtils.bindEvent($(_pageId + "#turnOut"), function(e){
			$(_pageId+"#turnIn ul").hide();
			$(_pageId+"#turnOut ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		//辅
		appUtils.bindEvent($(_pageId + "#turnIn"), function(e){
			$(_pageId+"#turnOut ul").hide();
			$(_pageId+"#turnIn ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		//提交一键归集转账
		appUtils.bindEvent($(_pageId + "#collection .ce_btn a"),function(e){
			cashCollectSubmit(); //提交转账
			e.stopPropagation();	// 阻止冒泡
		});
		//提交资金归集转账
		appUtils.bindEvent($(_pageId  + "#cashTransfer .ce_btn a"),function(e){
			cashSweepSubmit(); //提交转账
			e.stopPropagation();	// 阻止冒泡
		});
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+"#turnOut ul").hide();	
			$(_pageId+"#turnIn ul").hide();
			e.stopPropagation();	// 阻止冒泡
		});
		//资金密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"banking_collection", "eleId":"stock_password", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
	}
	
	/**
	 * 客户资产帐户信息查询
	 */
	function queryAccountInfos(){
		var cust_code = userInfo.cust_code;	//客户代码
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var fund_account = userInfo.fund_account;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var password = userInfo.password;// 委托方式  在configuration配置 
		var money_type="";
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"money_type":money_type,
				"fund_account":fund_account,
				"password":password
				
		};
		service_common.queryAccountInfos(param,function(data){queryAccountInfosCallBack(data,param);});
	}
	function queryAccountInfosCallBack(data,param){
		if(data.error_no == 0){
			var results=data.results;
			if(results && results.length > 0){
				var listHtml_transfer = "<tr><th scope=\"col\">银行名称</th><th scope=\"col\">账户类型</th><th scope=\"col\">资金余额</th><th scope=\"col\">可转资金</th></tr>";
				var listHtml_colletion = "<tr><th><input type=\"checkbox\"></th><th scope=\"col\">银行名称</th><th scope=\"col\">账户类型</th><th scope=\"col\">资金余额</th><th scope=\"col\">可转资金</th></tr>";
				var fuAccountHtml = "<ul style=\"display:none;\">";
				var flag = true;
				for(var i = 0;i < results.length; i++) {
					var accountType = "辅";
					if(results[i].fundseq =="0"){
						accountType = "主";
						$(_pageId+"#turnOut p").html("(主)<strong data-fetch="+results[i].enable_balance+">"+results[i].fundid+"</strong>"+results[i].bank_name);
						$(_pageId+"#moneyList p").html(results[i].money_type_name);
						$(_pageId+"#moneyList").attr("value",results[i].money_type);
					    listHtml_colletion += "<tr><td></td>";
					}else{
						if(flag){
							$(_pageId+"#turnIn p").html("(辅)<strong>"+results[i].fundid+"</strong>"+results[i].bank_name);
                            flag = false;
						}
						fuAccountHtml +="<li><a href=\"javascript:void(0);\">(辅)<strong>"+results[i].fundid+"</strong>"+results[i].bank_name+"</a></li>";
					    listHtml_colletion += "<tr><td><input type=\"checkbox\" id="+results[i].fundid+"></td>";
					}
					listHtml_transfer += " <tr>";
					listHtml_transfer += "    <td>"+results[i].bank_name+"</td>";
					listHtml_transfer += "    <td>"+accountType+"<br /></td>";
					listHtml_transfer += "    <td>"+results[i].current_balance+"<br /></td>";
					listHtml_transfer += "    <td>"+results[i].enable_balance+"<br /></td>";
					listHtml_transfer += " </tr>";

					listHtml_colletion += "    <td>"+results[i].bank_name+"</td>";
					listHtml_colletion += "    <td>"+accountType+"<br /></td>";
					listHtml_colletion += "    <td>"+results[i].current_balance+"<br /></td>";
					listHtml_colletion += "    <td>"+results[i].enable_balance+"<br /></td>";
					listHtml_colletion += " </tr>";
				};
				fuAccountHtml+="</ul>";
				if(fuAccountHtml.indexOf("<li>") == -1){
					$(_pageId+"#turnIn").html("<p>暂未查询到您的子存管账号</p>").addClass("deleteBefore");
				}else{
					$(_pageId+"#turnIn").append(fuAccountHtml);
				}
				$(_pageId+"#collection .inte_table #accountList").html(listHtml_colletion);
				$(_pageId+"#cashTransfer #accountList").html(listHtml_transfer);
				appUtils.bindEvent($(_pageId+"#turnIn ul li"),function(){ // 下拉框选择
					$(_pageId+action+"#turnIn p").html($(this).find("a").html());
				});
				$(_pageId+"#collection #accountList input:eq(0)").on("click",function(e){ // 单选框事件
                     // 框架设置了500ms的防止重复点击 高频率的点击事件会失效
                     var fu_check = $(_pageId+"#collection #accountList input:gt(0)");
                     var fundId = "";
					if($(this).attr("checked")){
						    fu_check.each(function(){
						    	    var  enable_balance = $(this).parent().parent().find("td:eq(4)").text();
						    	     if(enable_balance!=0){
						    	     	$(this).attr("checked",true);
						    	     }else{
						    	     	fundId +=  $(this).attr("id")+",";
						    	     }
						    });
						    if(fundId!=""){
						    		layerUtils.iAlert(fundId.substring(0,fundId.length-1)+"可转资金为0");
						    		return false;
						    }
					}else{
							$(_pageId+"#collection #accountList input").attr("checked",false);
					}
					e.stopPropagation(); // 阻止冒泡
				});
				$(_pageId+"#collection #accountList input:gt(0)").on("click",function(e){ // 单选框事件
                     // 框架设置了500ms的防止重复点击 高频率的点击事件会失效		
                     var  enable_balance = $(this).parent().parent().find("td:eq(4)").text();
                     if(enable_balance == 0){ 	
                     	    $(_pageId).attr("checked",false);
                     	    layerUtils.iAlert("该账户可转资金为0");
						    return false;
                     }
					e.stopPropagation(); // 阻止冒泡
				});
			}
		}else{
			   layerUtils.iAlert(data.error_info);
		 }
	}
	
	 /**
     * 一键归集提交转账
     */
	function cashCollectSubmit(){
//		var stock_password =  $(_pageId+action+"#stock_password").val();	
//		if(stock_password == ""){
//			layerUtils.iMsg(-1,"请输入资金密码");
//			return false ;
//		}else if(stock_password.length!=6){
//			layerUtils.iMsg(-1,"资金密码长度为6位数");
//			return false ;
//		}
		var $checkEle = $(_pageId+"#collection #accountList input:gt(0)");
		var f_accounts = "";
		 $checkEle.each(function(){
			    if($(this).attr("checked")){
			    		f_accounts += $(this).attr("id")+",";
			    }
		});
		if(f_accounts==""){
		    layerUtils.iMsg(-1,"请选择归集的辅资金账号");
			return false ;
		}
//		//密码加密
//		service_common.getKey({},function(data){
//			if(data.error_no != "0"){
//				layerUtils.iAlert(data.error_info);
//				return false;
//			}else{
//				//参数固定,是密码加密的参数
//				var modulus = data.results[0].modulus;
//				var publicExponent = data.results[0].publicExponent;
//				var endecryptUtils = require("endecryptUtils");
//				if(stock_password){
//					stock_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(stock_password));
//				}
				var cust_code = userInfo.cust_code;	//客户代码
				var branch_no  = userInfo.branch_no; //分支机构
				var fund_account = userInfo.fund_account;
				var sessionid = userInfo.session_id;
				var money_type = $(_pageId+action+"#moneyList").attr("value");
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var z_fund_account = $(_pageId+action+"#turnOut p strong").text();
				var f_fund_account = f_accounts.substring(0,f_accounts.length-1);
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"z_fund_account":z_fund_account,
						"f_fund_account":f_fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"money_type":money_type,
				};
				service_common.cashCollection(param,cashCollectionCallBack);
			}
//	  },{"isLastReq":false});	
//	}
	function cashCollectionCallBack(data){
		if(data.error_no == 0){
			$(_pageId+action+"#stock_password").val("");
			layerUtils.iMsg(1,data.results[0].fundeffec!=""?"归集金额为："+data.results[0].fundeffec:"已提交转款",3);
			resetBuyForm();
			queryAccountInfos();
		}else{
			layerUtils.iAlert(data.error_info);
			resetBuyForm();
		}
	}
	
	 /**
     * 提交资金归集转账
     */
	function cashSweepSubmit(){
		var moneyNum = $(_pageId+"#moneyNum").val(); // 转账金额
		var maxNum = $(_pageId+"#cashTransfer #turnOut strong").attr("data-fetch"); // 最大可转
		if(moneyNum==""){
			layerUtils.iMsg(-1,"请输入转账金额");
			return false;
		}else if(!validatorUtil.isNumberFloat(moneyNum)){
			layerUtils.iMsg(-1,"转账金额请输入数字");
			return false;
		}else if(Number(moneyNum)>Number(maxNum)){
			layerUtils.iMsg(-1,"可转金额不足");
			return false;
		}
//		var stock_password =  $(_pageId+action+"#stock_password").val();	
//		if(stock_password == ""){
//			layerUtils.iMsg(-1,"请输入资金密码");
//			return false ;
//		}else if(stock_password.length!=6){
//			layerUtils.iMsg(-1,"资金密码长度为6位数");
//			return false ;
//		}
		//密码加密
//		service_common.getKey({},function(data){
//			if(data.error_no != "0"){
//				layerUtils.iLoading(false);
//				layerUtils.iAlert(data.error_info);
//				return false;
//			}else{
				//参数固定,是密码加密的参数
//				var modulus = data.results[0].modulus;
//				var publicExponent = data.results[0].publicExponent;
//				var endecryptUtils = require("endecryptUtils");
//				if(stock_password){
//					stock_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(stock_password));
//				}
				var cust_code = userInfo.cust_code;	//客户代码
				var fund_account = userInfo.fund_account;	//资产账户
				var branch_no  = userInfo.branch_no;	//分支机构
				var sessionid = userInfo.session_id;
	//			var password = userInfo.password;
				var money_type = $(_pageId+action+"#moneyList").attr("value");
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var out_fundid = $(_pageId+action+"#turnOut p strong").text();
				var in_fundid = $(_pageId+action+"#turnIn p strong").text();
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"money_type":money_type,
			      	    "out_fundid":out_fundid,
		  	            "in_fundid":in_fundid,
		  	            "tranamt":moneyNum
				};
				service_common.cashSweep(param,cashSweepCallBack);
			}
//	},{"isLastReq":false});
//	}
	function cashSweepCallBack(data){
		if(data.error_no == 0){
			$(_pageId+action+"#moneyNum").val("");
			$(_pageId+action+"#stock_password").val("");
			layerUtils.iMsg(1,data.results[0].outsno!=""?"转出流水号为："+data.results[0].outsno:"已提交转款",3);
			resetBuyForm();
			queryAccountInfos();
		}
		else{
			layerUtils.iAlert(data.error_info);
			resetBuyForm();
		}
	}
	//数据重置
	function resetBuyForm(){
		$(_pageId+"#moneyNum").val("");
		$(_pageId+"#stock_password").val("");
		$(_pageId+"#turnIn ul").hide();
		$(_pageId+"#turnOut ul").hide();
		$(_pageId+"#accountList input").attr("checked",false);
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + ".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		resetBuyForm();
		action="#collection ";
		$(_pageId +"#cashTransfer").hide();
		$(_pageId +"#collection").show();
		external.callMessage({"moduleName":"trade","funcNo": "50211"});

	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("banking/collection","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});