/**
 * 交易转账流水查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var service_common = require("service_common");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var common = require("common");
	var vIscroll = {"scroll":null,"_init":false};
	var timeLimit = 7;
    var _pageId = "#banking_collectionHistory ";
    var userInfo = null;
    var dateUtils = require("dateUtils");
    var begin_date= "";
    var end_date= "";
    var queryType = "today";  // today当日  history历史
    
    /**
     * 初始化
     */
	function init(){
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var now_time = new Date();
		begin_date = new Date(now_time.setMonth(now_time.getMonth() - 1));
	    begin_date = begin_date.format("yyyy-MM-dd");
		end_date = new Date().format("yyyy-MM-dd");
		$(_pageId+".data_check .inner .t1:eq(0)").val(begin_date);
		$(_pageId+".data_check .inner .t1:eq(1)").val(end_date);
		//日期时间输入点击调用日期组件，第一次点击不会触发效果，所以在init里面先初始化一次。
		dateUtils.initDateUI("banking_collectionHistory");
		queryType = "today";
        queryData(); // 查询流水数据
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("banking/collectionHistory","banking/collection");
		});
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
		});
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".top_title small").text(timeText);
			queryData(); 
		});
		//点击其他位置，隐藏下拉框
		appUtils.bindEvent($(_pageId + ".main"),function(){
			if($(_pageId + ".top_title .top_nav").is(':visible')){
				$(_pageId + ".top_title .top_nav").slideToggle("fast");
			}
		},"click");
        //查询点击事件
		appUtils.bindEvent($(_pageId+" #clickQuery"), function(e){
            var time_one =  $(_pageId + ".data_check .inner .t1:eq(0)").val();
            var time_two = $(_pageId + ".data_check .inner .t1:eq(1)").val();
			var begin = new Date(time_one.replace(/-/g,"/"));
			var end = new Date(time_two.replace(/-/g,"/"));
			var flag_one = new Date(time_two.replace(/-/g,"/"));;
			var flag_two = end.setMonth(end.getMonth()-3);
			if(flag_two > begin){
				 layerUtils.iAlert("最多只能查询三个月期间的数据");
			}else if(begin > flag_one){
				 layerUtils.iAlert("请查询正确的时间间隔");
			}else{
				begin_date = time_one;
				end_date = time_two;
				queryData(); 
			}
			e.stopPropagation();
		},"click");
	}
    
    //页面切换
	appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title h4 span").text($(this).find("a").text());
			if($(this).index()==0){
                queryType = "today";
			}else{
                queryType = "history";
			}
			queryData();
	});
	
	function queryData(){
		if(queryType=="today"){
				var endDate= new Date().format("yyyy-MM-dd");
				var beginDate = new Date().format("yyyy-MM-dd");
				queryHistory(beginDate,endDate);
				$(_pageId + ".data_check").hide();
		}else{
				queryHistory(begin_date,end_date);
				$(_pageId + ".data_check").show();
		}
	}
	/**
	 * 转账转账  (300203)
	 */
	function queryHistory(beginDate,endDate){
		$(_pageId+".bank_over ul").html("");
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var money_type ="";//货币 ""所有货币，0 人民币，1 港币，2 美元 
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.session_id;
		var password =userInfo.password;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"money_type":money_type,
				"begin_date":beginDate,
				"end_date":endDate
		};
		service_common.queryCollectionHistory(param,function(data){
			if(data.error_no != 0){
				layerUtils.iAlert(data.error_info);
			}else{
				$(_pageId+ ".no_data").hide();
				var results = data.results;
				if(results && results.length> 0 && typeof results != "undefined"){
					//显示历史流水数据
					showHistory(results);
					initVIScroll();
					$(_pageId+".visc_pullUp").hide();
				}else{
					initVIScroll();
					$(_pageId+ ".no_data").show();
					$(_pageId+ ".visc_pullUp").hide();
				}
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	
	/**
	 * 显示流水数据
	 */
	function showHistory(results){
		var strHtmls = "";
		for(var i=0 ;i<results.length;i++){
    		var css = "";
    		var tranamt = results[i].tranamt;
    		var transfer_direction = results[i].transfer_direction;
    		if(transfer_direction == "0"){
    			css = "ared";
    			tranamt = "+"+tranamt;
    		}else if(transfer_direction == "1"){
    			css = "agreen";;
    			tranamt = "-"+tranamt;
    		}
    		var failedNote = "";
    		if(results[i].entrust_name.indexOf("失败") != "-1"){
    			failedNote = ": " + results[i].bank_error_info;
    		}
			strHtmls += "<li><strong class="+css+">"+tranamt+"</strong>";
			strHtmls += "<p>"+results[i].trans_name+"</p>";
			strHtmls += "<em style=\"float:right\">"+results[i].bank_name_out+ "<span style=\"color:red\">-></span>" +results[i].bank_name_in+" <span style=\"font-weight:bolder;font-size:0.15rem\">"+results[i].entrust_name+"</span></em>";
			strHtmls += "<span class=\"time\">"+results[i].business_date+" "+results[i].business_time+"</span>";
			strHtmls += "</li>";
		}
		$(_pageId+".bank_over ul").html(strHtmls);
		$(_pageId+".visc_pullUp").hide();
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		vIscroll = {"scroll":null,"_init":false};
		var height = 0;
		if(queryType == "today"){
			height = $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".inner").outerHeight() - $(_pageId+".data_check").outerHeight();
		}else{
			height = $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".inner").outerHeight() - $(_pageId+".data_check").outerHeight();
		}
		var config = {
					"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": height,
					"container": $(_pageId+" #v_container_funds_jj"),	
					"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
					"downHandle": function() {	//下拉获取上一页数据方法
						queryData();
						vIscroll.scroll.refresh() ;//刷新滑动组件滚动条
					},
					"upHandle": function() { //上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); //初始化，需要做if(!hIscroll._init)判断
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		 timeLimit = 7;
		 $(_pageId+ ".no_data").hide();
		 $(_pageId + ".top_title .top_nav").hide();
		 $(_pageId+".bank_over ul").html("");
		 if(vIscroll._init){
			vIscroll.scroll.refresh();
		 }
		 $(_pageId + " .top_title small").text("一周内");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("banking/transferHistory","banking/transfer");
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});