/**
 * 交易转账
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var validatorUtil = require("validatorUtil");
	var service_common = require("service_common");
	var service_stock = require("service_stock");
	var service_credit = require("service_credit");
	var external = require("external");
    var _pageId = "#banking_transfer ";
    var action = "#transferIn ";
	var g_need_bank_passwd = false; // 是否需要银行密码
	var g_need_fund_passwd = false; // 是否需要资金密码
	var check_need_bank_passwd = false;// 是否需要银行密码  (余额查询)
	var check_need_fund_passwd = false;// 是否需要银行密码 (余额查询)
	var userInfo = null;
	var witchAccount = "";
	var whichPage = "";
	var money_types = {"0":"人民币","1":"美元","2":"港币"};
	
    /**
     * 初始化
     */
	function init(){
		$(_pageId).css("overflow-x","hidden");
		if(gconfig.platform != "0"){
			common.ssoLogin("",stockCallBack);
		}else{
			stockCallBack();
		}
    }
	
	// 普通交易登录信息回调
	function stockCallBack(){ 
		whichPage = appUtils.getSStorageInfo("whichPage"); //判断从那个页面跳转过来
		if(whichPage=="account/index"){
			$(_pageId + ".top_title .icon_back").text("交易");
		}else if(whichPage=="stock/stockHolding"){
			$(_pageId + ".top_title .icon_back").text("交易持仓");
		}else if(whichPage=="fund/fundHolding"){
			$(_pageId + ".top_title .icon_back").text("基金持仓");
		}else if(whichPage=="ggt/ggtHolding"){
			$(_pageId + ".top_title .icon_back").text("港股持仓");
		}else if(whichPage == "credit/asset/asset" || whichPage == "credit/order/mainOrder" || whichPage == "credit/transferred/collateralTransfer" || whichPage == "credit/query/financingQuery"){
			$(_pageId + ".top_title .icon_back").text("融资融券");
		}else{
			whichPage = "account/index";
			$(_pageId + ".top_title .icon_back").text("交易");
		}
		var ModuleName = appUtils.getPageParam("ModuleName");
		if(ModuleName && ModuleName=="me"){
			$(_pageId + ".top_title .icon_back").text("我");
		}
		witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
		if(witchAccount){
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}
		$(_pageId+"#moneyList").addClass("deleteBefore");
		queryAccount(); //查询存管银行
	}
	
	/**
	 * 事件绑定 
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
			e.stopPropagation();	// 阻止冒泡
		});
		//流水查询
		appUtils.bindEvent($(_pageId +".top_title .noicon_text"), function(e){
			appUtils.pageInit("banking/transfer","banking/transferHistory");
			e.stopPropagation();	// 阻止冒泡
		});
		//页面切换
		appUtils.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			resetBuyForm();
			$(this).addClass("active").siblings().removeClass("active");
			var showPage = "#"+$(this).attr("show-page");
			var hidePage = "#"+$(this).siblings().attr("show-page");
			action = showPage+" ";
			$(_pageId + hidePage).hide();
			$(_pageId + showPage).show();
			queryAccount();  //查询存管银行
			bindPageEvent(); //重新绑定事件
			e.stopPropagation(); // 阻止冒泡
		});
		//存管银行下拉框
		appUtils.bindEvent($(_pageId + action + "#bankList"), function(e){
			//$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+action+"#moneyList ul").hide();
			$(_pageId+action+"#bankList ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
/*		//币种下拉框
		appUtils.bindEvent($(_pageId + action + "#moneyList"), function(e){
			//$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+action+"#bankList ul").hide();
			$(_pageId+action+"#moneyList ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});*/
/*		//币种下拉框选择
		appUtils.bindEvent($(_pageId + action + "#moneyList ul li"),function(e){
			$(_pageId+action+"#moneyList").attr("value",$(this).attr("id"));
			$(_pageId+action+"#moneyList p").html($(this).find("a").html());
			queryBalance();
		});*/
		//提交转账
		appUtils.bindEvent($(_pageId + action + ".ce_btn a"),function(e){
			transferSubmit(); //提交转账
			e.stopPropagation();	// 阻止冒泡
		});
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			if($(_pageId + action + "#moneyList ul").is(':visible')){
				$(_pageId + action +" #moneyList ul").slideToggle("fast");
			}
			if($(_pageId + action+" #bankList ul").is(':visible')){
				$(_pageId + action+" #bankList ul").slideToggle("fast");
			}	
			e.stopPropagation();	// 阻止冒泡
		});
		
		//银行密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"banking_transfer", "eleId":"bank_password_out", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		//资金密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"banking_transfer", "eleId":"stock_password_out", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		//银行密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"banking_transfer", "eleId":"bank_password_in", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		//资金密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"banking_transfer", "eleId":"stock_password_in", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		//弹出密码输入框
		appUtils.bindEvent($(_pageId + "#checkmoeny"), function(e){
			if(!check_need_bank_passwd && !check_need_fund_passwd){
				$(_pageId + ".backdrop").hide();
				$(_pageId + ".pop_box").hide();
				checkEnblance();
			}else{
				$(_pageId + ".backdrop").show();
				$(_pageId + ".pop_box").show();
			}
			e.stopPropagation();	// 阻止冒泡
		});
		//余额查询
		appUtils.bindEvent($(_pageId + ".pop_box .pop_footer a:eq(0)"), function(e){
			$(_pageId + ".backdrop").hide();
			$(_pageId + ".pop_box").hide();
			var check_bank_password = $(_pageId+"#check_bank_password").val();
			var check_fund_password = $(_pageId+"#check_fund_password").val();
			if(check_bank_password == "" && check_need_bank_passwd){
				layerUtils.iMsg(-1,"请输入银行密码");
				return false ;
			}else if(check_bank_password.length!=6 && check_need_bank_passwd){
				layerUtils.iMsg(-1,"银行密码长度为6位数");
				return false ;
			}else if(check_fund_password == "" && check_need_fund_passwd){
				layerUtils.iMsg(-1,"请输入资金密码");
				return false;
			}else if(check_fund_password.length!=6 && check_need_fund_passwd){
				layerUtils.iMsg(-1,"资金密码长度为6位数");
				return false ;
			}else{
				checkEnblance();
			}
			e.stopPropagation();	// 阻止冒泡
		});
		//余额查询取消
		appUtils.bindEvent($(_pageId + ".pop_box .pop_footer a:eq(1)"), function(e){
			$(_pageId + ".backdrop").hide();
			$(_pageId + ".pop_box").hide();
			$(_pageId + "#check_bank_password").val("");
			$(_pageId + "#check_fund_password").val("");
			e.stopPropagation();	// 阻止冒泡
		});
		//银行密码输入框
		appUtils.bindEvent($(_pageId + "#check_bank_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"banking_transfer", "eleId":"check_bank_password", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();	// 阻止冒泡
		},"click");
		//密码输入框
		appUtils.bindEvent($(_pageId + "#check_bank_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();	// 阻止冒泡
		},"blur");
		//资金密码输入框
		appUtils.bindEvent($(_pageId + "#check_fund_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"banking_transfer", "eleId":"check_fund_password", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();	// 阻止冒泡
		},"click");
		//密码输入框
		appUtils.bindEvent($(_pageId + "#check_fund_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();	// 阻止冒泡
		},"blur");

	}
	
    /**
     * 获取开通转帐银行账号
     */
	function queryAccount(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var bank_code="";
		var money_type="";
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"bank_code":bank_code,
				"money_type":money_type,
				"account_type":witchAccount
		};
		service_common.queryAccounts(param,function(data){queryAccountCallBack(data,param);});
	}
	function queryAccountCallBack(data,param){
		if(data.error_no == 0){
			var results=data.results;
			if(results && results.length > 0){
				$(_pageId+"#bankList ul").remove();
				var bank_account = results[0].bank_account;
				if(bank_account.length>0){
					bank_account = bank_account.substring(0,4) + "****" +bank_account.substring(bank_account.length-4,bank_account.length);
				}
				$(_pageId+action+"#bankList p").html("<strong style=\"display:none;\" id="+results[0].fund_account+">"+bank_account+"</strong>"+results[0].bank_name);
				$(_pageId+action+"#moneyList p").html(money_types[results[0].money_type]);
				$(_pageId+action+"#moneyList").attr("value",results[0].money_type);
				$(_pageId+action+"#bankList").attr("value", results[0].bank_code+","+results[0].bank_account);
				var listHtml = "<ul style=\"display:none;\">";
				if("#transferOut "== action){
					queryBalance();
				};
				for(var i = 0;i < results.length; i++) {
					var bank_accounts = results[i].bank_account;
					if(bank_accounts.length>0){
						bank_accounts = bank_accounts.substring(0,4) + "****" +bank_accounts.substring(bank_accounts.length-4,bank_accounts.length);
					}
					listHtml += "<li id='"+results[i].bank_code+","+results[i].bank_account+"' data-type="+results[i].money_type+"><a href=\"javascript:void(0);\"><strong style=\"display:none;\" id="+results[i].fund_account+">"+bank_accounts+"</strong>"+results[i].bank_name+"</a></li>";
				};
				listHtml+="</ul>";
				$(_pageId+action+"#bankList").append(listHtml);
				param.transfer_direction = action == "#transferIn "?"0":"1"; // 转入方向	
				param.bank_code = results[0].bank_code; // 第一条记录银行代码	
				queryBankInfo(param); // 查询转账银行业务信息
				param.transfer_direction = "2"; // 转入方向	
				queryBankInfo(param); // 银行余额查询
				appUtils.bindEvent($(_pageId+action+"#bankList ul li"),function(){
					$(_pageId+action+"#bankList").attr("value",this.id);
					$(_pageId+action+"#bankList p").html($(this).find("a").html());
					console.log($(this).attr("data-type"));
					console.log(money_types[$(this).attr("data-type")]);
					$(_pageId+action+"#moneyList p").html(money_types[$(this).attr("data-type")]);
					$(_pageId+action+"#moneyList").attr("value",$(this).attr("data-type"));
					param.bank_code = this.id.split(",")[0]; // 选中银行卡代码
					param.transfer_direction = action == "#transferIn "?"0":"1"; // 转入方向	
					queryBankInfo(param); // 查询转账银行业务信息
					param.transfer_direction = "2"; // 转入方向	
					queryBankInfo(param); //银行余额查询
					if("#transferOut "== action){
						queryBalance();
					}
				    });
				}
			}else {
			   layerUtils.iAlert(data.error_info);
		    }
	}
	
	
	 /**
     * 保证金可转余额查询
     */
	function queryBalance(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var money_type = $(_pageId+action+"#moneyList").attr("value");//货币 ""所有货币，0 人民币，1 港币，2 美元
		var sessionid = userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"password":password,
				"money_type":money_type,
				"account_type":witchAccount
		};
		if(witchAccount=="credit_userInfo"){
			service_credit.rzrq_liabilitiesQuery(param,queryBalanceCallBack);
		}else{
			service_stock.queryFundSelect(param,queryBalanceCallBack);
		}
	}
	function queryBalanceCallBack(data){
		if(data.error_no == 0){
			var results=data.results[0];
			if(results){
				if(witchAccount=="credit_userInfo"){
					$(_pageId+action+".max strong").text(results.fetch_balance);
				}else{
					$(_pageId+action+".max strong").text(results.fetch_balance);
				}
			}
				
		}
	}
	
	 /**
     * 查询转帐银行业务信息 
     */
	function queryBankInfo(param){
		service_common.queryBankInfo(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0){
				var res = data.results[0];
				if(res){
					var transfer_direction = res.transfer_direction; // 转账方向
					var fund_password_flag = res.fund_password_flag; // 资金密码标志
					var bank_password_flag = res.bank_password_flag; // 银行密码标志
					// 银行转证券
					if(transfer_direction == 0){
						if(fund_password_flag == 1){
							g_need_fund_passwd = true; 
							$(_pageId+"#transferIn #stock_password_in").parent().show();
						}else{
							g_need_fund_passwd = false; 
							$(_pageId+"#transferIn #stock_password_in").parent().hide();
						}
						if(bank_password_flag == 1){
							g_need_bank_passwd = true;
							$(_pageId+"#transferIn #bank_password_in").parent().show();
						}else{
							g_need_bank_passwd = false;
							$(_pageId+"#transferIn #bank_password_in").parent().hide();
						}
					}else if(transfer_direction == 1){ // 证券转银行
						if(fund_password_flag == 1){
							g_need_fund_passwd = true;
							$(_pageId+"#transferOut #stock_password_out").parent().show();
						}
						else{
							g_need_fund_passwd = false;
							$(_pageId+"#transferOut #stock_password_out").parent().hide();
						}
						if(bank_password_flag == 1){
							g_need_bank_passwd = true;
							$(_pageId+"#transferOut #bank_password_out").parent().show();
						}
						else{
							g_need_bank_passwd = false;
							$(_pageId+"#transferOut #bank_password_out").parent().hide();
						}
					}else if(transfer_direction == 2){
						if(bank_password_flag == 1){
							check_need_bank_passwd = true;
							$(_pageId+"#bank_box").show();
						}else{
							check_need_bank_passwd = false;
							$(_pageId+"#bank_box").hide();
						}
						if(fund_password_flag == 1){
							check_need_fund_passwd = true;
							$(_pageId+"#fund_box").show();
						}else{
							check_need_fund_passwd = false;
							$(_pageId+"#fund_box").hide();
						}
					}
				}else{
					check_need_fund_passwd = false;
					check_need_bank_passwd = false;
				}
			}
			else{
				layerUtils.iLoading(false);
				layerUtils.iAlert(error_info);
			}
		});
	}
	
	 /**
     * 提交转账
     */
	function transferSubmit(){

		var moneyNum = $(_pageId+action+"#moneyNum").val(); // 转账金额
		var tipMsg = $(_pageId+action+".select_box p:eq(0)").text();
		if(moneyNum==""){
			layerUtils.iMsg(-1,"请输入转账金额");
			return false;
		}else if(!validatorUtil.isNumberFloat(moneyNum)){
			layerUtils.iMsg(-1,"转账金额请输入数字");
			return false;
		}
		if(action=="#transferOut "){
			var max_transfer=$(_pageId+action+".max strong").text(); //可转金额
			if($.trim(max_transfer).length<=0||parseFloat(max_transfer)<parseFloat(moneyNum)){
				layerUtils.iMsg(-1,"转账金额不足");
				return false;
			}
		}
		if(tipMsg == "选择银行"){
			layerUtils.iMsg(-1,"请选择银行");
			return false;
		}
		var fund_password = "";
		var bank_password = "";
		if(action=="#transferOut "){
			fund_password = $(_pageId+"#stock_password_out").val();	
//			bank_password = $(_pageId+"#bank_password_out").val();	
			if(fund_password == "" && g_need_fund_passwd){
				layerUtils.iMsg(-1,"请输入资金密码");
				return false;
			}else if(fund_password.length!=6 && g_need_fund_passwd){
				layerUtils.iMsg(-1,"资金密码长度为6位数");
				return false ;
			}
		}else{
//			fund_password = $(_pageId+"#stock_password_in").val();	
			bank_password = $(_pageId+"#bank_password_in").val();	
			if(bank_password == "" && g_need_bank_passwd){
				layerUtils.iMsg(-1,"请输入银行密码");
				return false ;
			}else if(bank_password.length!=6 && g_need_bank_passwd){
				layerUtils.iMsg(-1,"银行密码长度为6位数");
				return false ;
			}
		}
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				//将isShowWait关闭掉(圈)
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				$(_pageId + "#check_password").val("");
				return false;
			}else{
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				//为密码加密
				if(bank_password){
					bank_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(bank_password));
				}
				if(fund_password){
					fund_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(fund_password));
				}
				var bankInfo=$(_pageId+action+"#bankList").attr("value");
				var bankInfos=bankInfo.split(",");	
				var cust_code = userInfo.cust_code; // 客户代码
				var fund_account = userInfo.fund_account;
				var transfer_fund_account = $(_pageId+action+"#bankList p strong").attr("id");
				var branch_no  = userInfo.branch_no; // 分支机构
				var sessionid = userInfo.sessionid;
				var bank_code = bankInfos[0];
				var client_account = bankInfos[1];
				var money_type = $(_pageId+action+"#moneyList").attr("value");
				var transfer_direction="0";
		        var password =userInfo.password;
				if(action == "#transferOut "){
					transfer_direction = "1";
				}
				var tranamt=moneyNum;
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"sessionid":sessionid,
						"password":password,
						"bank_code":bank_code,
						"cust_code":cust_code,
						"transfer_fund_account":transfer_fund_account,
						"money_type":money_type,
						"transfer_direction":transfer_direction,
						"tranamt":tranamt,
						"fund_password":fund_password,
						"bank_password":bank_password,
						"client_account":client_account,
						"account_type":witchAccount
				};
				service_common.transfer(param,transferCallBack,{"isLastReq":true,"isShowWait":true});
			}
		},{"isLastReq":false});
	}
	function transferCallBack(data){
		if(data.error_no == 0){
			$(_pageId+action+"#moneyNum").val("");
			$(_pageId+action+"#password").val("");
			layerUtils.iAlert("转账请求已发送，流水号为："+data.results[0].serial_no+"<br/>可在转账查询中查询转账结果!");
			resetBuyForm();
			queryBalance();
		}else if(data.error_no == 10){
			$(_pageId+"#bank_password_out").val("");
			$(_pageId+"#stock_password_out").val("");
			layerUtils.iAlert(data.error_info);
		}else{
			resetBuyForm();
			queryBalance();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	 /**
    * 查询银行余额
    */
	function checkEnblance(){
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				//将isShowWait关闭掉(圈)
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				$(_pageId+"#check_bank_password").val();
				$(_pageId+"#check_fund_password").val();
				return false;
			}else{
				//获得旧密码和新密码
				var check_bank_password = $(_pageId+"#check_bank_password").val();
				var check_fund_password = $(_pageId+"#check_fund_password").val();
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				//为旧密码和新密码加密
				if(check_bank_password){
					check_bank_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(check_bank_password));
				}
				if(check_fund_password){
					check_fund_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(check_fund_password));
				}
				var bankInfo=$(_pageId+action+"#bankList").attr("value");
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var fund_account = userInfo.fund_account;	//资产账户
				var cust_code = userInfo.cust_code;
				var transfer_fund_account = $(_pageId+action+"#bankList p strong").attr("id");
				var branch_no  = userInfo.branch_no;	//分支机构
				var sessionid = userInfo.session_id;
				var password =userInfo.password;
				var bank_code = bankInfo.split(",")[0];
				var money_type = "0";  //  0：人民币，1：美元，2：港币
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"sessionid":sessionid,
						"password":password,
						"bank_code":bank_code,
						"cust_code":cust_code,
						"transfer_fund_account":transfer_fund_account,
						"money_type":money_type,
						"bank_password":check_bank_password,
						"fund_password":check_fund_password,
						"account_type":witchAccount
				};
				service_common.bankBalance(param,function(data){
					if(data.error_no == 0){
						var results = data.results[0];
						if(results){
							$(_pageId+"#enblance").text(results.fundeffect);
						}
					}else{
						layerUtils.iAlert(data.error_info);
					}
				});
			}
		
		},{"isLastReq":false});
	}
	
	//数据重置
	function resetBuyForm(){
		$(_pageId+"#moneyNum").val("");
		$(_pageId+"#enblance").text("");
		$(_pageId+"#bank_password_in").val("");
		$(_pageId+"#stock_password_in").val("");
		$(_pageId+"#bank_password_out").val("");
		$(_pageId+"#stock_password_out").val("");
		$(_pageId+"#moneyList ul").hide();
		$(_pageId+"#moneyList p").html("人民币");
		$(_pageId+"#bankList p").html("选择银行");
		$(_pageId+"#transferOut .max strong").text("");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		resetBuyForm();
		$(_pageId+"#bankList ul").remove();
		$(_pageId+"#enblance").text("");
		action="#transferIn ";
		$(_pageId + "#transferOut").hide();
		$(_pageId + "#transferIn").show();
		$(_pageId + ".toggle_nav ul li:eq(0)").addClass("active");
		$(_pageId + ".toggle_nav ul li:eq(1)").removeClass("active");
		g_need_bank_passwd = false; // 是否需要银行密码
		g_need_fund_passwd = false;// 是否需要资金密码
		external.callMessage({"moduleName":"trade","funcNo": "50211"});
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		var ModuleName = appUtils.getPageParam("ModuleName");
		if(ModuleName && ModuleName=="me"){
            var toPage = "";
            if(gconfig.platform == "2"){
                toPage={"prefix":"www/m/ygt","suffix":"me/bondAccount","ModuleName":"trade"};
            }else{
                toPage = gconfig.seaBaseUrl+"ygt/index.html#!/me/bondAccount.html?ModuleName=trade";
            }
            var param = {"funcNo":"50101","moduleName":"ygt","params":{"ModuleName":"trade","toPage":toPage}};
            external.callMessage(param);
            appUtils.pageInit("banking/transfer","account/index");
		}else{
			appUtils.pageInit("banking/transfer",whichPage,{});
		}
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});