/**
 * 交易模块公用 js
 */
define(function(require, exports, module) {
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig"); 
    var global = gconfig.global;
    var globalConfig = require("globalConfig");
    var external = require("external");
    var validata = require("validatorUtil");
    var	service_credit = require("service_credit");
    var service_common = require("service_common");
    var service_hq = require("service_hq");
    var commonFunc = require("commonFunc");
	var nativePluginService = require("nativePluginService");
	var logoutTimer = null; //登录超时定时检测定时器
	var fileUrl_red =  ["./css/common_red.css","./css/style_red.css"];
	var fileUrl_blue = ["./css/common_blue.css","./css/style_blue.css"];
	var getHqStateTimer = null;//获取行情服务状态定时器
	
	/**
	 * 绑定普通交易菜单事件
	 */
	function bindStockEvent(_pageId){
		appUtils.bindEvent($(_pageId+'.tab_nav ul li a'), function(e){
			var pageCode = _pageId.replace("#","").replaceAll("_","/").replace(" ","");
			var topage = $(this).attr("to-page").replaceAll("_","/"); //获取跳转的页面
			if(topage == "credit/transferred/collateralTransfer"){
				commonFunc.isAStockLogin();
			}else if((pageCode == "credit/asset/asset" && topage == "banking/transfer")|| (pageCode == "credit/order/mainOrder" && topage == "banking/transfer")
			|| (pageCode == "credit/transferred/collateralTransfer" && topage == "banking/transfer") || (pageCode == "credit/query/financingQuery" && topage == "banking/transfer")){
				appUtils.setSStorageInfo("whichAccount","credit_userInfo");
				appUtils.setSStorageInfo("whichPage",pageCode);
				appUtils.pageInit(pageCode,topage);	
			}else{
				appUtils.pageInit(pageCode,topage,{});	
			}
			e.stopPropagation();
		 });
	}
	
	/**
	 * 将数字转换为金钱格式
	 */
	function numToMoneyType(str){
		str = str + "";  //强制转换成字符串
		var sign = "";
		if(str < 0){
			sign = str.substring(0,1);
			str = str.substring(1,str.length);
		}
		var index = str.indexOf(".");
		var afterStr = "";
		if(index != -1){
			afterStr = str.substring(index,str.length);
			str = str.substring(0,index);
		}
		var len = str.length, 
		lastIndex, 
		arr = []; 
		while( len > 0 ){ 
		lastIndex = len; 
		len -= 3; 
		arr.unshift( str.substring(len, lastIndex) ); 
		} 
		return ""+sign + arr.join(',') + afterStr; 
	}

	/**
	 * 启动用户登录超时定时检测
	 * */
	function initLogoutTime(){
		//启动账户登录检测定时器
		if(logoutTimer != null){
			clearInterval(logoutTimer);
			logoutTimer = null;
		}
		logoutTimer = setInterval(function(){
			var lastDoTime=appUtils.getSStorageInfo("_lastDoTime");
			if(new Date().getTime() - lastDoTime > 1000*60*global.logoutTimeNum){   
				appUtils.clearSStorage("stock_userInfo"); 
				appUtils.clearSStorage("credit_userInfo");
				appUtils.setSStorageInfo("_isLoginIn","false");
				clearStateTime(); //清楚行情定时器
				layerUtils.iLayerClose();
				$(".top_title .logout").hide();
				appUtils.pageInit($("body #content div.page[data-display=block]").attr("id").replaceAll("_","/"),"account/index");
				clearInterval(logoutTimer);
				logoutTimer = null;
				if(gconfig.platform != "0"){
			       var param = {};
			       param["funcNo"] = "60400";
			       param["moduleName"] = gconfig.projName;
			       external.callMessage(param);
				}
			}
		},5000);//5秒检测一次
	}
	function clearLogoutTime(){
		if(logoutTimer != null)
		{
			clearInterval(logoutTimer);
			logoutTimer = null;
		}
	}
	
	
	/**
	 * 交易需要向后台传入如下格式的字符串，传入的接口比较多，因此写在 common 里面
	 * @param return 字符串 市场代码:账户类别:证券账户,市场代码:账户类别:证券账户,….
	 */
	function getStockAccountListStr(){
		var stockAccountListStr = [];
		var StockAccount = JSON.parse(appUtils.getSStorageInfo("StockAccount" , true));
		var keys = Object.keys(StockAccount);
		for(var i = 0, length = keys.length; i < length; i++){
			/**
			 * exchange_type	交易市场类别	0：深A，1：深B，2：沪A，3：沪B，4：三板，F1：郑州交易所，F2：大连交易所
			 * holder_kind	股东账户类别	0：普通账户, 1：基金账户 2：法人账户 3：回购账户 4：机构账户 5：报价转让
			 */
			var curStockStr = null;
			var exchange_type = StockAccount[keys[i]].exchange_type; // 市场代码
			var holder_kind = StockAccount[keys[i]].holder_kind; // 账户类别
			var stock_account = StockAccount[keys[i]].stock_account; // 证券账户
			curStockStr = exchange_type + ":" + holder_kind + ":" + stock_account;
			stockAccountListStr.push(curStockStr);
		}
		return stockAccountListStr.join(",");
	}
	
	/**
	 * 每个页面校验
	 */
	function checkPermission(checkInParam){
		return true;
	}
	
	/**
	 * 首次进入模块的时候，调用
	 */
	function firstLoadFunc(){
		//加载配置
		loadBus();
		
		
    	$("#loading").fadeOut(); //隐藏载入效果
    	external.callMessage({"funcNo": "50100", "moduleName":"trade"});
    	getURL(); //获取原生url
    	Number.prototype.toFixed=function (d) { 
    		var s=this+""; 
    	    if(!d)d=0; 
    		if(s.indexOf(".")==-1)s+="."; 
    		s+=new Array(d+1).join("0"); 
    		if(new RegExp("^(-|\\+)?(\\d+(\\.\\d{0,"+(d+1)+"})?)\\d*$").test(s)){
    			var s="0"+RegExp.$2,pm=RegExp.$1,a=RegExp.$3.length,b=true;
    			if(a==d+2){
    				a=s.match(/\d/g); 
    				if(parseInt(a[a.length-1])>4){
    					for(var i=a.length-2;i>=0;i--){
    						a[i]=parseInt(a[i])+1;
    						if(a[i]==10){
    							a[i]=0;
    							b=i!=1;
    						}else break;
    					}
    				}
    				s=a.join("").replace(new RegExp("(\\d+)(\\d{"+d+"})\\d$"),"$1.$2");
    			}if(b)s=s.substr(1); 
    			return (pm+s).replace(/\.$/,"");
    		}
    		return this+"";
    	};

	}
	
	function loadBus(){
		var isFinance = appUtils.getSStorageInfo("isFinance");
		if(isFinance){
			isFinance = JSON.parse(isFinance);
			filterFinance(isFinance);
			return false;
		}
		service_common.loadBus("",function(data){
			if(data.error_no == 0){
				var results = data.results[0];
				if(results["giveup"] == "0"){
					appUtils.setSStorageInfo("isShowNewShare","false");
				}else{
					appUtils.setSStorageInfo("isShowNewShare","true");
				}
				if(results["OTC"]){
					appUtils.setSStorageInfo("showfinance",results["OTC"]);
				}
				if(results["YYH"] == "0"){
					global.tradeList[12].isShow = "false";
				}else{
					global.tradeList[12].isShow = "show";
				}
				if(globalConfig.platform == "0"){
					
					
				}else if(globalConfig.platform == "1"){
					if(results["ANDROID"] == "0"){
						global.tradeList[5].isShow = "false";
					}else{
						global.tradeList[5].isShow = "true";
					}
				}else if(globalConfig.platform == "2"){
					if(results["IOS"] == "0"){
						global.tradeList[5].isShow = "false";
					}else{
						global.tradeList[5].isShow = "true";
					}
				}
				
				var items=global["tradeList"];
				for(var i=0;i<items.length;i++){   //根据配置隐藏相应的菜单项
					if(items[i].isShow=="false"){
						$("#account_index #"+items[i].id).hide(); 
					}else{
						$("#account_index #"+items[i].id).show(); 
					}
				}
			}
		},{"isShowWait":false});
	}
	
	//友盟统计
	function onEvent(tag, label, duration) {
	    prompt("event", JSON.stringify({tag:tag,label:label, duration:duration}));
	}

	function onKVEvent(tag, map, duration) {
	    map.id = tag;
	    map.duration = duration;

	    prompt("ekv", JSON.stringify( map ));
	}
	
	/**
	 * 判断激活
	 */
	function checkActive(callback){
		var token = "";
		//获取token
		if(gconfig.platform != "0"){
			token = external.callMessage({"funcNo":"50022"}).results[0].deviceToken;
		}else{
			token = "aabbccddeeffgg";
		}
		global.hardId = token+""; //获取硬件
		var activePhone ="";
		//获取activePhone
		if(gconfig.platform == "1"){
			activePhone = external.callMessage({"funcNo":"50043","key":"activePhone"}).results[0].value;
		}else if(gconfig.platform == "2"){
			activePhone = appUtils.getLStorageInfo("acitve_phone");
		}else{
			activePhone = appUtils.getLStorageInfo("acitve_phone");
		}
		global.activePhone = activePhone+""; //获取硬件
		if(activePhone && activePhone!="null"){
			var param = {
				"phone":activePhone,
				"hardsn":token
			};
			//查询客户是否激活
			service_common.queryBinDingCustomerPhone(param,function(data){
				if(data.error_no == 0){
					var results = data.results[0];
					if(typeof results != "undefined" && results != null && results != ""){
						var flag = results.flag;
						if(flag == 0 ){
							callback("false");
						}else{//激活不作处理
							callback("true");
						}
					}else{
						callback("false");
					}
				}else{
					callback("false");
				}
			});
		}else{
			callback("false");
		}
	}
	
	/**
	 * ios 解禁系统键盘
	 */
	function systemKeybord(){
		var curPageCode = appUtils.getSStorageInfo("_curPageCode").replaceAll("/","_");
//		var curPageCode = $("body #content div.page[data-display=block]").attr("id").replaceAll("/","_");
		$(function(){    //遍历
		   $("#"+curPageCode+" input").each(function(){
		      if($(this).attr("custom_keybord")=="0"){
		  		appUtils.bindEvent($(this), function(e){
		  			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":curPageCode, "eleId":"", "doneLable":"done", "keyboardType":"9"});
					e.stopPropagation();
				},"click");
		      }
		    });
		});
	}
	
	/**
	 * 登录超时
	 */
	function filterLoginOut(){
		layerUtils.iMsg("","登录超时,请重新登陆","");
		var sCurPage = appUtils.getSStorageInfo("_curPage");
		appUtils.clearSStorage();
		clearStateTime(); //清楚行情定时器
		var curPage = JSON.parse(sCurPage);
		var pageCode = curPage.pageCode;
		$(".top_title .logout").hide();
		external.callMessage({"funcNo": "60202"});
		appUtils.pageInit(pageCode,"account/index",{"topage":pageCode});
	} 
	
	/**
	 * 股票小数保留位数
	 */
	function decimalKeep(stockCode,callback){  //小数保留
		var KEEP_TWO = 2;
		var KEEP_THREE = 3;
		var stockStrParam = {
				"q" : stockCode
		};
	    service_hq.getStockList(stockStrParam,function(data){
	    	if(data.errorNo == "0"){
	    		var results = data.results;
				if(results && results.length > 0){
					var market = results[0][9];
					var stockCode = results[0][1];
					var param = {
					   "stock_list" : market+":"+stockCode
					};
					service_hq.getStockNowPrice(param,function(data){
						if(data.errorNo == "0"){
							var results = data.results;
							if(results && results.length>0){
								var stkType = results[0][10];  //行情类别
								var keyTwonum = [0,1,2,7,9,15,18,25,26,27]; //保留两位
								var step_flag = $.inArray(stkType, keyTwonum);
								var keepNum = KEEP_TWO;
								if(step_flag == -1){
									keepNum = KEEP_THREE;
								}else{
									keepNum = KEEP_TWO;
								}	
								var shbondType = [14,25,26,27,30]; //上海债券
								var szbondType = [6,21,22,23,24]; //深圳债券
								var shbond_flag = $.inArray(stkType, shbondType);
								var szbond_flag = $.inArray(stkType, szbondType);
								var is_bond = "0";
								if(shbond_flag != -1){
									is_bond = "1";
								}else if(szbond_flag != -1){
									is_bond = "2";
								}else{
									is_bond = "0";
								}
							    callback(keepNum,is_bond);
							}
						}else{
				    		layerUtils.iAlert("获取股票信息失败");
				    		return KEEP_TWO;
				    	}	
				    },{"isShowWait":false});
				}	
	    	}else{
	    		layerUtils.iAlert("获取股票信息失败");
	    		return KEEP_TWO;
	    	}
	    },{"isLastReq":false,"isShowWait":false});
	}
	
	/**
	 * 得到证券类型
	 */
	function getStockType(stkType){
		var typeName = "股票";
		var bondType = [6,14,21,22,23,24,25,26,27,30]; //债券
		var fundType = [3,4,11,12,19,20]; //基金
		var warrantType = [5,13]; //权证
		if($.inArray(stkType, bondType)!=-1){
			typeName = "债券";
		}else if($.inArray(stkType, fundType)!=-1){
			typeName = "基金";
		}else if($.inArray(stkType, warrantType)!=-1){
			typeName = "权证";
		}else{
			typeName = "股票";
		}
		return typeName;
	}
	
	/**
	 * IOS下拉卡屏问题
	 */
	function appDownStop(ev){
		appUtils.bindEvent($("body"),function(e){
			var touch = e.targetTouches[0] || event.targetTouches[0];
			var y = Number(touch.pageY); //页面触点Y坐标
			var yHeight = Number($(" #content").height());
			if(gconfig.platform == "2"){
				if(y >= (yHeight-1)){
					if($(_pageId + " .visc_flip").css("display") == "block"){
						if(vIscroll._init){
							vIscroll.scroll.refresh();
						}	        	
					}
				}
				if(y < 10){
					if($(_pageId + " .visc_flip").css("display") == "block"){
						if(vIscroll._init){
							vIscroll.scroll.refresh();
						}	        	
					}
				}
			}
		},"touchmove");
	}

	/**
	 * H5换肤
	 */
	function loadCSS(theme){  	
		var color = {
			'0': fileUrl_red,   // 红色
			'1': fileUrl_blue   // 蓝色
	    };
	    if(theme!="0"&&theme!="1" ){
	    	theme = "0";
	    }
	    var oHead = document.getElementsByTagName('head').item(0);
	    var fileUrl = color[theme];
	    for(var i=0;i<fileUrl.length;i++){
	    	var cssTag = document.getElementById(fileUrl+i);
	    	if (cssTag) oHead.removeChild(cssTag); 
	    	var ocss= document.createElement("link");
		    ocss.id= fileUrl+i;
		    ocss.href = fileUrl[i]; 
		    ocss.rel = "stylesheet"; 
		    ocss.charset= "uf-8";
	    	oHead.appendChild(ocss); 
	    }
	    //保存主题颜色
		if(gconfig.platform != "0"){
			external.callMessage({"funcNo":"50042","key":"theme","value":theme});
			appUtils.setLStorageInfo("theme",theme);
		}else{
			appUtils.setLStorageInfo("theme",theme);
		}
	}
	
	/**
	 * 启动行情服务器定时检测
	 * */
	function initStateTime(){
		//启动更新个股数据定时器
		if(getHqStateTimer != null){
			clearInterval(getHqStateTimer);
			getHqStateTimer = null;
		}
		getHqStateTimer = setInterval(function(){
			getHqState();
		}, 60000);//1分钟
	}
	
	/**
	 * 清除行情服务器定时检测
	 * */
	function clearStateTime(){
		//启动更新个股数据定时器
		if(getHqStateTimer != null){
			clearInterval(getHqStateTimer);
			getHqStateTimer = null;
			global.isTrade =  false;
		}
	}
	
	/**
	 * 获取行情服务器状态
	 * */
	function  getHqState(){
		service_hq.getHqState(null,getHqStateCallBack,{"isShowWait":false});
	}
	
	/**
	 * 获取行情服务器状态返回
	 * */
	function getHqStateCallBack(data){
		if(data != null ){
			var result = data.results;
			if(result.length>0){//取行情服务器时间
				var obj = result[0];
				var hvDate = Number(obj[2].toString().substring(0,8));
				var hqServerDate = Number(obj[1].toString().substring(0,8));
				var hqServerTime = Number(Number(obj[3].toString().substring(8,12)));
				if(hvDate != hqServerDate){
					global.isTrade =  false;
				}else{
					//判断行情服务器时间是否
					if((hqServerTime>928&&hqServerTime<1132)||(hqServerTime>1258&&hqServerTime<1502)){
						global.isTrade =  true;
					}else{
						global.isTrade =  false;
					}
				}
			}else{//取客户端时间
				var time = new Date().format("HHmmss");
				var timeNumber = parseFloat(time);
				if((93000 <= timeNumber && timeNumber <= 113000)||(130000 <= timeNumber && timeNumber <= 150000)){
					global.isTrade =  true;
				}
				else{
					global.isTrade =  false;
				}
			}
		}else{//取客户端时间
			var time = new Date().format("HHmmss");
			var timeNumber = parseFloat(time);
			if((93000 <= timeNumber && timeNumber <= 113000)||(130000 <= timeNumber && timeNumber <= 150000)){
				global.isTrade = true;
			}
			else{
				global.isTrade = false;
			}
		}
		global.isTrade = true;
	}
	
	/**
	 * 获取原生url
	 * */
	function  getURL(){
  	    //调原生获取最快的IP
        var tradeURL = external.callMessage({"moduleName":"trade","serverName":"TRADEURL","funcNo": "50112"});
		if(tradeURL && (tradeURL.error_no == 0) && tradeURL.results[0].url){
			var result = tradeURL.results[0].url;
			global.serverPathTrade = result+"/servlet/json";//交易地址
			global.serverPath = result+"/servlet/json";//统一登录
			global.validateimg = result+"/servlet/NewImage";//验证码
		}
		var newshareURL = external.callMessage({"moduleName":"trade","serverName":"NEWSHAREURL","funcNo": "50112"});
		if(newshareURL && (newshareURL.error_no == 0) && newshareURL.results[0].url){
			var result = newshareURL.results[0].url;
			global.newshareUrl = result+"/servlet/json";//新股
		}
		var hqURL = external.callMessage({"moduleName":"trade","serverName":"HQURL","funcNo": "50112"});
		if(hqURL && (hqURL.error_no == 0) && hqURL.results[0].url){
			var result = hqURL.results[0].url;
			global.HqUrl = result+"/market/json";//行情
		}
//		var unityURL = external.callMessage({"moduleName":"trade","serverName":"UNITY_LOGIN_SERVER_URL","funcNo": "50112"});
//		if(unityURL && (unityURL.error_no == 0)){
//			var result = unityURL.results[0].url;
//			global.serverPath = result;//统一登录
//		}  
	}
	
	// 自定义弹出层
	function btnConfirm(conMsg, yesFunc, noFunc, yesBtnWords, noBtnWords){
		    var iAlertIdx = -9999;
			var viewContent ="<div class=\"backdrop\" style=\"display:block;\"></div>";
			viewContent +="<div class=\"pop_box pop_cancel pop\" id=\"pop_tip_confirm\" style=\"top:40%;display:block\">";
			viewContent += conMsg;
			viewContent +="    <div class=\"pop_footer\">";
			viewContent +="   	<div class=\"pop_btn two\">";
			viewContent +="  		<a href=\"javascript:void(0);\" id=\"pop_tip_confirm_yes\">"+(yesBtnWords||"确 定")+"</a><a href=\"javascript:void(0);\" id=\"pop_tip_confirm_no\">"+(noBtnWords||"取消")+"</a>";
			viewContent +="     </div>";
			viewContent +="   </div>";
			viewContent +="</div>";
			var iConfirmLayer = function(){
				return $.layer({
					type: 1,
					title: false,
					closeBtn: false,
					shade : [0.5 , '#000' , true],
					border: [5, 0.5, '', true],
					area: ['310px','auto'],
					offset: [($(window).height()*0.3)+'px', ''],
					page: {
						html: viewContent
					},
					success: function(iLayer) {
						window.ontouchmove = stopDefaultAction;
						var eType = gconfig.triggerEventName;
						$x("pop_tip_confirm", "pop_tip_confirm_yes").off(eType);
						$x("pop_tip_confirm", "pop_tip_confirm_yes").on(eType, function() {
							try{layer.close(iAlertIdx);}catch(e){};
							p = -9999;
							if(yesFunc){ yesFunc(); }
						});
						$x("pop_tip_confirm", "pop_tip_confirm_no").off(eType);
						$x("pop_tip_confirm", "pop_tip_confirm_no").on(eType, function() {
							try{layer.close(iAlertIdx);}catch(e){};
							p = -9999;
							if(noFunc){ noFunc(); }
						});
						$("#pop_tip_confirm").css("margin-top","-"+($("#pop_tip_confirm").height()/2)+"px");
					},
					end: function() {window.ontouchmove = null;}
				});
			};
			if(iAlertIdx == -9999) { //如果没有iConfirm层
				iAlertIdx = iConfirmLayer();
			} else { //存在iConfirm层，先关闭前面那个iConfirm层，再弹出新的iConfirm层
				try{layer.close(iAlertIdx);}catch(e){};
				iAlertIdx = iConfirmLayer();
			}
	}
	
	/**
	 * 阻止默认事件的行为
	 * @param e
	 */
	function stopDefaultAction(e){
		if(e && e.preventDefault) {
			e.preventDefault();
		} else {
			window.event.returnValue = false;
		}
	}
	
	/**
	 * h5与原生交互 无回调
	 */
	function nativePlugin(param){
		var funcName = "function" + param.funcNo;
		nativePluginService[funcName](param);
	}
	
	/**
	 * h5与原生交互 有回调
	 */
	function nativePluginBack(param,key){
		var result = "";
		var funcName = "function" + param.funcNo;
		var dataSet = nativePluginService[funcName](param); // 获取应用配置
		if(dataSet.error_no == 0){
			result = dataSet.results[0].key;
		}
		return result;
	}
       
       /**
        * 保存用户信息
        */
       function saveSessionUserInfo(userInfo)
       {
       appUtils.setSStorageInfo("stock_userInfo",JSON.stringify(userInfo[0]));
//       console.log(userInfo);
       }
	
   	
       /**
        * 删除用户信息
        */
       function clearSessionUserInfo(){
           appUtils.clearSStorage();
           $("#account_index .user_value2").hide();
   		   $("#account_index .user_value").show();
           $("#account_index .user_value2 .mobile_num").text("--");
   		   $("#account_index .user_value2 strong:eq(0)").text("--"); // 总资产
   		   $("#account_index .user_value2 .more_info ul li:eq(0) strong").text("--");  // 当日盈亏 
   		   $("#account_index .user_value2 .more_info ul li:eq(1) strong").text("--");  // 总盈亏
   		   var height_Up = $(window).height() - $("#account_index .header").height() - $("#account_index .trade_nav").height() - $("#account_index .user_value").height()-15;
   		   $("#account_index .main .trade_nav2").css("overflow-y","auto");
   		   $("#account_index .main .trade_nav2").height(height_Up); //查询目录添加高度
   		   if($("body>#afui div.page[data-display=block]").attr("id") != "account_index"){
   			appUtils.pageInit("","account/index");
   		   }       
       }
          
       /**
        *处理模拟登陆失败
        */
   	   function ssoLoginFailed(data){
          //这里可以加一些逻辑处理，根据返回的错误号，目前，我这里默认处理是：弹出提示信息，跳到登陆页面
          //弹出提示信息，跳到登陆页面
          layerUtils.iAlert(data.error_info);
          require.async("sso",function(module){
               if(module.checkLoginRight()){
                   module.goTologin();
               }
           });
       }

   	   function ssoLogin(pageCode,callBackFunc){
			// 本地session为空，需要进行模拟登陆
			var resultVo = nativePluginService.function50041({"key":"temp_token_" + gconfig.projName});
			var token = resultVo.results[0].value;
			if(!token || token.length == 0){
				reBuildSsoToken();
				return false;
			}
			var stock_userInfo = appUtils.getSStorageInfo("stock_userInfo");
			if(stock_userInfo){  // 如果已经取到用户信息则不再调用接口
				 if(callBackFunc){ // 执行回调方法
				 	callBackFunc();
				 }
				 if(pageCode == "credit/asset/asset"){  // 融资融券和港股通权限校验
					 commonFunc.creditLogin();
                 }else if(pageCode == "ggt/ggtBuy"){
                	 commonFunc.checkGGTPermission();
                 }
			}else{
				appUtils.invokeServer(global.serverPath, {"funcNo":"600001","temp_token":token}, function(data){
					if(data.error_no == 0){
						appUtils.setSStorageInfo(gconfig.projName + "_login_token",token);
						appUtils.setSStorageInfo("_isLoginIn","true");
						nativePluginService.function50040({"key": gconfig.projName + "_login_state","value":"1"});
						saveSessionUserInfo(data.results);
						if(callBackFunc){
							callBackFunc();
						}
						if(pageCode == "credit/asset/asset"){ // 融资融券和港股通权限校验
							 appUtils.pageInit(null,"account/index",{}); // 先刷新首页
							 commonFunc.creditLogin();
		                }else if(pageCode == "ggt/ggtBuy"){
		                	 appUtils.pageInit(null,"account/index",{}); // 先刷新首页
		                	 commonFunc.checkGGTPermission();
		                }
					}else if(data.error_no == -501031) {
						reBuildSsoToken();
					}else{
						nativePluginService.function50040({"key":"temp_token_" + gconfig.projName,"value":""});
						ssoLoginFailed(data);
					}
			   },true,true);	
			}
		}

		/**
		 *  @return 重构SSO的Token
		 */
	   function reBuildSsoToken(pageCode){
		  var param = {};
		  param["funcNo"] = "60402";
		  param["moduleName"] = gconfig.projName;
		  if(pageCode){
		   param["toPage"] = pageCode;
		  }
		  external.callMessage(param);
	   }
	   
		//左右滑动
		function FixTable(TableID, FixColumnNumber, width, height) {

		    if ($("#" + TableID + "_tableLayout").length != 0) {
		        $("#" + TableID + "_tableLayout").before($("#" + TableID));
		        $("#" + TableID + "_tableLayout").empty();
		    }
		    else {
		        $("#" + TableID).after("<div id='" + TableID + "_tableLayout' style='overflow:hidden;height:" + height + "px; width:" + width + "px;'></div>");
		    }
		    $('<div id="' + TableID + '_tableFix"></div>'
		    + '<div id="' + TableID + '_tableHead"></div>'
		    + '<div id="' + TableID + '_tableColumn"></div>'
		    + '<div id="' + TableID + '_tableData"></div>').appendTo("#" + TableID + "_tableLayout");
		    var oldtable = $("#" + TableID);
		    var tableFixClone = oldtable.clone(true);
		    tableFixClone.attr("id", TableID + "_tableFixClone");
		    $("#" + TableID + "_tableFix").append(tableFixClone);
		    var tableHeadClone = oldtable.clone(true);
		    tableHeadClone.attr("id", TableID + "_tableHeadClone");
		    $("#" + TableID + "_tableHead").append(tableHeadClone);
		    var tableColumnClone = oldtable.clone(true);
		    tableColumnClone.attr("id", TableID + "_tableColumnClone");
		    $("#" + TableID + "_tableColumn").append(tableColumnClone);
		    $("#" + TableID + "_tableData").append(oldtable);
		    $("#" + TableID + "_tableLayout table").each(function () {
		        $(this).css("margin", "0");
		    });
		    var HeadHeight = $("#" + TableID + "_tableHead thead").height();
		    HeadHeight += 2;
		    $("#" + TableID + "_tableHead").css("height", HeadHeight);
		    $("#" + TableID + "_tableFix").css("height", HeadHeight);
		    var ColumnsWidth = 0;
		    var ColumnsNumber = 0;
		    $("#" + TableID + "_tableColumn tr:last td:lt(" + FixColumnNumber + ")").each(function () {
		        ColumnsWidth += $(this).outerWidth(true);
		        ColumnsNumber++;
		    });
		    ColumnsWidth += 2;
		    if ($.browser.msie) {
		        switch ($.browser.version) {
		            case "7.0":
		                if (ColumnsNumber >= 3) ColumnsWidth--;
		                break;
		            case "8.0":
		                if (ColumnsNumber >= 2) ColumnsWidth--;
		                break;
		        }
		    }
		    $("#" + TableID + "_tableColumn").css("width", ColumnsWidth);
		    $("#" + TableID + "_tableFix").css("width", ColumnsWidth);
		    $("#" + TableID + "_tableData").scroll(function () {
		        $("#" + TableID + "_tableHead").scrollLeft($("#" + TableID + "_tableData").scrollLeft());
		        $("#" + TableID + "_tableColumn").scrollTop($("#" + TableID + "_tableData").scrollTop());
		    });
		    $("#" + TableID + "_tableFix").css({ "overflow": "hidden", "position": "relative", "z-index": "50","background-color": "white" });
		    $("#" + TableID + "_tableHead").css({ "overflow": "hidden",  "position": "relative", "z-index": "45", "background-color": "white" });
		    $("#" + TableID + "_tableColumn").css({ "overflow": "hidden", "height": height, "position": "relative", "z-index": "40", "background-color": "white" });
		    $("#" + TableID + "_tableData").css({ "overflow": "scroll", "width": width, "height": height, "position": "relative", "z-index": "35" });
		    if ($("#" + TableID + "_tableHead").width() > $("#" + TableID + "_tableFix table").width()) {
		        $("#" + TableID + "_tableHead").css("width", $("#" + TableID + "_tableFix table").width());
		        $("#" + TableID + "_tableData").css("width", $("#" + TableID + "_tableFix table").width() + 17);
		    }
		    if ($("#" + TableID + "_tableColumn").height() > $("#" + TableID + "_tableColumn table").height()) {
		        $("#" + TableID + "_tableColumn").css("height", $("#" + TableID + "_tableColumn table").height());
		        $("#" + TableID + "_tableData").css("height", $("#" + TableID + "_tableColumn table").height());
		    }
		    $("#" + TableID + "_tableFix").offset($("#" + TableID + "_tableLayout").offset());
		    $("#" + TableID + "_tableHead").offset($("#" + TableID + "_tableLayout").offset());
		    $("#" + TableID + "_tableColumn").offset($("#" + TableID + "_tableLayout").offset());
		    $("#" + TableID + "_tableData").offset($("#" + TableID + "_tableLayout").offset());
		}

		
		/**
		 * 理财账户登录交易
		 */
		function filterFinance(data)
		{
			 if(data.error_no == "-985")
		       {
				 nativePluginService.function50040({"key":"temp_token_" + gconfig.projName,"value":""});
				 clearSessionUserInfo();
				 appUtils.setSStorageInfo("isFinance",JSON.stringify(data));			 
				 layerUtils.iAlert(data.error_info,0,function(){
		        	  external.callMessage({"moduleName":"com.cairh.app.sjkh.sc","funcNo": "50101"});		        	  
		          });	          
		       }
		}
	   

       var base = {
    	"bindStockEvent":bindStockEvent,
    	"numToMoneyType":numToMoneyType,
    	"filterLoginOut":filterLoginOut,
    	"firstLoadFunc" : firstLoadFunc,
    	"filterFinance":filterFinance,
    	"checkPermission":checkPermission,
    	"systemKeybord" :systemKeybord,
    	"getStockAccountListStr":getStockAccountListStr,
    	"initLogoutTime":initLogoutTime,
		"initStateTime":initStateTime,
		"clearStateTime":clearStateTime,
    	"decimalKeep":decimalKeep,
    	"appDownStop":appDownStop,
    	"loadCSS":loadCSS,
    	"btnConfirm":btnConfirm,
    	"getStockType":getStockType,
    	"nativePlugin":nativePlugin,
    	"nativePluginBack":nativePluginBack,
        "saveSessionUserInfo":saveSessionUserInfo,
        "clearSessionUserInfo": clearSessionUserInfo,
    	"ssoLoginFailed": ssoLoginFailed,
    	"ssoLogin": ssoLogin,
    	"FixTable":FixTable,
    	"onEvent":onEvent,
    	"loadBus":loadBus
    };

    module.exports = base;
});