/**
 * 交易模块公用方法js  （涉及到业务接口的调用）
 */
define(function(require, exports, module) {
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var external = require("external");
	var validata = require("validatorUtil");
	var service_common = require("service_common");
	var service_stock = require("service_stock");
	var service_ggt = require("service_ggt");
	var service_credit = require("service_credit");
	var service_fund = require("service_fund");
	
	/*==========================================普通交易持仓公共方法================================================ */
    /**
	 * 普通交易证券持仓查询
	 */
	function queryPosition(pageId,whichPage){
		 return function() {//为了解决定时器不能传参数的问题	 
			var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password =  userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid,
			    "password":password
			};
			service_stock.queryStockData(param,function(data){
				if (data && data != "undefined") {
					if(data.error_no == 0){
						var results = data.results;
						if(results && results.length>0){
							var total_cost_balance = 0;//持仓数量X持仓成本
							var total_last_price = 0; //持仓数量X最新价
							var data = "<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>";
							var float_yk = 0; //浮动盈亏
							for (var i=0;i<results.length;i++){ 
								 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
								 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
								 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
								 data += queryPositionHTML_stock(results[i]);
							}
							$(pageId+".fund_table .ce_table").html(data);
							$(pageId+".no_data").hide();
							
							//添加总浮动盈亏
							var css = "";
							//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
							if(float_yk > 0){
								float_yk = "+" + float_yk.toFixed(2);
								css = "ared";
							}else if(float_yk < 0){
								float_yk = "" + float_yk.toFixed(2);
								css = "agreen";
							}else{
								float_yk = "" + float_yk.toFixed(2);
								css = "";
							}
							$(pageId+".hold_table tr:eq(0) td:eq(1) strong").text(float_yk).attr("class",css);//盈亏
							//卖出事件
							appUtils.bindEvent($(pageId+".fund_table .ce_table tr"), function(e){
								var stock_code = $(this).attr("id");
								var topage = "";
								//点击卖出,跳转到买卖页面.
								if(whichPage==1){
									topage = "stock/stockBuy";
								}else if(whichPage==2){
									topage = "stock/stockSell";
								}else{
									topage = "stock/stockSell";
								}
								appUtils.pageInit("stock/stockHolding",topage,{"stockCode":stock_code});
								e.stopPropagation();
							},"click");
						}else{ 
							$(pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
							$(pageId+".no_data").show();
						}
					}else{
						$(pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
						$(pageId+".no_data").show();
						layerUtils.iAlert(data.error_info);
					}
				}else{
					$(pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
					$(pageId+".no_data").show();
					layerUtils.iAlert("查询失败");
				}
				
			},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		 };
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element){
		var price_digit = 0;
		if(element.exchange_type === "3"){
			price_digit = 3;
		}else{
			price_digit = 2;
		}
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
			float_yk = float_yk.toFixed(2);
		}
        var eleHtml = "";
        eleHtml+="<tr id="+element.stock_code +">";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.market_value +"</small></td>";
        eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+element.float_yk_per+"%</span></td>";
        eleHtml+="<td>"+Number(element.cost_amount)+"<br/>"+Number(element.enable_amount)+"</td>";
        eleHtml+="<td>"+Number(element.cost_price).toFixed(price_digit)+"<br/>"+Number(element.last_price).toFixed(price_digit)+"</td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	
	/*==========================================信用交易持仓公共方法================================================ */
	/**
	 * 信用交易证券持仓查询
	 */
	function queryHolding(pageId,whichPage){
		 return function() {//为了解决定时器不能传参数的问题	 
				var userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var branch_no  = userInfo.branch_no;	//分支机构
				var fund_account = userInfo.fund_account;	//资产账户
				var cust_code = userInfo.cust_code;	//客户代码
				var sessionid= userInfo.session_id;
				var password = userInfo.password;
				var stock_account ="";
				var stock_code = "";
				var exchange_type = "";
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"stock_account":stock_account,
						"stock_code":stock_code,
						"exchange_type":exchange_type,
						"password":password
				};
				service_credit.cc_query(param,function(data){
					if (data && data != "undefined") {
						if(data.error_no == 0){
							$(pageId+".no_data").hide();
							var results = data.results;
							if(results && results.length>0){
								var total_cost_balance = 0;//持仓数量X持仓成本
								var total_last_price = 0; //持仓数量X最新价
								var data = "<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>";
								var float_yk = 0; //浮动盈亏
								for (var i=0;i<results.length;i++){ 
									 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
									 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
									 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
									 data += queryPositionHTML_credit(results[i]);
								}
								$(pageId+".fund_table .ce_table").html(data);
								
								//添加总浮动盈亏
								var css = "";
								//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
								if(float_yk > 0){
									float_yk = "+" + float_yk.toFixed(2);
									css = "ared";
								}else if(float_yk < 0){
									float_yk = "" + float_yk.toFixed(2);
									css = "agreen";
								}else{
									float_yk = "" + float_yk.toFixed(2);
									css = "";
								}
								$(pageId+".hold_table tr:eq(0) td:eq(1) strong").text(float_yk).attr("class",css);//盈亏
								//卖出事件
								appUtils.bindEvent($(pageId+".fund_table .ce_table tr"), function(e){
									var stock_code = $(this).attr("id");
									var topage = "";
									//点击卖出,跳转到买卖页面.
									if(whichPage==1){
										topage = "credit/order/ordinaryToBuy"; //普通买入
									}else if(whichPage==2){
										topage = "credit/order/ordinaryToSell"; //普通卖出
									}else if(whichPage==3){
										topage = "credit/order/sellTicketsRepayment"; //卖券还款
									}else if(whichPage==4){
										topage = "credit/order/buyTicketsRepay"; //买券还券
									}else if(whichPage==5){
										topage = "credit/order/financingToBuy"; //融资买入
									}else if(whichPage==6){
										topage = "credit/order/financingToSell"; //融券卖出
									}
									appUtils.pageInit("",topage,{"stockCode":stock_code});
									e.stopPropagation();
								},"click");
							}else{  
								$(pageId+".no_data").show();
							}
						}
						else{
							layerUtils.iAlert(data.error_info);
						}
					}
					else{
						  layerUtils.iAlert("查询失败");
					}
				},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		 };
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_credit(element){
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		var float_yk_per = element.float_yk_per;//浮动盈亏%
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
			float_yk = float_yk.toFixed(2);
		}
        var eleHtml = "";
        eleHtml+="<tr id="+element.stock_code +">";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.market_value +"</small></td>";
        eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+float_yk_per+"%</span></td>";
        eleHtml+="<td>"+Number(element.cost_amount)+"<br/>"+Number(element.enable_amount)+"</td>";
        eleHtml+="<td>"+Number(element.cost_price).toFixed(2)+"<br/>"+Number(element.last_price).toFixed(2)+"</td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	/*==========================================港股持仓公共方法================================================ */
	 /**
	 * 港股通证券持仓查询
	 */
	function queryPosition_ggt(pageId,whichPage){
		 return function() {//为了解决定时器不能传参数的问题	 
			var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid,
			    "password":password
			};
			service_ggt.queryHolding_ggt(param,function(data){
				if (data && data != "undefined") {
					if(data.error_no == 0){
						$(pageId+".no_data").hide();
						var results = data.results;
						var data = "<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>";
						if(results && results.length>0){
							var total_cost_balance = 0;//持仓数量X持仓成本
							var total_last_price = 0; //持仓数量X最新价
							var float_yk = 0; //浮动盈亏
							for (var i=0;i<results.length;i++){ 
								 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
								 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
								 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
								 data += queryPositionHTML_ggt(results[i]);
							}
							$(pageId+".fund_table .ce_table").html(data);
							
							//添加总浮动盈亏
							var css = "";
							//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
							if(float_yk > 0){
								float_yk = "+" + float_yk.toFixed(2);
								css = "ared";
							}else if(float_yk < 0){
								float_yk = "" + float_yk.toFixed(2);
								css = "agreen";
							}else{
								float_yk = "" + float_yk.toFixed(2);
								css = "";
							}
							$(pageId+".hold_table tr:eq(0) td:eq(1) strong").text(float_yk).attr("class",css);//盈亏
							//卖出事件
							appUtils.bindEvent($(pageId+".fund_table .ce_table tr"), function(e){
								var stock_code = $(this).attr("id");
								var topage = "";
								//点击卖出,跳转到买卖页面.
								if(whichPage==1){
									topage = "ggt/ggtBuy";
								}else if(whichPage==2){
									topage = "ggt/ggtSell";
								}else{
									topage = "ggt/ggtSell";
								}
								appUtils.pageInit("ggt/ggtHolding",topage,{"stockCode":stock_code});
								e.stopPropagation();
							},"click");
						}else{  
							$(pageId+".no_data").show();
						}
					}
					else{
						layerUtils.iAlert(data.error_info);
					}
				}
				else{
					  layerUtils.iAlert("查询失败");
				}
			},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		 };
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_ggt(element){
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		var float_yk_per = Number(element.float_yk_per);//浮动盈亏%
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			float_yk_per = "+" + float_yk_per.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<tr id="+element.stock_code +">";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.market_value +"</small></td>";
        eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+float_yk_per+"%</span></td>";
        eleHtml+="<td>"+Number(element.hold_amount)+"<br/>"+Number(element.enable_amount)+"</td>";
        eleHtml+="<td>"+Number(element.cost_balance)+"<br/>"+Number(element.last_price)+"</td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	
	/*==========================================普通交易划转登录公共方法================================================ */
	/**
	 * 点击划转获取客户登陆信息
	 */
	function isAStockLogin(callBack){
		var stock_userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var credit_userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		var serverConfig = global.serverConfig;
		var stockInfo = JSON.parse(appUtils.getSStorageInfo("stockInfo"));
		if(serverConfig=="1" || stockInfo){
			var curPageCode = appUtils.getSStorageInfo("_curPageCode");
			if(callBack){
				callBack();
			}else{
				appUtils.pageInit(curPageCode, "credit/transferred/collateralTransfer");
			}
		}else{
	    	var param = {
				entrust_way: global.entrust_way, // 委托方式  在configuration配置
				branch_no: credit_userInfo.branch_no, // 分支机构
				cust_code: credit_userInfo.cust_code, // 客户编号
				fund_account:credit_userInfo.fund_account,//资金账号（普通）
				password: credit_userInfo.password, // 交易密码
				sessionid: credit_userInfo.session_id, // 会话号
			};
	    	service_credit.queryStockAccount(param,function(data){
	    		if(data.error_no == "0"){
	    			var data = data.results[0];
	    			if(data && (!stock_userInfo || stock_userInfo.cust_code!=data.client_id || stock_userInfo.fund_account!=data.fund_account)){
	    				var pdwBox = "";
	    				pdwBox += "<div class='cover_layer' id='inputPopLayer'>";
	    				pdwBox +=	"<div class='pop_confirm2' style='margin-top: -104px;'>";
	    				pdwBox += 		"<div style=\"  height: 0.36rem;line-height: 0.36rem;border-bottom: 1px solid #CBCBCB;\">";
	    				pdwBox +=			"<h3 style=\"color: #1199EE;\">登录普通交易</h3>";
	    				pdwBox += 		"</div>";
	    				pdwBox +=		"<div class='pop_main' style='border-bottom: 1px solid #CBCBCB;'>";
	    				pdwBox +=			"<div class='input_text2 mt10' style='border:none;'>";
	    				pdwBox +=				"<span style='  text-align: left;margin-left: 10px;'>资金帐号:</span>";
	    				pdwBox +=				"<div style='font-size: 16px;'id='custNo'>"+data.fund_account+"</div>";
	    				pdwBox +=			"</div>";
	    				pdwBox +=			"<div class='input_text2 mt10' style='padding-right: 20px;border:none;'>";
	    				pdwBox +=				"<span style='  text-align: left;margin-left: 10px;'>密&nbsp;&nbsp;&nbsp;&nbsp;码:</span>";
	    				pdwBox +=				"<input type='password' class='input_custom2' id='pwdInput' placeholder='请输入普通交易密码' maxlength='12' readonly='readonly' >";
	    				pdwBox +=			"</div>";
	    				pdwBox +=		 "</div>";
	    				pdwBox +=		 "<div class='btn' style='height: 45px; padding: 0px;'>";
	    				pdwBox +=			 "<a href='javascript:void(0)' id='confirm' style='height: 45px; line-height: 45px; width: 50%;background:rgb(242, 242, 242);color: #1199EE;'>确定</a>";
	    				pdwBox +=			 "<a href='javascript:void(0)' id='cancel' style='height: 45px; line-height: 45px; width: 50%; color: rgb(51, 51, 51); background: white;'>取消</a>";
	    				pdwBox +=		 "</div>";
	    				pdwBox +=	 "</div>";
	    				pdwBox += "</div>";
	    				$("body").append(pdwBox);
	    				setTimeout(triggerClick,500);
	    				//取消按钮
	    				appUtils.bindEvent($("#cancel"), function(e){
	    					$(" #inputPopLayer").remove();
	    					e.stopPropagation();
	    				},"click");
	    				//确定按钮
	    				appUtils.bindEvent($("#confirm"), function(e){
	    					stockALogin(data,"0",callBack);
	    					e.stopPropagation();
	    				},"click");
	    				//密码输入框调用原生键盘
	    				appUtils.bindEvent($("#pwdInput"),function(e){
	    					external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"inputPopLayer", "eleId":"pwdInput", "doneLable":"done", "keyboardType":"4"});
	    					e.stopPropagation();
	    				},"click");
	    				//失去焦点关闭原生键盘
	    				appUtils.bindEvent($("#pwdInput"),function(e){
	    					external.callMessage({"moduleName":"trade","funcNo": "50211"});
	    					e.stopPropagation();
	    				},"blur");
	    			}else{
	    				stockALogin(data,"1",callBack);
	    			}
	    		}else{
	    			layerUtils.iAlert(data.error_info);
	    		}		
	    	});
		}

	}
	/**
	 * 模拟点击
	 */
	function triggerClick(){
		$("#pwdInput").trigger("click");
		$("#pwdInput").focus();
	}
	/**
	 * 普通A股登陆
	 */
	function stockALogin(dataInfo,type,callBack){
		var stock_pwd = "";
		if(type=="0"){
			if(!checkInput()){
				return false;
			};
		}else{
			stock_pwd = JSON.parse(appUtils.getSStorageInfo("stock_userInfo")).password;
		}
		var credit_userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		var custNo = credit_userInfo.cust_code;
		var pwd = $("#pwdInput").val();
		//密码加密
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				return false;
			}else{
				//参数固定,是密码加密的参数
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				if(pwd){
					pwd = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(pwd));
				}else{
					pwd = stock_pwd;
				}
				var params = {
					entrust_way: global.entrust_way, // 委托方式  在configuration配置
					branch_no: dataInfo.branch_no, // 分支机构
					cust_code: dataInfo.client_id, // 客户编号
					fund_account:dataInfo.fund_account,//资金账号（普通）
					sessionid: dataInfo.session_id, // 会话号
					stock_account: dataInfo.stock_account, // 证券账号
					stock_code: "", // 股票代码
					exchange_type: dataInfo.exchange_type,
    	    	};
				var curPageCode = $("body #content div.page[data-display=block]").attr("id").replaceAll("_","/");
				var params_stock =JSON.stringify(params);
				appUtils.setSStorageInfo("stockInfo",params_stock);
				if(callBack){
					callBack();
				}else{
					appUtils.pageInit(curPageCode, "credit/transferred/collateralTransfer");
				}
				//loginFuc(); // 调用登录接口
			}
		});
//		var loginFuc = function(){
//			var loginParam = {
//    				"entrust_way" : global.entrust_way, // 委托方式  在configuration配置   // 委托方式
//    				"branch_no" : "",  // 营业部编号
//    				"input_type" : "5",  // 账号类型
//    				"input_content" : custNo,  // 登录账号
//    				"password" : pwd,  // 交易密码
//    				"ticket" : '',  // 图片验证码
//    				"mobileKey" : '',  // 验证码的 mobileKey
//    				"ticketFlag" : "0", // 0 不需要验证码 1 需要验证码
//    				"content_type" : ""  // 客户标识类型
//    		};
//    	service_credit.goodsSwitchTradeLogin(loginParam,function(data){
//			if(data.error_no != 0){
//					$("#pwdInput").val("");
//					layerUtils.iLoading(false);
//					layerUtils.iAlert(data.error_info);
//					return false;
//			}else{
//				if(data.results[0]){
//					$(" #inputPopLayer").remove();
//					var userInfo = data.results[0];
//					userInfo.password = pwd; // 保存交易密码
//					appUtils.setSStorageInfo("stock_userInfo",JSON.stringify(userInfo));
//					var curPageCode = $("body #content div.page[data-display=block]").attr("id").replaceAll("_","/");
//					appUtils.pageInit(curPageCode, "credit/transferred/collateralTransfer");
//				}else{
//					layerUtils.iAlert("账户信息不足");
//					return false;
//				}
//			}
//    	});
//	  }
	}	
	/**
	 * 校验登录账号,交易密码,手机验证码
	 */
	function checkInput(){
		if(validata.isEmpty($("#custNo").text())){
			layerUtils.iMsg(-1,"登录账号不能为空");
			return false;
		}
		if(validata.isEmpty($("#pwdInput").val())){
			layerUtils.iMsg(-1,"密码不能为空");
			return false;
		}else if($("#pwdInput").val().length != 6){
			layerUtils.iMsg(-1,"请输入6位密码");
			return false;
		}
		return true;
	}

	/* *******************/
	/**
	 * 选择确认框，只带"确认"和"取消"按钮
	 * @param conMsg 提示内容
	 * @param yesFunc 确认按钮的回调，可不传，默认只是去掉提示层
	 * @param noFunc 取消按钮的回调，可不传，默认只是去掉提示层
	 * 	callback参数支持3种形式：iConfirm("conMsg",funcName);、iConfirm("conMsg",function () {});、iConfirm("conMsg",function funcName() {});
	 * @param yesBtnWords 确认按钮的文字，可不传，默认为“确定”
	 * @param noBtnWords 取消按钮的文字，可不传，默认为“取消”
	 */
	function btnConfirm(pageId,conMsg, yesFunc, noFunc, yesBtnWords, noBtnWords){

		var viewContent = '<div class="pop_tip notice" id="pop_tip_confirm">';
		viewContent += '<span class="icon"></span>';
		viewContent += '<p><span style="display:block;text-align:center;padding:0 16px;font-size:16px;word-break:break-all;">';
		viewContent += conMsg;
		viewContent += '</span>';
		viewContent += '</p>';
		viewContent += '<div class="btn">';
		viewContent += '<a href="javascript:void(0);" id="pop_tip_confirm_yes">'+(yesBtnWords||"确 定")+'</a>';
		viewContent += '<a href="javascript:void(0);" id="pop_tip_confirm_no">'+(noBtnWords||"取消")+'</a>';
		viewContent += '</div></div>';
			$(pageId).append(viewContent);
	}

    
	//融资融券模拟登
	function creditLogin(source,callBack){
	    var stock_userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = stock_userInfo.branch_no;	//分支机构
		var fund_account = stock_userInfo.fund_account;	//资产账户
		var cust_code = stock_userInfo.cust_code;	//客户代码
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
			};
		service_common.creditLogin(param,function(data){
			if(data.error_no == 0){
				var tradeResults = ""; // 交易登录的结果集 results DataSet
	            if(data.DataSet){
	            	tradeResults = data.DataSet;
	            }else if(data.results){
	            	tradeResults = data.results;
	            }
	        	if(tradeResults && tradeResults.length > 0){
	        		var credit_userInfo =JSON.stringify(tradeResults[0]);
	        		appUtils.setSStorageInfo("credit_userInfo",credit_userInfo);
	        		if(source == 1){ // 从首页过来
	        			appUtils.pageInit("account/index","credit/asset/asset",{"param":param}); 
	        		}
	        		if(callBack){
	        			callBack();
	        		}
	        	}
			}else if(data.error_no=="-100001110"){ //-100001110
				appUtils.pageInit("account/index","account/login",{"topage":"credit/asset/asset"}); 
        	}else{
        		var jurisdiction = stock_userInfo.jurisdiction;
            	if(source == 2){ // 从详情页面过来
        			appUtils.pageInit("credit/asset/asset","account/index",{"param":param}); 
        		}
                if(jurisdiction!="1" &&  jurisdiction!="5"){
                	layerUtils.iAlert("您暂未开通融资融券");
				}else{
					layerUtils.iAlert("信用交易登录失败");
				}
        	}
		},{"isShowWait":false});
	}
	
	// 检测港股通权限
	function checkGGTPermission(source,callBack){
	    var stock_userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
	    if(stock_userInfo){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = stock_userInfo.branch_no;	//分支机构
			var fund_account = stock_userInfo.fund_account;	//资产账户
			var cust_code = stock_userInfo.cust_code;	//客户代码
			var param = {			
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
				};
			service_common.checkGGTPermission(param,function(data){
				if(data.error_no == 0){
                  var result = data.results;
                  if(result){
                	  var flag = false;
                	  for(var i=0,len= result.length;i< len;i++){
                		  if(result[i].exchange_type == "G"){
                			  flag = true;
                			  if(source == 1){ // 从首页跳转
                      			 appUtils.pageInit("account/index","ggt/ggtBuy",{});
                			  }
	             	          if(callBack){
		            	        callBack();
		            	      }
	                      	  return ;
                     	  }
                	  }
                	  if(!flag){
                		  if(source == 2){ // 从详情过来
                    		  appUtils.pageInit("ggt/ggtBuy","account/index",{});
                		  }
                		  layerUtils.iAlert("您暂未开通港股通");
                	  }  
                  }
				}else{ 
					layerUtils.iAlert(data.error_info);
	        	}
			},{"isShowWait":false});
	    }
	}
	
	//检测月月红权限
	function checkYYHOpen(){
		var stock_userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var state = "";
		if(stock_userInfo.client_rights.indexOf("e")<=0){
		     state = "1" ;//开通签署权限
		}		
		var cust_code = stock_userInfo.cust_code;	// 客户代码
		var fund_account = stock_userInfo.fund_account; // 资产账户
		var branch_no = stock_userInfo.branch_no;	// 分支机构
		var sessionid = stock_userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"password":stock_userInfo.password,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"e":state,
				"ofcash_balance":2000,
				"ofcash_status":0
		};
		service_fund.fundOpenYYH(param,function(data){
			if(data.error_no == 0){
				appUtils.pageInit("yyh/signProtocol","yyh/yyhEdit");			
			}else if(data.error_no == -10){
				appUtils.pageInit("account/index","yyh/signProtocol",{param:"BB1005"});
			}else if(data.error_no == -11){
				appUtils.pageInit("yyh/signProtocol","yyh/yyhEdit");	
			}else if(data.error_no == -12){
				
			}else if(data.error_no == -13){
				appUtils.pageInit("yyh/signProtocol","yyh/yyhEdit");
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
		
	}
	
    var base = {
    	"queryPosition":queryPosition,
    	"queryPosition_ggt":queryPosition_ggt,
    	"queryHolding":queryHolding,
    	"isAStockLogin":isAStockLogin,
        "creditLogin":creditLogin,
        "checkGGTPermission":checkGGTPermission,
    	"btnConfirm":btnConfirm,
    	"checkYYHOpen":checkYYHOpen
    };

    module.exports = base;
});