/**
 * 交易下单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var service_stock = require("service_stock");
	var service_credit = require("service_credit");
	var service_hq = require("service_hq");
	var external = require("external");
    var userInfo = null;  //账号信息
	var price_step = 0.01; //步长
	var price_digit = 3; //小数点位数
	var fifthOrder_timer = null; //五档定时器
	var position_timer = null; //持仓定时器
	var lotsOf = 100; //每手数量
	var _stockAccount=""; //股东帐号
	var _market =""; //交易市场
	var commonFunc = require("commonFunc");
	var enable_balance = "";
	var isChangePrice = true; //五档变化是否改变相应价格
	var _stockName = "";
	var stock_price = ""; 
	var stkType = ""; //证券类型
	var up_stop = "";
	var down_stop = "";
	var _pageId = "#stock_stockBuy ";
	var _orderType = ""; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，信用买入 6，信用卖出 7，买券还券 8，卖券还款
	var entrustType = { //融资融券委托类型
		"3":"6",  
		"4":"7",
		"5":"0",
		"6":"0",
		"7":"7",
		"8":"6",
	};
	var orderName = { //委托名称
		"1":"委托买入",
		"2":"委托卖出",
		"3":"融资买入",
		"4":"融券卖出",
		"5":"信用买入",
		"6":"信用卖出",
		"7":"买券还券",
		"8":"卖券还款",
	};
	
    /**
     * 数据初始化
     */
	function dataInit(pageId,orderType){
		_pageId = pageId;
		_orderType = orderType;
		common.systemKeybord(); // 解禁系统键盘
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".trade_main").height()-27;
        $(_pageId+".fund_table").height(height_table);   //给持仓数据添加高度
		var stockCode = appUtils.getPageParam("stockCode");
		//判断是否普通交易
		if(_orderType=="1" || _orderType=="2"){
			common.bindStockEvent(_pageId); //绑定头部菜单事件
			var stockInfo = appUtils.getSStorageInfo("_loginInPageParam");
			if(stockInfo && stockInfo!=""){
				stockCode = JSON.parse(stockInfo).stockCode;
			}
			appUtils.clearSStorage("_loginInPageParam");
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		}
		//查询个股行情
		if(stockCode){
			$(_pageId+"#stockCode").val(stockCode);
			getStockList(stockCode);
		}else{
			$(_pageId+".fund_table").scrollTop(0);
		}
		if(position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		if(_orderType!="7"){
			window.setTimeout(queryHolding(),100);
	       	if(global.isTrade){
				position_timer = window.setInterval(queryHolding(), 10000);
			}
		}
		if(gconfig.platform=="0"){ //方便pc端调试
			$(_pageId+"#stockCode").attr("readonly",false);
			$(_pageId+"#stockNum").attr("readonly",false);
		}	
    }
	
	/**
	 * 事件绑定
	 */
	function elementBindEvent(){

		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			orderPageBack();
			e.stopPropagation();
		});
		//股票代码输入框监听
		appUtils.bindEvent($(_pageId+"#stockCode"), function(e){
			var stockCode = $(this).val();
			clearBuyMsg();
			var vail=/^[A-Za-z]+$/;
			if(stockCode.length>1 && vail.test(stockCode)){
				getStockList(stockCode);
				if(stockCode.length<2){
					$(_pageId+"#stock_list").html("");
				}
			}else if(stockCode.length>3){
				getStockList(stockCode);
				if(stockCode.length<4){
					$(_pageId+"#stock_list").html("");
				}
			}else{
				clearBuyMsg();
			}
			$(_pageId+".ce_btn #total").hide();
			e.stopPropagation();
		},"keyup");
		//股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+".trade_form .input_code"), function(e){
			$(_pageId+"#stockCode").focus();
			var code =$.trim($(_pageId+"#stockCode").val().substring(0,6));
			$(_pageId+"#stockCode").val(code);
			if(gconfig.platform != "0"){
				var data = external.callMessage({"moduleName":"price","funcNo": "60100", "searchKey":""});
				showStockList(data,"1");// 显示股票列表
			}
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(){
					var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
					clearBuyMsg();
					var vail=/^[A-Za-z]+$/;
					if(stockCode.length>1 && vail.test(stockCode)){
						getStockList(stockCode);
						if(stockCode.length<2){
							$(_pageId+"#stock_list").html("");
						}
					}else if(stockCode.length>3){
						getStockList(stockCode);
						if(stockCode.length<4){
							$(_pageId+"#stock_list").html("");
						}
					}else{
						clearBuyMsg();
					}
					$(_pageId+".ce_btn #total").hide();
				}
			};
			var pageId = _pageId.substring(1,_pageId.length-1);
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":pageId, "eleId":"stockCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			var stockCode = $.trim($(_pageId+"#stockCode").val());
			if(stockCode.length==6){
				$(_pageId+"#stockCode").val(stockCode+" "+_stockName);
			}
			e.stopPropagation();
		},"blur");
		//股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+".trade_form .input_num #stockNum"), function(e){
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(keyCode){
					totalValue();
					var mostBuy = $(_pageId+"#buyLimit").text();
					if(validatorUtil.isNumeric(mostBuy)){// 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
						if(keyCode == "-14" && (_orderType=="1" || _orderType=="3" || _orderType=="5" || _orderType=="7")){ // 买入全仓
							$(_pageId+"#stockNum").val((mostBuy/lotsOf).toFixed(0)*lotsOf);
						}else if(keyCode == "-14" && (_orderType=="2" || _orderType=="4" || _orderType=="6"|| _orderType=="8")){ // 卖出全仓
							$(_pageId+"#stockNum").val(mostBuy);
						}else if(keyCode == "-12"){ // 3分之一仓
							$(_pageId+"#stockNum").val((mostBuy/(3*lotsOf)).toFixed(0)*lotsOf);
						}else if(keyCode == "-13"){ // 2分之一仓
							$(_pageId+"#stockNum").val((mostBuy/(2*lotsOf)).toFixed(0)*lotsOf);
						}else if(keyCode == "-11"){ // 4分之一仓
							$(_pageId+"#stockNum").val((mostBuy/(4*lotsOf)).toFixed(0)*lotsOf);
						}
					}else{
						if(keyCode == "-11"||keyCode == "-12"||keyCode == "-13"||keyCode == "-14"){
							$(_pageId+"#stockNum").val(0);
						}
					}
				}
			};
			var pageId = _pageId.substring(1,_pageId.length-1);
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":pageId, "eleId":"stockNum", "doneLable":"done", "keyboardType":"6"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockNum"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		//价格输入框
		appUtils.bindEvent($(_pageId+"#stockPrice"), function(e){
			totalValue();
			var stockPrice = $(_pageId+"#stockPrice").val();
			var needDatas = "1,3,4,5,7";
			if(stockPrice && stockPrice!="0" && needDatas.indexOf(_orderType)!=-1 ){
				var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
				queryMaxAmount(stockCode,stkType);
			}
			e.stopPropagation();
		},"input");
		//增加价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .add"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;
				}
				curPrice = Number(curPrice);  
				if(curPrice >= 0&&curPrice<999999999){
					curPrice = (parseFloat(curPrice)+parseFloat(price_step)).toFixed(price_digit);
					$(_pageId+"#stockPrice").val(curPrice);
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			totalValue();
			var stockPrice = $(_pageId+"#stockPrice").val();
			var needDatas = "1,3,4,5,7";
			if(stockPrice && stockPrice!="0" && needDatas.indexOf(_orderType)!=-1 ){
				var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
				queryMaxAmount(stockCode,stkType);
			}
			e.stopPropagation();
		},"touchstart");
		//减少价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .less"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);   
				if(curPrice-price_step >= 0){
					curPrice=(parseFloat(curPrice)-parseFloat(price_step)).toFixed(price_digit);
					$(_pageId+"#stockPrice").val(curPrice);
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			totalValue();
			var stockPrice = $(_pageId+"#stockPrice").val();
			var needDatas = "1,3,4,5,7";
			if(stockPrice && stockPrice!="0" && needDatas.indexOf(_orderType)!=-1 ){
				var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
				queryMaxAmount(stockCode,stkType);
			}
			e.stopPropagation();
		},"touchstart");
		//五档买卖盘联动
		appUtils.bindEvent($(_pageId+".five_box ul li"),function(e){
			var curPrice=$(this).find("span").text();
			if(curPrice && curPrice!="--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = isNaN(Number(curPrice)) ? 0 : curPrice;
				$(_pageId+"#stockPrice").val(curPrice);
				totalValue();
				var stockPrice = $(_pageId+"#stockPrice").val();
				var needDatas = "1,3,4,5,7";
				if(stockPrice && stockPrice!="0" && needDatas.indexOf(_orderType)!=-1 ){
					var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
					queryMaxAmount(stockCode,stkType);
				}
			}
			e.stopPropagation();
		});
		//下单
		appUtils.bindEvent($(_pageId+"#submitOrder"),function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		//点击其他位置去掉五档点击效果
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+".five_box ul li").removeClass("active");
			$(_pageId+"#stock_list").html("");
			e.stopPropagation();
		});
		//滚动联动
		appUtils.bindEvent($(_pageId+".input_slider .r1"), function(e){
			var buyLimit = $(_pageId+"#buyLimit").text();
			if(validatorUtil.isNumeric(buyLimit)){
				var turn = $(this).val();
				var stockNum = ((buyLimit*turn)/(100*lotsOf)).toFixed(0)*lotsOf;
				if(turn==100){
					stockNum = buyLimit;
				}
				$(_pageId+"#stockNum").val(stockNum);
				totalValue();
			}
			e.stopPropagation();
		},"input");
	}
	
	//计算当前总值
	function totalValue(){
		var stockNum = $(_pageId+"#stockNum").val();
		var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
		var stockPrice = $(_pageId+"#stockPrice").val();
		if(stockCode && validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
		$(_pageId+".ce_btn #total").show();
			$(_pageId+".ce_btn #total").text("(¥"+common.numToMoneyType(""+(stockPrice*stockNum).toFixed(2))+")");
		}else{
			$(_pageId+".ce_btn #total").hide();
		}
	}
	
	/**
	 * 显示股票列表
	 * */
	function showStockList(data,source){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var len = 0; //推送过来的A股
				for(var i = 0;i < results.length; i++) {
					if(results[i].code.length==6){
						len ++;
					}
				}
				$(_pageId+"#stock_list").html("");
				if(source != "1" && results.length == 1){
					$(_pageId+"#stock_list").html("");
					var market = results[0].market;
					var stockCode = results[0].code;
					getStockInfo(market,stockCode);
				}else{
					if(len >= 6){
						var selectHeight = 6 * 0.44;
					}else{
						selectHeight = 0.44*len;
					}
					var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
					for(var i = 0;i < results.length; i++) {
						if(results[i].code.length==6){
							listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.10rem;\"><strong style=\"font-size:0.15rem\">"+results[i].code+"</strong>"+results[i].name+"</a>";
							listHtml +=	"<span style=\"display:none;\">"+results[i].market+"</span></li>";
						}
					};
					listHtml+="</ul>";
					$(_pageId+"#stock_list").append(listHtml);
					appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
						var market = $(this).find("span").text();
						var stockCode = $(this).find("strong").text();
						$(_pageId+"#stock_list").html("");
						getStockInfo(market,stockCode);
					});
				}
			}else{
				var stockLength = $(_pageId+"#stockCode").val().length;
				if(stockLength == 6){
					queryMaxAmount(results[0].code,stkType);
				}
				
				if(source != "1"){
//				layerUtils.iAlert("该股票列表不存在");
				}
                _stockName = "";
			}
		}
	}
	
	/**
	 * 获取股票列表
	 * */
	function getStockList(stockStr){
		if(stockStr != ""){
			if(gconfig.platform != "0"){
				var data = external.callMessage({"moduleName":"price","funcNo": "60101","num":10,"searchKey":stockStr});
	            var results = data.results;
				if(results && results.length>0){
					showStockList(data,"0");
	            }else{
	            	showStockListH5(stockStr); // 查询行情接口获取列表
	            }
			}else{
				showStockListH5(stockStr); // 查询行情接口获取列表
			}
		}	
	} 

	/**
	 * 查询行情接口获取列表
	 * */
	function showStockListH5(stockStr){
		var stockStrParam = {
			"q" : stockStr
		}; 
		service_hq.getStockList(stockStrParam,function(data){
			if(data.errorNo == 0){
				$(_pageId+"#stock_list").html("");
				var results = data.results;
				//显示股票列表
				if(results && results.length > 0){
					if(results.length == 1 && stockStr.length==6){
						$(_pageId+"#stock_list").html("");
						var market = results[0][9];
						var stockCode = results[0][1];
						getStockInfo(market,stockCode);
					}else{
						if(results.length >= 6){
							var selectHeight = 6 * 0.44;
						}else{
							selectHeight = 0.44*results.length;
						}
						var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
						for(var i = 0;i < results.length; i++) {
							listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.10rem;\"><strong style=\"font-size:0.15rem\">"+results[i][1]+"</strong>"+results[i][0]+"</a>";
							listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
						};
						listHtml+="</ul>";
						$(_pageId+"#stock_list").append(listHtml);
						appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
							var market = $(this).find("span").text();
							var stockCode = $(this).find("strong").text();
							$(_pageId+"#stock_list").html("");
							getStockInfo(market,stockCode);
						});
					}
				}else{
//					layerUtils.iAlert("该股票列表不存在");
					var stockLength = $(_pageId+"#stockCode").val().length;
					if(stockLength == 6){
						queryMaxAmount(stockStr,stkType);
					}					
                    _stockName = "";
				}
			}else{
				layerUtils.iAlert("获取股票列表失败");
			}
		},{"isShowWait":false});
	}
	
	/**
	 * 获取股票个股行情
	 * */
	function getStockInfo(market,stockCode){
		if(stockCode && market){
			if (fifthOrder_timer != null ) {
		        window.clearInterval(fifthOrder_timer);
		    }
			var stockStrParam = {
				"stock_list" : market+":"+stockCode
			};
			$(_pageId + "#stockNum").val("");
			//查询个股行情
			service_hq.getStockNowPrice(stockStrParam,function(data){
			    common.decimalKeep(stockCode,function(keepNum,is_bond){  //获取保留的位数
//			    price_digit = keepNum;
		    	if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
                        $(_pageId+"#stock_list").html("");
                        $(_pageId+"#stockPrice").val("");
						$(_pageId+"#stockCode").val(""); // 每次修改股票代码，那么将初始值置为0
						if(results[0][15] == "1"){
							layerUtils.iAlert("该股票已停牌");
							clearBuyMsg();
							return false;
						}
						
						var price = results[0][2] ? results[0][2]:results[0][6];
						stkType = results[0][10];    //行情类别
						var stockVal = results[0][1];    //股票代码
						var price_step_const = [10,12,13,4,6,19,20,3,11,16];  //最小变动单位为0.001的
						var step_flag = $.inArray(stkType, price_step_const);
                 
						var typeName = common.getStockType(stkType);
						$(_pageId + ".trade_form .select_box label").text(typeName);
		                if(step_flag == -1){ // 否则浮动为0.01
							price_step = 0.01;
						}else{  // 变动价格为0.001
							price_step = 0.001;
						}
						// 上海国债逆回购
						if(stockVal.substring(0,3) == "204"){
							price_step = 0.005;
						}
						var yesterdayClose = results[0][6]; //昨收
						if(typeof yesterdayClose == "undefined" || yesterdayClose == ""){
							yesterdayClose = 0 ;
						}
						if(is_bond == "1"){  //上海债券
							$(_pageId + ".limit span").text("手");
							$(_pageId + ".input_num em").text("手");
							lotsOf = 10;
						}else if(is_bond == "2"){  //深圳债券
							$(_pageId + ".limit span").text("张");
							$(_pageId + ".input_num em").text("张");
							lotsOf = 10;
						}else{  //其他股票
							up_stop = Number(results[0][13]).toFixed(price_digit);
							down_stop = Number(results[0][14]).toFixed(price_digit);
							$(_pageId + "#up_stop").html(up_stop).attr("class","ared");
							$(_pageId + "#down_stop").html(down_stop).attr("class","agreen");
							$(_pageId + ".limit span").text("股");
							$(_pageId + ".input_num em").text("股");
							lotsOf = 100;
						}

						//证券代码显示  
						$(_pageId + "#stockCode").val(results[0][1]+" "+results[0][0]);
						_stockName = results[0][0];
						$(_pageId + "#stockCode").blur();
						//证券名称显示
						//$(_pageId + "#stockName").html(results[0][0]);
						stock_price = price.toFixed(price_digit);
						//$(_pageId + "#stockPrice").val(price);
						//保存此股票的市场类型
						//$(_pageId+ " .mod_stock_buy .fl").find("p").attr("id",results[0][9]);
						
						//保存此股票的信息
						var market = results[0][9];
						var stockCode = results[0][1];
						if(typeof market != "undefined" && market != "" && market != null && stockCode.length == "6"){
							var stockMsg = market+":"+stockCode;
							appUtils.setLStorageInfo("stockMsg",stockMsg);
						}
						//调用五档行情
						var stock_list = results[0][9] + ":" + results[0][1];
						if (fifthOrder_timer != null ) {
					        window.clearInterval(fifthOrder_timer);
					    }
						isChangePrice = true;
						window.setTimeout(setFifthOrder(stock_list),100);
						if(global.isTrade){
							fifthOrder_timer =  window.setInterval(setFifthOrder(stock_list), 10000);//定时刷新
						}
						//股票联动,查询股票信息，最大可买
						queryMaxAmount($.trim($(_pageId+"#stockCode").val().substring(0,6)),stkType);
					}else{
						$(_pageId+" .mod_stock_item #stock_list").hide();
						clearBuyMsg();
						layerUtils.iLoading(false);
						layerUtils.iAlert("该股票不存在");
                        _stockName = "";
					}
				}else{
					clearBuyMsg();
					layerUtils.iAlert(data.error_info);
				}
			});
			},{"isLastReq":false,"isShowWait":false});
		}
	}
	
	//五档买卖盘
	function setFifthOrder(stock_list){
		 return function() {//为了解决定时器不能传参数的问题	 
			 if(stock_list){
				var fifthOrder = {
					"stock_list" : stock_list
				};
				service_hq.getStockFiveStep(fifthOrder,callbackFifthOrder,{"isShowWait":false});
			 } 
		 };
	}
	//回调五档买卖盘
	function callbackFifthOrder(data){
		if(data.errorNo == 0){
			var results = data.results;
			if(results && results.length>0){
				$(_pageId+"#stock_list").html("");
				var stock_gear = $(_pageId+" .five_box ul li");
				var yesProfit = Number(results[0][26]).toFixed(price_digit);
				if(isChangePrice){
					var nowPrice = Number(results[0][30]).toFixed(price_digit);
					var fifthOne = "";
					if(_orderType=="1"){
						fifthOne = Number(results[0][10]);
					}else{
						fifthOne = Number(results[0][16]);
					}
					if(nowPrice == up_stop){
						$(_pageId + "#stockPrice").val(up_stop);
					}else if(nowPrice == down_stop){
						$(_pageId + "#stockPrice").val(down_stop);
					}else if(fifthOne=="0"){
						$(_pageId+"#stockPrice").val(nowPrice);
					}else{
						$(_pageId + "#stockPrice").val(fifthOne.toFixed(price_digit));
					}
					isChangePrice = false;
				}
				/**
				 * 此处逻辑:买卖五档盘也是根据昨收作比较,将受到的五档盘颜色信息保存在集合中,在给五档盘价格赋值和样式
				 */
				//卖五档盘颜色集合
				var soldFiveOrder = [];
				for(var i = 0 ; i < 5 ; i ++){
					var fivePirce = results[0][(i+6)];
					if(yesProfit <fivePirce){
						soldFiveOrder[i] = "ared";
					}else if(yesProfit >fivePirce && fivePirce!=0){
						soldFiveOrder[i] = "agreen";
					}else{
						soldFiveOrder[i] = "";
					}
				}
				//买五档盘颜色集合
				var buyFiveOrder = [];
				for(var i = 0 ; i < 5 ; i ++){
					var fivePirce = results[0][(i+16)];
					if(yesProfit <fivePirce){
						buyFiveOrder[i] = "ared";
					}else if(yesProfit >fivePirce && fivePirce!=0){
						buyFiveOrder[i] = "agreen";
					}else{
						buyFiveOrder[i] = "";
					}
				}
				//卖
				stock_gear.eq(0).find("span").text(transferText(results[0][6])).attr("class",soldFiveOrder[0]);
				stock_gear.eq(0).find("em").text(overAMillion(results[0][11]));
				stock_gear.eq(1).find("span").text(transferText(results[0][7])).attr("class",soldFiveOrder[1]);
				stock_gear.eq(1).find("em").text(overAMillion(results[0][12]));
				stock_gear.eq(2).find("span").text(transferText(results[0][8])).attr("class",soldFiveOrder[2]);
				stock_gear.eq(2).find("em").text(overAMillion(results[0][13]));
				stock_gear.eq(3).find("span").text(transferText(results[0][9])).attr("class",soldFiveOrder[3]);
				stock_gear.eq(3).find("em").text(overAMillion(results[0][14]));
				stock_gear.eq(4).find("span").text(transferText(results[0][10])).attr("class",soldFiveOrder[4]);
				stock_gear.eq(4).find("em").text(overAMillion(results[0][15]));
				//买
				stock_gear.eq(5).find("span").text(transferText(results[0][16])).attr("class",buyFiveOrder[0]);
				stock_gear.eq(5).find("em").text(overAMillion(results[0][21]));
				stock_gear.eq(6).find("span").text(transferText(results[0][17])).attr("class",buyFiveOrder[1]);
				stock_gear.eq(6).find("em").text(overAMillion(results[0][22]));
				stock_gear.eq(7).find("span").text(transferText(results[0][18])).attr("class",buyFiveOrder[2]);
				stock_gear.eq(7).find("em").text(overAMillion(results[0][23]));
				stock_gear.eq(8).find("span").text(transferText(results[0][19])).attr("class",buyFiveOrder[3]);
				stock_gear.eq(8).find("em").text(overAMillion(results[0][24]));
				stock_gear.eq(9).find("span").text(transferText(results[0][20])).attr("class",buyFiveOrder[4]);
				stock_gear.eq(9).find("em").text(overAMillion(results[0][25]));
			}
		}else{
			if (fifthOrder_timer != null ) {
		        window.clearInterval(fifthOrder_timer);
		    }
			layerUtils.iAlert(data.error_info);
		}
	}
	//数量过万改以万为单位
	function overAMillion(num){
		num = Number(num);
		if(num >= 10000){
			num = (num/10000).toFixed(2) + "万";
		}
		return num;
	}
	
	/**
	 * 将不规则文本转换为 "--"
	 */
	function transferText(inText){
		var outText = "";
		if(!inText || inText=="0.00" || inText=="0"){
			outText = "--";
		}else{
			outText = Number(inText).toFixed(price_digit);
		}
		return outText;
	}
	
	//五档颜色过滤
	function colorFilter(num,color){
		var outColor = "";
		var orderText = stock_gear.eq(num).find("span").text();
		if(orderText=="--"){
			outColor = "";
		}else{
			outColor = color;
		}
		return outColor;
	}
	
	/**
	 * 查询买入可用资金最大可买可卖数量
	 * */
	function queryMaxAmount(stockCode,stkType){
		if(!stockCode){
			return false;
		}
		var price = $(_pageId+"#stockPrice").val();
		if(price && price!="0"){
			stock_price = price;
		}
		var entrust_bs = "";	
		if(_orderType=="1" || _orderType=="3" || _orderType=="5" || _orderType=="7"){
			entrust_bs = "0";
		}else{
			entrust_bs = "1";
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var stock_code =stockCode;
		var entrust_price = stock_price;
		var exchange_type = stkType;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
	            "newstock_flag":"",
	            "exchange_type":exchange_type,
	            "price_hq":$(_pageId+"#stockPrice").val()
			};
		if(_orderType=="1" || _orderType=="2"){
	  	  service_stock.queryStockMaxBuy(param,queryMaxAmountCallBack,{"isLastReq":true,"isShowWait":false});
		}else{
	      param.entrust_type = entrustType[_orderType]; 
		  service_credit.stock_link(param,queryMaxAmountCallBack,{"isLastReq":true,"isShowWait":false});
		}
	}
	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				var stock_price = $(_pageId+"#stockPrice").val();
				stock_price?"":$(_pageId+"#stockPrice").val(results[0].price);
//				results[0].price_hq&&$(_pageId+"#stockPrice").val(results[0].price_hq);
				$(_pageId+"#buyLimit").text(Number(results[0].stock_max_amount));
				$(_pageId+".stat").find("span").text("应还："+Number(results[0].enable_amount).toFixed(2));
				enable_balance = Number(results[0].enable_balance);
				_market=results[0].exchange_type;
				_stockAccount=results[0].stock_account;
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){	
		var typeText = "买入";
		if(_orderType=="1" || _orderType=="3" || _orderType=="5" || _orderType=="7"){
			typeText = "买入";
		}else{
			typeText = "卖出";
		}
		//验证股票代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
		if(buy_stockCode.length == 0){
			layerUtils.iMsg(-1,"请输入股票代码");
			return false;
		}	
		if(buy_stockCode.length != 6){
			layerUtils.iMsg(-1,"股票代码输入错误");
			return false;
		}	
		//验证股票价格输入是否正确
		var now_price = $(_pageId+"#stockPrice").val();
		if($.trim(now_price).length<=0){
			layerUtils.iMsg(-1,"请输入"+typeText+"价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(now_price)){
			layerUtils.iMsg(-1,"请正确输入价格");
			return false;
		}
		//验证最大可买
		var mostBuy = $(_pageId+"#buyLimit").text();
		if($.trim(mostBuy).length<=0||parseFloat(mostBuy)<=0){
			layerUtils.iMsg(-1,"最大可"+typeText+"为0");
			return false;
		}
		//验证买入数量
		var mountBuy = $(_pageId+"#stockNum").val();
		if($.trim(mountBuy).length<=0){
			layerUtils.iMsg(-1,"请输入"+typeText+"数量");
			return false;
		}else if(parseFloat(mountBuy)<=0){
			layerUtils.iMsg(-1,"数量必须大于0");
			return false;
		}else if(parseFloat(mostBuy)<parseFloat(mountBuy)){
			layerUtils.iMsg(-1,"最大可"+typeText+"数量不足");
			return false;
		}
//		if(_orderType=="1"){
//			if(mountBuy%Number(lotsOf)!=0){
//				layerUtils.iMsg(-1,typeText+"数量应为"+lotsOf+"的倍数");
//				return false;
//			}else if(mountBuy>=1000000){
//				layerUtils.iMsg(-1,typeText+"数量必须小于100万股");
//				return false;
//			}
//		}else if(_orderType=="2"){
//			if(mostBuy!=mountBuy && mountBuy%Number(lotsOf)!=0){
//				layerUtils.iMsg(-1,"卖出数量应为"+lotsOf+"的倍数");
//				return false;
//			}
//		}
		if(mountBuy>=1000000){
			layerUtils.iMsg(-1,typeText+"数量必须小于100万股");
			return false;
		}
		var exchange_type=_market;
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>"+orderName[_orderType]+"</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
	    tipStr+="    <li>证券名称 <em>"+$(_pageId+"#stockCode").val().substring(7)+"</em></li>";
		tipStr+="    <li>证券代码 <strong>"+buy_stockCode+"</strong></li>";
		tipStr+="    <li>委托价格 <strong>"+now_price+"</strong></li>";
		tipStr+="    <li>委托数量 <strong>"+mountBuy+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
		var entrust_bs = "";	
		if(_orderType=="1" || _orderType=="3" || _orderType=="5" || _orderType=="7"){
			entrust_bs = "0";
		}else{
			entrust_bs = "1";
		}
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var password = userInfo.password;	
		var stock_account = _stockAccount;
		var stock_code = buy_stockCode;
		var entrust_price = now_price;
		var entrust_amount = mountBuy;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
				"entrust_amount":entrust_amount,
			};
		    var compact_id = "";
		    var debit_type = "";
		    var serial_no = "";
		    var init_date = "";
		    $(_pageId+".search_scroll ul:gt(0)").each(function(){
			    //用$(this)可以访问正在循环的元素 
				if($(this).hasClass("active")){
					compact_id = $(this).find("li:eq(1) span:eq(1)").text();
					debit_type = $(this).find("li:eq(4)").text();
					serial_no = $(this).find("li:eq(5)").text();
					init_date = $(this).find("li:eq(6)").text();
					exchange_type_pay = $(this).find("li:eq(7)").text();
				}
			});
			if(_orderType=="1" || _orderType=="2"){
				service_stock.getStockBuy(param,getStockBuyCallBack);
			}else if(_orderType=="8" && compact_id!=""){
				param.debit_type = debit_type; 
				param.serial_no = serial_no; 
				param.init_date = init_date; 
				param.exchange_type_pay = exchange_type_pay;
			    service_credit.repayCash(param,getStockBuyCallBack);
			}else{
				param.entrust_type = entrustType[_orderType]; 
			    service_credit.entrust_trade(param,getStockBuyCallBack);
			}
			
		},function fail(){
		});
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				if(_orderType=="8"){
					$(_pageId+".fund_tab ul li:eq(0)").addClass("active").siblings().removeClass("active");
					$(_pageId+".fund_table").show();
					$(_pageId+".search_scroll").hide();
				}
				queryHolding();
				//layerUtils.iAlert(data.error_info);
				var tipStr = "";
			        tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				layerUtils.iAlert(tipStr);
				clearBuyMsg();
				$(_pageId + "#stockCode").val("");
			}
		}else{
			layerUtils.iAlert(data.error_info);
			clearBuyMsg();
			$(_pageId + " #stockCode").val("");
		}
	}
	
	function queryHolding(){
	 return function() {//为了解决定时器不能传参数的问题	 
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password =  userInfo.password;
			var stock_account ="";
			var stock_code = "";
			var exchange_type = "";
			var param={
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"sessionid":sessionid,
					"stock_account":stock_account,
					"stock_code":stock_code,
					"exchange_type":exchange_type,
					"password":password
			};
			if(_orderType=="1" || _orderType=="2"){
				service_stock.queryStockData(param,queryHoldingCallback,{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
			}else{
				service_credit.cc_query(param,queryHoldingCallback,{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
			}
		 };
	}
	
	function queryHoldingCallback(data){
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var total_cost_balance = 0;//持仓数量X持仓成本
					var total_last_price = 0; //持仓数量X最新价
					var data = "<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>";
					var float_yk = 0; //浮动盈亏
					for (var i=0;i<results.length;i++){ 
						 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
						 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
						 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
						 data += queryHoldingHTML_stock(results[i]);
					}
					$(_pageId+".fund_table .ce_table").html(data);
					$(_pageId+".no_data").hide();
					
					//添加总浮动盈亏
					var css = "";
					//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
					if(float_yk > 0){
						float_yk = "+" + float_yk.toFixed(2);
						css = "ared";
					}else if(float_yk < 0){
						float_yk = "" + float_yk.toFixed(2);
						css = "agreen";
					}else{
						float_yk = "" + float_yk.toFixed(2);
						css = "";
					}
					$(_pageId+".hold_table tr:eq(0) td:eq(1) strong").text(float_yk).attr("class",css);//盈亏
					//卖出事件
					appUtils.bindEvent($(_pageId+".fund_table .ce_table tr:gt(0)"), function(e){
						var stockCode = $(this).attr("id");
						getStockList(stockCode);
						e.stopPropagation();
					},"click");
				}else{ 
					$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
					$(_pageId+".no_data").show();
				}
			}else{
				$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
				$(_pageId+".no_data").show();
				layerUtils.iAlert(data.error_info);
			}
		}else{
			$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
			$(_pageId+".no_data").show();
			layerUtils.iAlert("查询失败");
		}
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryHoldingHTML_stock(element){
		var price_digit = 3;
//		if(element.exchange_type === "3"){
//			price_digit = 3;
//		}else{
//			price_digit = 2;
//		}
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
			float_yk = float_yk.toFixed(2);
		}
       var eleHtml = "";
       eleHtml+="<tr id="+element.stock_code +">";
       eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.market_value +"</small></td>";
       eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+element.float_yk_per+"%</span></td>";
       eleHtml+="<td>"+Number(element.cost_amount)+"<br/>"+Number(element.enable_amount)+"</td>";
       eleHtml+="<td>"+Number(element.cost_price).toFixed(price_digit)+"<br/>"+Number(element.last_price).toFixed(price_digit)+"</td>";
       eleHtml+="</tr>";
       return eleHtml;
	}
	
	
	/**
	 * 重置买卖页面数据  
	 */
	function clearBuyMsg(){
		if (fifthOrder_timer != null ) {
	        window.clearInterval(fifthOrder_timer);
	    }
		$(_pageId+".stat").find("span").text("应还：--");
		$(_pageId+"#stock_list").html("");
		$(_pageId+"#stockName").text("证券名称");
		$(_pageId+"#stockPrice").val("");	
		$(_pageId+"#stockNum").val("");
		$(_pageId+"#buyLimit").text("--");
		$(_pageId+"#up_stop").text("--");
		$(_pageId+"#down_stop").text("--");
		$(_pageId+".five_box ul li em").text("--");
		$(_pageId+".five_box ul li").removeClass("active");
		$(_pageId+".five_box ul li span").removeClass("agreen").removeClass("ared").text("--");
		$(_pageId+".ce_btn #total").hide();
		$(_pageId+".limit span").text("股");
		$(_pageId+".input_num em").text("股");
		$(_pageId+".input_slider .r1").val("0");
		$(_pageId+".trade_form .select_box label").text("股票");
		isChangePrice = true;
	}
	
	/**
	 * 销毁
	 */
	function dataDestroy(){
		 if (position_timer != null ) {
	         window.clearInterval(position_timer);
	     }
		 clearBuyMsg();
	     userInfo = null;  //账号信息
		 price_step = 0.01; //步长
		 price_digit = 3; //小数点位数
		 fifthOrder_timer = null; //五档定时器
		 position_timer = null; //持仓定时器
		 lotsOf = 100; //每手数量
		 _stockAccount=""; //股东帐号
	     _market ="";   //交易市场
         _stockName = "";
         stock_price = "";
		 $(_pageId+"#stockCode").val("");
		 external.callMessage({"moduleName":"trade","funcNo": "50211"});
		 $(_pageId+".no_data").hide();
		 $(_pageId+".fund_table .ce_table").html("");
		 $(_pageId+".input_slider .r1").val("0");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function orderPageBack(){
		var curPageCode = appUtils.getSStorageInfo("_curPageCode");
		var nextPageCode = "";
		if(_orderType=="1" || _orderType=="2"){
			nextPageCode = "account/index";
		}else{
			nextPageCode = "credit/order/mainOrder";
		}
		appUtils.pageInit(curPageCode,nextPageCode,{});
	}
	
	var base = {
		"dataInit" : dataInit,
		"elementBindEvent": elementBindEvent,
		"dataDestroy": dataDestroy,
		"getStockList":getStockList,
		"orderPageBack": orderPageBack
	};
	module.exports = base;
});