/**
 * 信用交易-现券还券
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var service_credit = require("service_credit");
	var _pageId = "#credit_order_bondAlsoCoupons ";
	var external = require("external");
	var stockAccount =null;//证券账号
	var exchangeType = null;//交易市场类别（见数据字典)
	var userInfo =null;
	
    /**
     * 初始化
     */
	function init(){
		common.systemKeybord(); // 解禁系统键盘
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));	
		canPayStock();//查询可还证券
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("credit/order/bondAlsoCoupons","credit/order/mainOrder",{});
			e.stopPropagation();
		});
		//查询跳转
		appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
			appUtils.pageInit("credit/order/bondAlsoCoupons","credit/query/financingQuery",{});
			e.stopPropagation();
		});
		//滚动联动
		appUtils.bindEvent($(_pageId+".input_slider .r1"), function(e){
			var canPay = $(_pageId+"#canPay").val();
			var turn = $(this).val();
			$(_pageId+"#stockNum").val((canPay*turn/100).toFixed(0));
			e.stopPropagation();
		},"input");
		//提交委托
		appUtils.bindEvent($(_pageId+".input_form .ce_btn"), function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		//可还下拉框
		appUtils.bindEvent($(_pageId + ".select_box"), function(e){
			$(_pageId+".select_box ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			if($(_pageId +".select_box ul").is(':visible')){
				$(_pageId +".select_box ul").slideToggle("fast");
			}	
			e.stopPropagation();	// 阻止冒泡
		});
		//增加数量
		appUtils.bindEvent($(_pageId+".add"),function(e){
			var num = $(_pageId+"#stockNum").val();
			if(!num||num==""){
				return false;
			}
			num = Number(num);
			if(num >=0){
				num = num+1;
			}	
			$(_pageId+"#stockNum").val(num.toFixed(0));
		});
		//减少数量
		appUtils.bindEvent($(_pageId+".less"),function(e){
			var num = $(_pageId+"#stockNum").val();
			if(!num||num==""){
				return false;
			}
			num = Number(num);
			if(num > 0){
				num = num-1;
			}
			$(_pageId+"#stockNum").val(num.toFixed(0));
		});
	}
    
	//查询可还证券
	function canPayStock(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid= userInfo.session_id;
		var password = userInfo.password;
		var stock_account ="";
		var stock_code = "";
		var exchange_type = "";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"exchange_type":exchange_type,
				"password":password
		};
		service_credit.cc_query(param,queryStockCallback);
	}
	/**
	 * 证券持仓查询回调
	 */
	function queryStockCallback(data){
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					if(results.length >= 6){
						var selectHeight = 6 * 0.44;
					}else{
						selectHeight = 0.44*results.length;
					}
					var listHtml = "<ul style=\"display:none;overflow-y:auto;height:"+selectHeight+"rem\">";
					for(var i = 0;i < results.length; i++) {
						listHtml += "<li><a href=\"javascript:void(0);\"><strong>"+results[i].stock_code+"</strong>"+results[i].stock_name+"</a></li>";
					};
					listHtml+="</ul>";
					$(_pageId+".select_box").append(listHtml);
					appUtils.bindEvent($(_pageId+".select_box ul li"),function(){
						var stockCode = $(this).find("strong").html();
						$(_pageId+".select_box p").html(stockCode);
						queryMaxAmount(stockCode);
					});
				}else{
					$(_pageId+".select_box p").text("暂无现券可还");
					$(_pageId+".select_box").addClass("deleteBefore");
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 查询买入可用资金最大可买数量
	 * */
	function queryMaxAmount(stockCode){
		if(!stockCode){
			return false;
		}
		$(_pageId+"#canPay").val("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid= userInfo.session_id;
		var password = userInfo.password;
		var stock_code =stockCode;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"stock_code":stock_code
			};
		service_credit.restock_link(param,queryMaxAmountCallBack);
	}
	/**
	 * 查询买入可用资金最大可买数量回调方法
	 */
	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				var canPay = results[0].enable_amount;
				var needPay = results[0].enable_return_amount;
				var stock_code = results[0].stock_code;
				$(_pageId+"#stockName").val(results[0].stock_name);
				stockAccount = results[0].stock_account;
				exchangeType = results[0].exchange_type;
				$(_pageId+"#canPay").val(canPay);//可卖（还）数量(现券还券有效
				$(_pageId+"#needPay").val(needPay);//需还
				$(_pageId+".input_form .input_slider em:eq(1)").text(canPay);
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){	
		//验证股票代码输入是否正确
		var buy_stockCode = $(_pageId+"#stockCode").text();
		if(buy_stockCode.length == 0){
			layerUtils.iAlert("请输入证券代码");
			return false;
		}	
		if(buy_stockCode.length <5){
			layerUtils.iAlert("证券代码输入错误");
			return false;
		}	
		//验证还券数量
		var num = $(_pageId+"#stockNum").val();
		if(num.length == 0){
			layerUtils.iAlert("请输入还券数量");
			return false;
		}
		if(Number(num) <= 0){
			layerUtils.iAlert("还券数量必须大于0");
			return false;
		}
		var needPay = $(_pageId+"#needPay").val();
		if(Number(num) > Number(needPay)){
			layerUtils.iAlert("委托数量大于需还数量");
			return false;
		}
		var mostBuy = $(_pageId+"#canPay").val();
		if(Number(num) > Number(mostBuy)){
			layerUtils.iAlert("该证券可还数量不足");
			return false;
		}
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>现券还券</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>证券名称 <em>"+$(_pageId+"#stockName").val()+"</em></li>";
		tipStr+="    <li>证券代码 <strong>"+$(_pageId+"#stockCode").text()+"</strong></li>";
		tipStr+="    <li>还券数量 <strong>"+num+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
			var cust_code = userInfo.cust_code;	//客户代
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no = userInfo.branch_no;	//分支机构
			var sessionid=userInfo.session_id;
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var password= userInfo.password;
			var exchange_type = exchangeType;	
			var stock_account = stockAccount;
			var stock_code=buy_stockCode;
			var entrust_amount=num;
			var compact_id = "";
			var param = {
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"password":password,
					"sessionid":sessionid,
					"exchange_type":exchange_type,
					"stock_account":stock_account,
					"stock_code":stock_code,
					"entrust_amount":entrust_amount,
					"compact_id":compact_id
				};
			service_credit.repaystock(param,getStockBuyCallBack);
		}, null);
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data)
	{
		if(data.error_no == 0){
			var results = data.results;
			if(results ){
				//提示框
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				layerUtils.iAlert(tipStr);
			}
			resetBuyForm();
			$(_pageId+"#stockCode").val("");
		}else{
			layerUtils.iAlert(data.error_info);
			resetBuyForm();
		}
	}
	/**
	 * 重置表单
	 * */
	function resetBuyForm(){
		$(_pageId+"#stockCode").text("请选择");
		$(_pageId+"#stockName").val("");
		$(_pageId+"#stockNum").val("");
		$(_pageId+"#canPay").val("");
		$(_pageId+"#needPay").val("");
		$(_pageId+".select_box ul").hide();
		$(_pageId+".input_slider .r1").val("0");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		resetBuyForm();
		stockAccount =null,//证券账号
		exchangeType = null,//交易市场类别（见数据字典)
		$(_pageId+"#stockCode").val("");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/order/bondAlsoCoupons","credit/order/mainOrder",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});