/**
 * 信用交易-买券还券
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var commonOrder = require("commonOrder");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_credit = require("service_credit");
	var _pageId = "#credit_order_buyTicketsRepay ";
	
    /**
     * 初始化
     */
	function init(){
		var orderType = "7"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
		commonOrder.dataInit(_pageId,orderType);
		queryReapy();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		commonOrder.elementBindEvent();
		//查询跳转
		appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
			appUtils.pageInit("credit/order/buyTicketsRepay","credit/query/financingQuery",{});
			e.stopPropagation();
		});
	}
	
	//资产负债查询
	function queryReapy(){
		var userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password =  userInfo.password;
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"password":password
		};
		service_credit.queryRqLiabilities(param,queryRqLiabilitiesCallback);
	}
	function queryRqLiabilitiesCallback(data){
		if (data && data != "undefined") {
			if(data.error_no == 0){
				$(_pageId+".fund_table").show();
				var results = data.results;
				if(results && results.length>0){
					var data = "<tr><th scope=\"col\">证券/代码</th> <th scope=\"col\">负债数量</th><th scope=\"col\">盈亏</th><th scope=\"col\">需还数量</th></tr>";
					for (var i=0;i<results.length;i++){ 
						 data += queryHTML(results[i]);
					}
					$(_pageId+".fund_table .ce_table").html(data);
					$(_pageId+".no_data").hide();
					//卖出事件
					appUtils.bindEvent($(_pageId+".fund_table .ce_table tr:gt(0)"), function(e){
						var stockCode = $(this).attr("id");
						commonOrder.getStockList(stockCode);
						e.stopPropagation();
					},"click");
				}else{ 
					$(_pageId+".no_data").show();
				}
			}else{
				$(_pageId+".no_data").show();
				layerUtils.iAlert(data.error_info);
			}
		}else{
			$(_pageId+".no_data").show();
			layerUtils.iAlert("查询失败");
		}
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryHTML(element){
		var css = "";
		var shortsell_profit = Number(element.shortsell_profit);//浮动盈亏
		if(shortsell_profit>0){
			shortsell_profit = "+" + shortsell_profit.toFixed(2);
			css = "ared";
		}else if(shortsell_profit<0){
			css = "agreen";
			shortsell_profit = shortsell_profit.toFixed(2);
		}
        var eleHtml = "";
        eleHtml+="<tr id="+element.stock_code +">";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.stock_code +"</small></td>";
        eleHtml+="<td><span>"+element.debit_current_amount+"</span></td>";
        eleHtml+="<td><span class=\""+css+"\">"+shortsell_profit+"</span></td>";
        eleHtml+="<td>"+element.payback_return_amount+"</td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		commonOrder.dataDestroy();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		commonOrder.orderPageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});