/**
 * 信用交易-现金还款
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
    var _pageId = "#credit_order_cashPayments ";
    var userInfo =null;
	var debtdate = ""; //合约日期
	var debtsno = "";  //合约编号
    
    /**
     * 初始化
     */
	function init(){
		common.systemKeybord(); // 解禁系统键盘
		$(_pageId+".input_slider r1").attr("value",50);
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));	
		$(_pageId+".main .fund_table").scrollTop(0);
		$(_pageId+".main .fund_table").css("overflow-y","auto");
        var height_meau = $(window).height() - $(_pageId+".header").height() - $(_pageId+".main .pay_form").outerHeight() - 22;
		$(_pageId+".main .fund_table").height(height_meau); //查询目录添加高度
		queryFundSelectData(); // 查询资金
		//openInterest();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("credit/order/cashPayments","credit/order/mainOrder",{});
			e.stopPropagation();
		});
		//查询跳转
		appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
			appUtils.pageInit("credit/order/cashPayments","credit/query/financingQuery",{});
			e.stopPropagation();
		});
		//滚动联动
		appUtils.bindEvent($(_pageId+".input_slider .r1"), function(e){
			var mayPay = $(_pageId+".input_form .input_slider em:eq(1)").text();
			var turn = $(this).val();
			$(_pageId+"#payMoney").val((mayPay*turn/100).toFixed(2));
			e.stopPropagation();
		},"input");
		//提交委托
		appUtils.bindEvent($(_pageId+".input_form .ce_btn"), function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		//可还下拉框
		appUtils.bindEvent($(_pageId + ".select_box"), function(e){
			$(_pageId+".select_box ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		//选择还款类型
		appUtils.bindEvent($(_pageId + ".select_box ul li"),function(e){
			$(_pageId + ".select_box").attr("value",$(this).attr("value"));
			$(_pageId + ".select_box p").html($(this).find("a").html());
			if($(this).index()=="0"){
				var mayPay = $(_pageId+"#mayPay").val();  //需还款额
				$(_pageId+".input_form .input_slider em:eq(1)").text(mayPay);
				$(_pageId+"#stockInfo").val("");
				$(_pageId+"#payMoney").val("");
			}
		});
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			if($(_pageId +".select_box ul").is(':visible')){
				$(_pageId +".select_box ul").slideToggle("fast");
			}	
			e.stopPropagation();	// 阻止冒泡
		});
	}
    
	/**
	 * 资金查询
	 */
	function queryFundSelectData(bz){	
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = bz?bz:"";////货币 ""所有货币，0 人民币，1 港币，2 美元
		var password = userInfo.password;
		var sessionid=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"money_type":money_type
		};
		service_credit.remoney_link(param,queryFundSelectCallback);
	}
	
	/**
	 * 资金查询回调方法
	 * @param {Object} data 返回数据
	 */
	function queryFundSelectCallback(data){
		if(data) {
			if(data.error_no == 0){
				var account = data.results;
				var current_balance = account[0].fin_enrepaid_balance;
				var total_debit = account[0].real_compact_balance;
				$(_pageId+"#enableMoney").val(Number(current_balance).toFixed(2)); // 资金可用金额
				$(_pageId+"#mayPay").val(Number(total_debit).toFixed(2));  // 需还款额
				$(_pageId+".input_form .input_slider em:eq(1)").text(Number(total_debit).toFixed(2));
				if(Number(total_debit)>0){
					openInterest(); //需还款证券查询
				}else{
					$(_pageId+ ".no_data").show();
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){	
		//还款金额
		var money = $(_pageId+"#payMoney").val();
		if(money.length == 0){
			layerUtils.iAlert("请输入还款金额");
			return false;
		}	
		//验证股票价格输入是否正确
		if(!validatorUtil.isNumberFloat(money)){
			layerUtils.iAlert("请输入正确还款金额");
			return false;
		}
		if(Number(money) <= 0){
			layerUtils.iAlert("还款金额必须大于0");
			return false;
		}
		var avail = $(_pageId+" #enableMoney").val();
		if(Number(avail) < Number(money)){
			layerUtils.iAlert("可用金额不足");
			return false;
		}
		var mayPay = $(_pageId + ".input_form .input_slider em:eq(1)").text();
		//验证需还款额
		if(Number(money) > Number(mayPay)){
			layerUtils.iAlert("还款金额已经大于需还款额");
			return false;
		}
		var tipText = $(_pageId + ".select_box p").text();
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>"+tipText+"</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>资产账户 <em>"+userInfo.fund_account+"</em></li>";
		tipStr+="    <li>操作类型 <em>现金还款</em></li>";
		tipStr+="    <li>需还款额 <strong>"+$(_pageId+" #mayPay").val()+"</strong></li>";
		tipStr+="    <li>还款金额 <strong>"+money+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
			var pay_type = 0;
			var debit_type = "";
			var serial_no = "";
			var init_date = "";
			var compact_id = "";
			if($(_pageId + ".select_box").attr("value")=="0"){
				pay_type = 0;
			}else{
				pay_type = 1;
				var datas = $(_pageId + "#stockInfo").attr("data");
				serial_no = datas.split(",")[0];
				init_date = datas.split(",")[1];
				compact_id = datas.split(",")[2];
			}
			var cust_code = userInfo.cust_code;	//客户代码
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no = userInfo.branch_no;	//分支机构
			var sessionid = userInfo.session_id;
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var password = userInfo.password;
			var money_type = "0";	
			var occur_balance = $(_pageId+"#payMoney").val();
		
			var param = {
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"password":password,
					"sessionid":sessionid,
					"money_type":money_type,
					"pay_type":pay_type,
					"occur_balance":occur_balance,
					"compact_id":compact_id,
					"debit_type":debit_type,
					"serial_no":serial_no,
					"init_date":init_date,
				};
			service_credit.repayment(param,getStockBuyCallBack);
		}, null);
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results ){
				var entrust_no = results[0].entrust_no;
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号 : "+(entrust_no);
				layerUtils.iAlert(tipStr);
			}
			resetBuyForm();
			openInterest();
			queryFundSelectData();
			
		}else{
			resetBuyForm();
			queryFundSelectData();
			layerUtils.iAlert(data.error_info);
		}
	}

	/**
	 * 需还款证券查询
	 * */
	function openInterest(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid
		};
		service_credit.openInterest_Query(param,function(data){
			if (data && data != "undefined") {
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length > 0){
						var queryStockHtml = "<tr><th scope=\"col\">名称/代码</th><th scope=\"col\">剩余未还</th><th scope=\"col\">合约到期日</th></tr>";
						for(var i = 0; i < results.length; i++) {
							queryStockHtml += createHtml(results[i]);
						}
						$(_pageId+".fund_table .ce_table").html(queryStockHtml);
						$(_pageId+".no_data").hide();
						//绑定买卖下单事件
						appUtils.bindEvent($(_pageId+".fund_table .ce_table tr"), function(e){
							var datas = $(this).attr("id");
							var payMoney = $(this).find("td:eq(1)").text();
							var stockName = $(this).find("strong").text();
							var stockCode = $(this).find("small").text();
							$(_pageId + "#payMoney").val(payMoney);
							$(_pageId + "#stockInfo").val(stockCode+"  "+stockName);
							$(_pageId + "#stockInfo").attr("data",datas);
							$(_pageId + ".input_form .input_slider em:eq(1)").text(payMoney);
							$(_pageId + ".input_slider .r1").val((payMoney/payMoney)*100).slider("refresh");
							$(_pageId + ".select_box").attr("value","1");
							$(_pageId + ".select_box p").html("合约还款");
							e.stopPropagation();
						},"click");
					}else{
						$(_pageId+ ".no_data").show();
					}
				}
				else{
					layerUtils.iAlert(data.error_info);
				}
			}
		});
	}
	
	/**
	 * 需还HTML生成
	 */
	function createHtml(element){
		var price_digit = 2;
        var eleHtml = "";
        eleHtml+="<tr id="+element.serial_no+","+element.init_date+","+element.compact_id+">";
        eleHtml+="<td><strong>"+element.stock_code +"</strong><small>"+element.stock_name +"</small></td>";
//      eleHtml+="<td>"+element.repaid_balance+"</td>";
        eleHtml+="<td>"+element.real_compact_balance +"</td>";
        eleHtml+="<td>"+element.end_date +"</td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	
	/**
	 * 重置表单
	 * */
	function resetBuyForm(){
		$(_pageId + ".select_box").attr("value","0");
		$(_pageId + ".select_box p").html("直接还款");
		$(_pageId + "#enableMoney").val("");
		$(_pageId + "#mayPay").val("");
		$(_pageId + "#payMoney").val("");
		$(_pageId + ".select_box ul").hide();
		$(_pageId + "#stockInfo").val("");
		$(_pageId + ".input_slider .r1").val("0");
	
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		resetBuyForm();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/order/cashPayments","credit/order/mainOrder",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});