/**
 * 信用交易-还款换券
 */

define(function(require,exports,module){
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var service_credit = require("service_credit");
	var global = gconfig.global;
	var _pageId = "#credit_order_sellList ";
	var userInfo = null;
	
	/**
	 * 初始化
	 */
	function init(){
	    userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		queryFundSelectData();
	}
	
	/**
	 * 绑定事件
	 */
	function bindPageEvent(){
		appUtils.bindEvent($(_pageId+".top_title .icon_back"),function(e){
			appUtils.pageInit("credit/order/sellList","credit/order/mainOrder");
			e.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+".mar_nav ul li a"),function(e){
			var topage = $(this).attr("to-page").replaceAll("_","/");
			appUtils.pageInit("credit/order/sellList",topage);
			e.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId+".mar_link a"),function(e){
			appUtils.pageInit("credit/order/sellList","credit/order/cashPayments");
			e.stopPropagation();
		});
	}
	
	
	/**
	 * 资金查询
	 */
	function queryFundSelectData(bz){	
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = bz?bz:"";////货币 ""所有货币，0 人民币，1 港币，2 美元
		var password = userInfo.password;
		var sessionid=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"money_type":money_type
		};
		service_credit.remoney_link(param,queryFundSelectCallback, {"isLastReq":false,"isShowWait":false});
	}
	
	/**
	 * 资金查询回调方法
	 * @param {Object} data 返回数据
	 */
	function queryFundSelectCallback(data){
		if(data) {
			if(data.error_no == 0){
				var total_debit = data.results[0].real_compact_balance;
				$(_pageId+".mar_link span").text(Number(total_debit).toFixed(2));
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	
	/**
	 * 销毁
	 */
	function destroy(){
		
	}
	
	var base = {
			"init":init,
			"bindPageEvent":bindPageEvent,
			"destroy":destroy
	};
	module.exports = base;
});