/**
 * 信用交易-卖券还款
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_credit = require("service_credit");
	var commonOrder = require("commonOrder");
	var _pageId = "#credit_order_sellTicketsRepayment ";
	
    /**
     * 初始化
     */
	function init(){
		var orderType = "8"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
		commonOrder.dataInit(_pageId,orderType);
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".trade_main").height()-27;
        $(_pageId+".search_scroll").height(height_table);   //给持仓数据添加高度
		queryInquiry();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		commonOrder.elementBindEvent();
		//持仓和选择合约切换
		appUtils.bindEvent($(_pageId+".fund_tab ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			//$(_pageId+".search_scroll ul:gt(0)").removeClass("active");
			if($(this).index()==0){
				$(_pageId+".fund_table").show();
				$(_pageId+".search_scroll").hide();
			}else if($(this).index()==1){
				queryInquiry();
				$(_pageId+".search_scroll").show();
				$(_pageId+".fund_table").hide();
			}
			e.stopPropagation();
		});	
		//查询跳转
		appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
			appUtils.pageInit("credit/order/sellTicketsRepayment","credit/query/financingQuery",{});
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 查询未偿还合约
	 */
	function queryInquiry(){
		$(_pageId+".main .table_box").html("");
		var userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		//var query_type = "0";  // 为偿还合约
		var compact_type = "1";  // 为偿还合约
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"password":password,
			"cust_code":cust_code,
			"compact_type":compact_type,
			"sessionid":sessionid
		};
		service_credit.contractInquiry(param,queryInquiryCallBack);//未偿还合约查询
	}
	function queryInquiryCallBack(data){
		if(data.error_no == 0){
			$(_pageId+".search_scroll .title").html("").nextAll("ul").remove();
			var results = data.results;	
			if(results && results.length > 0){
				var dealHtml = "<li style=\"width:25%;\">证券/代码</li><li style=\"width:25%;\">合约日期/编号</li><li style=\"width:25%;\">负债数量</li><li style=\"width:25%;\">未还金额</li>";
				$(_pageId+".search_scroll .title").html(dealHtml);
				var interestHtml = "";
				for(var i = 0;i < results.length; i++){
					var data = results[i];
					interestHtml += createHtml(data);
				}
				$(_pageId+".search_scroll .title").after(interestHtml);
				appUtils.bindEvent($(_pageId+".search_scroll ul:gt(0)"), function(e){
					if($(this).hasClass("active")){
						$(this).removeClass("active");
					}else{
						$(this).addClass("active").siblings().removeClass("active");
					}
				});
			}else{
				$(_pageId+".no_data").show();
			}
		}else{
			layerUtils.iAlert(data.error_info);	
		}
	}
	function createHtml(element){
        var eleHtml = "";
        eleHtml+="<ul>";
		eleHtml+="<li style=\"width:25%;\"><span>"+element.stock_name +"</span><small>"+element.stock_code+"</small></li>";
		eleHtml+="<li style=\"width:25%;\"><span>"+element.init_date+"</span><span>"+element.pc_id+"</span></li>";
		eleHtml+="<li style=\"width:25%;line-height:0.45rem\">"+element.enable_return_amount+"</li>";
		eleHtml+="<li style=\"width:25%;line-height:0.45rem\">"+element.real_compact_balance+"</li>";
		eleHtml+="<li style=\"display:none\">"+element.debit_type+"</li>";
		eleHtml+="<li style=\"display:none\">"+element.serial_no+"</li>";
		eleHtml+="<li style=\"display:none\">"+element.init_date+"</li>";
		eleHtml+="<li style=\"display:none\">"+element.exchange_type_pay+"</li>";
		eleHtml+="</ul>";
        return eleHtml;
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		commonOrder.dataDestroy();
		$(_pageId+".search_scroll ul:gt(0)").removeClass("active");		
		$(_pageId+".fund_tab ul li:eq(0)").addClass("active").siblings().removeClass("active");
		$(_pageId+".fund_table").show();
		$(_pageId+".search_scroll").hide();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		commonOrder.orderPageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});