/**
 * 信用交易-交易撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
	var VIscroll = require("vIscroll"); 
	var common = require("common"); 
	var	vIscroll = {"scroll":null,"_init":false};	//上下滑动
	var _pageId = "#credit_order_tradeCancellation ";
	var userInfo = null;
		
    /**
     * 初始化
     */
	function init(){
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		queryCancelData(); // 撤单查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		//全部撤单
		appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
			var entrust_no = getEntrustNo();//合同序号
			if(!entrust_no){
				layerUtils.iAlert("暂无可撤单委托");
				return false;
			}
			var batch_flag="1";
			var exchange_type="";
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid=userInfo.session_id;
			var password= userInfo.password;
			var param={				
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"password":password,
					"sessionid":sessionid,
					"entrust_no":entrust_no,
					"batch_flag":batch_flag,
					"exchange_type":exchange_type	
			};
			var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>是否全部撤单?</div></div>";
			common.btnConfirm(tipStr,function success(){
				service_credit.credit_cancel(param,postCancelOrderCallback);
			},function fail(){
			} );

			e.stopPropagation();
		});
	}
    
	/**
	 * 撤单查询
	 */
	function queryCancelData(){
		$(_pageId+ ".no_data").hide();
		$(_pageId+".cancel_list").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account	= userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid= userInfo.session_id;
		var stock_account ="";
		var stock_code = "";
		var entrust_bs = "";
		var exchange_type = "";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"entrust_bs":entrust_bs
		};
		service_credit.todaykcwt_query(param,queryCancelCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});//股票查询
	}
	/**
	 * 股份查询回调方法
	 * @param {Object} data 返回数据
	 */
	function queryCancelCallback(data){
		if(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var queryStockHtml = "";
					for ( var i = 0; i < results.length; i++) {
						queryStockHtml += createHtml(results[i]);
					}
					$(_pageId+".cancel_list").html(queryStockHtml);
					//绑定撤单事件
					appUtils.bindEvent(_pageId+" .cancel_li a",function (){
						selectObject=$(this).parents(" .trade_box");
						var $currItem = $(this).parents("ul");
						if(selectObject&&selectObject.length>0){
							postCancelOrder($currItem);
						}
					});
					//撤单事件
					appUtils.bindEvent($(_pageId+".cancel_list #cancel"), function(e){
						postCancelOrder($(this).parent().parent());
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}

	/**
	 * 生成股份查询html
	 */
	function createHtml(element){
		var price_digit = 2;
		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
	    	if(data){
	    		price_digit = data;
	    	}
		});
		var css = "";
		var entrust_bs = element.entrust_bs;
		if(entrust_bs=="0"){
			css = "ared";
		}else if(entrust_bs=="1"){
			css = "agreen";
		}
		var eleHtml = "";
			eleHtml +="<dl class=\"part\" id="+element.entrust_no+">";
			eleHtml +="<dt><span class="+css+">"+element.entrust_type_name+"</span><strong>"+element.stock_name+"</strong><small>"+element.stock_code+"</small></dt>";
			eleHtml +="<dd>";
			eleHtml +="	   <a href=\"javascript:void(0);\" id=\"cancel\">撤单</a>";
			eleHtml +="	   <p class=\"time\">"+element.entrust_time+"</p>";
			eleHtml +="    <span>委托价 <em>"+Number(element.entrust_price).toFixed(price_digit)+"</em></span><span>委托数 <em>"+Number(element.entrust_amount)+"</em></span>";
			eleHtml +="    <span>成交价 <em>"+Number(element.business_price).toFixed(price_digit)+"</em></span><span>成交数 <em>"+Number(element.business_amount)+"</em></span>";
			eleHtml +=" </dd>";
			eleHtml +="</dl>";
        return eleHtml;
	}
	
	/**
	 * 委托撤单
	 * @param $currItem 当前条目
	 */
	function postCancelOrder(dom){
		var stockCode = dom.find("dt small").text(); // 证券代码
		var stockName = dom.find("dt strong").text(); // 证券名称
		var delegateOrien = dom.find("dt span").text(); // 操作类型
		var delegatePrice = dom.find("dd span:eq(0) em").text(); // 委托价格
		var delegateQuantity = dom.find("dd span:eq(1) em").text(); // 委托数量
		var entrust_no = dom.attr("id");//合同序号
		var batch_flag="0";
		var exchange_type="";
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";////货币 ""所有货币，0 人民币，1 港币，2 美元
		var sessionid=userInfo.session_id;
		var password= userInfo.password;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_no":entrust_no,
				"batch_flag":batch_flag,
				"exchange_type":exchange_type
		};
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>撤单</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>证券名称 <em>"+stockName+"</em></li>";
		tipStr+="    <li>证券代码 <strong>"+stockCode+"</strong></li>";
		tipStr+="    <li>操作类型 <strong>"+delegateOrien+"</strong></li>";
		tipStr+="    <li>委托价格 <strong>"+delegatePrice+"</strong></li>";
		tipStr+="    <li>委托数量 <strong>"+delegateQuantity+"</strong></li>";
		tipStr+="    <li>委托编号 <strong>"+entrust_no+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
			service_credit.credit_cancel(param,postCancelOrderCallback);
		},function fail(){
		} );
	}
	/**
	 * 委托撤单回调方法
	 * @param {Object} data 返回数据
	 */
	function postCancelOrderCallback(data){
		if(data){
			var errorNo = data.error_no;
			if (errorNo == 0) {
				layerUtils.iAlert(data.error_info);
			}else{
				layerUtils.iAlert(data.error_info);
			}
			queryCancelData();
		}
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						queryCancelData();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}
	
	//获取全部撤单的合同序号
	function getEntrustNo(){
		var entrust_no = "";
		var ents = $(_pageId+'.cancel_list>dl[class="part"]');
		for(var i=0;i<ents.length;i++){
			entrust_no +=(ents.eq(i).attr("id")+",");
		}
		if(entrust_no.length>0){
			entrust_no = entrust_no.substring(0,entrust_no.length-1);
		}
		return entrust_no;
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+ ".no_data").hide();
		$(_pageId+".cancel_list").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});