/**
 * 信用交易-担保品证券
 */
define(function(require, exports, module) {
    var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var	layerUtils = require("layerUtils");
	var	service_credit = require("service_credit");
	var external = require("external");
	var	_pageId = "#credit_query_collateralQuery ";
	var common = require("common");
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	var service_hq = require("service_hq");
	var changeToPinyin = require("changeToPinyin");
	var userInfo = null;//保存的客户信息
	var stockNameArr = [];//保存股票英文简写名称
	var stockCodeArr = [];//保存股票股票代码
	var queryMsg = null;//查询后返回的结果集
	var isStockInput = false;//输入后状态
    var position_str = ""; // 当前页数定位串
    var pageNum = "15"; // 每次查询页数
	
    /**
     * 初始化
     */
	function init(){
		//获取客户保存在本地的数据
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		queryCollateral();//查询数据
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			if ($(_pageId + " input").is(":focus")){
				$(_pageId + " input").blur();
				setTimeout(function(){
					appUtils.pageBack();
				}, 210);
			} else {
				appUtils.pageBack();
			}
			e.stopPropagation();
		});
		//点击查询按钮
		appUtils.bindEvent($(_pageId+" #search"),function(){
			$(_pageId + " #remove").remove();
			position_str = "";
			var stockCode = $(_pageId+" #stockCode").val();
			queryCollateral(stockCode);
		});
	}
 
    /**
	 * 担保品数据查询
	 */
	function queryCollateral(stockCode,position_str){
		stockCodeArr.length = 0;//保存股票英文简写名称
		queryMsg = null;//查询后返回的结果集
		$(_pageId + ".ti_table tr:eq(0)").nextAll().remove();
		$(_pageId + ".no_data").hide();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var stock_code = stockCode ? stockCode : "";
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var request_num = pageNum;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"stock_code":stock_code,
			"position_str":position_str,
			"request_num":request_num
		};
		service_credit.db_query(param,db_queryCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	/**
	 * 担保品数据调方法
	 * @param {Object} data 返回数据
	 */
	function db_queryCallBack(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;	
				queryMsg = data.results;//将返回的结果集保存
				if(results && results.length > 0){
					var todayDealHtml = "";
					for(var i = 0;i < results.length; i++){
						var data = results[i];
						todayDealHtml += createHtml(data);
					}
					position_str = results[results.length-1].position_str;
//					$(_pageId+" .cz_table tr:eq(0)").after(todayDealHtml);
					$(_pageId+" tbody").append(todayDealHtml);
				}else{
					$(_pageId+ ".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
		 	}else{
				layerUtils.iAlert(data.error_info);	
			}
		}
	}
	/**
	 * 
	 * @param {Object} element
	 */
	function createHtml(element){
		var market = element.exchange_type;
		if(market == "0"){
			market = "深A";
		}else if(market == "1")
		{ 
			market ="深B";
		}else if(market == "2")
		{ 
			market ="沪A";
		}else if(market == "3")
		{ 
			market ="沪B";
		}else if(market == "4")
		{ 
			market ="三板";
		}else if(market == "F1")
		{ 
			market ="郑州交易所";
		}else if(market == "F2")
		{ 
			market ="大连交易所";
		}
		
//		var stockNameHan = (element.stock_name).replace(/\s/g, "").replaceAll("Ａ", "A");//这支股票的名称(汉字)
//		var stockNameEn = "";//股票名称英文简写
//		for(var i = 0;i< stockNameHan.length;i++){
//			//将股票名称每个字符遍历，转换成英文，并取出第一个字母，拼在一起，组成了股票名称英文简写
//			stockNameEn += changeToPinyin.changeToPinyin(stockNameHan.charAt(i)).substring(0,1).toLowerCase(); 
//		}
//		stockNameArr.push(stockNameEn);

		stockCodeArr.push(element.stock_code);//将股票名称放入集合中
		var eleHtml = "";
	    eleHtml += "<tr id='remove'>";
		eleHtml += "<td>"+element.stock_code+"</td>";
		eleHtml += "<td>"+element.stock_name+"</td>";
		eleHtml += "<td>"+market+"</td>";
		eleHtml += "<td>"+Number(element.assure_ratio*100).toFixed(2)+"%</td>";
		eleHtml +="</tr>";
		return eleHtml;
	}
	
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createSearchHtml(element)
	{
		var market = element.exchange_type;
		if(market == "0"){
			market = "深A";
		}else if(market == "1")
		{ 
			market ="深B";
		}else if(market == "2")
		{ 
			market ="沪A";
		}else if(market == "3")
		{ 
			market ="沪B";
		}else if(market == "4")
		{ 
			market ="三板";
		}else if(market == "F1")
		{ 
			market ="郑州交易所";
		}else if(market == "F2")
		{ 
			market ="大连交易所";
		}
		
		var eleHtml = "";
	    eleHtml += "<tr id='remove'>";
		eleHtml += "<td>"+element.stock_code+"</td>";
		eleHtml += "<td>"+element.stock_name+"</td>";
		eleHtml += "<td>"+market+"</td>";
		eleHtml += "<td>"+Number(element.assure_ratio*100).toFixed(2)+"%</td>";
		eleHtml +="</tr>";
		return eleHtml;
	}
    
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".header").height() - $(_pageId+".search_box").height() - 16,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					$(_pageId + ".ti_table tr:eq(0)").nextAll().remove();
					position_str = "";
					queryCollateral("",position_str);
				},
				"upHandle": function() {
					var index = $(_pageId+".table_box tbody").children().length;
					if(index>2){
						queryCollateral("",position_str);
					}
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+" #stock_list").html("");//清空股票搜索框
		$(_pageId + " #remove").remove();
		$(_pageId + " #stockCode").val("");
		$(_pageId + " #stockName").text("证券名称");
		stockCodeArr.length = 0;
		isStockInput = false;//输入后状态
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});