/**
 * 信用交易-未偿还合约查询/已了结合约
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var service_credit = require("service_credit");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_contractInquiryQuery ";
    var userInfo = null;
    var queryType = null;
    	
    /**
     * 初始化
     */
	function init(){
		queryType = appUtils.getPageParam("param");
		if(queryType=="0"){
			$(_pageId + ".top_title h3").text("未偿还合约");
			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="1"){
			$(_pageId + ".top_title h3").text("已了结合约（60天）");
			$(_pageId+".tab_nav ul li:eq(1)").addClass("active").siblings().removeClass("active");
		}
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		queryMsg(queryType);//查询信息
    }
	/**
	 * 查询信息
	 */
	function queryMsg(queryType){
		$(_pageId+ ".no_data").hide();
//		if($(_pageId+".tab_nav ul li:eq(0)").hasClass("active")){
//			queryContractData(); //未偿还合约查询
//		}else{
			queryContractData(queryType); //已了结合约查询
//		}
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		//页面切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			if(vIscroll._init){
				vIscroll.scroll.destroy();
				vIscroll.scroll = null;
				vIscroll._init = false;
			}
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title h3").text($(this).find("a").text());
			queryMsg(); //平仓合约查询
		},"click");
	}
	
	/**
	 * 未偿还合约查询
	 */
	function queryContractData(query_type){
		$(_pageId+".main .table_box").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;

		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"password":password,
			"cust_code":cust_code,
			"query_type":query_type,
			"sessionid":sessionid
		};
		if(query_type == "1"){  // 已了结
			var begin_date = new Date();  
			var end_date  = new Date();	//截止时间
			begin_date.setDate(begin_date.getDate() - 60);
			begin_date = begin_date.format("yyyy-MM-dd");
			end_date.setDate(end_date.getDate());
			end_date = end_date.format("yyyy-MM-dd");
			param.begin_date = begin_date;
			param.end_date = end_date;
		}
		service_credit.openInterest_Query(param,openInterest_QueryCallBack,
		{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
		}
		});//未偿还合约查询
	}
	/**
	 * 未偿还合约数据查询回调方法
	 */
	function openInterest_QueryCallBack(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;	
				if(results && results.length > 0){
					var openInterestHtml = "";
					for(var i = 0;i < results.length; i++){
						var data = results[i];
						openInterestHtml += createHtml(data,i);
					}
					$(_pageId+".main .table_box").html(openInterestHtml);
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		}
	}
	/**
	 * 生成未偿还合约html
	 * @param {Object} element 数据项
	 */
	function createHtml(element,i){
		var type = "";
		if(element.type == "0"){
			type = "融资";
		}else if(element.type == "1"){
			type = "融券";
		}
		if(element.status == "0"){
			status = "未偿还";
		}else if(element.status == "1"){
			status = "已偿还";
		}else if(element.status = "2"){
			status = "到期未平仓";
		}
		if(queryType == 0){
			var eleHtml = "";
				eleHtml += "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"ct_table\" style=\"margin-top: 10px;\">";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>序号</span>"+(i+1)+"</td>";
				eleHtml += "  <td><span>合约日期</span>"+element.open_date+"</td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>证券代码</span><strong style=\"font-family: serif;font-size: 15px;'\">"+element.stock_code+"</strong></td>";
				eleHtml += "  <td><span>证券名称</span><strong style=\"font-family: serif;font-size: 15px;\">"+element.stock_name+"</strong></td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>融资融券方向</span>"+type+"</td>";
				eleHtml += "  <td><span>合约状态</span>"+status+"</td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>成交数量</span>"+element.business_amount+"</td>";
				eleHtml += "  <td><span>成交金额</span>"+element.business_price+"</td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>融资金额</span>"+element.clearing_money+"</td>";
				eleHtml += "  <td><span>合约盈亏</span>"+element.contractProfit+"</td>";
				eleHtml += "</tr>";
				eleHtml += " <tr>";
				eleHtml += "  <td><span>未还金额</span>"+element.real_compact_balance+"</td>";
				eleHtml += "  <td><span>未还本金</span>"+element.fundremain+"</td>";
				eleHtml += " </tr>";
	//			eleHtml += "<tr>";
	//			eleHtml += "  <td><span>未还数量</span>"+element.real_compact_amount+"</td>";
	//			eleHtml += "  <td><span>已还数量</span>"+element.repaid_amount+"</td>";
	//			eleHtml += " </tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>已还利息</span>"+element.repaid_interest+"</td>";
				eleHtml += "  <td><span>未还利息</span>"+element.fee+"</td>";
				eleHtml += "</tr>";
	//			eleHtml += "<tr>";
	//			eleHtml += "  <td><span>已还逾期利息</span>"+element.punidebts+"</td>";
	//			eleHtml += "  <td><span>未还逾期利息</span>"+element.punifeeunfrz+"</td>";
	//			eleHtml += "</tr>";
//				eleHtml += "<tr>";
//				eleHtml += "  <td><span>已还罚息</span>"+element.punifee_repay+"</td>";
//				eleHtml += "  <td><span>未还罚息</span>"+element.punifeeunfrz+"</td>";
//				eleHtml += "</tr>";
	//			eleHtml += "<tr>";
	//			eleHtml += "  <td><span>未还权益补偿金额/数量</span>"+element.equity_not+"</td>";
	//			eleHtml += "  <td><span>逾期未偿还权益/数量</span>"+element.equity_has+"</td>";
	//			eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td colspan=\"2\" style=\"font-family: serif;font-size: 15px;;\"><span>合约到期日</span><strong>"+element.end_date+"</strong></td>";
				eleHtml += "</tr>";
				eleHtml += " </table>";
		}else{
			var eleHtml = "";
				eleHtml += "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"ct_table\" style=\"margin-top: 10px;\">";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>序号</span>"+(i+1)+"</td>";
				eleHtml += "  <td><span>合约日期</span>"+element.open_date+"</td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>证券代码</span><strong style=\"font-family: serif;font-size: 15px;'\">"+element.stock_code+"</strong></td>";
				eleHtml += "  <td><span>证券名称</span><strong style=\"font-family: serif;font-size: 15px;\">"+element.stock_name+"</strong></td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>融资融券方向</span>"+type+"</td>";
				eleHtml += "  <td><span>合约状态</span>"+status+"</td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>成交数量</span>"+element.business_amount+"</td>";
				eleHtml += "  <td><span>成交金额</span>"+element.business_price+"</td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>融资金额</span>"+element.clearing_money+"</td>";
				eleHtml += "  <td><span>已还利息</span>"+element.repaid_interest+"</td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span>已还罚息</span>"+element.punifee_repay+"</td>";
				eleHtml += "  <td style=\"font-family: serif;font-size: 15px;;\"><span>合约了结日</span><strong>"+element.date_clear+"</strong></td>";
				eleHtml += "</tr>";
				eleHtml += " </table>";
		}
		return eleHtml;
	}
    
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						 queryMsg(queryType);//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".main .table_box").html("");
		$(_pageId+ ".no_data").hide();
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});