/**
 * 信用交易-当日委托
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_credit = require("service_credit");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_dateContract ";
    
    /**
     * 初始化
     */
	function init(){
		
		curcontractquery();
    }
	
	/**
	 * 实时合约流水查询
	 */
	function curcontractquery(){
		var userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo")),
		param = {
			"entrust_way": global.entrust_way,
			"branch_no": userInfo.branch_no,
			"fund_account": userInfo.fund_account,
			"cust_code": userInfo.cust_code,
			"password": userInfo.password,
			"sessionid": userInfo.session_id
		};
		$(_pageId+ ".no_data").hide();
		service_credit.curcontractquery(param, function(data){
			if (data){
				$(_pageId+".search_list").html("");
				var errorNo = data.error_no,
				errorInfo = data.error_info;
				if (errorNo === "0"){
					$(_pageId+".no_data").hide();
					var results = data.results,
					reLength = results.length;
					if (results && reLength >0){
						var data = "";
						for (var i=0;i<results.length;i++){
							data += queryEntrustHTML(results[i]);
						}
						$(_pageId+".search_list").html(data);
					}else{
						$(_pageId+".no_data").show();
					}
					if(!vIscroll._init){
						initVIScroll();
					}else{
						vIscroll.scroll.refresh();
					}
				} else {
					layerUtils.iAlert(errorInfo);
				}
			}
		}, {"isLastReq":true, "isShowWait":true, "isShowOverLay":false, "timeOutFunc":function(){$(_pageId+ ".no_data").show(); initVIScroll(); if(vIscroll._init){vIscroll.scroll.refresh();}}});
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var typeJson = {"0": "融资", "1": "融券"};
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<span class=\"time\">"+element.init_date+"</span>";
        eleHtml+="<h5>"+typeJson[element.compact_type]+"</h5>";
        eleHtml+="<dl class=\"clearfix\">";
        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
        eleHtml+="    <dd><em>发生金额</em>"+Number(element.occur_balance).toFixed(2)+"</dd>";
        eleHtml+="    <dd><em>发生利息</em>"+Number(element.occur_interest).toFixed(2)+"</dd>";
        eleHtml+="    <dd><em>后资金额</em>"+Number(element.post_balance).toFixed(2)+"</dd>";
        eleHtml+="    <dd><em>后证券额</em>"+Number(element.post_amount).toFixed(2)+"</dd>";
//      eleHtml+="    <dd><em>委托类别</em>"+element.entrust_type_name+"</dd>";
//      eleHtml+="    <dd><em>报价方式</em>"+element.trade_name+"</dd>";
//      eleHtml+="    <dd><em>股东代码</em>"+element.stock_account+"</dd>";
        eleHtml+="</dl>";
        eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": gconfig.appHeight - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						curcontractquery();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".search_list").html("");
		$(_pageId + ".top_title .top_nav").hide();
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});