/**
 * 信用交易---查询标的证券
 */
define(function(require,exports,module){
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var	layerUtils = require("layerUtils");
	var	service_credit = require("service_credit");
	var common = require("common");
	var external = require("external");
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	var	financialSecurities = false;
	var service_hq = require("service_hq");
	var changeToPinyin = require("changeToPinyin");
	var	_pageId = "#credit_query_queryCanRZBuyStock ";
	var userInfo = null;//保存的客户信息
	var stockNameArr = [];//保存股票英文简写名称
	var stockCodeArr = [];//保存股票股票代码
	var queryMsg = null;//查询后返回的结果集
	var isStockInput = false;//输入后状态
    var position_str = ""; // 当前页数定位串
    var pageNum = "15"; // 每次查询页数

	/**
	 * 初始化
	 * */
	function init()
	{   
		//获取客户保存在本地的数据
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
//		$(_pageId + " .t1").css("width", $(_pageId + " .input_code").width()*0.57 + "px");
		queryData();//查询数据
	}
	
	
	/**
	 * 事件绑定
	 * */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			if ($(_pageId + " input").is(":focus")){
				$(_pageId + " input").blur();
				setTimeout(function(){
					appUtils.pageBack();
				}, 210);
			} else {
				appUtils.pageBack();
			}
			e.stopPropagation();
		});
		//点击查询按钮
		appUtils.bindEvent($(_pageId+" #search"),function(){
			$(_pageId + "#remove").remove();position_str=null;
			$(_pageId + ".cz_table tr:eq(0)").nextAll().remove();
			var stockCode = $(_pageId+" #stockCode").val();
			queryData(stockCode);
		});
		//融资，融券切换
		appUtils.bindEvent($(_pageId+" .tab_nav li"),function(e){
			if(!vIscroll._init){
				initVIScroll();
			}else{
				vIscroll.scroll.refresh();
			}
			$(_pageId + " #remove").remove();
			$(_pageId + " #numRemove").remove();
			$(_pageId + " #stockCode").val("");
			$(_pageId + " #stockName").text("证券名称");
			$(this).addClass("active").siblings().removeClass("active");
			financialSecurities = ($(_pageId+" .tab_nav li").index($(this)) == 1);
			if(financialSecurities){
				$(_pageId+" #changeName").text("可融券卖出数量");
				$(_pageId + " .cz_table tr").append("<th id= \"numRemove\" scope=\"col\">最新价</th>");
			}else{
				$(_pageId + " #numRemove").remove();
				$(_pageId+" #changeName").text("融资保证金比例");
			}
			queryData();
		});
	}
	/**
	 * 查询数据
	 */
	function queryData(stockCode,position_str)
	{
		stockCodeArr.length = 0;//保存股票英文简写名称
		queryMsg = null;//查询后返回的结果集
		$(_pageId+ ".no_data").hide();
//		$(_pageId+" .ti_table tr:eq(0)").nextAll().remove();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var stock_code = stockCode ? stockCode : "";
		var exchange_type = "";
		var request_num = pageNum;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"stock_code":stock_code,
			"position_str":position_str,
	 		"request_num":request_num,
			"exchange_type":exchange_type
		};
		if(financialSecurities){
			service_credit.queryCanBeMargin(param,queryCallBack,
					{  //传给接口的json格式数据            
				"isLastReq":true,                
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){    //超时调用方法
					$(_pageId+ ".no_data").show();
					initVIScroll();
					if(vIscroll._init){
						vIscroll.scroll.refresh();
					}
		        }
			});
		}else{
			service_credit.qualificationInquiry(param,queryCallBack,
					{  //传给接口的json格式数据            
				"isLastReq":true,                
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){    //超时调用方法
					$(_pageId+ ".no_data").show();
					initVIScroll();
					if(vIscroll._init){
						vIscroll.scroll.refresh();
					}
		        }
			});
		}
	}
	/**
	 * 回调方法
	 * @param {Object} data 返回数据
	 */
	function queryCallBack(data)
	{
		if(data) {
			if(data.error_no == 0){
				var results = data.results;	
				queryMsg = data.results;//将返回的结果集保存
				if(results && results.length > 0)
				{
					if(financialSecurities){$(_pageId+" .cz_table tbody").html("")};
					var dataHtml = "";
					for(i = 0;i < results.length; i++){
						var data = results[i];
						dataHtml += createHtml(data);
					}
					position_str = results[results.length-1].position_str;
					$(_pageId+" .cz_table tbody").append(dataHtml);
				}else{
					$(_pageId+" .cz_table tbody").html("");
					$(_pageId+ ".no_data").show();
				}
				
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}else{
				$(_pageId+" .cz_table tbody").html("")
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element)
	{
		var status = "";
		if(element.finance_status == "0"||element.slo_status == "0"){
			status = "正常";
		}else if(element.finance_status == "1"||element.slo_status == "1"){
			status = "暂停";
		}
		if(element.today_enable == "0"){
			enable = "是";
		}else if(element.today_enable == "1"){
			enable = "否";
		}
		stockCodeArr.push(element.stock_code);//将股票名称放入集合中
		var eleHtml = "";
		    eleHtml += "<tr id='remove'>";
			eleHtml += "<td>"+element.stock_code+"</td>";
			eleHtml += "<td>"+element.stock_name+"</td>";
			eleHtml += "<td>"+element.exchange_type_name+"</td>";
			if(financialSecurities){
				eleHtml += "<td>"+element.enable_amount+"</td>";
				eleHtml += "<td>"+element.newest_price+"</td>";
//				eleHtml += "<td>"+element.bail_ratio+"</td>";
//				eleHtml += "<td>"+element.today_enable+"</td>";		
			}else{
				eleHtml += "<td>"+element.bail_ratio+"</td>";
//				eleHtml += "<td>"+status+"</td>";
//				eleHtml += "<td>"+""+"</td>";
			}
			
			eleHtml +="</tr>";
		return eleHtml;
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".search_box").height() - 18,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					$(_pageId+" .cz_table tbody").html("");
					position_str = "";
					queryData("",position_str);
				},
				"upHandle": function() {
					var index = $(_pageId+".table_box tbody").children().length;
					if(index>2){
						queryData("",position_str);
					}
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	
	/**
	 * 销毁
	 * */
	function destroy()
	{
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
		$(_pageId+" #stock_list").html("");//清空股票搜索框
		$(_pageId + " #stockCode").val("");
		$(_pageId + " #stockName").text("证券名称");
		financialSecurities = false;
		$(_pageId + " #numRemove").remove();
		$(_pageId + " #remove").remove();
//		$(_pageId+" .cz_table tr:eq(0)").nextAll().remove();
		$(_pageId+" .cz_table tbody").html("");
		$(_pageId+" .tab_nav li:eq(0)").addClass("active").siblings().removeClass("active");
		$(_pageId+" #changeName").text("融资保证金比例");
		stockCodeArr.length = 0;//保存股票英文简写名称
		queryMsg = null;//查询后返回的结果集
	    isStockInput = false;//输入后状态
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});