/**
 * 担保品转出
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
    var _pageId = "#credit_transferred_collateralTransferOut ";
    var	layerUtils = require("layerUtils");
    var commonFunc = require("commonFunc");
    var	service_credit = require("service_credit");
	var	VIscroll = require("vIscroll");
	var external = require("external");
	var common = require("common");
    var	vIscroll = {"scroll":null,"_init":false};	//上下滑动
    var userInfo = null;
    var stockCodeOut = "";//保存点击转出的股票代码
    /**
     * 初始化
     */
	function init(){
		if(gconfig.platform != "0"){
			common.ssoLogin("",stockCallBack);
		}else{
			stockCallBack();
		}
    }
	
	// 普通交易登录信息回调
	function stockCallBack(){ 
		commonFunc.creditLogin(2,creditCallback); // 判断融资融券权限
	}
	// 融资融券权限校验回调
	function creditCallback(){ 
		commonFunc.isAStockLogin(queryData);
	}
	
	function queryData(){
		var ModuleName = appUtils.getPageParam("ModuleName");
		if(ModuleName && ModuleName=="me"){
			$(_pageId + ".top_title .icon_back").text("我");
		}
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));//获取登陆后保存的普通账户信息
	 	//交易持仓查询（划入）
		callsQuery();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			pageBack(); // 返回
			e.stopPropagation();
		});
		//查询按钮
		appUtils.bindEvent($(_pageId+".top_title .noicon_text"), function(e){
			$(_pageId+".toggle_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
			appUtils.pageInit("credit/transferred/collateralTransferOut","credit/query/financingQuery",{});
			e.stopPropagation();
		});
		//转出，撤单切换
		appUtils.bindEvent($(_pageId+".toggle_nav li"), function(e){
			$(_pageId+" #append").html("");
			$(_pageId+".no_data").hide();
			$(this).addClass("active").siblings().removeClass("active");
			if($(this).index() == 0){
				//交易持仓查询（划出）
				queryTradePosition();
			}else{
				//撤单查询
				 queryTransCanCancel();
			}
			e.stopPropagation();
		});
	}
    
	/**
	 * 调用查询
	 */
	function callsQuery(){
		$(_pageId+" #append").html("");
		$(_pageId+".no_data").hide();
		if($(_pageId+".toggle_nav ul li:eq(0)").hasClass("active")){
			queryTradePosition();
		}else{
			queryTransCanCancel();
		}
	}
	
    /**
	 * 交易持仓查询
	 */
    function queryTradePosition(){
    	var param = {
				entrust_way: global.entrust_way, // 委托方式  在configuration配置
				branch_no: userInfo.branch_no, // 分支机构
				fund_account: userInfo.fund_account, // 资金账号
				cust_code: userInfo.cust_code, // 客户编号
				password: userInfo.password, // 交易密码
				sessionid: userInfo.session_id, // 会话号
				stock_account: "", // 证券账号
				stock_code: "", // 股票代码
				exchange_type: ""
		};
		/**
		 * 担保信息查询(划出信息查询)
		 */
		service_credit.cc_query(param,queryMsgCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
	    });
    }
    /**
     * 查询信息回调函数
     */
    function queryMsgCallBack(data){
		if(data.error_no == "0"){
			var data = data.results;
			if(data[0]){
				creatHtml(data);
			}else{
				 $(_pageId+ ".no_data").show();
			}
			if(!vIscroll._init){
				initVIScroll();
			}else{
				vIscroll.scroll.refresh();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}			
    }
    /**
     * 生成查询持仓函数
     * @param {Object} data
     */
    function creatHtml(data){
    	var html = "";
		for(var i= 0;i<data.length;i++){
			var cssClass = "";
			if(data[i].last_price > data[i].cost_price){
				cssClass = "ared";
			}else if(data[i].last_price < data[i].cost_price){
				cssClass = "agreen";
			}else{
				cssClass = "";
			}
			var float_vk = data[i].float_yk;
			if(float_vk > 0){
				float_vk = "+" + float_vk;
			}
			var float_yk_per = data[i].float_yk_per;
			
//				html += "<div class=\"mar_stock cancel_order\" id='remove'>";
				html +=	  "<div class='part' data-lastP="+data[i].last_price+" data-stockCode="+data[i].stock_code+" data-stockName="+data[i].stock_name+" data-cost="+data[i].cost_price+" data-exchageType="+data[i].exchange_type+">";
		        html +=    	"<a href='javascript:void(0);' class='order' id='stockIn'>转出</a>"
		        html +=    	"<h5>"+data[i].stock_name+" <small>"+data[i].stock_code+"</small></h5>"
		        html +=    	"<dl class='clearfix'>"
		        html +=        	"<dt><strong class="+cssClass+">"+Number(data[i].last_price).toFixed(2)+"</strong><p><span class="+cssClass+">"+float_vk+"</span><span class="+cssClass+">"+float_yk_per+"</span></p></dt>"
		        html +=            "<dd><p><em>成本</em> "+Number(data[i].cost_price).toFixed(2)+"</p><p><em>可用</em> "+data[i].enable_amount+"</p></dd>"
		        html +=            "<dd><p><em>现价</em> "+Number(data[i].last_price).toFixed(2)+"</p><p><em>市值</em> "+Number(data[i].market_value).toFixed(2)+"</p></dd>";
		        html +=    	"</dl>";
		        html +=    "</div>";
//		        html += "</div>";
		}
		$(_pageId + " #append").html(html);
		
		//划出按钮
		appUtils.bindEvent($(_pageId+"#stockIn"), function(e){
			var stockCode = $(this).parent().attr("data-stockCode");//股票代码
			var stockPrice = $(this).parent().attr("data-cost");//股票成本价
			var last_price = $(this).parent().attr("data-lastP");//现价
			var exchageType = $(this).parent().attr("data-exchageType");//市场
			creatBoxHtml(stockCode,stockPrice,last_price,exchageType);
			e.stopPropagation();
		},"click");
		
    }
    /**
     * 生成划入弹出框
     */
    function creatBoxHtml(stockCode,stockPrice,last_price,exchageType){
    	var html = "";
	    	html += "<div class='cover_layer' id='inputPopLayer'>";
	    	html += 	"<div class='pop_confirm2' style='margin-top: -80.5px;'>";
	    	html += 		"<div class='pop_main'>";
	    	html += 			"<div class='input_text2 mt10'>";
	    	html += 				"<span>划出数量:</span>";
	    	html += 				"<input type='tel' class='input_custom2' id='pwdInput' placeholder='请输入数量' custom_keyboard='0' onkeyup=\"this.value=this.value.replace(/\D/g,'')\" onafterpaste=\"this.value=this.value.replace(/\D/g,'')\">";
	    	html += 			"</div>";
	    	html += 		"</div>";
	    	html += 		"<div class='btn' style='height: 45px; padding: 0px;'>";
			html += 	    	"<a href='javascript:void(0)' id='confirm' style='height: 45px; line-height: 45px; width: 50%; background:rgb(242, 242, 242);color:#D70B17;'>确定</a>";
			html += 	    	"<a href='javascript:void(0)' id='cancel' style='height: 45px; line-height: 45px; width: 50%; color: rgb(51, 51, 51); background: white;'>取消</a>";
	    	html += 		"</div>";
	    	html += 	"</div>";
	    	html += "</div>";
    	    $("body").append(html);
			//解禁系统键盘
			appUtils.bindEvent($("#pwdInput"), function(e){
	              external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_transferred_collateralTransferOut", "eleId":"pwdInput", "doneLable":"done", "keyboardType":"9"});
	              e.stopPropagation();
	        },"click");
    		//取消按钮
			appUtils.bindEvent($("#cancel"), function(e){
				$(" #inputPopLayer").remove();
				e.stopPropagation();
			});
			//确定按钮
			appUtils.bindEvent($("#confirm"), function(e){
				stockCodeOut = stockCode;
				getStockMsg(stockCode,stockPrice,last_price,exchageType);//股票联动，获取信息
				e.stopPropagation();
			});
    }
    /**
     * 股票联动，获取信息
     */
    function getStockMsg(stockCode,stockPrice,last_price,exchageType){
    	var  param={};
    	var stockInfo = JSON.parse(appUtils.getSStorageInfo("stockInfo"));//获取登陆后保存的普通账户信息
		var stockAcc = $("#pwdInput").val();//数量
		param.branch_no= stockInfo.branch_no || userInfo.branch_no;//分支机构（普通）
		param.fund_account = stockInfo.fund_account || userInfo.fund_account;; //资金账号（普通）
		param.cust_code= stockInfo.cust_code || userInfo.cust_code;//客户编号
		param.password = userInfo.password;//密码
		param.exchange_type = exchageType;//交易类别（见数据字典）
		param.entrust_way = global.entrust_way; // 委托方式  在configuration配置
		param.branch_no_crdt = userInfo.branch_no;//分支机构（信用）
		param.fund_account_crdt = userInfo.fund_account;//资金账户（信用）
		param.client_id_crdt = userInfo.cust_code;//客户编号（信用）
		param.password_crdt = userInfo.password; // 信用账户交易密码
		param.sessionid="";//会话
		param.cost_price = stockPrice;//成本价格
		param.last_price = last_price;//现价
		param.stock_code = stockCode;//证券代码
		param.entrust_amount = stockAcc;//过户数量
		param.entrust_bs = "1";//买卖方向（0：买入--普转信，1：卖出--信转普）
		service_credit.dbin_link(param, getStockMsgCallback);
    }
    /**
     * 股票联动回调函数
     */
    function getStockMsgCallback(data){
    	if(data.error_no == "0"){
    		var result = data.results[0];
    		var seat_no = result.seat_no;
    		var seat_no_crdt = result.seat_no_crdt;
    		var exchange_type = result.exchange_type;
    		var cost_price = result.cost_price;
    		var last_price = result.last_price;
    		var stock_account_cred = result.stock_account_crdt;
    		var stock_account = result.stock_account;
    		stockTransIn(stockCodeOut,cost_price,seat_no,seat_no_crdt,exchange_type,stock_account,stock_account_cred,last_price);
    	}else{
    		layerUtils.iAlert(data.error_info);
    		return false;
    	}
    }
    /**
	 * 划转操作
	 */
	function stockTransIn(stockCodeOut,cost_price,seat_no,seat_no_crdt,exchange_type,stock_account,stock_account_cred,last_price)
	{
		var  param={};
		var stockInfo = JSON.parse(appUtils.getSStorageInfo("stockInfo"));//获取登陆后保存的普通账户信息
		param.branch_no = stockInfo.branch_no || stockInfo.branch_no;//分支机构（普通）
		param.fund_account = stockInfo.fund_account || userInfo.fund_account;//资金账号（普通）
		param.cust_code = stockInfo.cust_code || userInfo.cust_code;//客户编号
		param.stock_account = stock_account;//证券账号（普通）
		param.password = userInfo.password;//密码
		var stockAcc = $("#pwdInput").val();//数量
		param.entrust_way = global.entrust_way; // 委托方式  在configuration配置
		param.password_crdt = userInfo.password; // 信用账户交易密码
		param.sessionid="";//会话
		param.seat_no=seat_no;//席位编号（普通）
		param.exchange_type = exchange_type;//交易类别（见数据字典）
		param.stock_code = stockCodeOut;//证券代码
		param.entrust_amount = stockAcc;//过户数量
		param.branch_no_crdt = userInfo.branch_no;//分支机构（信用）
		param.client_id_crdt = userInfo.cust_code;//客户编号（信用）
		param.fund_account_crdt = userInfo.fund_account;//资金账户（信用）
		param.stock_account_crdt = stock_account_cred;//证券账号（信用）
		param.seat_no_crdt = seat_no_crdt;//席位编号（信用）
		param.cost_price = cost_price;//成本价格
		param.last_price = last_price;//现价
		param.entrust_bs = "77";//买卖方向（76：买入--普转信，77：卖出--信转普）
		service_credit.dbin_sub(param, transCallback);
		
	}
	/**
	 * 划入回调函数
	 */
	function transCallback(data){
		if(data.error_no == "0"){
			layerUtils.iAlert("委托成功，委托编号为："+data.results[0].entrust_no+"，T+1日到账");
			$(" #inputPopLayer").remove();
			return false;
		}else{
			layerUtils.iAlert(data.error_info);
			return false;
		}
	}
	
	/**
	 * 查询撤单数据
	 */
	function  queryTransCanCancel(){
		var queryParam = {
				entrust_way: global.entrust_way, // 委托方式  在configuration配置
				branch_no: userInfo.branch_no, // 分支机构
				fund_account: userInfo.fund_account, // 资金账号
				cust_code: userInfo.cust_code, // 客户编号
				password: userInfo.password, // 交易密码
				op_station: "", // 操作站点（见数据字典)	Y	
				sessionid: userInfo.session_id, // 会话号
				exchange_type: "", // 交易市场类别（见数据字典)
				stock_account: "", // 证券账号
				stock_code: "", // 证券代码
				entrust_bs: "77" // 委托标志（见数据字典)
		};
		service_credit.queryTransCanCancel(queryParam, queryCancelCallBack);
	}
	/*
	 * 查询撤单回调
	 */
	function queryCancelCallBack(data){
		if(data.error_no == "0"){
			if(data.results[0]){
				creatCancelHtml(data);
			}else{
				 $(_pageId + ".no_data").show();
			}
			if(!vIscroll._init){
				initVIScroll();
			}else{
				vIscroll.scroll.refresh();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	/**
     * 生成查询持仓函数
     * @param {Object} data
     */
    function creatCancelHtml(data){
    	var eleHtml = "";
    	var data = data.results;
    	for(var i=0;i<data.length;i++){
    		var price_digit = 2;
//  		require("common").decimalKeep(data[i].stock_code,function(data){  //获取保留的位数
//  	    	if(data){
//  	    		price_digit = data;
//  	    	}
//  		});
    		eleHtml+="<div class=\"part\" data-id="+data[i].entrust_no+">";
	        eleHtml+="<div class=\"title\"><span class=\""+""+"\">"+data[i].entrust_name+"</span><p>"+data[i].stock_name+"</p><small>"+data[i].stock_code+"</small><span class=\"agreen\">"+data[i].entrust_type_name+"</span></div>";
	        eleHtml+="<div class=\"value\">";
	        eleHtml+="<a href=\"javascript:void(0)\" id=\"stockIn\" data-id="+data[i].exchange_type+" data-no="+data[i].entrust_no+">撤单</a>";
	        eleHtml+="<span class=\"time\">"+data[i].entrust_time+"</span>";
	        eleHtml+="<ul>";
	        eleHtml+="<li>委托价 <span>"+Number(data[i].entrust_price).toFixed(price_digit)+"</span></li>";
	        eleHtml+="<li>委托数 <span>"+data[i].entrust_amount+"</span></li>";
	        eleHtml+="<li>成交价 <span>"+Number(data[i].business_price).toFixed(price_digit)+"</span></li>";
	        eleHtml+="<li>成交数 <span>"+data[i].business_amount+"</span></li>";
	        eleHtml+="</ul></div></div>";
// 			var css = "";
//  		var transPro = "";
//  		if(data[i].entrust_bs == "76"){
//  			transPro = "担保品转入";
//  			css = "ared";
//  		}else{
//  			transPro = "担保品转出";
//  			css = "agreen";
//  		}
//  		
//  		eleHtml += "<div class=\"cancel_list colla_cancel mt10\" id=\"remove\">";
//  		eleHtml += "<dl class=\"part\" id=\"remove\">"
//          eleHtml +=    "<dt><span class="+css+">"+transPro+"</span><strong>"+data[i].stock_name+"</strong><small>"+data[i].stock_code+"</small></dt>"
//          eleHtml +=    "<dd>"
//          eleHtml +=    	"<a href=\"javascript:void(0);\" id=\"stockIn\" data-no = "+data[i].entrust_no+">撤单</a>"
//          eleHtml +=    	"<p class=\"time\">"+data[i].entrust_time+"</p>"
//          eleHtml +=       "<span>成本价 <em>"+Number(data[i].entrust_price).toFixed(price_digit)+"</em></span><span>委托数  <em>"+data[i].entrust_amount+"</em></span>"
//          eleHtml +=  "</dd>"
//          eleHtml += "</dl>"
//          eleHtml += "</div>";
            
    	}
		$(_pageId + " #append").html(eleHtml);
		
		//撤单按钮cancelOrder
		appUtils.bindEvent($(_pageId+"#stockIn"), function(e){
			var entrust_no = $(this).attr("data-no");//委托编号
			var cancelParam = {
				"entrust_way": global.entrust_way, // 委托方式  在configuration配置
				"branch_no": userInfo.branch_no, // 分支机构
				"fund_account": userInfo.fund_account, // 资金账号
				"cust_code": userInfo.cust_code, // 客户编号
				"password": userInfo.password, // 交易密码
				"sessionid": userInfo.session_id, // 会话号
				"entrust_no": entrust_no, // 委托编号
				"batch_flag": "0", // 批量撤单标志（0:不是，1：是）
				"exchange_type": "" // 交易市场类别
		};
		
		
			var dom = $(this).parent().parent();
			var stockCode = dom.find(".title small").text(); // 证券代码
			var stockName = dom.find(".title p").text(); // 证券名称
			var delegateOrien = dom.find(".title span").text(); // 操作类型
			var delegatePrice = dom.find(".value ul li:eq(0) span").text(); // 委托价格
			var delegateQuantity = dom.find(".value ul li:eq(1) span").text(); // 委托数量
			var entrust_no = $(this).attr("data-no");
			var tipStr ="<div class=\"pop_header\">";
			tipStr+="<h3>撤单</h3>";
			tipStr+="</div>";
			tipStr+="<div class=\"pop_main\">";
			tipStr+="<ul>";
			tipStr+="    <li>证券名称 <em>"+stockName+"</em></li>";
			tipStr+="    <li>证券代码 <strong>"+stockCode+"</strong></li>";
			tipStr+="    <li>委托价格 <strong>"+delegatePrice+"</strong></li>";
			tipStr+="    <li>委托数量 <strong>"+delegateQuantity+"</strong></li>";
			tipStr+="    <li>委托编号 <strong>"+entrust_no+"</strong></li>";
			tipStr+="</ul>";
			tipStr+="  </div>";
			common.btnConfirm(tipStr,function success(){
				service_credit.credit_cancel(cancelParam, CancelCallBack);
				},function fail(){
			});
	
			e.stopPropagation();
		},"click");
    }
    function CancelCallBack(data){
    	if(data.error_no == "0"){
    		layerUtils.iAlert("撤单成功");
    		//撤单查询
			 callsQuery();
    	}else{
    		layerUtils.iAlert(data.error_info);
    		return false;
    	}
    }
    
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".toggle_nav").height()- 25,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						callsQuery();
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+ ".no_data").hide();
		$(_pageId + " #append").html("");
		stockCodeOut = "";
		$(_pageId+".toggle_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		$(_pageId+".toggle_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		var ModuleName = appUtils.getPageParam("ModuleName");
		if(ModuleName && ModuleName=="me"){
			if(gconfig.platform == "2"){
				toPage={"prefix":"www/m/ygt","suffix":"twoFinancial/showCollateralRatio","ModuleName":"trade"};
			}else{
				toPage = gconfig.seaBaseUrl + "ygt/index.html#!/twoFinancial/showCollateralRatio.html?ModuleName=trade";
			}
			var param = {"funcNo":"50101","moduleName":"ygt","params":{"moduleName":"trade","toPage":toPage}};
			require("external").callMessage(param);
			appUtils.pageInit("credit/transferred/collateralTransferOut","account/index");
		}else{
			appUtils.pageInit("credit/transferred/collateralTransferOut","credit/transferred/collateralTransfer",{});
		}
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});