/**
 * 银行理财-撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_finance = require("service_finance");
	var _pageId = "#finance_bankFinCancel ";
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; // 上下滑动
	var productType = ""; // 产品类型
	var BANKTYPE = "bankProduct"; // 银行产品
	var STOCKTYPE = "stockProduct"; // 证券产品
	var userInfo = null;
	
    /**
     * 初始化
     */
	function init() {
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		productType = appUtils.getSStorageInfo("productType"); // 获取查询产品的类型
		queryMayCancel(); // 可撤产品查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});
		//全部撤单
		appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
			var allot_no = getEntrustNo();//合同序号
			if(!allot_no){
				layerUtils.iAlert("暂无可撤单委托");
				return false;
			}
			var batch_flag="1";
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var password= userInfo.password;
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "password":password,
				    "cust_code":cust_code,
				    "batch_flag":batch_flag,
				    "allot_no":allot_no	
			};
			var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>是否全部撤单?</div></div>";
			common.btnConfirm(tipStr,function success(){
				if(productType == BANKTYPE){ // 银行产品
					service_finance.bankFinCancel(param,proDuctCancelCallBack);
				}else if(productType == STOCKTYPE){ // 证券产品
					service_finance.stockFinCancel(param,proDuctCancelCallBack);
				}
			},function fail(){
			} );

			e.stopPropagation();
		});
	}
	
	//获取全部撤单的合同序号
	function getEntrustNo(){
		var entrust_no = "";
		var ents = $(_pageId+'.part');
		for(var i=0;i<ents.length;i++){
			entrust_no +=(ents.eq(i).find("a").attr("id")+",");
		}
		if(entrust_no.length>0){
			entrust_no = entrust_no.substring(0,entrust_no.length-1);
		}
		return entrust_no;
	}
	/**
	 * 产品持仓查询
	 */
	function queryMayCancel(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;	// 客户代码
		var password = userInfo.password;
		var bankm_account = "";
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "bankm_account":bankm_account
		};
		if(productType == BANKTYPE){ // 银行产品
			service_finance.bankFinMayCancel(param,queryMayCancelCallBack);
		}else if(productType == STOCKTYPE){ // 证券产品
			service_finance.stockFinMayCancel(param,queryMayCancelCallBack);
		}
	}
    // 产品持仓查询回调
	function queryMayCancelCallBack(data){
		if(data.error_no == 0){
			$(_pageId + ".fina_list2").html("");
			var results = data.results;
			if(results && results.length>0){
				$(_pageId + ".no_data").hide();
				var data = "";
				for(var i=0,len=results.length;i<len;i++){
					data += queryHTML(results[i]);
				}
				$(_pageId + ".fina_list2").html(data);
				appUtils.bindEvent($(_pageId + ".fina_list2 .part a"), function(e){
					var allot_no = $(this).attr("id");
					var $element = $(this).parent();
					var tipStr ="<div class=\"pop_header\">";
					tipStr+="<h3>"+"确认撤单"+"</h3>";
					tipStr+="</div>";
					tipStr+="<div class=\"pop_main\">";
					tipStr+="<ul>";
			    	tipStr+="    <li><em>"+$element.find(".title span").text()+"</em><strong>"+$element.find(".title small").text()+"</strong></li>";
			    	tipStr+="    <li>操作类型 <em>"+$element.find(".title strong").text()+"撤单</em></li>";
			    	tipStr+="    <li>委托金额 <strong>"+$element.find(".inner ul li:eq(2) span").text()+"</strong></li>";
			    	tipStr+="    <li>发行人代码 <strong>"+$element.find(".inner ul li:eq(3) span").text()+"</strong></li>";
					tipStr+="</ul>";
					tipStr+="</div>";
					common.btnConfirm(tipStr,function success(){
						proDuctCancel(allot_no); // 产品撤单
					},function fail(){
					});
				},"click");
			}else{
				$(_pageId + ".no_data").show();
		    }
			if(!vIscroll._init){
				initVIScroll();
			}else{
				vIscroll.scroll.refresh();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	// 页面数据填充
	function queryHTML(element){
		var price_digit = 2;
		var eleHTML = "";
			eleHTML += "<div class=\"part\">";  
			eleHTML += "<a href=\"javascript:void(0);\" class=\"cancel\" id="+element.allot_no+">撤单</a>";  
			eleHTML += "<div class=\"title\">";  
			eleHTML += "	<strong class=\"ared\"></strong><span>"+element.prod_name+"</span><small>"+element.prodta_no+"</small>";  
			eleHTML += "</div>";  
			eleHTML += "<div class=\"inner clearfix\">";  
			eleHTML += "	<ul>";  
			eleHTML += "    	<li>委托编号：<span>"+element.entrust_no+"</span></li>";  
			eleHTML += "        <li>状态说明：<span>"+element.entrust_status_name+"</span></li>";  
			eleHTML += "        <li>委托金额：<span>"+Number(element.entrust_balance).toFixed(price_digit)+"</span></li>";  
			eleHTML += "        <li>发行人代码：<span>"+element.prod_code+"</span></li>";  
			eleHTML += "        <li class=\"full\"><span>委托时间：</span>"+element.entrust_date+" "+element.entrust_time+"</span></li>";  
			eleHTML += "     </ul>";  
			eleHTML += "</div>";  
			eleHTML += "</div>";  
		return eleHTML;
	}
	
	/**
	 * 产品撤单
	 */
	function proDuctCancel(allot_no){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;	// 客户代码
		var password = userInfo.password;
		var batch_flag = "0";
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "batch_flag":batch_flag,
			    "allot_no":allot_no
		};
		if(productType == BANKTYPE){ // 银行产品
			service_finance.bankFinCancel(param,proDuctCancelCallBack);
		}else if(productType == STOCKTYPE){ // 证券产品
			service_finance.stockFinCancel(param,proDuctCancelCallBack);
		}
	}
	// 产品撤单回调
	function proDuctCancelCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var tipStr = "";
		        tipStr = "<span style='font-weight:bold;font-size: 18px;'>撤单提示</span><br>撤单成功，流水序号："+results[0].serial_no;
			    layerUtils.iAlert(tipStr);
			    queryMayCancel();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false, // false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId + "#v_container_funds_jj"),	
				"wrapper":$(_pageId + "#v_wrapper_funds_jj"),	
				"downHandle": function() { // 下拉获取上一页数据方法
					queryMayCancel();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); // 初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; // 尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	function destroy(){
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("finance/bankFinCancel","finance/bankFinOrder",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});