/**
 * 银行产品-历史申赎委托查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_finance = require("service_finance");
    var vIscroll = {"scroll":null,"_init":false};
	var _pageId = "#finance_bankFinHistory ";
    var userInfo = null;
    var dateUtils = require("dateUtils");
    var begin_date = "";
    var end_date = "";
//	var queryType = "entrust"; // 查询内容
	var productType = ""; // 产品类型
	var BANKTYPE = "bankProduct"; // 银行产品
	var STOCKTYPE = "stockProduct"; // 证券产品
	
    /**
     * 初始化
     */
	function init(){
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		productType = appUtils.getSStorageInfo("productType"); // 获取查询产品的类型
//      queryType = appUtils.getPageParam("param");
//		if(queryType == "entrust"){
//			$(_pageId + ".top_title h3").text("历史委托");
//			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
//		}else if(queryType == "deal"){
//			$(_pageId + ".top_title h3").text("历史成交");
//			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
//		}
		var now_time = new Date();
		begin_date = new Date(now_time.setMonth(now_time.getMonth() - 1));
		begin_date = begin_date.format("yyyy-MM-dd");
	    end_date = new Date().format("yyyy-MM-dd");
		$(_pageId+".data_check .inner .t1:eq(0)").val(begin_date);
		$(_pageId+".data_check .inner .t1:eq(1)").val(end_date);
		//日期时间输入点击调用日期组件，第一次点击不会触发效果，所以在init里面先初始化一次。
		dateUtils.initDateUI("finance_bankFinHistory");
		queryData(); // 数据查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack(); // 返回查询首页
		});
		// 页面切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title h3").text($(this).find("a").text());
			queryData();
		});
        // 查询点击事件
		appUtils.bindEvent($(_pageId+" #clickQuery"), function(e){
            var time_one =  $(_pageId + ".data_check .inner .t1:eq(0)").val();
            var time_two = $(_pageId + ".data_check .inner .t1:eq(1)").val();
			var begin = new Date(time_one.replace(/-/g,"/"));
			var end = new Date(time_two.replace(/-/g,"/"));
			var flag_one = new Date(time_two.replace(/-/g,"/"));;
			var flag_two = end.setMonth(end.getMonth()-3);
			if(flag_two > begin){
				 layerUtils.iAlert("最多只能查询三个月期间的数据");
			}else if(begin > flag_one){
				 layerUtils.iAlert("请查询正确的时间间隔");
			}else{
				begin_date = time_one;
				end_date  = time_two;
				queryData();
			}
			e.stopPropagation();
		},"click");
		
	}
    
	/**
	 * 调用查询
	 */
	function queryData(){
		$(_pageId+".fina_list2").html("");
//		if(queryType == "entrust"){
			queryEntrust();
//		}else{
//			queryDeal();
//		}
	}
    
	/**
	 * 历史委托查询
	 */
	function queryEntrust(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var cust_code = userInfo.cust_code;
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var bankm_account = "";
		var prod_code = "";
		var prodta_no = "";
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "bankm_account":bankm_account,
			    "prod_code":prod_code,
			    "prodta_no":prodta_no,
			    "begin_date":begin_date,
			    "end_date":end_date
		};
		if(productType == BANKTYPE){ // 银行产品
			service_finance.bankFinHistory(param,queryEntrustCallBack);
		}else if(productType == STOCKTYPE){ // 证券产品
			service_finance.stockFinHisSS(param,queryEntrustCallBack);
		}
	}
    // 历史委托查询回调
	function queryEntrustCallBack(data){
		if(data.error_no == 0){
			$(_pageId + ".no_data").hide(); 
			var results = data.results;
			if(results && results.length>0){
				var data = "";
				for(var i=0,len=results.length;i<len;i++){
					data += queryHTMLEntrust(results[i]);
				}
				$(_pageId + ".fina_list2").html(data);
			}else{
				$(_pageId + ".no_data").show();
			}
			if(!vIscroll._init){
				initVIScroll();
			}else{
				vIscroll.scroll.refresh();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	// 页面数据填充 
	function queryHTMLEntrust(element){
		var cssType = "";
		var eleHTML = "";
			eleHTML += "<div class='part "+cssType+"'>";     
			eleHTML += "<div class=\"title\">";     
			eleHTML += "	<strong class=\"ared\">"+element.business_name+"</strong><span>"+element.prod_name+"</span>\<small>"+element.prodta_no+"</small>";     
			eleHTML += "</div>";     
			eleHTML += "<div class=\"inner clearfix\">";     
			eleHTML += "	<ul>";     
			eleHTML += "    	 <li><span>委托价格：</span>"+element.entrust_price+"</li>";     
			eleHTML += "         <li><span>委托金额：</span>"+element.entrust_balance+"</li>";    
			eleHTML += "         <li><span>委托数量：</span>"+element.entrust_amount+"</li>";
			eleHTML += "         <li><span>委托时间：</span>"+element.entrust_date+" "+element.entrust_time+"</li>";     
			eleHTML += "     </ul>";     
			eleHTML += " </div>";     
			eleHTML += "</div>";     
		return eleHTML;
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false, // false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height() - $(_pageId+".data_check").height() - 15  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() { // 下拉获取上一页数据方法
					queryData();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); // 初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; // 尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	function destroy(){
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("finance/bankFinHistory","finance/bankFinQuery",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});