/**
 * 银行产品-产品列表
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_finance = require("service_finance");
	var _pageId = "#finance_bankFinList ";
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; // 上下滑动
	var productType = ""; // 产品类型
	var BANKTYPE = "bankProduct"; // 银行产品
	var STOCKTYPE = "stockProduct"; // 证券产品
    var currPosition = ""; // 当前页数
    var pageNum = "15"; // 每次查询页数
	
    /**
     * 初始化
     */
	function init() {
		common.bindStockEvent(_pageId); // 绑定头部菜单事件
		productType = appUtils.getSStorageInfo("productType"); // 获取查询产品的类型
		if(productType == BANKTYPE){ // 银行产品
			$(_pageId + ".top_title h3").text("银行产品");
		}else if(productType == STOCKTYPE){ // 证券产品
			$(_pageId + ".top_title h3").text("证券产品");
		}else{
			$(_pageId + ".top_title h3").text("银行产品");
			productType = BANKTYPE;
		}
		bankFinList(); // 产品列表查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});
	}
	
	/**
	 * 产品列表查询
	 */
	function bankFinList(position){
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account; // 资产账户
		var branch_no = userInfo.branch_no;	// 分支机构
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var position_str = position;
		var request_num = pageNum;
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"position_str":position_str,
				"request_num":request_num
		};
		if(productType == BANKTYPE){ // 银行产品
			param.en_prod_status = "2"; // 银行产品只能认购
			service_finance.bankFinList(param,bankFinListCallBack);
		}else if(productType == STOCKTYPE){ // 证券产品
			service_finance.stockFinList(param,bankFinListCallBack);
		}
	}
	// 产品列表查询回调
	function bankFinListCallBack(data){
		if(data.error_no == 0){
			$(_pageId + ".no_data").hide(); 
			var results = data.results;
			if(results && results.length>0){
				var data = "";
				for(var i=0,len=results.length;i<len;i++){
					data += queryHTML(results[i]);
				}
				$(_pageId + ".bank_fina").html(data);
				appUtils.bindEvent($(_pageId+".bank_fina .part .btn"), function(e){
					var status = $(this).attr("data-status");
					var prodcode = $(this).attr("data-prodcode");
					if(status == "申购期"){
						appUtils.pageInit("finance/bankFinList","finance/bankFinApply",{"prodcode":prodcode});
					}else if(status == "认购期"){
						appUtils.pageInit("finance/bankFinList","finance/bankFinSubscribe",{"prodcode":prodcode});
					}else{
						layerUtils.iAlert(status);
					}
				},"click");
                currPosition = results[results.length-1].position_str;	
			}else{
				$(_pageId+".visc_pullUp").hide();
				$(_pageId + ".no_data").show(); // 没有数据时显示的暂无数据图标
			}
			if(!vIscroll._init){ // 滑动组件初始化
				initVIScroll();
			}else{
				vIscroll.scroll.refresh();
			}
			if(results.length < pageNum){
             	 $(_pageId+".visc_pullUp").hide();
              }
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	// 页面数据填充
	function queryHTML(element){
		var price_digit = 2;
		var productName = element.prod_name + " " + element.prodta_no;
		if(productName.length > 20) {
			productName = "<marquee>"+productName+"</marquee>";
		}
		var eleHtml = "";
			eleHtml += "<div class=\"part\">";
			eleHtml += "<a href=\"javascript:void(0);\" class=\"btn\" data-status="+element.prod_status+" data-prodcode="+element.prod_code+">立即购买</a>";
			eleHtml += "<h5 style=\"width:70%\">"+productName+"</h5>";
			eleHtml += "<ul>";
			eleHtml += "	<li><strong class=\"ared\">"+(Number(element.prodpre_ratio)*100).toFixed(price_digit)+"<em>%</em></strong><p>预期年化</p></li>";
			eleHtml += "    <li><span>"+Number(element.open_share).toFixed(price_digit)+"元</span><p>起购金额</p></li>";
			eleHtml += "    <li><span>"+element.prod_term+"</span><p>投资日期</p></li>";
			eleHtml += "</ul>";
		    eleHtml += "</div>";
	   return eleHtml;
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false, // false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() { // 下拉获取上一页数据方法
					$(_pageId+".bank_fina").html("");
					currPosition = "";
					bankFinList(currPosition); // 产品列表查询
				},
				"upHandle": function() {
					if($(_pageId+".visc_pullUp").css("display")=="block") {
						bankFinList(currPosition);
					}
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); // 初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; // 尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		
	}
	
	function destroy(){
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("finance/bankFinList","finance/otherProMain",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});