/**
 * 银行产品-产品下单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var _pageId = "#finance_bankFinOrder ";
	var productType = ""; // 产品类型
	var BANKTYPE = "bankProduct"; // 银行产品
	var STOCKTYPE = "stockProduct"; // 证券产品
	
    /**
     * 初始化
     */
	function init() {
		common.bindStockEvent(_pageId); // 绑定头部菜单事件
		productType = appUtils.getSStorageInfo("productType"); // 获取查询产品的类型
		if(productType == BANKTYPE){ // 银行产品
			$(_pageId + ".top_title h3").text("银行产品");
			$(_pageId + ".bank_nav ul li:eq(0)").hide(); // 产品申购功能屏蔽
			$(_pageId + ".bank_nav ul:eq(1) li:eq(0)").hide(); // 产品赎回功能屏蔽
		}else if(productType == STOCKTYPE){ // 证券产品
			$(_pageId + ".top_title h3").text("证券产品");
			$(_pageId + ".bank_nav ul li:eq(0)").show();
			$(_pageId + ".bank_nav ul:eq(1) li:eq(0)").show();
		}else{
			$(_pageId + ".top_title h3").text("银行产品");
			$(_pageId + ".bank_nav ul li:eq(0)").hide();
			productType = BANKTYPE;
		}
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});
		// 查询页面事件跳转
		appUtils.bindEvent($(_pageId + ".bank_nav ul li a"), function(e){
			var topage = $(this).attr("to-page").replaceAll("_","/"); //获取跳转的页面
			var param =  $(this).attr("param");
			if(!param){
				param = "";
			}
			appUtils.pageInit("finance/bankFinOrder",topage,{"param":param}); 
			e.stopPropagation();
		});

	}

	function destroy(){
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("finance/bankFinOrder","finance/otherProMain",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});