/**
 * 银行理财-赎回
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var validata = require("validatorUtil");
	var service_finance = require("service_finance");
	var _pageId = "#finance_bankFinRedeem ";
	var productType = ""; // 产品类型
	var BANKTYPE = "bankProduct"; // 银行产品
	var STOCKTYPE = "stockProduct"; // 证券产品
	
    /**
     * 初始化
     */
	function init() {
		productType = appUtils.getSStorageInfo("productType"); // 获取查询产品的类型
		queryHolding(); // 查询客户基金持仓
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});
		// 可还下拉框
		appUtils.bindEvent($(_pageId + ".select_box"), function(e){
			if($(_pageId+".select_box ul li").length >0){
				$(_pageId+".select_box ul").slideToggle("fast");
			}
			e.stopPropagation(); // 阻止冒泡
		});
		// 点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			if($(_pageId +".select_box ul").is(':visible')){
				$(_pageId +".select_box ul").slideToggle("fast");
			}	
			e.stopPropagation(); // 阻止冒泡
		});
		// 赎回
		appUtils.bindEvent($(_pageId + ".ce_btn"),function(e){
            confirmRedeem(); // 赎回提交
			e.stopPropagation(); // 阻止冒泡
		});

	}
    
	/**
	 * 产品持仓查询
	 */
	function queryHolding(){
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;	// 客户代码
		var password = userInfo.password;
		var bankm_account = "";
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "bankm_account":bankm_account
		};
		if(productType == BANKTYPE){ // 银行产品
			service_finance.bankFinShare(param,queryHoldingCallBack);
		}else{ // 证券产品
			service_finance.stockFinShare(param,queryHoldingCallBack);
		}
	}
    // 产品持仓查询回调
	function queryHoldingCallBack(data){
		if(data.error_no == 0){
			$(_pageId + ".no_data").hide(); 
			$(_pageId + ".select_box ul").html("");
			var results = data.results;
			if(results && results.length>0){
				var data = "";
				for(var i=0;i<results.length;i++){
					
					
                    data += "<li prodta_no="+results[i].prodta_no+"><a href=\"javascript:void(0);\">"+results[i].prod_name+"<span style=\"display:none\">"+results[i].prod_code+"</span><span style=\"display:none\">"+results[i].prodta_no+"</a>";
                    data += "<span style=\"display:none\">"+results[i].buy_date+"</span>";
                    data += "<span style=\"display:none\">"+Number(results[i].income_balance).toFixed(2)+"</span>";
                    data += "<span style=\"display:none\">"+Number(results[i].enable_amount).toFixed(2)+"</span></li>";
				}
				if(results.length>5){
					$(_pageId+".select_box ul").css({"overflow":"auto","height":5*44});
				}
				$(_pageId + ".select_box ul").html(data);
				appUtils.bindEvent($(_pageId+".select_box ul li"),function(){
					var proName = $(this).find("a").html();
					$(_pageId+".select_box p").html(proName);
					$(_pageId+"#buyDate").val($(this).find("span:eq(1)").text());
					$(_pageId+"#incomeBalance").val($(this).find("span:eq(2)").text());
					$(_pageId+"#enableAmount").val($(this).find("span:eq(3)").text());
				});
			}else{
				$(_pageId+".select_box p").text("暂无可赎回的产品");
				$(_pageId+".select_box").addClass("deleteBefore");
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 赎回提交
	 */
	function confirmRedeem(){
		var proNo = $(_pageId+".select_box p span:eq(0)").text();
		var proName = $(_pageId+".select_box p").text();
		var prodtaNo = $(_pageId+".select_box p span:eq(1)").text();
		var redeemNum = $(_pageId+"#redeemNum").val();
		var enableAmount = $(_pageId+"#enableAmount").val();
		if(!proNo && proName=="暂无可赎回的产品"){
			layerUtils.iMsg(-1,"暂无可赎回的产品");
			return false;
		}else if(!proNo){
			layerUtils.iMsg(-1,"请选择需要赎回的产品");
			return false;
		}
		
		if(validata.isEmpty(redeemNum) || !redeemNum>0){
			layerUtils.iMsg(-1,"赎回数量不能小于0");
			return false;
		}else if(!validata.isNumberFloat(redeemNum)){
			layerUtils.iMsg(-1,"请正确输入赎回数量");
			return false;
		}else if(redeemNum > enableAmount){
			layerUtils.iMsg(-1,"可赎回的量不足");
			return false;
		}
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;	// 客户代码
		var password = userInfo.password;
		var bankm_account = "";
		var prod_code = proNo;
		var amount = redeemNum;
		var prodta_no = prodtaNo;
		var param={	
				"type":productType,
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "prod_code":prod_code,
			    "amount":amount,
			    "bankm_account":bankm_account,
			    "prodta_no":prodta_no
		};
//		if(productType == BANKTYPE){ // 银行产品
//			service_finance.bankFinRedeem(param,confirmRedeemCallBack);
//		}else{ // 证券产品
//			service_finance.bankFinRedeem(param,confirmRedeemCallBack);
//		}
		service_finance.bankFinRedeem(param,confirmRedeemCallBack);
	}
	// 赎回回调
	function confirmRedeemCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				var tipStr = "";
		        tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>赎回委托已提交，流水序号："+results[0].serial_no;
			    layerUtils.iAlert(tipStr);
			    clearMSG();
			    queryHolding(); // 查询客户基金持仓
			}
		}else{
			layerUtils.iAlert(data.error_info);
			return false;
		}
	}
	
	function clearMSG(){
		$(_pageId+"#buyDate").val("");
		$(_pageId+"#incomeBalance").val("");
		$(_pageId+"#enableAmount").val("");
		$(_pageId+"#redeemNum").val("");
		$(_pageId +".select_box ul").hide();
		$(_pageId+".select_box p").html("请选择要赎回的产品");
	}
	
	function destroy(){
		clearMSG();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("finance/bankFinRedeem","finance/bankFinOrder",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});