/**
 * 银行理财-签署协议
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var _pageId = "#finance_signProtocol ";
	var service_finance = require("service_finance");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var userInfo = null;
	var queryNo = null;
	var p_No = null;
	var showInfo = [];
	var productInfo = null; // 产品类型
	var BANKTYPE = "bankProduct"; // 银行产品
	var STOCKTYPE = "stockProduct"; // 证券产品
	var prePageCode = null;

	
    /**
     * 初始化
     */
	function init() {
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		prePageCode = appUtils.getSStorageInfo("_prePageCode");
		if(prePageCode != "finance/protocolInfo"){
			productInfo = appUtils.getPageParam("productInfo"); // 获取查询产品的类型
			console.log(productInfo);
			$(_pageId+".icon_check").find("input").attr("checked",false);
			$(_pageId+".ce_btn").addClass("disable");
		}	
		showMsg();
    }
	
	function showMsg(){
		if(productInfo.type == "openStock"){
			$(_pageId+".top_title h3").text("开户签署协议");
			showOpenStock(productInfo.prodta_no);
		}else if(productInfo.type == "product"){
			$(_pageId+".top_title h3").text("产品签署协议");
			showOpenStock(productInfo.prod_code);
		}
	}
	
	//开户协议展示
	function showOpenStock(queryNo){
		var param = {"queryNo":queryNo};
		service_finance.queryProtocol(param,function(data){
			if(data.error_no == 0){
				var str = "";
				var results = data.results;
				if(results && results.length>0){
					for(var i =0;i<results.length;i++){
						str +="<li><a href=\"javascript:void(0);\">《"+results[i].agreement_title+"》</a></li>";
						showInfo.push(results[i]);
					}
					$(_pageId+".rule_list ul").html(str);
					appUtils.bindEvent($(_pageId + ".rule_list>ul li"), function(e){
						var index = $(this).index();
						appUtils.pageInit("finance/signProtocol","finance/protocolInfo",{"showInfo":showInfo[index]});
					},"click");
				}
				
				
			}
		},{"isLastReq":true,"isShowWait":false,});
	}
	
	
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});

		appUtils.bindEvent($(_pageId+" .icon_check"), function(e){
			var isChecked = $(this).find("input").attr("checked");
			if(isChecked){
				$(this).find("input").attr("checked",false);
				$(_pageId+".ce_btn").addClass("disable");
			}else{
				$(this).find("input").attr("checked",true);
				$(_pageId+".ce_btn").removeClass("disable");
			}
			e.stopPropagation();
		},"click");
		
		appUtils.bindEvent($(_pageId + ".ce_btn"), function(e){
			if(!$(this).hasClass("disable")){
				if(productInfo.type == "openStock"){
					stockFinOpen();//开户
				}else if(productInfo.type == "product"){
					finApply(productInfo.p_type);//产品
				}
				
			}
		},"click");
		
	}

	function stockFinOpen(){
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account; // 资产账户
		var branch_no = userInfo.branch_no;	// 分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"prodta_no":productInfo.prodta_no,
				"sessionid":sessionid
		};
		service_finance.stockFinOpen(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
//					require("trade/scripts/finance/bankFinApply").clearMSG();
					appUtils.pageInit("finance/signProtocol","finance/bankFinApply",{});
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/**
	 * 产品申购方法
	 */
	function finApply(p_type){
		if(p_type == "stockApply"){//证券产品申购
			StockApply();
		}else if(p_type == "bankFinSubscribe"){//银行认购
			bankFinSubscribe();
		}else if(p_type == "stockFinSubscribe"){//证券认购
			stockFinSubscribe();
		}
	}
	
	function StockApply(){
		var param={			
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"prod_code":productInfo.prod_code,
				"prodta_no":productInfo.prodta_no,
				"entrust_balance":productInfo.entrust_balance,
				"sessionid":userInfo.sessionid
		};
		service_finance.stockFinApply(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
//					layerUtils.iAlert("产品申购成功");
					appUtils.pageInit("finance/signProtocol","finance/bankFinApply",{"applyType":"true"});
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
		
	}
	
	function bankFinSubscribe(){
		var param={			
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"prod_code":productInfo.prod_code,
				"prodta_no":productInfo.prodta_no,
				"entrust_balance":productInfo.entrust_balance,
				"sessionid":userInfo.sessionid
		};
		service_finance.bankFinSubscribe(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
//					layerUtils.iAlert("产品申购成功");
					appUtils.pageInit("finance/signProtocol","finance/bankFinSubscribe",{"applyType":"true"});
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	function stockFinSubscribe(){
		var param={			
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"prod_code":productInfo.prod_code,
				"prodta_no":productInfo.prodta_no,
				"entrust_balance":productInfo.entrust_balance,
				"sessionid":userInfo.sessionid
		};
		service_finance.stockFinSubscribe(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
//					layerUtils.iAlert("产品申购成功");
					appUtils.pageInit("finance/signProtocol","finance/bankFinSubscribe",{"applyType":"true"});
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	
	function destroy(){
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});