/**
 * 基金交易-基金风险测试
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var VIscroll = require("vIscroll");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	var service_fund = require("service_fund");
    var _pageId = "#fund_assessmentRisk ";
    var entrustNo = ""; //撤单编号
	var exchangeType = ""; //市场类型
    var arr = ""; //题号数据，用于记录题号 
    var k = 0;//总题目数量
    var riskList = {
    	 "1":"n1",
    	 "2":"n2",
    	 "3":"n3",
    	 "4":"n4",
    	 "5":"n5",
    }
    
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		riskLevelQuery(); // 风险等级查询
		//queryRiskQuestions();//查询风险题目
    }
	
	/*
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			//appUtils.pageBack();
			appUtils.pageInit("fund/assessmentRisk","fund/fundQuery",{});
		});
		//点击测试
		appUtils.bindEvent($(_pageId + " #reRisk"), function(e){
			queryRiskQuestions();//查询风险题目
		});
	}
	
	/**
	 * 风险测评等级查询
	 */
	function riskLevelQuery(){
		//获取保存在本地的账户信息
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var risk_kind = "1";//0 A股 1 基金
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "risk_kind":risk_kind,
		};
		service_fund.riskLevelQuery(param,function(data){
			if(data.error_no == "0"){
				var result = data.results[0];
				if(result){
					var risk_level = result.risk_level;
					var risk_flag = "";
					if(result.risk_flag == "1"){
						risk_flag = "否";
					}else{
						risk_flag = "是";
					}
					$(_pageId + " .fund_level").show();
					$(_pageId + " .test_main").hide();
					$(_pageId + " #point").attr("class",riskList[risk_level]);
					$(_pageId + " .level_box p").text(result.risk_name);
					$(_pageId + " .info_box ul li:eq(0) span").text(risk_level);//风险等级
					$(_pageId + " .info_box ul li:eq(1) span").text(risk_flag);//风险等级
					$(_pageId + " .info_box ul li:eq(2) span").text(result.update_date);//日期
				}
			}else if(data.error_no == "-10"){
				queryRiskQuestions();//查询风险题目 直接测评
			}else{
				layerUtils.iAlert(data.error_info);
				return false;
			}
		});
	}
	/**
	 * 风险测评题目查询
	 */
	function queryRiskQuestions(){
		$(_pageId+ " .fund_level").hide();
		$(_pageId+ " .test_main").show();
		$(_pageId + " .test_main").html("");
		//获取保存在本地的账户信息
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var risk_kind = "1";//0 A股 1 基金
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "risk_kind":risk_kind,
			    "organ_flag":"0"
		};
		//最后一个为超时处理函数
		service_fund.queryRiskQuestions(param,queryRiskQuestionsCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
			}
	    });
	}
	/**
	 * 查询基金题目回调
	 */
	function queryRiskQuestionsCallBack(data){
		if(data.error_no == "0"){
			if(data.results[0]){
				creatHtml(data.results);
				//点击下一题
				appUtils.bindEvent($(_pageId + " #next"), function(e){
					var num = Number($(_pageId + " .test_main  h1 em").text());
					if(!isNotChecked(num)){
						layerUtils.iAlert("您还未勾选答案");
						return false;
					}
					
					if(num != k){
						if(num == (k-1)){//最后一个题目把按钮变成提交
							$(_pageId + " .ce_btn a:eq(1)").attr("id","submit").text("提交");
						}else{
							$(_pageId + " .ce_btn a:eq(1)").attr("id","next").text("下一题");
						}
						$(_pageId + " .test_main dl:eq("+(num-1)+")").hide();//隐藏本题
						$(_pageId + " .test_main dl:eq("+(num)+")").show();//显示下一个题目
						$(_pageId + " .test_main  h1 em").text(num+1);//修改标题
						//点击提交题
						appUtils.bindEvent($(_pageId + " #submit"), function(e){
							var num = Number($(_pageId + " .test_main  h1 em").text());
							if(!isNotChecked(num)){
								layerUtils.iAlert("您还未勾选答案");
								return false;
							}
							submitCustAnswer();
						});
					}
				});
				//点击上一题
				appUtils.bindEvent($(_pageId + " #prev"), function(e){
					$(_pageId + " .ce_btn a:eq(1)").attr("id","next").text("下一题");
					var num = Number($(_pageId + " .test_main  h1 em").text());
					if(num != 1){
						$(_pageId + " .test_main dl:eq("+(num-1)+")").hide();
						$(_pageId + " .test_main dl:eq("+(num-2)+")").show();
						$(_pageId + " .test_main  h1 em").text(num-1)
					}
				});
				// 为选择按钮添加事件
				appUtils.bindEvent($(_pageId+" .test_main .icon_radio"),function(){
					var quetype = $(this).attr("data-kind");	 // 问题类型0：单选，1：多选
					var queid   = $(this).attr("id");
					if(quetype == 1){
						if($(this).find("input").attr("checked")){
							$(this).find("input").attr("checked",false);
						}else{
							$(this).find("input").attr("checked","checked");
						}
					}else{
						$(this).parent().siblings().find("input").attr("checked",false);
						if($(this).find("input").attr("checked")){
							$(this).find("input").attr("checked",false);
						}else{
							$(this).find("input").attr("checked","checked");
						}
					}
				});
			}
		}else{
			layerUtils.iAlert(data.error_info);
			return false;
		}
	}
	/**
	 * 生成题目的html
	 */
	function creatHtml(data){
		var question_no;
		var html = "<h1>第<em>1</em>题<small>（共"+"--"+"题）</small></h1>";
		k = 0;
		for(var i=0;i<data.length;i++){
			var result = data[i];
			var question_content = data[i].question_content;//问题内容
			var answer_content =  data[i].answer_content;//答案内容
			var answer_no = data[i].answer_no;
			var kind = data[i].question_kind;//问题类型(0：单选，1：多选)
			if( i == 0){
				if(question_no != data[i].question_no){
					k++;
					html += "<dl class=\"test_box\" data-index="+k+"  style=\"display:none;\">"
		            html +=	"<dt id=\"append\">"+question_content+"</dt>"
		            html +=	   "<dd><span data-kind = "+kind+" class=\"icon_radio\"><input type=\"radio\" class=\"r1\" data-question_no="+data[i].question_no+" data-answer_no ="+answer_no+" data-score="+data[i].score+" /><label>"+answer_content+"</label></span></dd>"
				}else{
					html += "<dd><span data-kind = "+kind+" class=\"icon_radio\"><input type=\"radio\" class=\"r1\" data-question_no="+data[i].question_no+" data-answer_no ="+answer_no+" data-score="+data[i].score+"  /><label>"+answer_content+"</label></span></dd>"
				}
			}else if( i == data.length){
				html += "<dd><span data-kind = "+kind+" class=\"icon_radio\"><input type=\"radio\" class=\"r1\" data-question_no="+data[i].question_no+" data-answer_no ="+answer_no+" data-score="+data[i].score+"  /><label>"+answer_content+"</label></span></dd>"
				html += "</dl>";
			}else{
				if(question_no != data[i].question_no){
					k++;
					html += "</dl>"
					html += "<dl class=\"test_box\" data-index="+k+" data-kind = "+kind+" style=\"display:none;\">"
		            html +=	"<dt id=\"append\">"+question_content+"</dt>"
		            html +=	   "<dd><span data-kind = "+kind+" class=\"icon_radio\"><input type=\"radio\" class=\"r1\" data-question_no="+data[i].question_no+" data-answer_no ="+answer_no+" data-score="+data[i].score+"  /><label>"+answer_content+"</label></span></dd>"
				}else{
					html += "<dd><span data-kind = "+kind+" class=\"icon_radio\"><input type=\"radio\" class=\"r1\" data-question_no="+data[i].question_no+" data-answer_no ="+answer_no+" data-score="+data[i].score+"  /><label>"+answer_content+"</label></span></dd>"
				}
			}
			question_no = data[i].question_no;
		}
		var footHtml = "";
		footHtml += "<div class=\"ce_btn two_btn\">"
        footHtml +=    	"<a href=\"javascript:void(0);\" id=\"prev\">上一题</a><a href=\"javascript:void(0);\" id=\"next\">下一题</a>";
        footHtml +=    "</div>";
		$(_pageId + " .test_main").html(html);
		$(_pageId + " .test_main small").text("共"+k+"题");
		$(_pageId + " .test_main dl:eq(0)").show();
		$(_pageId + " .test_main").append(footHtml);
	}
	/**
	 * 判断是否勾选
	 */
	function isNotChecked(num){
		var actCheckBox = $(_pageId + " .test_main dl:eq("+(num-1)+") input");
		for(var i = 0;i<actCheckBox.length;i++){
			var hasChecked = $(_pageId + " .test_main dl:eq("+(num-1)+") input:eq("+i+")").attr("checked");
			if(hasChecked == "checked"){
				return true;
			}
		}
	}
	/**
	 * 获取后端需要的答案
	 */
	function getAnswer(){
		var oDl = $(_pageId + " .test_box");
		var custTotalAnswer = "";
		for(var num =0;num<oDl.length;num++){
			var custAnswer = [];
			var custScore = [];
			var actCheckBox = $(_pageId + " .test_main dl:eq("+(num)+") input");
			var ans_question_no = $(_pageId + " .test_main dl:eq("+(num)+") input:eq(0)").attr("data-question_no");
			for(var i = 0;i<actCheckBox.length;i++){
				var oInput = $(_pageId + " .test_main dl:eq("+(num)+") input:eq("+i+")");
				var hasChecked = oInput.attr("checked");
				if(hasChecked == "checked"){
					var k = 0;
					var ans_answer_no = oInput.attr("data-answer_no");
					var ans_score = oInput.attr("data-score");
					custAnswer[k] = ans_answer_no;
					custScore[k] = ans_score;
					k++;
				}
			}
			custTotalAnswer += ans_question_no + "|" + "&" + "|" + custAnswer.toString()+ ";";
			//custTotalAnswer += ans_question_no + "&" + custAnswer.toString() + "|" ;
		}
		return custTotalAnswer;
	}
	
	/**
	 * 提交客户所需要的答案
	 */
	function submitCustAnswer(){
		//获取保存在本地的账户信息
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var password = userInfo.password;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var risk_kind = "1";//0 A股 1 基金
		var paper_answer = getAnswer();
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "risk_kind":risk_kind,
			    "organ_flag":"0",
			    "paper_answer":paper_answer
		};
		//最后一个为超时处理函数
		service_fund.submitCustAnswer(param,submitCustAnswerCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
			}
	    });
	}
	/**
	 * 提交客户答案回调函数
	 */
	function submitCustAnswerCallBack(data){
		if(data.error_no == "0"){
			if(data.results[0]){
			$(_pageId+ " .fund_level").show();
			$(_pageId+ " .test_main").hide();
			var result = data.results[0];
			var update_date = result.update_date;//风险测评日期
			var risk_level = Number(result.risk_level);//0：安全型，1：保守型，2：稳健型，3：积极型，4：激进型
			var risk_name = result.risk_name;
			var custRiskKind = "";//客户测试的风险类型
			$(_pageId + " #point").attr("class",riskList[risk_level]);
			$(_pageId + " .level_box p").text(risk_name);
			$(_pageId + " .info_box ul li:eq(0) span").text(risk_level);//风险等级
			$(_pageId + " .info_box ul li:eq(2) span").text(update_date);//日期
				//点击再次测试
				appUtils.bindEvent($(_pageId + " #reRisk"), function(e){
					entrustNo = ""; //撤单编号
				    exchangeType = ""; //市场类型
			        arr = ""; //题号数据，用于记录题号 
			        k = 0;//总题目数量
					queryRiskQuestions();//查询风险题目
				});	
			}else{
				layerUtil.iAlert("未返回测评结果");
				return false;
			}
			
		}else{
			layerUtils.iAlert(data.error_info);
			return false;
		}
	}
    
	/**
	 * 图标指示
	 */
	function picChoose(risk_level){
		switch(risk_level){
		case 0://$(_pageId + " #point").css("transform","rotate(-75deg)");
			   $(_pageId + " #point").attr("class","n1");
			   custRiskKind = "安全型";
			   break;
		case 1://$(_pageId + " #point").css("transform","rotate(-39deg)");
			   $(_pageId + " #point").attr("class","n1");
			   custRiskKind = "保守型";
			   break;
		case 2://$(_pageId + " #point").css("transform","rotate(0deg)");
		 	   $(_pageId + " #point").attr("class","n3");
			   custRiskKind = "稳健型";
			   break;
		case 3://$(_pageId + " #point").css("transform","rotate(39deg)");
		       $(_pageId + " #point").attr("class","n4");
			   custRiskKind = "积极型";
			   break;
		case 4://$(_pageId + " #point").css("transform","rotate(-75deg)");
		       $(_pageId + " #point").attr("class","n5");
			   custRiskKind = "激进型";
			   break;
	}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + ".fund_level").hide();
		$(_pageId + ".test_main").html("");
		$(_pageId + ".test_main small").text("共"+"0"+"题");
		entrustNo = ""; //撤单编号
	    exchangeType = ""; //市场类型
        arr = ""; //题号数据，用于记录题号 
        k = 0;//总题目数量
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});