/**
 * 基金交易-查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_fund = require("service_fund");
    var _pageId = "#fund_canBuyQuery ";
    var vIscroll = require("vIscroll");
    var myVIscroll = null;
    var currPosition = ""; // 当前页数
    var pageNum = "15"; // 每次查询页数
	
    /**
     * 初始化
     */
	function init(){
		$(_pageId+".fund_table .ce_table").width($(window).width()); //查询目录添加高度
		queryCanbuy(); // 查询可申购认购基金
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/canBuyQuery","fund/fundQuery",{});
		});

	}
    
	/**
	 * 查询可申购认购基金
	 */
	function queryCanbuy(position){
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var fund_code = "";
		var fund_company = "";
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code; // 关联资产账户标志
		var position_str = position;
		var request_num = pageNum;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"position_str":position_str,
				"request_num":request_num
		};
		service_fund.getFundInfo(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				var data = "";
				if(results && results.length > 0){
                     for(var i=0,len=results.length;i< len;i++){
                    	 data += queryFundHTML(results[i]);
                     }
                     currPosition = results[results.length-1].position_str;
                     $(_pageId+".fund_table .ce_table").append(data);		
                     if(results.length < pageNum){
                    	 $(_pageId+".visc_pullUp").hide();
                     }
                     initVIScroll();
				}else{
					 $(_pageId+".visc_pullUp").hide();
				}
			}	
		});
	}
	
	function queryFundHTML(element){
	       var eleHtml = "";
		       eleHtml+="<tr>";
		       eleHtml+="<td style=\"width:25%\"><small>"+element.fund_name+"</small><strong>"+element.fund_code+"</strong></td>";
		       eleHtml+="<td style=\"width:25%\"><span>"+element.nav+"</span><span>"+element.fund_status_name+"</span></td>";
		       eleHtml+="<td style=\"width:30%\">"+element.fund_risklevel_name +"</td>";
		       eleHtml+="<td style=\"width:20%\">"+element.company_name+"</td>";
		       eleHtml+="</tr>";
	       return eleHtml;
	}
	
	
	//获取数据后，初始化滑动组件
	function initVIScroll(){
		if(!myVIscroll){
			var config = {
				"isPagingType": false,
				"visibleHeight":$(window).height()- $(_pageId+".header").height() - 6 ,	
				"container": $(_pageId + "#v_container_funds_jj"), // wrapper对象
				"wrapper": $(_pageId + "#v_wrapper_funds_jj"), // scroller对象
				"downHandle": function() {
					$(_pageId+".fund_table .ce_table tr:eq(0)").nextAll().remove();
					currPosition = "";
					queryCanbuy(currPosition);
				},
				"upHandle": function() {
					if($(_pageId+".visc_pullUp").css("display")=="block") {
						queryCanbuy(currPosition);
					}
				}
			};
			myVIscroll = new vIscroll(config);
		} else {
			myVIscroll.refresh();
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_table .ce_table tr:eq(0)").nextAll().remove();
		currPosition = "";
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/canBuyQuery","fund/fundQuery",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});