/**
 * 基金-撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; // 上下滑动
	var service_fund = require("service_fund");
    var _pageId = "#fund_fundCancel ";
    var entrustNo = ""; // 撤单编号
	var exchangeType = ""; // 市场类型
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent(_pageId); // 绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryCancelFund(); // 可撤单查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		appUtils.bindEvent($(_pageId + " .icon_back"), function(){
			appUtils.pageInit("fund/fundCancel","fund/fundQuery",{});
		});
	}
    
	/**
	 * 可撤单列表查询
	 */
	function queryCancelFund(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param = {
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"password":userInfo.password,
				"sessionid":userInfo.session_id
		};
		// 每次查询前,先将暂无数据隐藏
		$(_pageId + ".no_data").hide();
		// 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_fund.queryTodayCancel(param,queryTrustDataCallback,
		{ // 传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId + ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	
	/**
	 * 可撤单查询回调
	 */
	function queryTrustDataCallback(data){
		if(typeof(data) != undefined && typeof(data) != null) {
			$(_pageId + ".cancel_order").html("");
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryTrustDataHTML(results[i]);
					}
					$(_pageId + ".cancel_order").html(data);
					//撤单事件
					appUtils.bindEvent($(_pageId + ".cancel_order #cancel"), function(e){
						var $element = $(this).parent().parent();
						var tipStr ="<div class=\"pop_header\">";
						tipStr+="<h3>"+"基金撤单"+"</h3>";
						tipStr+="</div>";
						tipStr+="<div class=\"pop_main\">";
						tipStr+="<ul>";
				    	tipStr+="    <li><em>"+$element.find(".title p").text()+"</em> <strong>"+$element.find(".title small").text()+"</strong></li>";
				    	tipStr+="    <li>操作类型 <em>"+$element.find(".title span").text()+"</em></li>";
				    	tipStr+="    <li>委托编号 <em>"+$element.find("ul li:eq(0) span").text()+"</em></li>";
				    	tipStr+="    <li>委托金额 <strong>"+$element.find("ul li:eq(1) span").text()+"</strong></li>";
				    	tipStr+="    <li>委托份额 <strong>"+$element.find("ul li:eq(2) span").text()+"</strong></li>";
				    	tipStr+="    <li>成交份额 <strong>"+$element.find("ul li:eq(3) span").text()+"</strong></li>";
						tipStr+="</ul>";
						tipStr+="</div>";
						common.btnConfirm(tipStr,function success(){
							var dataInfo = $element.find("a").attr("data-id");
							cancellation(dataInfo); // 确认撤单
						},function fail(){
						});
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId + ".no_data").show();
					$(_pageId + ".visc_pullUp").hide();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	/**
	 * 可撤单查询HTML生成
	 */
	function queryTrustDataHTML(element){
		var css = "";
		var eleHtml = "";
        eleHtml+="<div class=\"part\" data-id="+element.entrust_no+">";
        eleHtml+="<div class=\"title\"><span class=\""+css+"\">"+element.business_name+"</span><p>"+element.fund_name+"</p><small>"+element.fund_code+"</small></div>";
        eleHtml+="<div class=\"value\">";
        eleHtml+="<a href=\"javascript:void(0)\" id=\"cancel\" data-id="+element.entrust_no+"|"+element.fund_code+"|"+element.entrust_date+"|"+element.fund_company+">撤单</a>";
        eleHtml+="<span class=\"time\">"+element.entrust_time+"</span>";
        eleHtml+="<ul>";
        eleHtml+="<li>委托编号 <span>"+element.entrust_no+"</span></li>";
        eleHtml+="<li>委托金额 <span>"+Number(element.balance).toFixed(3)+"</span></li>";
        eleHtml+="<li>委托份额 <span>"+Number(element.shares).toFixed(0)+"</span></li>";
        eleHtml+="<li>成交份额 <span>"+Number(element.deal_share).toFixed(0)+"</span></li>";
        eleHtml+="</ul>";
        eleHtml+="</div>";
        eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 确定撤单
	 */
	function cancellation(dataInfo){
		var aDataArr = dataInfo.split("|");
		var param={				
			"entrust_way":global.entrust_way,// 委托方式  在configuration配置
		    "branch_no":userInfo.branch_no,
		    "fund_account":userInfo.fund_account,
		    "cust_code":userInfo.cust_code,
		    "password":userInfo.password,
		    "sessionid":userInfo.session_id,
		    "entrust_no":aDataArr[0],
		    "fund_code":aDataArr[1],
		    "allot_date":aDataArr[2].replace(/-/g,""),
		    "fund_company":aDataArr[3]
		};
		service_fund.cancelFundEntrust(param,postCancelOrderCallback);
	}
    //确定撤单回调
	function postCancelOrderCallback(data){
		if (typeof data != "undefined" && data != null) {
			if (data.error_no == 0) {	
				if(typeof data.results[0] != "undefined" && data.results[0] != null ){
					layerUtils.iAlert("撤单成功");
					queryCancelFund();//刷新页面重新加载数据
				}
			}
			else{  
				//layerUtils.iAlert("<div style=\"display:block;text-align:center;padding:0 16px;font-size:16px;word-break:break-all;\">"+data.error_info+"</div>");
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			layerUtils.iAlert("撤单失败");
		}
	}
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryCancelFund();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	/**
	 * 销毁
	 */
	function destroy(){
	    entrustNo = "";
		exchangeType = "";
		$(_pageId+".cancel_order").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundCancel","fund/fundQuery",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});