/**
 * 基金交易-认购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var validata = require("validatorUtil");
	var service_stock = require("service_stock");
	var service_fund = require("service_fund"); 
    var _pageId = "#fund_fundSubscribe ";
    var userInfo = null;
    /**
     * 初始化
     */
	function init(){
		common.systemKeybord(); // 解禁系统键盘
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryCanSubscribe();//查询可认购基金
		queryCapital();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundSubscribe","account/index",{});
		});
		//基金下拉框
		appUtils.bindEvent($(_pageId + "#fundList"), function(e){
			$(_pageId+"#fundList ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId +"#fundList ul").hide();
			e.stopPropagation();	// 阻止冒泡
		});
		//赎回
		appUtils.bindEvent($(_pageId + ".input_form .ce_btn"), function(e){
			var flag = "";
			vailSubmitOrder(flag);
			e.stopPropagation();
		});
	}
	
	function queryCanSubscribe(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var fund_status = "1"; //基金状态  0：正常开放，1：认购时期，2：发行成功，3：发行失败，
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "sessionid":sessionid,
			    "cust_code":cust_code,
			    "fund_status":fund_status
		};
		//最后一个为超时处理函数
		service_fund.queryCanSubscribe(param,queryCanSubscribeCallback,{"isLastReq":false,"isShowWait":true});
	}
	function queryCanSubscribeCallback(data){
		if(typeof(data) != undefined && typeof(data) != null) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					$(_pageId+"#fundList").removeClass("deleteBefore");
					if(results.length >= 6){
						var selectHeight = 6 * 0.44;
					}else{
						selectHeight = 0.44*results.length;
					}
					var listHtml = "<ul style=\"display:none;overflow-y:auto;height:"+selectHeight+"rem\">";
					for(var i = 0;i < results.length; i++) {
						listHtml += "<li><a href=\"javascript:void(0);\"><strong>"+results[i].fund_code+"</strong>"+results[i].fund_name+"</a>";
						listHtml +=	"<span style=\"display:none;\">"+results[i].nav+"</span></li>";
					};
					listHtml+="</ul>";
					$(_pageId+"#fundList").append(listHtml);
					appUtils.bindEvent($(_pageId+"#fundList ul li"),function(e){
						var fundNav = parseFloat($(this).find("span").text()).toFixed(2);
						$(_pageId+"#fundList p").html($(this).find("a").html());
						$(_pageId+"#fundNav").val(fundNav); //基金净值
						$(_pageId +"#fundList ul").hide();
						e.stopPropagation();	// 阻止冒泡
					});
				}else{
					$(_pageId+"#fundList p").text("暂无可认购基金");
					$(_pageId+"#fundList").addClass("deleteBefore");
				}
			}else{
				  layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
	}

	
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type
		};
		//最后一个为超时处理函数
		service_stock.queryFundSelect(param,queryCapitalCallback);
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined"){
					$(_pageId+".input_form .max strong").text(common.numToMoneyType(""+Number(results[0].enable_balance).toFixed(2)+""));//可用
				}else{
					$(_pageId+".input_form .max strong").text("--");//可用
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(flag){
		//验证基金代码输入是否正确
		var fundNav = $(_pageId+"#fundNav").val();
		if(validata.isEmpty(fundNav)){
			layerUtils.iMsg(-1,"基金代码不能为空");
			return false;
		}
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#fundPrice").val();
		var can_buy = $(_pageId+".input_form .max strong").text();
		if($.trim(now_price).length<=0){
			layerUtils.iMsg(-1,"请输入认购金额");
			return false;
		}else if(now_price=="0"){
			layerUtils.iMsg(-1,"认购金额不能为0");
			return false;
		}
//		else if(Number(now_price) < 1000){
//			layerUtils.iMsg(-1,"认购金额不能少于1000");
//			return false;
//		}
		else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			layerUtils.iMsg(-1,"请正确输入认购金额");
			return false;
		}else if(Number(now_price)>Number(can_buy)){
			layerUtils.iMsg(-1,"认购金额超过可用金额");
			return false;
		}
		var fundCode = $(_pageId+"#fundList p strong").text();
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>基金认购</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>基金名称 <em>"+$(_pageId+"#fundList p").text()+"</em></li>";
		tipStr+="    <li>基金代码 <strong>"+fundCode+"</strong></li>";
		tipStr+="    <li>认购金额 <strong>"+now_price+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var amount="";
		var fund_company="";
		var fund_code=fundCode;
		var balance=now_price;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"flag":flag,
				"amount":amount,
				"balance":balance,
			};
		    service_fund.getSubScriptionBuy(param,getBuyCallBack);
		},function fail(){
		} );
	}
	//认购回调
	function getBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				$(_pageId+"#fundPrice").val("");
				layerUtils.iAlert(data.error_info);
				queryCapital();
			}
		}else if(data.error_no == "-30200610") {   //未开户时
			var imsg = "<div class=\"pop_header\">";
			    imsg +="<h3 class=\"ared\">基金开户</h3>";
			    imsg +="</div>";
			    imsg +="<div class=\"pop_main\">";
			    imsg +=" <h4>该基金您暂未开通权限，您是否现在开通？<span class=\"ared\"></span></h4>";
			    imsg +="</div>";
			common.btnConfirm(imsg,function() { // 点击确定
				var param = {
						"entrust_way" : global.entrust_way, // 委托方式  在configuration配置
						"branch_no" : userInfo.branch_no, // 分支机构
						"fund_account" : userInfo.fund_account, //资产账户
						"cust_code" : userInfo.cust_code, //客户代码
						"password" : userInfo.password, // 交易密码
						"sessionid" : userInfo.sessionid, // 会话号
						"fund_company" : $(_pageId+"#fundName").find("span").attr("data-fundCom") // 基金公司代码
				};
				// 基金开户
				service_fund.fundOpenAccount(param, function(data){
					if(data.error_no == 0) {
						layerUtils.iAlert("基金户开通成功");
						//vailSubmitOrder();
					} else {
						layerUtils.iAlert(data.error_info);
					}
				});
			});
		}else if(data.error_no == "-30200611"){
			var imsg = "<div class=\"pop_header\">";
		    imsg +="<h3 class=\"ared\">强制下单</h3>";
		    imsg +="</div>";
		    imsg +="<div class=\"pop_main\">";
		    imsg +=" <h4>"+data.error_info+"<span class=\"ared\"></span></h4>";
		    imsg +="</div>";
		    common.btnConfirm(imsg,function() { // 点击确定
		    	var flag = "1";
		    	vailSubmitOrder(flag);
			});
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){

		$(_pageId+"#fundPrice").val("");
		$(_pageId+"#fundNav").val("");
		$(_pageId+"#fundList ul").hide();
		$(_pageId+"#fundList p").text("请选择要认购的基金");
	}
	/**
	 * 销毁
	 */
	function destroy(){
		 clearBuyMsg();
		 $(_pageId+".input_form .max strong").text("--");
	}

	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundSubscribe","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});