/**
 * 新股-中签查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_stock = require("service_stock");
	var common = require("common");
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false};		//上下滑动
	var isShowWait = true;
	var _pageId = "#newshare_achieve ";
	var userInfo =null;
	var whichPage ="";
	var witchAccount = "";
    var dateUtils = require("dateUtils");
    var begin_time = "";
    var end_time = "";
    
    /**
     * 初始化
     */
	function init() {
		var isShow = appUtils.getSStorageInfo("isShowNewShare");
		if(isShow == "true"){
			$(_pageId+".tab_nav ul li:eq(3)").show();
		}else{
			$(_pageId+".tab_nav ul li:eq(3)").hide();
		}
		common.bindStockEvent(_pageId);
		whichPage = appUtils.getSStorageInfo("whichPage"); //判断从那个页面跳转过来
		if(whichPage=="account/index"){
			$(_pageId + ".top_title .icon_back").text("交易");
		}else if(whichPage=="stock/stockQuery"){
			$(_pageId + ".top_title .icon_back").text("查询");
		}else{
			whichPage="account/index";
			$(_pageId + ".top_title .icon_back").text("交易");
		}
		witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
		if(witchAccount){
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}
		var now_time = new Date();
		begin_time = new Date(now_time.setMonth(now_time.getMonth() - 1));
	    begin_time = begin_time.format("yyyy-MM-dd");
		end_time = new Date().format("yyyy-MM-dd");
		$(_pageId+".data_check .inner .t1:eq(0)").val(begin_time);
		$(_pageId+".data_check .inner .t1:eq(1)").val(end_time);
		//日期时间输入点击调用日期组件，第一次点击不会触发效果，所以在init里面先初始化一次。
		dateUtils.initDateUI("newshare_achieve");
		queryAchiveData(); //中签查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("newshare/achieve",whichPage,{});
			e.stopPropagation();
		});
        //查询点击事件
		appUtils.bindEvent($(_pageId+" #clickQuery"), function(e){
            var time_one =  $(_pageId + ".data_check .inner .t1:eq(0)").val();
            var time_two = $(_pageId + ".data_check .inner .t1:eq(1)").val();
			var begin = new Date(time_one.replace(/-/g,"/"));
			var end = new Date(time_two.replace(/-/g,"/"));
			var flag_one = new Date(time_two.replace(/-/g,"/"));;
			var flag_two = end.setMonth(end.getMonth()-3);
			if(flag_two > begin){
				 layerUtils.iAlert("最多只能查询三个月期间的数据");
			}else if(begin > flag_one){
				 layerUtils.iAlert("请查询正确的时间间隔");
			}else{
				begin_time = time_one;
				end_time = time_two;
				queryAchiveData();
			}
			e.stopPropagation();
		},"click");
	}
    
	/***
	 * 查询中签数据
	 */
	function queryAchiveData(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;;
//		var end_time = new Date();  
//		var begin_time  = new Date();	//截止时间
//		begin_time.setDate(begin_time.getDate() - 30);
//		begin_time=begin_time.format("yyyy-MM-dd");
//		end_time.setDate(end_time.getDate() - 1);
//		end_time=end_time.format("yyyy-MM-dd");
//		begin_time=begin_time.format("yyyyMMdd");
//		end_time.setDate(end_time.getDate());
//		end_time=end_time.format("yyyyMMdd");
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "stock_account":"",
		    "begin_time":begin_time,
		    "end_time":end_time,
		    "account_type":witchAccount
		};
		$(_pageId+ ".no_data").hide();
		service_stock.querySuccessData(param,querySuccessDataCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	/**
	 * 查询自选股数据回调方法
	 */
	function querySuccessDataCallBack(data)	{
		if (typeof data != "undefined" && data != null) {
			if(data.error_no == 0){
				if(typeof data.results != "undefined" && data.results!= null && data.results != ""){
					var results = data.results;	
					var dataHtml = "";
					for(var i = 0;i < results.length; i++){
						var data = results[i];
						dataHtml += createHtml(data);
					}
					$(_pageId+".search_list").html(dataHtml);
				}else{
					$(_pageId+ ".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
				isShowWait = false;
			}
			else{
				  layerUtils.iAlert(data.error_info);
			}
		}
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element){
//		var eleHtml =  "";
//		eleHtml += "<div class=\"part\">";
//		eleHtml += "<span class=\"time\">"+element.bizdate+"</span>";
//		eleHtml += "<h5>中签</h5>";
//		eleHtml += "<dl class=\"clearfix\">";
//		eleHtml += "	<dt>"+element.stock_name+"<small>"+element.stock_code+"</small></dt>";
//		eleHtml += "    <dd><em>股东代码</em>"+element.stock_account+"</dd>";
//		eleHtml += "    <dd><em>成交价格</em>"+element.matchprice+"</dd>";
//		eleHtml += "    <dd><em>成交数量</em>"+element.matchqty+"</dd>";
//		eleHtml += "    <dd><em>成交金额</em>"+(element.matchprice*element.matchqty).toFixed(2)+"</dd>";
//		eleHtml += "</dl>";
//		eleHtml += "</div>";
		
		var market = (element.exchange_type == 0 || element.exchange_type == 1)?"深圳":"上海";
    	var ipo_amount = Number(element.ipo_pacancel_amount) + Number(element.ipo_accancel_amount);
		var eleHtml =  "";
		eleHtml += "<div class=\"part\">";
		eleHtml += "<span class=\"time\">"+element.init_date+"</span>";
		eleHtml += "<h5>中签</h5>";
		eleHtml += "<dl class=\"clearfix\">";
		eleHtml += "	<dt>"+element.stock_name+"<small>"+element.stock_code+"</small></dt>";
		eleHtml += "    <dd><em>证券账号</em>"+element.stock_account+"</dd>";
		eleHtml += "    <dd><em>中签数量</em>"+Number(element.ipo_lucky_amount).toFixed(0)+"</dd>";
		eleHtml += "    <dd><em>发行价格</em>"+Number(element.issue_price).toFixed(2)+"</dd>";
		eleHtml += "    <dd><em>放弃数量</em>"+ipo_amount+"</dd>";
		eleHtml += "    <dd><em>应缴费金额</em>"+Number(element.lucky_balance).toFixed(2)+"</dd>";
		eleHtml += "    <dd><em>所属市场</em>"+market+"</dd>";
		eleHtml += "</dl>";
		eleHtml += "</div>";

	    return eleHtml;
	}
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height()  - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - $(_pageId+".inner").outerHeight()- 15  ,		//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryAchiveData();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".search_list").html();
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("newshare/achieve",whichPage,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});