/**
 * 新股-申购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var validator = require("validatorUtil");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var	service_stock = require("service_stock");
	var	service_credit = require("service_credit");
	var _pageId = "#newshare_apply ";
    var userInfo = null;
    var num_step = 500; //步数
    var exchange_market = ""; //市场类别
    var whichPage = "";
    var witchAccount = "";
    var stock_account = "";
    
    /**
     * 初始化
     */
	function init() {
		common.systemKeybord(); // 解禁系统键盘
		var isShow = appUtils.getSStorageInfo("isShowNewShare");
		if(isShow == "true"){
			$(_pageId+".tab_nav ul li:eq(3)").show();
		}else{
			$(_pageId+".tab_nav ul li:eq(3)").hide();
		}
		common.bindStockEvent(_pageId);
		whichPage = appUtils.getSStorageInfo("whichPage"); //判断从那个页面跳转过来
		if(whichPage=="account/index"){
			$(_pageId + ".top_title .icon_back").text("交易");
		}else if(whichPage=="stock/stockQuery"){
			$(_pageId + ".top_title .icon_back").text("查询");
		}else if(whichPage == "credit/order/mainOrder"){
			$(_pageId + ".top_title .icon_back").text("融资融券");
		}else{
			$(_pageId + ".top_title .icon_back").text("交易");
			whichPage = "account/index";
		}
		witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
		if(witchAccount){
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".input_form").height() - 22;
        $(_pageId+".fund_table").css("overflow-y","auto");  //给持仓数据添加高度
        $(_pageId+".fund_table").height(height_table);  //给持仓数据添加高度
		$(_pageId+".fund_table").scrollTop(0);
				
	    queryMessages(); //今日新股查询		
		querynewAmount();//新股额度查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("newshare/apply",whichPage,{});
			e.stopPropagation();
		});
		//申购
		appUtils.bindEvent($(_pageId+".input_form .ce_btn"),function(e){
			cofirmOrder(); //
			e.stopPropagation();	// 阻止冒泡
		});
		//下拉选择
		appUtils.bindEvent($(_pageId+".input_form .select_box"), function(e){
			//$(_pageId+".select_box ul").hide();
			$(_pageId+".select_box ul").slideToggle("fast");
			e.stopPropagation();
		});
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			if($(_pageId+".input_form .select_box ul").is(':visible')){
				$(_pageId+".input_form .select_box ul").slideToggle("fast");
			}
			e.stopPropagation();	// 阻止冒泡
		});
	}
    
	/**
	 * 今日新股查询		
	 */
	function queryMessages(){
		var param = {};
		param.flag = "5";
		//param.list_date = "2015-12-04";
		service_stock.queryTodayNewShare(param,messageCallBack,{"isLastReq":false,"isShowWait":false,"isShowOverLay":false});
	}
	//新股查询回调
	function messageCallBack(data){
		if(data.error_no == 0){
			var results = data.results;  //1、今日中签：refundmentList 2、今日上市:list 3、未上市：notList 4、即将上市：issueList 5、新股申购：subNewStockList
			if( results && results.length>0){
				if(results.length >= 6){
					var selectHeight = 6 * 0.44;
				}else{
					selectHeight = 0.44*results.length;
				}
				var listHtml = "<ul style=\"display:none;overflow-y:auto;height:"+selectHeight+"rem\">";
				var list = "<tr><th scope=\"col\">名称</th><th scope=\"col\">发行价</th><th scope=\"col\">单位(股)</th><th scope=\"col\">上限(股)</th></tr>";
				for(var i = 0;i<results.length;i++){
					list +="   <tr id = \"newShare\" market="+results[i].market+">";
					list +="     <td><strong>"+results[i].stock_name+"</strong><small>"+results[i].subscribe_code+"</small></td>";
					list +="     <td><span>"+results[i].issue_price+"</span></td>";
					list +="     <td><span>"+results[i].applyunitonline+"</span></td>";
					list +="     <td><span>"+results[i].applymax_online+"</span></td>";
					list +="   </tr>";
					listHtml += "<li><a href=\"javascript:void(0);\"><strong>"+results[i].subscribe_code+"</strong><span>"+results[i].stock_name+"</span></a>";
					listHtml += "<span style=\"display:none;\">"+results[i].issue_price+"</span><span style=\"display:none;\">"+results[i].applyunitonline+"</span><span style=\"display:none;\">"+results[i].market+"</span><span style=\"display:none;\">"+results[i].applymax_online+"</span></li>";
				}
				$(_pageId+".fund_table .ce_table").html(list);
				$(_pageId+".input_select .select_box").append(listHtml+"</ul>");
				
				appUtils.bindEvent($(_pageId+".ce_table tr:gt(0)"),function(e){
					var stockPrice = $(this).find("td:eq(1) span").text();
					var stockCode = $(this).find("td:eq(0) small").text();
					var stockName = $(this).find("td:eq(0) strong").text();
					var sMax = Number($(_pageId+".order_form p strong:eq(1)").text())||0;
					var hMax = Number($(_pageId+".order_form p strong:eq(0)").text())||0;
					var exchange_type = $(this).attr("market");
//					exchange_market = exchange_type=="SZ"?"0":"2";
					var applymax_online =Number($(this).find("td:eq(3) span").text());
					num_step = $(this).find("td:eq(2) span").text();
					$(_pageId+".select_box p").html("<strong>"+$(this).find("td:eq(0) small").text()+"</strong><span>"+$(this).find("td:eq(0) strong").text()+"</span>");
					$(_pageId +"#stockPrice").val($(this).find("td:eq(1) span").text());
//					$(_pageId +"#stockNum").val($(this).find("span:eq(2)").text());
					if(exchange_type == "SZ"){
						$(_pageId+"#stockNum").val(sMax>applymax_online?applymax_online:sMax);
					}else if(exchange_type == "SH"){
						$(_pageId+"#stockNum").val(hMax>applymax_online?applymax_online:hMax);
					}
					queryMaxAmount(stockCode,stockPrice,stockName,exchange_type);
				},"click");
				
				
//				//新股列表事件
//				appUtils.bindEvent($(_pageId+" #clickOn"),function(e){
//					var stockName = $(this).find("strong").text();
//					var stockCode = $(this).find("small").text();
//					var stockPrice = $(this).find("td:eq(1) span").text();
//					var stockUnit = $(this).find("td:eq(2) span").text();
//					num_step = stockUnit;
//					$(_pageId +".input_select .select_box p").html("<strong>"+stockCode+"</strong>"+stockName);
//					$(_pageId +"#stockPrice").val(stockPrice);
//					$(_pageId +"#stockUnit").val(stockUnit);
//					//股票联动,查询股票信息，最大可买,配售
//					queryMaxAmount(stockCode,stockPrice,stockName);
//				});
				//下拉列表点击事件
				appUtils.bindEvent($(_pageId+".select_box ul li"),function(){
					var stockPrice = $(this).find("span:eq(1)").text();
					var stockCode = $(this).find("a strong").text();
					var stockName = $(this).find("a span").text();
					var sMax = Number($(_pageId+".order_form p strong:eq(1)").text())||0;
					var hMax = Number($(_pageId+".order_form p strong:eq(0)").text())||0;
					var exchange_type = $(this).find("span:eq(3)").text();
//					exchange_market = exchange_type=="SZ"?"0":"2";
					var applymax_online =Number($(this).find("span:eq(4)").text());
					num_step = $(this).find("span:eq(2)").text();
					$(_pageId+".select_box p").html($(this).find("a").html());
					$(_pageId +"#stockPrice").val($(this).find("span:eq(1)").text());
//					$(_pageId +"#stockNum").val($(this).find("span:eq(2)").text());
					if(exchange_type == "SZ"){
						$(_pageId+"#stockNum").val(sMax>applymax_online?applymax_online:sMax);
					}else if(exchange_type == "SH"){
						$(_pageId+"#stockNum").val(hMax>applymax_online?applymax_online:hMax);
					}
					queryMaxAmount(stockCode,stockPrice,stockName,exchange_type);
				});
		
			}else{
				$(_pageId +".input_select .select_box p").html("暂无新股数据");
				$(_pageId +".input_select .select_box").addClass("deleteBefore");
				$(_pageId+ ".no_data").show();
			}
		}else{
			layerUtils.iAlert("查询失败");
		}
	}    
	
	/**
	 * 新股申购额度查询	
	 */
	function querynewAmount(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid
			};
		
		if(witchAccount=="credit_userInfo"){
			service_credit.newAmount_Query(param,queryNewAmountCallBack);
		}else{
			service_stock.newAmount_QueryNew(param,queryNewAmountCallBack);
		}
	}
	//新股申购额度查询回调
	function queryNewAmountCallBack(data){
		if (typeof data != "undefined" && data != null) {
			if(data.error_no == 0){
				if(typeof data.results != "undefined" && data.results!= null && data.results != ""){
					var results = data.results;	
					for(var i=0;i<results.length;i++){
						var exchange_type = results[i].exchange_type;
						var enable_amount = results[i].enable_amount;
						if(exchange_type=="0"){//深市
							$(_pageId+" .input_form .max strong:eq(1)").text(enable_amount);
						}else if(exchange_type=="2"){//沪市
							$(_pageId+" .input_form .max strong:eq(0)").text(enable_amount);
						}
						
					}
				}
			}
		}else{
			 layerUtils.iAlert("新股额度查询失败");
		}
	}
		
	/**
	 * 查询最大可买数量
	 * */
	function queryMaxAmount(stockCode,stockPrice,stockName,exchange_type){
		//证券代码编号
		if(stockCode.length != 6){
			layerUtils.iAlert("请输入正确的证券代码");
			return false;
		}
		if(!validator.isNumeric(stockCode)){
			layerUtils.iAlert("请输入正确的证券代码");
			return false;
		}
		$(_pageId+" .input_form .notice span").text("--");
		if(!stockCode){
			return false;
		}
		if(exchange_type == "SZ"){
			exchange_type = "0";
		}else if(exchange_type == "SH"){
			exchange_type = "2";
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var password = userInfo.password;
		var stock_code = stockCode;
		var stock_name = stockName;
		var entrust_bs = "0";
		var entrust_price = stockPrice;
		var newstock_flag = "1";
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"stock_name":stock_name,
				"entrust_bs":entrust_bs,
				"entrust_price":entrust_price,
				"stock_code":stock_code,
				"exchange_type":exchange_type,
				"newstock_flag":newstock_flag
			};
		if(witchAccount=="credit_userInfo"){
			param.stock_accounts = common.getStockAccountListStr();
			service_credit.stock_link(param,queryMaxAmountCallBack);
		}else{
			service_stock.queryStockMaxBuy(param,queryMaxAmountCallBack);
		}
	}
    //查询最大可买卖数量回调
	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			if(typeof data.results != "undefined" && data.results!= null && data.results != ""){
				var results = data.results;
				$(_pageId+" .input_form .notice span").text(results[0].stock_max_amount);
				exchange_market = results[0].exchange_type;//交易市场类别（见数据字典)
				stock_account = results[0].stock_account;//股东账号
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 申购验证
	 * */
	function cofirmOrder(){
		//验证价格
		var now_price = $(_pageId+"#stockPrice").val();
		if(now_price.length == 0){
			layerUtils.iAlert("请选择申购的新股");
			return false;
		}
		if((!validator.isNumberFloat(now_price)) || parseFloat(now_price) <= 0){
			layerUtils.iAlert("输入的申购价格无效");
			return false;
		}
		//验证数量
		var mountBuy =Number($(_pageId+"#stockNum").val());
		if(mountBuy.length==0){
			layerUtils.iAlert("请输入委托数量");
			return false;
		}
		if(!validator.isNumeric(mountBuy)||mountBuy <= 0){
			layerUtils.iAlert("输入的委托数量无效");
			return false;
		}
		num_step = Number(num_step);
		if(mountBuy % num_step != 0 ){
			layerUtils.iAlert("买入数量必须为"+num_step+"的整数倍");
			return false;
		}
//		var max_buy = $(_pageId+".input_form .notice span").text(); //可买数量
//		if(max_buy == "--"){
//			layerUtils.iAlert("可买数量不足");
//			return false;
//		}
//		if(Number(mountBuy) > Number(max_buy)){
//			layerUtils.iAlert("可买数量不足");
//			return false;
//		}
		var apply_sell="";
		if(exchange_market=="0"){
			apply_sell= $(_pageId+" .input_form .max strong:eq(1)").text();
		}else if(exchange_market=="2"){
			apply_sell= $(_pageId+" .input_form .max strong:eq(0)").text();
		}
//		if(apply_sell == "" || apply_sell == "--"){
//			layerUtils.iAlert("可申购数量不足");
//			return false;
//		}
//		if(Number(apply_sell)<Number(mountBuy)){
//			layerUtils.iAlert("可申购数量不足");
//			return false;
//		}
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>申购确认</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>申购价格 <em>"+now_price+"</em></li>";
		tipStr+="    <li>申购数量 <strong>"+mountBuy+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no  = userInfo.branch_no;	//分支机构
			var fund_account = userInfo.fund_account;	//资产账户
			var cust_code = userInfo.cust_code;	//客户代
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var entrust_bs = "0";
			var exchange_type = exchange_market;
			var entrust_type = "0";
			var stock_code = $(_pageId + " #selectStockCode strong").text();
			var entrust_price = now_price;
			var entrust_amount = mountBuy;	
			var param = {
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"exchange_type":exchange_type, 
					"entrust_bs":entrust_bs,
					"entrust_price":entrust_price,
					"entrust_amount":entrust_amount,
					"password":password,
					"sessionid":sessionid,
					"entrust_type":entrust_type,
					"stock_account":stock_account,
					"stock_code":stock_code
				};
//			if(witchAccount=="credit_userInfo"){
//				param.stock_accounts = common.getStockAccountListStr();
//				service_credit.entrust_trade(param,succesCallback);
//			}else{
//				service_stock.getStockBuy(param,succesCallback);
//			}
			service_stock.newshareBuy(param,succesCallback);
		},null);
		$("#pop_tip_confirm").find("p").css("padding","5px");//修改提示框的边框高度
	}
	function succesCallback(data){
		if(data.error_no == 0){
			layerUtils.iAlert("申购成功");	
			destroy();
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	/**
	 * 销毁
	 */
	function destroy(){
		 $(_pageId+"#stockPrice").val("");
		 $(_pageId+"#stockNum").val("");
		 $(_pageId+".select_box ul").hide();
		 $(_pageId +".input_select .select_box p").html("请选择");
		 $(_pageId+" .input_form .max strong:eq(1)").text("--");
		 $(_pageId+" .input_form .max strong:eq(0)").text("--");
		 $(_pageId+" .input_form .notice span").text("--"); 
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("newshare/apply",whichPage,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});