/**
 * 新股中签_放弃认购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var validator = require("validatorUtil");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var	service_stock = require("service_stock");
	var	service_credit = require("service_credit");
	var _pageId = "#newshare_subscribeAbandon ";
    var userInfo =null;
    var stockPrice = 0;
    var total = 0;
    
    /**
     * 初始化
     */
	function init() {
		common.systemKeybord(); // 解禁系统键盘
		witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
		if(witchAccount){
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}
		//放弃认购数据查询
		querySubscribeAbandonData();
    }

	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("newshare/subscribeAbandon","newshare/more",{});
			e.stopPropagation();
		});
		
		//确定放弃认购
		appUtils.bindEvent($(_pageId+".input_form .ce_btn a"), function(e){
			checkParameter();
			submitAbandonSubscribe();
			e.stopPropagation();
		});
		
		//股票代码联动
		appUtils.bindEvent($(_pageId+"#abandonNum"), function(e){
			var pstr = $(_pageId+"#subscribeList>p").text();
			if(pstr != "暂无放弃认购数据"){
				var num = $(_pageId+"#abandonNum").val();
				if(isNaN(Number(num))&&isNaN(stockPrice)){
					checkMoney(Number(num));
				}				
			}			
			e.stopPropagation();
		},"input");
	}
	
	function checkMoney(num){	
		$(_pageId+"#payNum").text(total - num * stockPrice);
	}
	
	//放弃认购数据查询
	function querySubscribeAbandonData(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;;
		var end_time = new Date();  
		var begin_time  = new Date();	//截止时间
		begin_time.setDate(begin_time.getDate() - 30);
		begin_time=begin_time.format("yyyyMMdd");
		end_time.setDate(end_time.getDate());
		end_time=end_time.format("yyyyMMdd");
		var zq_bs = "1";
		
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "stock_account":"",
		    "begin_time":begin_time,
		    "end_time":end_time,
		    "account_type":witchAccount,
		    "zq_bs":zq_bs
		};
		
		//放弃认购数据查询服务层调用
		service_stock.querySuccessData(param,querySuccessDataCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
//				initVIScroll();
//				if(vIscroll._init){
//					vIscroll.scroll.refresh();
//				}
	        }
		});
		
		//放弃认购数据查询回调
		function querySuccessDataCallBack(data){
			if (typeof data != "undefined" && data != null) {
				if(data.error_no == 0){
					if(typeof data.results != "undefined" && data.results != null && data.results != ""){
						
						$(_pageId+"#subscribeList p").siblings().remove();
						
						var results = data.results;	
						var dataHtml = "";
						dataHtml += "<ul style='display:none;'>";
						for(var i = 0;i < results.length; i++){
							var data = results[i];
							dataHtml += createSubscribeAbandonHtml(data);
						}
						dataHtml += "</ul>";
						$(_pageId+"#subscribeList").append(listHtml);
						
						//下拉单击处理事件
						appUtils.bindEvent($(_pageId+"#subscribeList ul li"),function(){
							var luckyNum = parseFloat($(this).find("span:eq(1)").text()).toFixed(2);
							$(_pageId+"#subscribeList p").html($(this).find("a").html());
							$(_pageId+"#luckyNum").val(luckyNum); //中签数量
							stockPrice = Number($(this).attr("data-price"));
							var num = Number($(this).attr("data-num"));
							if(isNaN(num)){
								total = stockPrice * num;
							}
;							
						});
						
					}else{
						$(_pageId+"#subscribeList p").text("暂无放弃认购数据");
						$(_pageId+"#subscribeList").addClass("deleteBefore");
					}
				}
			}
		}
		
		//页面HTML生成
		function createSubscribeAbandonHtml(element){
			var listHtml = "";
			listHtml += "<li data-price="+element.price+" data-num="+element.maxamount+">";
			listHtml += "<a href='javascript:void(0);'>";
			listHtml += "<strong>"+element.stock_code+"</strong>"+element.stock_name+"</a>";
			listHtml +=	"<span style='display:none;'>"+element.ipo_lucky_amount+"</span>";
			listHtml +=	"</li>";
			return listHtml;
		}
	}
	
	
	function checkParameter(){
		if($(_pageId+"#subscribeList p").text() == "暂无放弃认购数据"){
			layerUtils.iMsg(-1,"请选择申购代码!");
			return false;
		}
		
		if(!$(_pageId + "#abandonNum").val()){
			layerUtils.iMsg(-1,"请输入放弃数量!");
			return false;
		}
		
		return true;
	}
	
	
	//提交放弃认购
	function submitAbandonSubscribe(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;;
		var issue_price = "";   //发行价
		var ipo_accancel_amount = "";   //主动放弃数量
		var stock_code = "";   //证券代码
		
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid,
			    "issue_price":issue_price,
			    "ipo_accancel_amount":ipo_accancel_amount,
			    "stock_code":stock_code
			};
		
		//放弃认购提交
		service_stock.submitAbandonSubscribe(param,submitAbandonSubscribeCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
//				initVIScroll();
//				if(vIscroll._init){
//					vIscroll.scroll.refresh();
//				}
	        }
		});
		
		function submitAbandonSubscribeCallBack(data){
			if (typeof data != "undefined" && data != null) {
				if(data.error_no == 0){
					if(typeof data.results != "undefined" && data.results != null && data.results != ""){
						layerUtils.iAlert(data.error_info);
					}else{
						layerUtils.iAlert(data.error_info);
					}
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}
			querySubscribeAbandonData();   //认购数据查询
		}
	}
	

	/**
	 * 销毁
	 */
	function destroy(){
//		if(vIscroll._init){
//			vIscroll.scroll.refresh();
//		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("newshare/apply",whichPage,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});