/**
 * 新股-新股认购信息查询
 */
define(function(require, exports, module) {
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var _pageId = "#newshare_subscriptionData ";
	var service_stock = require("service_stock");
	var userInfo = null;
	var isShowWait = true;
	var timeLimit = 7; //默认查询最近一周的数据
	//上下滑动组件
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	//左右滑动组件
    var shIscroll = require("shIscroll");
	var mySHIscroll = null;
	
	
    /**
     * 初始化
     */
	function init() {
		whichPage = appUtils.getSStorageInfo("whichPage"); //判断从那个页面跳转过来
		if(whichPage=="account/index"){
		}else if(whichPage=="stock/stockQuery"){
		}else{
		}
		var witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
		if(witchAccount){
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}
		//数据查询
		querySubscriptionData(timeLimit);
		//初始化上下滑动组件
		initVIScroll();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("newshare/subscriptionData","newshare/more",{});
			e.stopPropagation();
		});
		
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
			e.stopPropagation();
		});
		
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".top_title small").text(timeText);
			if(vIscroll._init){
				vIscroll.scroll.destroy();
				vIscroll.scroll = null;
				vIscroll._init = false;
			}
			querySubscriptionData(timeLimit);
			e.stopPropagation();
		});
	}
	
	
	function querySubscriptionData(timeLimit){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		
		var begin_time  = new Date();	//截止时间
		begin_time.setDate(begin_time.getDate() - timeLimit);
		begin_time=begin_time.format("yyyy-MM-dd");
		
		var end_time  = new Date();	//截止时间
		end_time.setDate(end_time.getDate() - 1);
		end_time=end_time.format("yyyy-MM-dd");
		
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "stock_account":"",
		    "begin_time":"",
		    "end_time":""
		};
		
		service_stock.querySubscription(param,querySubscriptionDataCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
		
		function querySubscriptionDataCallback(data){
			if(typeof(data) != undefined && typeof(data) != null) {
				if(data.error_no == 0){
					var results = data.results;
					var ceTableObj = $(_pageId+".fund_table .ce_table tbody");
					if(results && results.length > 0){
						$(_pageId+".no_data").hide();
						var htmlData = "";
						for (var i=0;i<results.length;i++){
							htmlData += querySubscriptionDataHTML(results[i]);
						}
						ceTableObj.find("tr:eq(0)").siblings().remove();
						ceTableObj.append(htmlData);
					}else{
						$(_pageId+".no_data").show();
					}
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}
			initVIScroll();
			//初始化左右滑动组件
			myInitHIScroll();
		}
		
		//页面代码动态生成
		function querySubscriptionDataHTML(results){
			var eleHtml = "";
				  eleHtml += "<tr>";
				  eleHtml += "<td><small>"+results.init_date+"</small></td>";
				  eleHtml += "<td><small>"+results.stock_code+"</small><br/><small>"+results.stock_name+"</small></td>";
				  eleHtml += "<td><small>"+results.ipo_lucky_amount+"</small><br/><small>"+results.lucky_balance+"</small></td>";
				  eleHtml += "<td><small>"+results.ipo_pacancel_amount+"</small><br/><small>"+results.ipo_accancel_amount+"</small></td>";
				  eleHtml += "<td><small>"+results.stock_account+"</small><br/><small>"+results.ipo_info_status+"</small></td>";
				  eleHtml += "<td><small>"+results.date_clear+"</small></td>";
				  eleHtml += "</tr>";
			return eleHtml;
		}
	}
	

	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					querySubscriptionData();
				},
				"upHandle": function() {
					
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}

	/**
	 * 初始化左右滑动组件
	 */
	function myInitHIScroll(){
		if(mySHIscroll){
			mySHIscroll.destroy();
			mySHIscroll = null;
		}
		if(!mySHIscroll){
			var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}
			};
			mySHIscroll = new shIscroll(config);
			window.wrapperObj = config.wrapperObj;
			$(_pageId+" #wrapper_hMainPanel").css("position", "initial");
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_table .ce_table tbody tr:eq(0)").siblings().remove();
		$(_pageId+".fund_table .ce_table").css("height","auto");
		//左右滑动组件
		mySHIscroll.destroy();
		mySHIscroll = null;
		//上下滑动组件
//		vIscroll.destroy();
		vIscroll = {"scroll":null,"_init":false};
		timeLimit = 7;
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});