/**
 * 普通交易-撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; // 上下滑动
	var service_stock = require("service_stock");
    var _pageId = "#stock_stockCancel ";
    var userInfo = null;
    var stock_code = "";
    var stock_num = "";  
    var stock_direction = "";
    
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent(_pageId); // 绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryCancellation(); // 可撤单查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("stock/stockCancel","account/index",{});
		});
	}
    
	/**
	 * 可撤单查询
	 */
	function queryCancellation(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid
		};
		// 每次查询前,先将暂无数据隐藏
		$(_pageId + ".no_data").hide();
		// 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_stock.queryTrustData(param,queryTrustDataCallback,
		{ // 传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	
	/**
	 * 可撤单查询回调
	 */
	function queryTrustDataCallback(data){
		if (typeof(data) != undefined && typeof(data) != null) {
			$(_pageId + ".search_table .ce_table").html("");
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var data = "<tr><th scope=\"col\">方向</th><th scope=\"col\">委托时间</th><th scope=\"col\">委托价/成交价</th><th scope=\"col\">委托数/成交数</th>";
					for (var i=0;i<results.length;i++){
						data += queryTrustDataHTML(results[i]);
					}
					$(_pageId + ".search_table .ce_table").html(data);
					// 撤单事件
					appUtils.bindEvent($(_pageId+".search_table .ce_table .part"), function(e){
						var entrust_no = $(this).attr("data-id");
						var exchange_type = $(this).find("td:eq(0)").attr("data-id");
					    stock_code = $(this).find("td:eq(1) span").text();
					    stock_num = $(this).find("td:eq(2) span:eq(1)").text();  
						stock_direction = $(this).attr("data-entrust_bs");
						var tipStr ="<div class=\"pop_header\">";
							tipStr+="<h3>"+"确认撤单"+"</h3>";
							tipStr+="</div>";
							tipStr+="<div class=\"pop_main\">";
							tipStr+="<ul>";
					    	tipStr+="    <li><em>"+$(this).find("td:eq(1) strong").text()+"</em> <strong>"+$(this).find("td:eq(1) span").text()+"</strong></li>";
					    	tipStr+="    <li>操作类型 <em>"+$(this).find("td:eq(0) span").text()+"</em></li>";
					    	tipStr+="    <li>委托价格 <strong>"+$(this).find("td:eq(2) span:eq(0)").text()+"</strong></li>";
					    	tipStr+="    <li>委托数量 <strong>"+$(this).find("td:eq(3) span:eq(0)").text()+"</strong></li>";
					    	tipStr+="    <li>成交数量 <strong>"+$(this).find("td:eq(3) span:eq(1)").text()+"</strong></li>";
							tipStr+="</ul>";
							tipStr+="</div>";
						common.btnConfirm(tipStr,function success(){
							cancellation(entrust_no,exchange_type); // 确认撤单
						},function fail(){
						});
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId + ".no_data").show();
					$(_pageId + ".visc_pullUp").hide();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	/**
	 * 可撤单查询HTML生成
	 */
	function queryTrustDataHTML(element){
		var price_digit = 3;
		var css = "";
		var entrust_name = "";
		if(element.entrust_bs == "0"){
			css = "buy_icon";
			entrust_name ="委托买入";
		}else if(element.entrust_bs == "1"){
			css = "sell_icon";
			entrust_name ="委托卖出";
		}
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
		var eleHtml = "";
        eleHtml+="<tr class=\"part\" data-id="+element.entrust_no+" data-entrust_bs="+element.entrust_bs+">";
        eleHtml+="<td class="+css+"><span style=\"display:none\">"+entrust_name+"</span></td>";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.entrust_time+"</small><span style=\"display:none\">"+element.stock_code+"</span></td>";
        eleHtml+="<td><span>"+Number(element.entrust_price).toFixed(price_digit)+"</span><span>"+Number(element.business_price).toFixed(price_digit)+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_amount+"</span><span>"+element.business_amount+"</span></td>";
        eleHtml+="</tr>";
        return eleHtml;
	}

	/**
	 * 确定撤单
	 */
	function cancellation(entrustNo,exchangeType){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code; // 关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;;
		var batch_flag = "0";
		var entrust_no = entrustNo;
		var exchange_type = exchangeType;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "entrust_no":entrust_no,
		    "batch_flag":batch_flag,
		    "exchange_type":exchange_type
		};
		service_stock.postCancelOrder(param,postCancelOrderCallback);
	}
    //确定撤单回调
	function postCancelOrderCallback(data){
		if (typeof data != "undefined" && data != null) {
			if (data.error_no == 0) {	
				if(typeof data.results[0] != "undefined" && data.results[0] != null ){
					//layerUtils.iAlert("撤单成功",function success(){stockTadeagain();});
					var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>撤单成功,是否市价追单?</div></div>";
					common.btnConfirm(tipStr,function success(){
							if(stock_direction == "0"){
								appUtils.pageInit("stock/stockCancel","stock/stockBuy",{"stockCode":stock_code,"stockNum":stock_num});
							}else{
								appUtils.pageInit("stock/stockCancel","stock/stockSell",{"stockCode":stock_code,"stockNum":stock_num});
							}
						},
						function fail(){
						},"市价追单"
					);
					queryCancellation(); //刷新页面重新加载数据
				}
			}else{  
				layerUtils.iAlert(data.error_info);
			}
		}else{
			layerUtils.iAlert("撤单失败");
		}
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryCancellation();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
	    stock_code = "";
	    stock_num = "";  
	    stock_direction = "";
		$(_pageId + ".search_table .ce_table").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("stock/stockCancel","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});