/**
 * 普通交易-持仓
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_stock = require("service_stock");
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false}; //上下滑动
    var hIscroll = require("hIscroll");
    var initHIscroll = {"scroll":null,"_init":false}; 
    var canBuy = 0 ;//可用
    var market_val = 0 ;//市值
    var _pageId = "#stock_stockHolding ";
    var position_timer = null; //持仓定时器
    var commonFunc = require("commonFunc");
    var userInfo = null;
    var pageNum = 20; // 每次查询页数
    var addNum = 20;//每次增加页数
    var isRefresh = true;
    var isShowDown = true;
    var isAll = false;
    
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent(_pageId);  //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryData();//查询持仓
		initHIScroll();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("stock/stockHolding","account/index",{});
		});
		//转账
		appUtils.bindEvent($(_pageId + "#transfer"), function(e){
			appUtils.setSStorageInfo("whichAccount","stock_userInfo");
			appUtils.setSStorageInfo("whichPage","stock/stockHolding");
			appUtils.pageInit("stock/stockHolding","banking/transfer",{});
		},"click");
	}
    
	/**
	 * 查询
	 */
	function queryData(){
//		initVIScroll();
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		//查询资金账户
		queryCapital();
		//查询持仓
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		window.setTimeout(queryPosition(),100);
        position_timer = window.setInterval(queryPosition(), 10000);
	}
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type
		};
		$(_pageId+ ".no_data").hide();
		//最后一个为超时处理函数
		service_stock.queryFundSelect(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
		"isLastReq":true,                
		"isShowWait":true,
		"isShowOverLay":false,
		"timeOutFunc":function(){    //超时调用方法
			$(_pageId+ ".no_data").show();
			initVIScroll();
			if(vIscroll._init){
				vIscroll.scroll.refresh();
			}
		}
	    });
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					var css = "";
					var sign = "";
					for(var i=0;i<results.length;i++){
						if(results[i].money_type=="0"){
							$(_pageId+"#RMB .hold_table tr:eq(0) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].assert_val).toFixed(2)+""));//总资产
							$(_pageId+"#RMB .hold_table tr:eq(0) td:eq(2) strong").text(common.numToMoneyType(""+Number(results[i].market_val).toFixed(2)+""));//市值
							$(_pageId+"#RMB .hold_table tr:eq(1) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].fetch_balance).toFixed(2)+""));//可取
							$(_pageId+"#RMB .hold_table tr:eq(1) td:eq(1) strong").text(common.numToMoneyType(""+Number(results[i].enable_balance).toFixed(2)+""));//可用
							var total_income_balance = results[i].total_income_balance;
							if(total_income_balance > 0){
								css = "ared";
								sign = "+";
							}else{
								css = "agreen";
							}
							total_income_balance = common.numToMoneyType(""+Number(total_income_balance).toFixed(2));
							$(_pageId+"#RMB .hold_table tr:eq(0) td:eq(1) strong").text(sign + total_income_balance).attr("class",css);//盈亏
						}else if(results[i].money_type=="2"){
							$(_pageId+"#HKD .hold_table tr:eq(0) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].assert_val).toFixed(2)+""));//总资产
							$(_pageId+"#HKD .hold_table tr:eq(0) td:eq(2) strong").text(common.numToMoneyType(""+Number(results[i].market_val).toFixed(2)+""));//市值
							$(_pageId+"#HKD .hold_table tr:eq(1) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].fetch_balance).toFixed(2)+""));//可取
							$(_pageId+"#HKD .hold_table tr:eq(1) td:eq(1) strong").text(common.numToMoneyType(""+Number(results[i].enable_balance).toFixed(2)+""));//可用
							var total_income_balance = results[i].total_income_balance;
							if(total_income_balance > 0){
								css = "ared";
								sign = "+";
							}else{
								css = "agreen";
							}
							total_income_balance = common.numToMoneyType(""+Number(total_income_balance).toFixed(2));
							$(_pageId+"#HKD .hold_table tr:eq(0) td:eq(1) strong").text(sign + total_income_balance).attr("class",css);//盈亏
						}else if(results[i].money_type=="1"){
							$(_pageId+"#Dollar .hold_table tr:eq(0) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].assert_val).toFixed(2)+""));//总资产
							$(_pageId+"#Dollar .hold_table tr:eq(0) td:eq(2) strong").text(common.numToMoneyType(""+Number(results[i].market_val).toFixed(2)+""));//市值
							$(_pageId+"#Dollar .hold_table tr:eq(1) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].fetch_balance).toFixed(2)+""));//可取
							$(_pageId+"#Dollar .hold_table tr:eq(1) td:eq(1) strong").text(common.numToMoneyType(""+Number(results[i].enable_balance).toFixed(2)+""));//可用
							var total_income_balance = results[i].total_income_balance;
							if(total_income_balance > 0){
								css = "ared";
								sign = "+";
							}else{
								css = "agreen";
							}
							total_income_balance = common.numToMoneyType(""+Number(total_income_balance).toFixed(2));
							$(_pageId+"#Dollar .hold_table tr:eq(0) td:eq(1) strong").text(sign + total_income_balance).attr("class",css);//盈亏
						}
					}
				}else{
					$(_pageId+".hold_table tr:eq(0) td:eq(0) strong").text("--");//总资产
					$(_pageId+".hold_table tr:eq(0) td:eq(2) strong").text("--");//市值
					$(_pageId+".hold_table tr:eq(1) td:eq(0) strong").text("--");//可取
					$(_pageId+".hold_table tr:eq(1) td:eq(1) strong").text("--");//可用
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	function queryPosition(){
		 return function() {//为了解决定时器不能传参数的问题	 
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid,
			    "password":password,
			    "position_str":"",
		 		"request_num":pageNum+1
			};
			service_stock.queryStockData(param,function(data){
				if (data && data != "undefined") {
					if(data.error_no == 0){
						var results = data.results;
						if(results && results.length>0){
							var total_cost_balance = 0;//持仓数量X持仓成本
							var total_last_price = 0; //持仓数量X最新价
							var data = "";
							var data = "<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>";
							var float_yk = 0; //浮动盈亏
							if(results.length == pageNum+1){
								results.length = results.length-1;
								isAll = false;
							}else{
								isAll = true;
							}
							for (var i=0;i<results.length;i++){ 
								 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
								 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
								 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
								 data += queryPositionHTML_stock(results[i]);							 
							}
							if(results.length!=pageNum){
								isRefresh = false;
								isShowDown = false;
								$(_pageId + ".visc_pullUp").css("display","none");
							}else{
								isRefresh = true;
								isShowDown = true;
								$(_pageId + ".visc_pullUp").css("display","block");
								$(_pageId + ".visc_pullUp").removeClass("visc_loading");
							}
							if(isAll){
								$(_pageId + ".visc_pullUp").css("display","none");
							}
							$(_pageId+".fund_table .ce_table").html(data);
//							$(_pageId+".fund_table2").html(data);
							$(_pageId+".no_data").hide();
							
							if(!vIscroll._init){
								initVIScroll();
							}else{
								vIscroll.scroll.refresh();
							}
							
							//添加总浮动盈亏
							var css = "";
							var sign = "";
							//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
							if(float_yk > 0){
								sign = "+";
								float_yk = "" + float_yk.toFixed(2);
								css = "ared";
							}else if(float_yk < 0){
								float_yk = "" + float_yk.toFixed(2);
								css = "agreen";
							}else{
								float_yk = "" + float_yk.toFixed(2);
								css = "";
							}
							//卖出事件
							appUtils.bindEvent($(_pageId+".fund_table .ce_table tr"), function(e){
								var stock_code = $(this).attr("id");
								var topage = "stock/stockSell";
								//点击卖出,跳转到买卖页面.
								appUtils.pageInit("stock/stockHolding",topage,{"stockCode":stock_code});
								e.stopPropagation();
							},"click");
						}else{ 
							if($(_pageId+".fund_table .ce_table").text()==""){
								$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
								$(_pageId+".no_data").show();
							}
							
						}
					}else{
						$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
						$(_pageId+".no_data").show();
						layerUtils.iAlert(data.error_info);
					}
				}else{
					$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
					$(_pageId+".no_data").show();
					layerUtils.iAlert("查询失败");
				}
				
			},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		 };
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element){ 		
		var price_digit = 3;
//	    common.decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(price_digit);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
			float_yk = float_yk.toFixed(price_digit);
		}
       var eleHtml = "";
       eleHtml+="<tr id="+element.stock_code +">";
       eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.market_value +"</small></td>";
       eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+element.float_yk_per+"</span></td>";
       eleHtml+="<td>"+Number(element.cost_amount)+"<br/>"+Number(element.enable_amount)+"</td>";
       eleHtml+="<td>"+Number(element.cost_price).toFixed(price_digit)+"<br/>"+Number(element.last_price).toFixed(price_digit)+"</td>";
       eleHtml+="<td style='display:none;' class='tools sCode_"+element.stock_code+"' data-Market='"+element.exchange_type+"' data-stockName='"+element.stock_name+"'><ul>";
       eleHtml+="<li><a class='in2' href='javascript:void(0);'><span>买入</span></a></li>";
       eleHtml+="<li><a class='out2' href='javascript:void(0);'><span>卖出</span></a></li>";
       eleHtml+="<li><a class='hq2' href='javascript:void(0);'><span>行情</span></a></li></ul></td>";
       eleHtml+="</tr>";
//       eleHtml+="<dl class='part clearfix' id="+element.stock_code +">";
//       eleHtml+="<dt><span>市值: <em>"+element.market_value+"</em></span>";
//       eleHtml+="<strong>"+element.stock_name +"</strong><small>"+element.stock_code+"</small></dt>";
//       eleHtml+="<dd>盈亏<span class="+css+">"+float_yk+"</span></dd>";
//       eleHtml+="<dd>持仓<span>"+element.cost_amount+"</span></dd>";
//       eleHtml+="<dd>成本<span>"+Number(element.cost_price).toFixed(price_digit)+"</span></dd>";
//       eleHtml+="<dd>盈亏(%)<span class="+css+">"+element.float_yk_per+"%</span></dd>";
//       eleHtml+="<dd>可用<span>"+element.enable_amount+"</span></dd>";
//       eleHtml+="<dd>现价<span id='xianjia_"+element.stock_code+"'>"+Number(element.last_price).toFixed(price_digit)+"</span></dd>";
//       eleHtml+="<dd style='display:none;' class='tools sCode_"+element.stock_code+"' data-Market='"+element.exchange_type+"' data-stockName='"+element.stock_name+"'><ul>";
//       eleHtml+="<li><a class='in2' href='javascript:void(0);'><span>买入</span></a></li>";
//       eleHtml+="<li><a class='out2' href='javascript:void(0);'><span>卖出</span></a></li>";
//       eleHtml+="<li><a class='hq2' href='javascript:void(0);'><span>行情</span></a></li></ul></dd></dl>";
       return eleHtml;
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - $(_pageId+".hold_main").height() - 6  ,	//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					pageNum = addNum;
					queryData();
				},
				"upHandle": function() {
					if(isRefresh){
						pageNum = pageNum + addNum;
						queryData();
					}
					
				},
				"onScrollMove":function(){
					console.log("底部");
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		if(isAll){
			$(_pageId + ".visc_pullUp").css("display","none");//隐藏"上拉加载下一页"
		}else{			
			$(_pageId + ".visc_pullUp").css("display","block");
		}
		
	}
	
	/*
	 * ，初始化滑动组件
	 */
	function initHIScroll(){
		if(!initHIscroll._init){
			var config = {
					wrapper: $('#stock_stockHolding #wrapper_div'), //wrapper对象
					scroller: $('#stock_stockHolding #scroller_div'), //scroller对象
					perCount: 1,  //每个可视区域显示的子元素
					showTab: true, //是否有导航点
					tabDiv: $("#stock_stockHolding .dot"), //导航点集合对象
					auto: false, //是否自动播放
					interval: null, //自动播放定时器
					idxPage: 1, //记录当前scroll滚动到第几个page
					wrapperObj: null,
					onScrollEnd :function(){//滑动后的回调函数
						//var hCurPageFund = initHIscroll.scroll.getActivePage();
					}
				};
			initHIscroll.scroll = new hIscroll(config); //初始化，需要做if(!hIscroll._init)判断
			initHIscroll._init = true; //尽量只初始化一次，保持性能
		} 
	}
	/**
	 * 销毁
	 */
	function destroy(){
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }		
		pageNum = addNum;
		isRefresh = true;
	    isShowDown = true;
	    isAll = false;
		position_timer = null;
	    canBuy = 0 ;//可用
	    market_val = 0 ;//市值
		$(_pageId+".hold_table tr:eq(0) td:eq(0) strong").text("--");//总资产
		$(_pageId+".hold_table tr:eq(0) td:eq(2) strong").text("--");//市值
		$(_pageId+".hold_table tr:eq(1) td:eq(0) strong").text("--");//可取
		$(_pageId+".hold_table tr:eq(1) td:eq(1) strong").text("--");//可用
		if(vIscroll._init){
			vIscroll.scroll.destroy();
		}
		vIscroll._init = null;
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("stock/stockHolding","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});