/**
 * 普通交易-今日查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_stock = require("service_stock");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#stock_stockQueryToday ";
    var userInfo = null;
    var queryType = null; //查询内容
    
    /**
     * 初始化
     */
	function init(){
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryType = appUtils.getPageParam("param");
		if(queryType=="entrust_index"){
			$(_pageId + ".top_title .icon_back").text("交易");
			$(_pageId + ".top_title h3").text("今日委托");
			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="entrust_query"){
			$(_pageId + ".top_title .icon_back").text("查询");
			$(_pageId + ".top_title h3").text("今日委托");
			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="deal_index"){
			$(_pageId + ".top_title .icon_back").text("交易");
			$(_pageId + ".top_title h3").text("今日成交");
			$(_pageId+".tab_nav ul li:eq(1)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="deal_query"){
			$(_pageId + ".top_title .icon_back").text("查询");
			$(_pageId + ".top_title h3").text("今日成交");
			$(_pageId+".tab_nav ul li:eq(1)").addClass("active").siblings().removeClass("active");
		}
		callsQuery();

    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			var sCurPage = appUtils.getSStorageInfo("_curPage");
			var curPage = JSON.parse(sCurPage);
			var prePageCode = curPage.prePageCode;
			if(!prePageCode || prePageCode=="account/login"){
				prePageCode ="account/index";
			}
			appUtils.pageInit("stock/stockQueryToday",prePageCode,{});
		});
		//页面切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			if(vIscroll._init){
				vIscroll.scroll.destroy();
				vIscroll.scroll = null;
				vIscroll._init = false;
			}
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title h3").text($(this).find("a").text());
			callsQuery();
		});
		
	}
    
	/**
	 * 调用查询
	 */
	function callsQuery(){
		$(_pageId+".search_table .ce_table").html("");
		if(queryType=="entrust_query" || queryType=="entrust_index" ){
			$(_pageId+".search_table .ce_table").html("");
			queryEntrust();
		}else{
			$(_pageId+".search_table .ce_table").html("");
			queryDeal();
		}
	}
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;;
		var sessionid=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid
			};
			$(_pageId+ ".no_data").hide();
			service_stock.queryTodayTrust(param,queryEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){
					$(_pageId+ ".no_data").show();
					initVIScroll();
					if(vIscroll._init){
						vIscroll.scroll.refresh();
					}
				}
			});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".search_table .ce_table").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "<tr><th scope=\"col\">&nbsp;</th><th scope=\"col\">委托时间</th><th scope=\"col\">委托/均价</th><th scope=\"col\">委托/成交</th><th scope=\"col\">状态</th>";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".search_table .ce_table").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 3;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		var entrust_name = "";
		if(element.entrust_bs == "0"){
			css = "buy_icon";
			entrust_name ="委托买入";
		}else if(element.entrust_bs == "1"){
			css = "sell_icon";
			entrust_name ="委托卖出";
		}else{
			css = "";
		}
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
        var eleHtml = "";
//        eleHtml+="<div class=\"part\">";
//        eleHtml+="<span class=\"time\">"+element.entrust_date+"&nbsp"+element.entrust_time+"</span>";
//        eleHtml+="<h5 class=\""+css+"\">"+entrust_name+"</h5>";
//        eleHtml+="<dl class=\"clearfix\">";
//        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
//        eleHtml+="    <dd><em>编&#160;&#160;&#160;号</em>"+element.entrust_no+"</dd>";
//        eleHtml+="    <dd><em>状&#160;&#160;&#160;态</em>"+element.entrust_state_name+"</dd>";
//        eleHtml+="    <dd><em>委托价</em>"+Number(element.entrust_price).toFixed(price_digit)+"</dd>";
//        eleHtml+="    <dd><em>委托数</em>"+element.entrust_amount+"</dd>";
//        eleHtml+="    <dd><em>成交价</em>"+Number(element.business_price).toFixed(price_digit)+"</dd>";
//        eleHtml+="    <dd><em>成交数</em>"+element.business_amount+"</dd>";
//        eleHtml+="</dl>";
//        eleHtml+="</div>";
        
        eleHtml+="<tr><td class="+css+"></td>";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.entrust_time+"</small></td>";
        eleHtml+="<td><span>"+Number(element.entrust_price).toFixed(price_digit)+"</span><span>"+Number(element.business_price).toFixed(price_digit)+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_amount+"</span><span>"+element.business_amount+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_state_name+"</span></td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	
	/**
	 * 成交查询
	 */
	function queryDeal(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid
		};
		$(_pageId+ ".no_data").hide();
		service_stock.queryTodayTrade(param,queryDealCallback,
		    {
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
		
	}
	/**
	 * 成交查询回调
	 */
	function queryDealCallback(data){
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+" .tarde_hit").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results != "undefined" && results.length>0){
					var data = "<tr><th scope=\"col\">&nbsp;</th><th scope=\"col\">成交时间</th><th scope=\"col\">编号/金额</th><th scope=\"col\">成交价/成交数</th><th scope=\"col\">状态</th>";
					for (var i=0;i<results.length;i++){
						data += queryDealHTML(results[i]);
					}
					$(_pageId+".search_table .ce_table").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	/**
	 * 成交查询HTML生成
	 */
	function queryDealHTML(element){
		var price_digit = 3;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		var entrust_name = "";
		if(element.entrust_bs == "0"||element.entrust_bs=="1000"){
			css = "buy_icon";
			entrust_name ="委托买入";
		}else if(element.entrust_bs == "1"){
			css = "sell_icon";
			entrust_name ="委托卖出";
		}
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
        var eleHtml = "";
//        eleHtml+="<div class=\"part\">";
//        eleHtml+="<span class=\"time\">"+element.business_date+"&nbsp"+element.business_time+"</span>";
//        eleHtml+="<h5 class=\""+css+"\">"+entrust_name+"</h5>";
//        eleHtml+="<dl class=\"clearfix\">";
//        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
//        eleHtml+="    <dd><em>编&#160;&#160;&#160;号</em>"+element.entrust_no+"</dd>";
//        eleHtml+="    <dd><em>金&#160;&#160;&#160;额</em>"+Number(element.business_balance).toFixed(price_digit)+"</dd>";
//        eleHtml+="    <dd><em>成交价</em>"+Number(element.business_price).toFixed(price_digit)+"</dd>";
//        eleHtml+="    <dd><em>成交数</em>"+Number(element.business_amount)+"</dd>";
//        eleHtml+="</dl>";
//        eleHtml+="</div>";
        
        eleHtml+="<tr><td class="+css+"></td>";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.business_time+"</small></td>";
        eleHtml+="<td><span>"+element.entrust_no+"</span><span>"+Number(element.business_balance).toFixed(price_digit)+"</span></td>";
        eleHtml+="<td><span>"+Number(element.business_price).toFixed(price_digit)+"</span><span>"+element.business_amount+"</span></td>";
        eleHtml+="<td><span>已成交</span></td>";
        eleHtml+="</tr>";
        return eleHtml;

	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6 ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						callsQuery();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".search_table .ce_table").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		var sCurPage = appUtils.getSStorageInfo("_curPage");
		var curPage = JSON.parse(sCurPage);
		var prePageCode = curPage.prePageCode;
		if(!prePageCode || prePageCode=="account/login"){
			prePageCode ="account/index";
		}
		appUtils.pageInit("stock/stockQueryToday",prePageCode,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});