/**
 * 普通交易-网络投票
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; // 上下滑动
	var service_added = require("service_added");
	var _pageId = "#voting_netVote ";
	
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent(_pageId); // 绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryVoteList(); // 查询股东大会信息
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});
		// 查询
		appUtils.bindEvent($(_pageId + ".search_box2 a"), function(e){
			queryByCode(); //模糊查询
		});
	}
	
	/**
	 * 查询股东大会信息
	 */
	function queryVoteList(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid
		};
		// 每次查询前,先将暂无数据隐藏
		$(_pageId + ".no_data").hide();
		// 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_added.queryStockMeetingInfo(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryHTML(results[i]);
					}
					$(_pageId + ".vote_list").html(data);
					// 撤单事件
					appUtils.bindEvent($(_pageId+".vote_list .vote"), function(e){
						var vote_code = $(this).attr("data-code");
						var meeting_seq = $(this).attr("data-seq");
						appUtils.pageInit("voting/netVote","voting/voteDetail",{"vote_code":vote_code,"meeting_seq":meeting_seq});
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId + ".no_data").show();
					$(_pageId + ".visc_pullUp").hide();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		},{ // 传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	
	function queryHTML(element){
		var eleHtml = "";
	        eleHtml+="<div class=\"part\">";
	        eleHtml+="<a href=\"javascript:void(0);\" class=\"vote\" data-seq="+element.meeting_seq+" data-code="+element.vote_code+">投票</a>";
	        eleHtml+="<div class=\"title\">";
	        eleHtml+="	<h5>"+element.company_name+"</h5><small>"+element.company_code+"</small>";
	        eleHtml+="</div>";
	        eleHtml+="<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
	        eleHtml+="  <tr>";
	        eleHtml+="   <th scope=\"row\" width=\"30%\">股东大会名称：</th>";
	        eleHtml+="   <td>"+element.meeting_desc+"</td>";
	        eleHtml+="  </tr>";
	        eleHtml+="  <tr>";
	        eleHtml+="   <th scope=\"row\">股东大会类型:</th>";
	        eleHtml+="   <td>"+element.meeting_type+"</td>";
	        eleHtml+=" </tr>";
	        eleHtml+="<tr>";
	        eleHtml+=" <th scope=\"row\">起始日期：</th>";
	        eleHtml+="  <td>"+element.meeting_begin+"</td>";
	        eleHtml+="</tr>";
	        eleHtml+=" <tr>";
	        eleHtml+="  <th scope=\"row\">到期日期：</th>";
	        eleHtml+=" <td>"+element.meeting_end+"</td>";
	        eleHtml+="  </tr>";
	        eleHtml+=" </table>";
	        eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 模糊查询信息
	 */
	function queryByCode(){
		var code = $(_pageId + "#stockCode").val();
		var listHight = 0;
		var height = $(_pageId + ".vote_list .part").height();
		$(_pageId + ".vote_list .part").each(function(){
		    //用$(this)可以访问正在循环的元素 
			var stockCode = $(this).find(".title small").text();
			if(stockCode.indexOf(code) != -1 ){
				$(this).show();
				listHight += height;
			}else{
				$(this).hide();
			}
		});
		//$(_pageId + "#v_container_funds_jj").height(listHight);
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".header").height()- $(_pageId+".tab_nav").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryVoteList();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("voting/netVote","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});