/**
 * 普通交易-网络历史记录查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_added = require("service_added");
	var layerUtils = require("layerUtils");
	var validatorUtil = require("validatorUtil");
	var _pageId = "#voting_voteDetail ";
    var userInfo = null;
	
    /**
     * 初始化
     */
	function init(){
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		// 高度初始化
		$(_pageId).css("overflow-x","hidden");
		$(_pageId + ".main .bill_table").scrollTop(0);
		$(_pageId + ".main .bill_table").css("overflow-y","auto");
//        var height_meau = $(window).height() - $(_pageId + ".header").height() - $(_pageId + ".tab_nav").outerHeight(true) - 
//        	              $(_pageId + ".bill_table").css("margin-top").slice(0, -2) - $(_pageId + "#batchVote").outerHeight(true) -10;
		var height_meau = $(window).height() - $(_pageId + ".header").height() - $(_pageId + ".tab_nav").outerHeight(true) -10 ;
        $(_pageId + " .main .bill_table").height(height_meau); // 查询目录添加高度
        
		var meeting_seq = appUtils.getPageParam("meeting_seq");
		if(meeting_seq){
			queryVoteBillInfo(meeting_seq); // 查询议案详细信息
		}
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});
		// tab切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			if($(this).index() == "0"){
				$(_pageId + ".bill_table").show();
				$(_pageId + ".bill_stat").hide();
			}else{
				$(_pageId + ".bill_table").hide();
				$(_pageId + ".bill_stat").show();
			}
		});
		// 提交投票
		appUtils.bindEvent($(_pageId + ".top_title .logout"), function(e){
            submitVote(); //提交投票
		});
		// 批量投票
		appUtils.bindEvent($(_pageId + "#batchVote .all_check"), function(e){
			var $parentEle = $(this).find("input");
			var $childEle = $(_pageId+".bill_table .part p");
			var index = $(this).index() + 1;
			if($parentEle.attr("checked")){
//				$parentEle.attr("checked",false);
//				$childEle.find("input[data-type="+index+"]").attr("checked",false);
			}else{
				$parentEle.attr("checked",true);
				$childEle.find("input").attr("checked",false);
				$childEle.find("input[data-type="+index+"]").attr("checked",true);
				$(this).siblings().find("input").attr("checked",false);
			}
		});
	}
	
	/**
	 * 查询投票历史纪录
	 */
	function queryVoteBillInfo(meeting_seq){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "meeting_seq":meeting_seq,
		    "v_id":"",
		    "vote_code":""
		};
		// 每次查询前,先将暂无数据隐藏
		$(_pageId + ".no_data").hide();
		// 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_added.queryVoteBillInfo(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				$(_pageId+".bill_stat table").html("<tr><th scope=\"col\" width=\"20%\">议案序号</th><th scope=\"col\" width=\"50%\">议案名称</th> <th scope=\"col\">应选数量</th></tr>");
				$(_pageId + ".bill_table .part").remove();
				if(results && results.length>0){
					var data_lj = ""; // 累计型
					var data_flj = ""; // 非累计型
					for (var i=0;i<results.length;i++){
						if(results[i].vote_type == "1"){
							data_lj += queryHTML(results[i]);
						}else if(results[i].vote_type == "0"){
							data_flj += queryHTML(results[i]);
						}
					}
					if(data_flj==""){
						$(_pageId + ".bill_table .no_data").show();
					}else{
						$(_pageId + ".bill_table #batchVote").after(data_flj);
					}
					if(data_lj==""){
						$(_pageId + ".bill_stat .no_data").show();
					}else{
						$(_pageId+".bill_stat table tr:eq(0)").after(data_lj);
					}
					appUtils.bindEvent($(_pageId+".bill_table .part .icon_check"), function(e){
						var $element = $(this).find("input");
						if($element.attr("checked")){
							//$element.attr("checked",false);
						}else{
							$element.attr("checked",true);
							$(this).siblings().find("input").attr("checked",false);
						}
					});
				}else{
					$(_pageId + ".no_data").show();
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	function queryHTML(element){
		var eleHtml = "";
		if(element.vote_type == "0"){
	        eleHtml+="<dl class=\"part\">";
	        eleHtml+="<dt>"+element.v_id+"</dt>";
	        eleHtml+="<dt style=\"display:none\">"+element.exchange_type+"</dt>";
	        eleHtml+="<dt style=\"display:none\">"+element.ref_code+"</dt>";
	        eleHtml+="<dt style=\"display:none\">"+element.meeting_seq+"</dt>";
	        eleHtml+="<dt style=\"display:none\">"+element.stock_account+"</dt>";
	        eleHtml+="<dd>";
	        eleHtml+="<h5>"+element.vote_info+"</h5>";
	        eleHtml+="   <p>";
	        eleHtml+="       <span class=\"icon_check\">";
	        eleHtml+="           <input type=\"checkbox\" data-type=\"1\" class=\"c1\" checked><label style=\"font-size:0.13rem\" for=\"input_check\">同意</label>";
	        eleHtml+="       </span>";
	        eleHtml+="       <span class=\"icon_check\">";
	        eleHtml+="           <input type=\"checkbox\" data-type=\"2\" class=\"c1\"><label style=\"font-size:0.13rem\" for=\"input_check\">反对</label>";
	        eleHtml+="       </span>";
	        eleHtml+="       <span class=\"icon_check\">";
	        eleHtml+="           <input type=\"checkbox\" data-type=\"3\" class=\"c1\"><label style=\"font-size:0.13rem\" for=\"input_check\">弃权</label>";
	        eleHtml+="       </span>";
	        eleHtml+="     </p>";
	        eleHtml+=" </dd>";
	        eleHtml+="</dl>";
		}else if(element.vote_type == "1"){
			if(element.vote_leijino != "0"){
		        eleHtml+="  <tr id="+element.vote_leijino+" >";
		        eleHtml+="    <td><em>*</em><span>"+element.v_id+"</span></td>";
		        eleHtml+="    <td>"+element.vote_info+"</td>";
		        eleHtml+="    <td>"+element.vote_leijino+"</td>";
		        eleHtml+="  </tr>";
			}else{
		        eleHtml+="  <tr id="+element.vote_leijino+">";
		        eleHtml+="    <td style=\"display:none\">"+element.ref_code+"</td>";
		        eleHtml+="    <td style=\"display:none\">"+element.meeting_seq+"</td>";
		        eleHtml+="    <td style=\"display:none\">"+element.exchange_type+"</td>";
		        eleHtml+="    <td style=\"display:none\">"+element.stock_account+"</td>";
		        eleHtml+="    <td>"+element.v_id+"</td>";
		        eleHtml+="    <td>"+element.vote_info+"</td>";
		        eleHtml+="    <td><input type=\"tel\" class=\"text\" onkeyup=\"this.value=this.value.replace(/\D/g,'')\" onafterpaste=\"this.value=this.value.replace(/\D/g,'')\" ></td>";
		        eleHtml+="  </tr>";
			}

		}
        return eleHtml;
	}
	
	/**
	 * 提交投票
	 */
	function submitVote(){
		var $flj = $(_pageId + ".bill_table .part"); // 非累计型页面
		var $lj = $(_pageId + ".bill_stat .part table tr:gt(0)"); // 累计型页面
		var exchange_type = "";
		var stock_code = "";
		var meeting_seq = "";
		var v_id = "";
		var vote_number = "";
		var vote_result = "";
		var stock_account ="";
		var fjlFlag = 0;
		var endFlag = false; // 终止标识
		if($flj.length>0){ 
			$flj.each(function(){ // 循环遍历非累计型页面节点
				var $flag = $(this);
			    // 用$(this)可以访问正在循环的元素 
				$(this).find(".icon_check").each(function(){
					if($(this).find("input").attr("checked")){
						stock_code += $flag.find("dt:eq(2)").text()+",";
						meeting_seq += $flag.find("dt:eq(3)").text()+",";
						v_id += $flag.find("dt:eq(0)").text()+",";
						vote_number += "0,";
						vote_result += $(this).find("input").attr("data-type")+",";
						fjlFlag ++;
						exchange_type = $(_pageId+".bill_table dl:eq(0) dt:eq(1)").text();
						stock_account = $(_pageId+".bill_table dl:eq(0) dt:eq(4)").text();
					}
				});
			});
		}
		var ljFlag = 0;
		if($lj.length>0){ // 循环遍历累计型页面节点
			var totalNum = 0; // 总投票数
			var vid = ""; //母议案编号
			var maxNum = 0; //最大可投票数
			$lj.each(function(index, item){
				if($(this).attr("id") == "0"){
					var num = Number($(this).find("td:eq(6) input").val());
					if(!validatorUtil.isNumeric(num)){
						layerUtils.iMsg(-1,"议案"+$(this).find("td:eq(4)").text()+"投票数量格式不正确");
						endFlag = true;
						return false;
					}
					stock_code += $(this).find("td:eq(0)").text()+",";
					meeting_seq += $(this).find("td:eq(1)").text()+",";
					v_id += $(this).find("td:eq(4)").text()+",";
					vote_number += num + ",";
					vote_result += "0,";
					ljFlag ++;
					totalNum += num;
				}else{
					if(totalNum > maxNum){
						layerUtils.iMsg(-1,"议案"+vid+"总投票数不能大于"+maxNum);
						endFlag = true;
						return false;
					}else if(maxNum!=0 && totalNum == 0 ){
						layerUtils.iMsg(-1,"议案"+vid+"投票数不能为0");
						endFlag = true;
						return false;
					}
					maxNum = Number($(this).attr("id")); //重置数据
					vid = $(this).find("td:eq(0) span").text();
					totalNum = 0;
				}
				if(index == $lj.length -1){
					if(totalNum > maxNum){
						layerUtils.iMsg(-1,"议案"+vid+"总投票数不能大于"+maxNum);
						endFlag = true;
						return false;
					}else if(maxNum!=0 && totalNum == 0 ){
						layerUtils.iMsg(-1,"议案"+vid+"投票数不能为0");
						endFlag = true;
						return false;
					}
				}
			});
		}
		if(endFlag){
			return false;
		}
		var flag = "0";
		if(ljFlag + fjlFlag> 1){
			flag = "1";
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "stock_account":stock_account,
		    "flag":flag,
			"exchange_type":exchange_type,
			"stock_code":stock_code.substring(0,stock_code.length - 1),
			"meeting_seq":meeting_seq.substring(0,meeting_seq.length - 1),
			"v_id":v_id.substring(0,v_id.length - 1), 
			"vote_number":vote_number.substring(0,vote_number.length - 1),
			"vote_result":vote_result.substring(0,vote_result.length - 1),
		};
		console.log("======"+JSON.stringify(param));
		service_added.queryVote(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var tipStr = "";
			        tipStr = "<span style='font-weight:bold;font-size: 18px;'>委托提示</span><br>投票委托已提交，委托编号："+results[0].entrust_no;
				    layerUtils.iAlert(tipStr);
				    $(_pageId+".bill_table .part .icon_check input").attr("checked",false);
				}
			}else{
				layerUtils.iAlert(data.error_info);
				$(_pageId+".bill_table .part .icon_check input").attr("checked",false);
			}
		});
	}
	/**
	 * 数据重置
	 */
	function destroy(){
		$(_pageId+".bill_table .part .icon_check input").attr("checked",false);
		$(_pageId+"#batchVote input").attr("checked",false);
		$(_pageId+"#batchVote input:eq(0)").attr("checked",true);
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("voting/voteDetail","voting/netVote",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});