/**
 * 普通交易-网络历史记录查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; // 上下滑动
	var service_added = require("service_added");
	var dateUtils = require("dateUtils");
	var _pageId = "#voting_voteQuery ";
    var userInfo = null;
    var begin_date = "";
    var end_date = "";
	
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent(_pageId); // 绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var now_time = new Date();
		begin_date = new Date(now_time.setMonth(now_time.getMonth() - 1));
		begin_date = begin_date.format("yyyy-MM-dd");
		end_date = new Date().format("yyyy-MM-dd");
		$(_pageId+".data_check .inner .t1:eq(0)").val(begin_date);
		$(_pageId+".data_check .inner .t1:eq(1)").val(end_date);
		//日期时间输入点击调用日期组件，第一次点击不会触发效果，所以在init里面先初始化一次。
		dateUtils.initDateUI("voting_voteQuery");
		queryVoteHistory(); // 查询投票历史纪录
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});
        //查询点击事件
		appUtils.bindEvent($(_pageId+" #clickQuery"), function(e){
            var time_one =  $(_pageId + ".data_check .inner .t1:eq(0)").val();
            var time_two = $(_pageId + ".data_check .inner .t1:eq(1)").val();
			var begin = new Date(time_one.replace(/-/g,"/"));
			var end = new Date(time_two.replace(/-/g,"/"));
			var flag_one = new Date(time_two.replace(/-/g,"/"));;
			var flag_two = end.setMonth(end.getMonth()-3);
			if(flag_two > begin){
				 layerUtils.iAlert("最多只能查询三个月期间的数据");
			}else if(begin > flag_one){
				 layerUtils.iAlert("请查询正确的时间间隔");
			}else{
				begin_date = time_one;
				end_date = time_two;
				queryVoteHistory();
			}
			e.stopPropagation();
		},"click");
	}
	
	/**
	 * 查询投票历史纪录
	 */
	function queryVoteHistory(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "begin_date":begin_date,
		    "end_date":end_date
		};
		// 每次查询前,先将暂无数据隐藏
		$(_pageId + ".no_data").hide();
		// 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_added.queryVoteHistory(param,function(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryHTML(results[i]);
					}
					$(_pageId + ".search_list ").html(data);
				}else{
					$(_pageId + ".no_data").show();
					$(_pageId + ".visc_pullUp").hide();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		},{ // 传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	
	function queryHTML(element){
		var vote_type = "";
		if(element.vote_type == "2"){
			vote_type = "累计型投票";
		}else{
			vote_type = "非累计型投票";
		}
		var eleHtml = "";
	        eleHtml+="<div class=\"part\">";
	        eleHtml+="<span class=\"time\">"+element.order_date+"</span>";
	        eleHtml+="<h5>"+vote_type+"</h5>";
	        eleHtml+="<dl class=\"clearfix\">";
	        eleHtml+="	<dt>"+element.stock_name+"<small>"+element.stock_code+"</small></dt>";
	        eleHtml+="    <dd><em>编号</em>"+element.order_sno+"</dd>";
	        eleHtml+="    <dd><em>委托状态</em>"+element.order_status_name+"</dd>";
	        eleHtml+="    <dd><em>资产账户</em>"+element.fund_account+"</dd>";
	        eleHtml+="    <dd><em>证券账号</em>"+element.fund_account+"</dd>";
	        eleHtml+="    <dd><em>投票议案</em>"+element.v_id+"</dd>";
	        eleHtml+="    <dd><em>投票结果</em>"+element.vote_result+"</dd>";
	        eleHtml+="    <dd><em>申请编号</em>"+element.order_id+"</dd>";
	        eleHtml+="    <dd><em>申请时间</em>"+element.report_time+"</dd>";
	        eleHtml+="</dl>";
	        eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".header").height()- $(_pageId+".tab_nav").height()- $(_pageId+".inner").outerHeight()- 16  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+"#v_container_funds_jj"),	
				"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
				"downHandle": function() {
					queryVoteHistory();//下拉获取上一页数据方法
				},
				"upHandle": function() {	
					//上拉获取下一页数据方法
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("voting/voteQuery","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});