/**
 * 银行理财-签署协议
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var _pageId = "#yyh_signProtocol ";
	var service_fund = require("service_fund");
	var service_finance = require("service_finance");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var stock_userInfo = null;
	var fund_company = "99";
	var fund_code = "BB1005";
	var state = "";
	var showInfo = [];

	
    /**
     * 初始化
     */
	function init() {
//		$(_pageId+"#loading").show();
		stock_userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		prePageCode = appUtils.getSStorageInfo("_prePageCode");
		console.log(stock_userInfo);
		if(prePageCode != "finance/protocolInfo"){
			$(_pageId+".icon_check").find("input").attr("checked",false);
			$(_pageId+".ce_btn").addClass("disable");
		}
		if(stock_userInfo.client_rights.indexOf("e")<=0){
			state = "1" ;//开通签署权限
		}		
		var showStock = appUtils.getPageParam("param"); 
		if(showStock){
			showOpenStock("BB1005");
		}else{
			checkOpen();
		}			
    }
	
	
	function checkOpen(){
		
		var cust_code = stock_userInfo.cust_code;	// 客户代码
		var fund_account = stock_userInfo.fund_account; // 资产账户
		var branch_no = stock_userInfo.branch_no;	// 分支机构
		var sessionid = stock_userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"password":stock_userInfo.password,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"e":state,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"ofcash_balance":2000,
				"ofcash_status":0
		};
		service_fund.fundOpenYYH(param,function(data){
			if(data.error_no == 0){
				appUtils.pageInit("yyh/signProtocol","yyh/yyhEdit");			
			}else if(data.error_no == -10){
				showOpenStock("BB1005");
			}else if(data.error_no == -11){
				appUtils.pageInit("yyh/signProtocol","yyh/yyhEdit");	
			}else if(data.error_no == -13){
				appUtils.pageInit("yyh/signProtocol","yyh/yyhEdit");	
			}else{
				layerUtils.iAlert(data.error_info,0,function(){
					appUtils.pageInit("yyh/signProtocol","account/index");
				});
			}
		});
		
	}
	
	//开户协议展示
	function showOpenStock(queryNo){
		var param = {"queryNo":queryNo};
		service_finance.queryProtocol(param,function(data){
//			$(_pageId+"#loading").hide();
			if(data.error_no == 0){
				var str = "";
				var results = data.results;
				if(results && results.length>0){
					for(var i =0;i<results.length;i++){
						str +="<li><a href=\"javascript:void(0);\">《"+results[i].agreement_title+"》</a></li>";
						showInfo.push(results[i]);
					}
					$(_pageId+".rule_list ul").html(str);
					
					appUtils.bindEvent($(_pageId + ".rule_list>ul li"), function(e){
						var index = $(this).index();
						appUtils.pageInit("finance/signProtocol","finance/protocolInfo",{"showInfo":showInfo[index]});
					},"click");
				}
				
				
			}
		},{"isLastReq":true,"isShowWait":false,});
	}
	
	
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		// 返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
		});

		appUtils.bindEvent($(_pageId+" .icon_check"), function(e){
			var isChecked = $(this).find("input").attr("checked");
			if(isChecked){
				$(this).find("input").attr("checked",false);
				$(_pageId+".ce_btn").addClass("disable");
			}else{
				$(this).find("input").attr("checked",true);
				$(_pageId+".ce_btn").removeClass("disable");
			}
			e.stopPropagation();
		},"click");
		
		appUtils.bindEvent($(_pageId + ".ce_btn"), function(e){
			if(!$(this).hasClass("disable")){
				state = "Y";
				checkOpen();
				
			}
		},"click");
		
	}

	
	
	function destroy(){
		state = "";
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("yyh/signProtocol","account/index");
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});