/**
 * 预售要约-解除
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var service_fund = require("service_fund");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var _pageId = "#yyh_yyhCache ";
	var userInfo = null;
	/**
     * 初始化
     */
	function init(){
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		queryNowShare();
    }
	
	function queryNowShare(){
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account; // 资产账户
		var branch_no = userInfo.branch_no;	// 分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid
		};
		service_fund.fundQueryShare(param,function(data){
			console.log(data)
		});
		
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
			e.stopPropagation();
		},"click");
		
		appUtils.bindEvent($(_pageId + ".tab_box ul li"), function(e){
			var toPage = $(this).attr("toPage");
			appUtils.pageInit("yyh/yyhCache",toPage.replace("_","/"));
			e.stopPropagation();
		},"click");
		
		appUtils.bindEvent($(_pageId+".btn_box a"),function(e){
			cacheProduct();
			e.stopPropagation();
		},"click");
	}
	
	function cacheProduct(){
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account; // 资产账户
		var branch_no = userInfo.branch_no;	// 分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"password":userInfo.password,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"ofcash_balance":2000,
				"ofcash_status":0
		};
		service_fund.fundCache(param,function(data){
			
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("yyh/yyhCache","account/index");
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});