/**
 * 预售要约-解除
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var service_fund = require("service_fund");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var _pageId = "#yyh_yyhCanel ";
	var userInfo = null;
	var fund_company = "99";
	var fund_code = "BB1005";
	/**
     * 初始化
     */
	function init(){
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		queryProductInfo();
		if(appUtils.getSStorageInfo("yyh_statecct")!="0"){
			$(_pageId+".btn_box").addClass("disable");
		}else{
			$(_pageId+".btn_box").removeClass("disable");
		}
    }
	
	
	
	function queryProductInfo(){
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account; // 资产账户
		var branch_no = userInfo.branch_no;	// 分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid
		};
		service_fund.fundProductYYH(param,function(data){
			if(data.error_no == 0){
				if(data.results.length>0){
					$(_pageId+".cash_input p span").html("<em>"+data.results[0].ofcash_amount+"</em>元");
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
		
	}
	
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			pageBack();
			e.stopPropagation();
		},"click");
		
		appUtils.bindEvent($(_pageId + ".tab_box ul li"), function(e){
			var toPage = $(this).attr("toPage");
			if(toPage == "yyh_yyhCache"){
				layerUtils.iMsg(0,"该功能正在完善中！");
			}else{
				appUtils.pageInit("yyh/yyhCanel",toPage.replace("_","/"));
			}
			
			e.stopPropagation();
		},"click");
		
		appUtils.bindEvent($(_pageId+".btn_box a"),function(e){
			if(appUtils.getSStorageInfo("yyh_statecct")!="0"){
//				layerUtils.iAlert("产品状态不正常");
				return false;
			}else{
				layerUtils.iConfirm("分红日前解约当季只能享受活期利率，请谨慎操作。",function(){
					canelProduct();
				});
			}
			
			e.stopPropagation();
		},"click");
	}
	
	
	function canelProduct(){
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account; // 资产账户
		var branch_no = userInfo.branch_no;	// 分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configurat
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"password":userInfo.password,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"ofcash_balance":2000,
				"ofcash_status":0
		};
		service_fund.fundCanelYYH(param,function(data){
			if(data.error_no == 0){
				layerUtils.iAlert("月月红取消确认中，资金T+1日可取！",0,function(){
					var cust_code = userInfo.cust_code;	// 客户代码
					var fund_account = userInfo.fund_account; // 资产账户
					var branch_no = userInfo.branch_no;	// 分支机构
					var sessionid = userInfo.session_id;
					var entrust_way = global.entrust_way; // 委托方式  在configurat
					var param={			
							"entrust_way":entrust_way,
							"branch_no":branch_no,
							"fund_account":fund_account,
							"password":userInfo.password,
							"cust_code":cust_code,
							"sessionid":sessionid,
							"e":"x"
					};
					service_fund.fundOpenYYH(param,function(data){
						if(data.error_no == 0){
//							var yyh_state = appUtils.setSStorageInfo("yyh_state","");
							appUtils.pageInit("yyh/signProtocol","yyh/yyhEdit",{"yyh_state":""});			
						}else if(data.error_no == -12 || data.error_no == -10){
							appUtils.pageInit("yyh/yyhCanel","yyh/signProtocol",{param:"BB1005"});
						}else{
							layerUtils.iAlert(data.error_info);
						}
					});
				});
				
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("yyh/yyhCanel","account/index");
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});