/**
 * 银行理财service层调用接口
 */
define(function(require, exports, module) {
	var gconfig = require("gconfig");
	var appUtils = require("appUtils");
	var service = require("service");
	var global = gconfig.global;
	var serviceSingleton = new service.Service();
    
	function TradeService(){
	    this.serviceMap = {};
	}
	/********************************公共代码部分********************************/
    function commonInvoke(paraMap, callback, ctrlParam, reqParamVo){
		reqParamVo.setReqParam(paraMap);
		ctrlParam = ctrlParam?ctrlParam:{};
		reqParamVo.setIsLastReq(ctrlParam.isLastReq);
		reqParamVo.setIsAsync(ctrlParam.isAsync);
		reqParamVo.setIsShowWait(ctrlParam.isShowWait);
		reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
		reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
		reqParamVo.setTipsWords(ctrlParam.tipsWords);
		reqParamVo.setDataType(ctrlParam.dataType);
		reqParamVo.setIsGlobal(ctrlParam.isGlobal);
		reqParamVo.setProtocol(ctrlParam.protocol);
		serviceSingleton.invoke(reqParamVo, callback);
	}

	function destroy(){
		serviceSingleton.destroy();
	}
	var service_finance = { //对应的接口方法需要在这里暴露出来
		"getInstance": getInstance, //为了避免以前调用getInstance方法报错
		"destroy": destroy
	};
	function getInstance(){
		return service_finance;
	}
	module.exports = service_finance;
	
	/********************************应用接口开始********************************/

	/**
	 * 添加OpStation
	 * */
	function addOpStation(param){
		var channelNo = " "; // 通道编号
		var ipAddr = " "; // ip 
		var macAddr = " "; // mac
		var hardId = " "; // 硬盘序列号（硬件id）
		var cpuId = " "; // cpu 序列号
		var mobileNo = " "; // 手机号
		var hardIdentifier = " "; //硬件特征码
		var source = " "; // 来源
		var other = " "; // 其他
 
		if(iBrowser.android){
			channelNo = "1";
		}else if(iBrowser.iPad || iBrowser.iPhone || iBrowser.ios){
			channelNo = "2";
		}else if(iBrowser.pc){
			channelNo = "0";
		}
		if(gconfig.platform != "0"){
			var external = require("external");
			var mobileNoInfo = external.callMessage({"funcNo":"50043","key":"mobilePhone"}); // 电话号码
			if(mobileNoInfo.error_no == "0" && mobileNoInfo.results[0].value!=""){
				mobileNo = mobileNoInfo.results[0].value;
			}
			var hardIdInfo = external.callMessage({"funcNo": "50022"}); //设备唯一码
			if(hardIdInfo.error_no ==  "0" && hardIdInfo.results[0].deviceToken!=""){
				hardId = hardIdInfo.results[0].deviceToken;
			}
			var ipAddrInfo = external.callMessage({"funcNo": "50023"}); //设备IP地址
			if(ipAddrInfo.error_no ==  "0" && ipAddrInfo.results[0].ip!=""){
				ipAddr = ipAddrInfo.results[0].ip;	
			}
			var macAddrInfo = external.callMessage({"funcNo": "50024"}); //设备MAC地址 
			if(macAddrInfo.error_no ==  "0" && macAddrInfo.results[0].mac!=""){
				macAddr = macAddrInfo.results[0].mac;
			}
			var versionInfo = external.callMessage({"funcNo": "50010"}); //应用版本号
			if(versionInfo.error_no ==  "0" && versionInfo.results[0].version!=""){
				other = versionInfo.results[0].version;
			}
		}
		source = global.opStationInfo; //来源
		var aOpStation = [];
		aOpStation.push(channelNo);
		aOpStation.push("|");
		aOpStation.push(ipAddr);
		aOpStation.push("|");
		aOpStation.push(macAddr);
		aOpStation.push("|");
		aOpStation.push(hardId);
		aOpStation.push("|");
		aOpStation.push(cpuId);
		aOpStation.push("|");
		aOpStation.push(mobileNo);
		aOpStation.push("|");
		aOpStation.push(hardIdentifier);
		aOpStation.push("|");
		aOpStation.push(source);
		aOpStation.push("|");
		aOpStation.push(other);
//		console.log(aOpStation.join(""));
		param.op_station = aOpStation.join(""); // 通道编号|IP地址|MAC地址|硬盘序列号|CPU序列号|手机号码|硬件特征码|来源|其他
	}
	
	/********************************业务范围--银行理财********************************/
	 /**
	 * 证券理财代码信息查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinList = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301800";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodcode_type"] = param.prodcode_type;
 		paraMap["money_type"] = param.money_type;
 		paraMap["en_prod_status"] = param.en_prod_status;
 		paraMap["position_str"] = param.position_str;
 		paraMap["request_num"] = param.request_num;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财代码交易查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinTradeQuery = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301801";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财产品认购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinSubscribe = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301802";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		paraMap["entrust_balance"] = param.entrust_balance;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财产品委托撤单
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinCancel = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301805";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		paraMap["allot_no"] = param.allot_no;
 		paraMap["batch_flag"] = param.batch_flag;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财产品份额查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinShare = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301806";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财产品当日申赎委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinTodaySS = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301807";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财交易当日委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinTodayEntrust = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301808";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财交易当日交易查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinTodayDeal = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301809";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财可申购数量查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinCanApply = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301810";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财产品申购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinApply = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301803";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["bankm_account"] = param.bankm_account;
 		paraMap["entrust_balance"] = param.entrust_balance;
 		paraMap["prod_open_date"] = param.prod_open_date;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	}; 
	
	 /**
	 * 证券理财交易历史委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinHisEntrust = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301811";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		paraMap["begin_date"] = param.begin_date;
 		paraMap["end_date"] = param.end_date;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财交易历史成交查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinHisDeal = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301812";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		paraMap["begin_date"] = param.begin_date;
 		paraMap["end_date"] = param.end_date;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财历史交割流水查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinHisFlow = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301813";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		paraMap["begin_date"] = param.begin_date;
 		paraMap["end_date"] = param.end_date;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财帐号查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinAccount = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301814";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财账户开户
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinOpen = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301815";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["secum_account"] = param.secum_account;
 		paraMap["prodholder_kind"] = param.prodholder_kind;
 		paraMap["secum_open_mode"] = param.secum_open_mode;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财产品历史申赎委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinHisSS = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301816";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		paraMap["begin_date"] = param.begin_date;
 		paraMap["end_date"] = param.end_date;
 		paraMap["query_date"] = param.query_date;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财产品可撤委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinMayCancel = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301817";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["secum_account"] = param.secum_account;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财判断是否开户
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinIsOpen = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301820";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财开通签署电子协议权限
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinPermission = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301821";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财资金查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinCapital = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301822";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["money_type"] = param.money_type;
 		paraMap["queryBal_fundAcc"] = param.prodta_no;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 证券理财风险测评问卷查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param flag          是否首次开户（0：否，1：是）
	 * */
	service_finance.stockFinQuestion = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301823";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["sessionid"] = param.sessionid;
		paraMap["password"] = param.password;
		paraMap["risk_kind"] = param.risk_kind;
		paraMap["organ_flag"] = param.organ_flag;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();;
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 证券理财风险测评问卷提交
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * @param risk_kind   风险问卷类型（见数据字典）
	 * @param paper_answer   提交答案
	 * */
	service_finance.stockFinRiskSubmit = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301824";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["fund_company"] = param.fund_company;
 		paraMap["risk_kind"] = param.risk_kind;
 		paraMap["paper_answer"] = param.paper_answer;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 证券理财风险测评结果查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.stockFinRiskResult = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301825";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["risk_kind"] = param.risk_kind;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	
	 /**
	 * 银行理财代码信息查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinList = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301900";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["money_type"] = param.money_type;
 		paraMap["en_prod_status"] = param.en_prod_status;
 		paraMap["position_str"] = param.position_str;
 		paraMap["request_num"] = param.request_num;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};   
	
	 /**
	 * 银行理财产品认购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinSubscribe = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301901";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["bankm_account"] = param.bankm_account;
 		paraMap["entrust_balance"] = param.entrust_balance;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	}; 
 
	 /**
	 * 银行理财产品申购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinApply = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301902";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["bankm_account"] = param.bankm_account;
 		paraMap["entrust_balance"] = param.entrust_balance;
 		paraMap["prod_open_date"] = param.prod_open_date;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	}; 
	
	 /**
	 * 银行理财产品赎回
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinRedeem = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301804";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["bankm_account"] = param.bankm_account;
 		paraMap["amount"] = param.amount;
 		paraMap["allot_no"] = param.allot_no;
 		paraMap["exceed_flag"] = param.exceed_flag;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 银行理财可申购数量获取
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinCanSub = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301904";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodta_no"] = param.prodta_no;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财产品委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinTrust = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301905";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prod_code"] = param.prod_code;
 		paraMap["prodta_no"] = param.prodta_no;
 		paraMap["bankm_account"] = param.bankm_account;
 		paraMap["allot_no"] = param.allot_no;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财产品历史申赎委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinHistory = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301906";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财产品可撤委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinMayCancel = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301907";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财产品委托撤单
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinCancel = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301908";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["secum_account"] = param.secum_account;
		paraMap["allot_no"] = param.allot_no;
		paraMap["batch_flag"] = param.batch_flag;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财产品份额查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinShare = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301909";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		paraMap["allot_no"] = param.allot_no;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财交割流水查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinFlow = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301910";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财历史交割流水查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinHisFlow = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301911";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财帐号查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinAccounts = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301912";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prodta_no"] = param.prodta_no;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财账户开户
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinOpen = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301913";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财交易当日委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinTodayTrust = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301914";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		paraMap["entrust_no"] = param.entrust_no;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财交易历史委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinHisTrust = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301915";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		paraMap["entrust_no"] = param.entrust_no;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财交易当日交易查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinTodayDeal = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301916";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		paraMap["serial_no"] = param.serial_no;
		paraMap["report_no"] = param.report_no;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财交易历史成交查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinHisDeal = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301917";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["prod_code"] = param.prod_code;
		paraMap["prodta_no"] = param.prodta_no;
		paraMap["bankm_account"] = param.bankm_account;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财试题获取
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinQuestion = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301919";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["risk_kind"] = param.risk_kind;
		paraMap["organ_flag"] = param.organ_flag;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财风险测评结果查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinRiskResult = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301920";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财风险测评问卷提交入参
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinRiskSubmit = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301921";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["money_type"] = param.money_type;
		paraMap["bank_code"] = param.bank_code;
		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 证券理财资金查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinCapital = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301922";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["money_type"] = param.money_type;
 		paraMap["queryBal_fundAcc"] = param.prodta_no;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
	 * 银行理财开通签署电子协议权限
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinPermission = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301923";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	 /**
	 * 银行理财判断是否开户
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.bankFinIsOpen = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301924";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["sessionid"] = param.sessionid;
 		paraMap["prodta_no"] = param.prodta_no;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	 /**
	 * 产品协议获取
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_finance.queryProtocol = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "902105";
		paraMap["product_code"] = param.queryNo;
 		addOpStation(paraMap); // 添加 op_station 到接口请求参数中
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl( global.serverPathTrade);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/***应用接口......................................................结束*/

});