/**
 * 借款确认页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		userInfoInSession = null,  // session 中的 userInfo
		_pageId = "#account_contactInfo";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession(); // session 中的 userInfos
		showContactInfo();  // 显示联系信息
		$(_pageId+" .fix_bot").css({"top" : $(window).height() - 80 + "px"}); // 防止键盘聚焦按钮挡住输入框
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("account/contactInfo","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		
		/*下一步*/
		appUtils.bindEvent($(_pageId+" .PubBtn"), function(e){
			if(validateNext())  // 校验下一步条件
			{
				modifyContactInfo();  // 修改联系信息
			}
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*校验下一步条件*/
	function validateNext()
	{
		var mobileNo = $(_pageId+" #urgent_telno").val(),
		    contactPerson = $(_pageId+" #urgent_contact").val(),
			email = $(_pageId+" #email").val();
		var testReg = new RegExp("^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$");
		if(!validatorUtil.isMobile(mobileNo))
		{
			layerUtils.iMsg(-1, "请输入正确的应急联系人的电话!");
			return false;
		}
		if(email.trim() == ""||!testReg.test(email))
		{
			layerUtils.iMsg(-1, "请输入正确的电子邮箱！");
			return false;
		}
		if(contactPerson.trim() == "")
		{
			layerUtils.iMsg(-1, "请输入联系人！");
			return false;
		}
		return true;
	}
	
	/*显示联系信息*/
	function showContactInfo()
	{
		 var param = {
				 "user_id": userInfoInSession.cust_code
		 };
		 service.getUserInfo(param,function(data){
			 if(data.error_no == 0){
				 $(_pageId+" #urgent_contact").val(data.results[0].urgent_contact);
				 $(_pageId+" #urgent_telno").val(data.results[0].urgent_telephone);
				 $(_pageId+" #email").val(data.results[0].email);
				 $(_pageId+" #custName").html(data.results[0].name);
				 $(_pageId+" #mobile").html(data.results[0].mobile);
			 };
		 });
	}
	
	/*修改联系信息*/
	function modifyContactInfo()
	{
		var modifyContactParam = {
				email : $(_pageId+" #email").val(),
				telephone :$(_pageId+" #mobile").html(),
				urgent_contact : $(_pageId+" #urgent_contact").val(),
				urgent_telephone : $(_pageId+" #urgent_telno").val(),
				op_source : gconfig.platform,
				name : $(_pageId+" #custName").html(),
		};
		service.modifyContactInfo(modifyContactParam, function(data){
			if(data.error_no == "0")  
			{
				//修改成功后从新写入缓存
//				var param = {
//								"email":email,
//								"urgent_telephone":urgent_telephone,
//								"urgent_name":urgent_contact
//							};
				utils.addDataToUserInfo(modifyContactParam);
				modifyAction();  // 调用修改资料的 action 
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		}, {"isLastReq":false});
	}
	
	/*调用修改资料的 action*/
	function modifyAction()
	{
		layerUtils.iAlert("修改资料成功！", 0);
		layerUtils.iLoading(false);
		//跳到个人中心页面
		appUtils.pageInit("account/contactInfo","account/myInfoCenter");
	}
	
	/*向外暴露的 JSON 对象*/
	var contactInfo = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = contactInfo;
});