/**
 * 个人中心
 * 信用记录页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		userInfoInSession = null,  // session 中的 userInfo
		_pageId = "#account_creditHistory";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession(); // session 中的 userInfos
		
		fillCredit();
		
	}
	
	/*填充信用记录*/
	function fillCredit(){
		var param = {
				user_id : userInfoInSession.user_id
				// , query_flog
		}
		service.getCreaditHistory(param, function(data){
			if(data.error_no == 0){
				
				var oneData = data.results[0];
					borrowingNumber = oneData.borrowingNumber, //借款次数
		     		normalRepay = oneData.normalRepay,   //正常还款次数
		     		advanceNumber = oneData.advanceNumber,   //提前还款次数
		     		delayNumber = oneData.delayNumber,     //延期还款次数
		     		defaultNumber = oneData.defaultNumber,   //违约次数
		     		replenishNumber = oneData.replenishNumber, //补充质押次数
		     		str = '';
					str += '<div style="text-align: center;font-size: 18px;margin-bottom:10px;">借款次数：'+borrowingNumber+'</div>'
						+ '<div class="cont">'
						+ '<div class="inner">'
						+ '<p>正常还款：</p>'
						+ '<p>'+normalRepay+'次 <font style="color:green">（点击查看详情）</font></p>'
						+ '</div>'
						+ '<div class="inner">'
						+ '<p>提前购回次数：</p>'
						+ '<p>'+advanceNumber+'次 <font style="color:green">（点击查看详情）</font></p>'
						+ '</div>'
						+ '<div class="inner">'
						+ '<p>延期购回次数：</p>'
						+ '<p>'+delayNumber+'次 <font style="color:green">（点击查看详情）</font></p>'
						+ '</div>'
						+ '<div class="inner">'
						+ '<p>补充质押次数：</p>'
						+ '<p>'+replenishNumber+'次 <font style="color:green">（点击查看详情）</font></p>'
						+ '</div>'
						+ '<div class="inner">'
						+ '<p style="color:red">违约记录：</p>'
						+ '<p style="color:red">'+defaultNumber+'次 <font style="color:green">（点击查看详情）</font></p>'
						+ '</div>'
						+ '</div>'
						+ '</div>';
					$(_pageId+" .IndividualAccount").html(str);
					bindCreditHistoryBtn();
			}else{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*绑定借款记录信息*/
	function bindCreditHistoryBtn(){
		appUtils.bindEvent($(_pageId+" .IndividualAccount .cont .inner"), function(e){
			var index = $(this).index();
			switch(index){
			case 0 : //正常还款
				appUtils.pageInit("account/creditHistory","account/normalRepayInfo");
				break;
			case 1 : //提前回购次数
				appUtils.pageInit("account/creditHistory","account/earlyRepurchaseInfo");
				break;
			case 2 : //延期回购次数
				appUtils.pageInit("account/creditHistory","account/deferredRepurchaseInfo");
				break;
			case 3 : //补充质押次数
				appUtils.pageInit("account/creditHistory","account/supplePledgeInfo");
				break;
			case 4 : //违约记录
				appUtils.pageInit("account/creditHistory","account/defaultRecordInfo");
				break;
			}
			
			e.stopPropagation();
		});
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*向外暴露的 JSON 对象*/
	var creditHistory = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = creditHistory;
});