/**
 * 额度管理
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		formatNum = require("formatNum"),
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		show_btn = false, //显示 我要借款 和 我要征信
		useamountmoneys = 0,//可用额度
		prePageCode = "",
		_pageId = "#account_limitManage";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		show_btn = (appUtils.getPageParam("show_btn") == true)?true:false;
		prePageCode = appUtils.getSStorageInfo("_prePageCode");
		if(show_btn){
			$(_pageId+" #show_btn").show();
			$(_pageId+" #adjust").hide();
		}
		
		queryLimit(); // 查询额度
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
				appUtils.pageInit("account/limitManage","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");		
		/*调整额度*/
		appUtils.bindEvent($(_pageId+" #adjust"), function(e){
				appUtils.setSStorageInfo("setLimit","true");
				appUtils.pageInit("account/limitManage","apply/creditAssessment");
				e.stopPropagation();
		});
		
		/**/
		appUtils.bindEvent($(_pageId+" #restCredit"), function(e){
			appUtils.pageInit("account/limitManage","apply/creditAssessment");
			e.stopPropagation();
		});
		
		/**/
		appUtils.bindEvent($(_pageId+" #toAapply"), function(e){
			//可用资金小于等于0  不能借款
			 //您的可用额度为0
			 if(useamountmoneys <= 0){
				 layerUtils.iMsg(-1,"您的可用额度为0");
				 return;
			 }
			 if(userInfoInSession.credit_money == null||userInfoInSession.credit_money == ""){
				 if(userInfoInSession.signargument == null||userInfoInSession.signargument == ""){
					 appUtils.setSStorageInfo("firstLand",true);
					 appUtils.pageInit("account/limitManage","apply/riskDisclosure");
				 }
				 else  if(userInfoInSession.risk_level == null||userInfoInSession.risk_level == "" ||userInfoInSession.risk_level == "保守型"){
					 appUtils.setSStorageInfo("firstLand",true);
					 appUtils.pageInit("account/limitManage","apply/riskAssessment");
				 }
			 }
			 else {
				 appUtils.pageInit("account/limitManage","business/borrowIndex");
			 }
			e.stopPropagation();
		});
	}
	
	
	
	/*调整额度*/
	function adjustLimit()
	{ 
		var adjustLimitParam = {
			orgid : userInfoInSession.orgid, // 机构id
			clinetId : userInfoInSession.custid, // 客户id
			after : $(_pageId+" #canchanmoney").attr("money")  // 可调整额度
			};
		service.getUserlimit(adjustLimitParam,function(data){
			if(data.error_no == "0")
			{
				layerUtils.iAlert("额度申请调整成功,请耐心等待审批!", 0, function(){
					queryLimit(); // 查询额度
				});
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*查询额度*/
	function queryLimit()
	{
		var queryLimitParam = {
				user_id : userInfoInSession.user_id
		};
		service.getUserlimit(queryLimitParam,function(data){
			if(data.error_no == "0")
			{
				fillqueryLimit(data.results); // 填充额度数据
			}
			else
			{
				 layerUtils.iLoading(false);
				 handleGetUserLimit();
			}
		},{"isLastReq":true,"isShowWait":true,"timeOutFunc":handleGetUserLimit});
	}
	
	/*填充额度数据*/
	function fillqueryLimit(results)
	{
		var canchanmoney = Number(results[0].use_money),  // 总资产
			canMoney = Number(results[0].use_money),  // 已借款
			moneyforisk = results[0].credit_money,    // 授信额度
			creditRate = Number(results[0].credit_coe).toFixed(2),      //授信系数
			canchanmoney = canchanmoney <= 0 ? "0.00元" : (canchanmoney+"元");
		
		useamountmoneys = results[0].residue_balance; // 可用额度
		$(_pageId+" #moneyforisk").text(formatNum.formatMoney(moneyforisk)+"元");
		$(_pageId+" #canchanmoney").text(formatNum.formatMoney(canchanmoney)+"元").attr("money",canMoney);
		$(_pageId+" #useamountmoneys").text(formatNum.formatMoney(useamountmoneys)+"元");
		$(_pageId+" #creditRate").text(creditRate);
		utils.addDataToUserInfo("grantMoney", moneyforisk);   // 将查出来的总额度添加到 session 中的 userInfo 中
		utils.addDataToUserInfo("avilMoney", useamountmoneys);   // 将查出来的可用额度添加到 session 中的 userInfo 中
	}
	
	
	/******** 重新加载 *************/
  	/*** 重新查询授信额度***/
	function handleGetUserLimit(){
		layerUtils.iAlert("数据加载失败，是否重新加载？",-1, function(){
			queryLimit();   
		});
	}
  	/********   开始   ************/
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" #show_btn").hide();
		show_btn = false;
		$(_pageId+" #adjust").show();
	}
	/*向外暴露的 JSON 对象*/
	var limitManage = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = limitManage;
});