/**
 * 登陆页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		endecryptUtils = require("endecryptUtils"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		imgServerPath = global.actionPath + "/servlet/Image",  // 图片验证码的请求地址
		imgCodeSubPath = global.actionPath + "/servlet/action/ValidateMobCode",  // 图片验证码的提交地址
		randomCode = null,  // 验证码的随机数 
		_pageId = "#account_loginIn";
	var external = require("nativePluginService");
	
	/*页面初始化方法*/
	function init()
	{
		appUtils.setSStorageInfo("_isLoginIn","false");
		appUtils.setSStorageInfo("_curPageCode","account/loginIn");
//		if(appUtils.getSStorageInfo("userInfo"))
//		{
//			appUtils.clearSStorage("userInfo");  // 清除 session 中的 userInfo ，防止加密组件出现错误
//			appUtils.clearSStorage("jsessionid");  // 清除 session 中的 jsessionid 
//			appUtils.clearSStorage("clientinfo");  // 清除 session 中的 clientinfo 
//		}
		$(_pageId+" #accountNo").val("");
		$(_pageId+" #accountPwd").val("");
		setImgCode();  // 设置图片验证码
		getIpMac();
		
	}
	

	function getIpMac(){
//		require("shellPlugin").callShellMethod("getIpMacPLugin",function(data){
//			data = data.split("|");
//			var mac = data[0];
//			var ip = data[1];
//			appUtils.setSStorageInfo("ip",ip); // 将 ip 保存到 sessionStorage 里面
//			appUtils.setSStorageInfo("mac",mac); // 将 mac 保存到 sessionStorage 里面
//		},null);
		//获取ip地址
		var param = {};
		param["funcNo"] = "50023";
		var resultip = require("external").callMessage(param);
		if(resultip != null && resultip.error_no > 0){
			if(resultip.results != null && resultip.results instanceof Array){
				ip = resultip.results[0].ip;
			}
		}
		//获取mac地址
		var param = {};
		param["funcNo"] = "50024";
		var resultmac = require("external").callMessage(param);
		if(resultip.results != null && resultip.results instanceof Array){
			mac = resultmac.results[0].mac;
		}
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
//		/*返回*/
//		appUtils.bindEvent($(_pageId+" .icon_menu"), function(e){
//			af.ui.toggleSideMenu();
//			e.stopPropagation();
//		});
		
		//调用原生方法返回一级模块
		appUtils.bindEvent($(_pageId+" #back"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		appUtils.bindEvent($(_pageId+" #back"), function(e){
			$(this).removeClass("active");
			var param = {
					"moduleName":"home",
					"params":"{}"
			};
			param["funcNo"] = "50101";
			require("external").callMessage(param);
		},"touchend");
		/*更换验证码*/
		appUtils.bindEvent($(_pageId+" #img"), function(e){
			setImgCode();  // 设置图片验证码	
			e.stopPropagation();
		});
		
		/*马上登陆*/
		appUtils.bindEvent($(_pageId+" #loginIn"), function(e){
			if(validateNext())  // 校验下一步条件
			{   
				appUtils.clearSStorage("userInfo");  // 清除 session 中的 userInfo ，防止加密组件出现错误
				appUtils.clearSStorage("jsessionid");  // 清除 session 中的 jsessionid 
				appUtils.clearSStorage("clientinfo");  // 清除 session 中的 clientinfo 
				validateAccountAndPwd();
			}
			e.stopPropagation();
		},"click");
		
		//绑定密码输入框
		appUtils.bindEvent($(_pageId+" #accountPwd"),function(e){
			var param = {
				"moduleName":"xdt",
				"pageId":_pageId.replace("#",""),
				"eleId":$(this).attr("id"),
				"doneLable":"done",
				"keyboardType":"5",
			};
			external.function50210(param);
			e.stopPropagation();
		});
		//关闭键盘
		appUtils.bindEvent($(_pageId),function(e){
			var param = {
				"moduleName":"xdt"
			};
			external.function50211(param);
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
//		$(_pageId+" #selAccountType").html("资金账户");   // 恢复账号类型
		$(_pageId+" .input_text input:not(:eq(0))").val("");   // 清除密码、验证码
	}
	
	/*设置图片验证码*/
	function setImgCode()
	{
		$(_pageId+" #imgCode").val("");   // 清除验证码
		randomCode = Math.random();  // 验证码的随机数 MobileImage
		$(_pageId+" #img").attr("src", imgServerPath+"?rand="+randomCode);
	}
	
	/*校验下一步条件*/
	function validateNext()
	{
		var accountNo = $(_pageId+" #accountNo").val(),  // 账号
			validateCode = $(_pageId+" #imgCode").val(),
			accountPwd = $(_pageId+" #accountPwd").val();  // 账户密码
			
		if(accountNo == "")
		{
			layerUtils.iMsg(-1, "请先输入账号");
			return false;
		}
		if(accountPwd == "")
		{
			layerUtils.iMsg(-1, "请先输入密码");
			return false;
		}
		if(validateCode == "")
		{
			layerUtils.iMsg(-1, "请输入验证码");
			return false;
		}
		return true;
	}
	 
	/*校验账号和密码*/
	function validateAccountAndPwd()
	{
		 var op_source = "2"; //登陆来源（pc端、移动端）
		 var loginParam = {
					"login_id" : $(_pageId+" #accountNo").val(),
					"password" : $(_pageId+" #accountPwd").val(),
					"op_source": op_source,
					"ticket"   : $(_pageId+" #imgCode").val(),
					"ip"   : appUtils.getSStorageInfo("ip"),
				 };
		 
		 service.loginIn(loginParam,function(data){
			 if(data.error_no==0){
				    var userInfo = data.results[0];
					//统一登录增加xdt_str  login_str   ---------------
					var trade_token = userInfo.trade_token; // 交易token
					var xdt_token = userInfo.xdt_token;    //小贷通token
					var trade_str = {funcNo:"50042",key:"APP_TRADE",value:trade_token};
					var xdt_str = {funcNo:"50042",key:"APP_XDT",value:xdt_token};
					var login_str = {funcNo:"50042",key:"login_state",value:"1"};
					require("external").callMessage(trade_str);
					require("external").callMessage(xdt_str);
					require("external").callMessage(login_str);
//					//-------------------------------
				 
				saveDataToSession(data.results);  // 将数据保存到 session 中
//				saveApitudeFlag(data.results);  // 保存开通资质的标识
//				queryUserDiscount(data.results);   // 查询用户折扣
				
			 }
			 else{
				layerUtils.iLoading(false);
				setImgCode();  // 设置图片验证码
				layerUtils.iAlert(data.error_info);
			 }
		 }, {"isLastReq":true,"isShowWait":true,"timeOutFunc":handleAccountTimeout});
	}
	
	/*处理校验账号超时*/
	function handleAccountTimeout()
	{
		layerUtils.iConfirm("请求超时，重新加载？", function(){
			validateAccountAndPwd();  // 校验账号和密码
		});
	}
   
//	
	/*将数据保存到 session 中*/
	function saveDataToSession(loginResults)
	{
		var userInfo = utils.getUserInfoInSession();  // 获取 session 中的用户信息
		userInfo = userInfo ? userInfo : {};  // 取到的 userInfo 为空，就创建一个新对象
		userInfo["accountNo"] = $(_pageId+" #accountNo").val();  // 账号
		userInfo["accountPwd"] = $(_pageId+" #accountPwd").val();  // 账号密码
		userInfo["entrust_way"] = loginResults[0].entrust_way;  // 客户 id
		userInfo["op_station"] = loginResults[0].op_station;  // 操作站点
		userInfo["branch_no"]  = loginResults[0].branch_no;  // 分支机构
		userInfo["user_id"]    = loginResults[0].user_id;  // 客户名
		userInfo["cust_code"]  = loginResults[0].cust_code;  // 客户编号	
		userInfo["fund_account"] = loginResults[0].fund_account;  // 基金帐号
		userInfo["client_name"] = loginResults[0].client_name;  // 客户姓名
		userInfo["login_id"] = loginResults[0].login_id;  // 登录id
		userInfo["exchange_type_sz"] = loginResults[0].exchange_type_sz;  // 深圳交易类型
		userInfo["exchange_type_sh"] = loginResults[0].exchange_type_sh;  // 上海交易类型
		userInfo["stock_account_sz"] = loginResults[0].stock_account_sz;  // 深圳的帐号
		userInfo["stock_account_sh"] = loginResults[0].stock_account_sh;  // 上海的帐号
		userInfo["risk_level"] = loginResults[0].risk_level;  // 信用等级
		userInfo["corp_risk_level"] = loginResults[0].corp_risk_level;  //客户柜台风险等级
		userInfo["identity_num"] = loginResults[0].identity_num;  // 身份证号码
		userInfo["mobile"] = loginResults[0].mobile;  // 手机号码
		userInfo["client_name"] = loginResults[0].client_name;  // 客户姓名
		userInfo["protocolStr"] = loginResults[0].protocolStr;  //需要签署的协议
		userInfo["signargument"] = loginResults[0].signargument;  //已签署的协议
		userInfo["zxscore"] = loginResults[0].zxscore;  //已签署的协议
		userInfo["szzzIsOpen"] = loginResults[0].szzzIsOpen;  //已签署的协议
		userInfo["shzzIsOpen"] = loginResults[0].shzzIsOpen;  //已签署的协议
		userInfo["valid_flag"] = loginResults[0].valid_flag;  // 0是有效期，1是超出。
		userInfo["valid_date"] = loginResults[0].valid_date;  // 到期时间
		userInfo["email"] = loginResults[0].email;  // 到期时间
		userInfo["urgent_telephone"] = loginResults[0].urgent_telephone;  // 到期时间
		userInfo["urgent_name"] = loginResults[0].urgent_contact;  // 紧急联系人
		userInfo["yearold"] = loginResults[0].yearold;  // 客户年龄
		userInfo["isoutold"] = loginResults[0].isoutold;  // 是否超出年龄。 0是没有超出  1是超出。
		userInfo["create_date"] = loginResults[0].create_date;  // 是否超出年龄。 0是没有超出  1是超出。
		userInfo["client_rights"] = loginResults[0].client_rights;  //客户权限 abo
		userInfo["credit_money"] = loginResults[0].credit_money;  //客户权限 abo
		
		appUtils.setSStorageInfo("userInfo", JSON.stringify(userInfo));
		appUtils.setSStorageInfo("jsessionid", loginResults[0].jsessionid);  // jsessionid
		appUtils.setSStorageInfo("password",$(_pageId+" #accountPwd").val());
//		getUserLimit(loginResults[0].user_id);
		appUtils.setSStorageInfo("_isLoginIn","true");
		appUtils.pageInit("account/loginIn","business/borrowIndex");
	}
	
	//获取用户授信额度的相关信息
	function getUserLimit(user_id){
		var param = {
				"user_id":user_id
		};
		service.getUserlimit(param,function(data){
			if(data.error_no == 0){
				//把用户的信用额度存储到用户信息中
				appUtils.setSStorageInfo("_isLoginIn","true");
				utils.addDataToUserInfo("credit_money",data.results[0].credit_money); 
				appUtils.setSStorageInfo("password",$(_pageId+" #accountPwd").val());
				appUtils.pageInit("account/loginIn","business/borrowIndex");
			}
			else{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	/*向外暴露的 JSON 对象*/
	var loginIn = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = loginIn;
});