/**
 * 个人中心页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		_pageId = "#account_myInfoCenter";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		$(_pageId+" section").height($(window).height()-40+'px').css("overflow","auto");
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			//判断是否登陆验证，如果没有登陆直接跳到登陆页面
			var resultVo = require("nativePluginService").function50041({"key":"app_login_state"});
	        var login_state = resultVo.results[0].value;
	        if(login_state == "1"){
	        	appUtils.pageInit("account/myInfoCenter", "business/borrowIndex");
	        }else{
	        	var param = {
						"moduleName":"home",
						"params":"{}"
				};
				param["funcNo"] = "50101";
				require("external").callMessage(param);
	        }
			e.stopPropagation();
		},"touchend");
		/*联系信息*/
		appUtils.bindEvent($(_pageId+" .one"), function(e){
			appUtils.pageInit("account/myInfoCenter", "account/contactInfo");
			e.stopPropagation();
		});
		
		
		/*我的信用记录*/
		appUtils.bindEvent($(_pageId+" section .PersonalInformation .cont .two"), function(e){
			appUtils.pageInit("account/myInfoCenter","account/creditHistory");
			e.stopPropagation();
		});
		
		/*银行转账*/
		appUtils.bindEvent($(_pageId+" .three"), function(e){
			appUtils.pageInit("account/myInfoCenter", "account/newStockRecord");
			e.stopPropagation();
		});
		
		/*风险测评*/
		appUtils.bindEvent($(_pageId+" .four"), function(e){
			appUtils.pageInit("account/myInfoCenter", "business/borrowRecord");  // 切换到测评页面
			e.stopPropagation();
		});
		
		/*征信评分*/
		appUtils.bindEvent($(_pageId+" .five"), function(e){
			appUtils.pageInit("account/myInfoCenter", "business/myHoldingStock");
			e.stopPropagation();
		});
		
		/*额度管理*/
		appUtils.bindEvent($(_pageId+" .six"), function(e){
			if(fzp()){
				appUtils.pageInit("account/myInfoCenter", "account/limitManage");
			}
			e.stopPropagation();
		});
		
		
		/*安全退出*/
		appUtils.bindEvent($(_pageId+" .PubBtn"), function(e){
			layerUtils.iConfirm("确认要安全退出吗?", function(){
				service.exitNotifyServer("",function(data){
					if(data.error_no == 0){
						appUtils.clearSStorage("userInfo");  // 清除 session 中的 userInfo ，防止加密组件出现错误
						appUtils.setSStorageInfo("_isLoginIn","false");
						appUtils.clearSStorage();  // 清除 session 中数据
//						appUtils.pageInit("account/myInfoCenter", "account/loginIn");
						//统一退出
						require("sso").ssoLoginOut();
						//跳到登录
						//require("sso").goTologin();
					}
					else{
						layerUtils.iAlert(layerUtils.error_info);
					}
				});
				
			});
			e.stopPropagation();
		});
	}
	
	/*风险测评*/
	function fzp(){
		//开通资质 szzzIsOpen shzzIsOpen //开通
		 //授信额度
		 //   风险测评 (那一步没有跳到那个界面)
		// isoutold  为2 
		//提示机构账户不允许开通易融宝
		if(userInfoInSession.isoutold == "2"){
			layerUtils.iMsg(-1,"目前机构户暂不能办理易融宝业务，请您到开户营业部或当地营业部柜台进行办理");
			return false;
		}
		
		if(userInfoInSession.isoutold != "0"){
			appUtils.setSStorageInfo("firstLand",true);
			appUtils.pageInit("business/borrowIndex","apply/outAge");
			return false;
		} 
		if(userInfoInSession.szzzIsOpen == 'N' || userInfoInSession.shzzIsOpen == 'N'){
			appUtils.setSStorageInfo("firstLand",true);
			layerUtils.iConfirm("您尚未开通易融宝业务权限，是否现在开通？",function(){
				appUtils.pageInit("business/borrowIndex","apply/personInfoConfirm");
			},null,"立即开通");
			return false;
		}
		 if(userInfoInSession.signargument == null || userInfoInSession.signargument == ""){
			 layerUtils.iConfirm("您还未签署相关协议，请签署! ", function(){
					appUtils.pageInit("business/borrowIndex","apply/personInfoConfirm");
			 },null);	 
			 return false;
		}
	     return true;
		 
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*向外暴露的 JSON 对象*/
	var myInfoCenter = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = myInfoCenter;
});