/**
 * 主页
 * 即将到期页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		formatNum = require("formatNum"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		userInfoInSession = null,  // session 中的 userInfo
		_status = ["处理中","申报处理中","申报处理中","交易成功","已放款","申报失败","购回处理中","购回处理中","购回处理中","成功","成功","申报失败","违约处置"],//status 质押状态-1
		_pageId = "#account_needRepayOrAdd";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession(); // session 中的 userInfos
		$(_pageId+" section").height($(window).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		fillNormalRepayInfo();
	}
	
	/*填充正常还款记录*/
	function fillNormalRepayInfo(){
		var param = {
				user_id : userInfoInSession.user_id,
				query_flog : "jjdq" //即将到期
		}
		service.getCreaditHistory(param, function(data){
			
			if(data.error_no == 0){
				var results = data.results,
					str = '';
				var client_name = userInfoInSession.client_name;//还 款 人
				for(var i = 0; i < results.length; i++){
					var oneData = results[i],
						entrust_date = oneData.entrust_date,//借款时间
						borrow_amount = oneData.lave_money+oneData.interest,//还款金额
						contract_id = oneData.contract_id,//借款单号
						back_date = oneData.back_date,//银行名称
						interest = oneData.interest,
						repay_type = oneData.repayType,
						pledge_money = oneData.pledge_money,
						back_date = oneData.back_date,
						order_id = oneData.parent_order_id,
						contract_id = oneData.contract_id,
						order_type = oneData.order_type,
						apply_status = oneData.apply_status,
						is_delay = oneData.is_delay,
						id = oneData.id,
						status = oneData.status;
					
					//
					if(typeof(id) == 'undefined' || id== null || id == '' || id == 0){
						continue;
					}
					
				/*
				 * 补充质押
				 * price_ratio <= warn_line && contract_id != null && price_ratio != 0
				 * 
				 * price_ratio == 0 说明已经补充质押过了
				 */
				var addPledgeflag = false;//是否补充质押
				//数
//				var todate = Math.abs(((Date.parse(new Date()) - Date.parse(back_date))/1000/3600/24).toFixed());
				//距离还款还有多少天
				//+((Date.parse(new Date()) - Date.parse(back_date))/1000/3600/24).toFixed()+'天'
				
				//是否可以补充质押
				/*is_delay != 2 
				status == 2 还款失败  == null 没有还款*/
				
				addPledgeflag = (is_delay != 2 && order_type != "4" && apply_status == "5" && status != 0 && status != 1);
				
				var currTime = new Date().getTime(),// 当前时间
					show_ahead = false,//提前还款
					show_immediate = false;//到期还款
				
					if(is_delay != 2){
						if(repay_type == '1') // 当前时间小于当前还款日期
						{
							//提前还款
							show_ahead = (apply_status=='5') && (status==null|| status=='null'||status=='' || status == 2);
						}else if(repay_type == '0')  // 当前时间等于当前还款日期
						{
							//到期还款
							show_immediate = (apply_status=='5') && (status==null|| status=='null'||status=='' || status == 2);
						}
	//					else
	//					{
	//					 	//到期还款
	//					 	show_immediate = true && (apply_status=='5') && (status==null||typeof(status)=='undefined'||status=='');
	//					}
						
						
					}
					if(typeof(entrust_date) == 'undefined' || entrust_date== null || entrust_date == '' || entrust_date == 0){
						continue;
					}else{
						str += '<div class="cont" interest="'+interest+'" borrow-Money="'+pledge_money+'" deadline="'+back_date+'" order-id="'+order_id+'" contract_id="'+contract_id+'">'
							+ '<p>借款时间：'+entrust_date+'</p>'
							+ '<p>还款金额：'+formatNum.formatMoney(borrow_amount)+'元</p>'
							+ '<p>借款单号：'+contract_id+'</p>'
							+ '<p>还款时间：'+back_date+'</p>'
							+ '<p>还 款 人：'+client_name+'</p>'
							+ '<p>质押状态: '+((apply_status == 0 || apply_status=="null" || typeof(apply_status)=='undefined')?'':_status[apply_status-1])+'</p>'
							+ '<p></p>'
							+ '<p class="smartbtn" id="is_ahead" flag='+show_ahead+' style="width:60px;'+(show_ahead?'':'background:#ccc;')+'">提前还款</p>'
							+ '<p class="smartbtn" id="is_immediate" flag='+show_immediate+' style="width:60px;'+(show_immediate?'':'background:#ccc;')+'">到期还款</p>'
							+ '<p class="smartbtn" id="is_addPledge" flag="'+addPledgeflag+'" style="width:60px;'+(addPledgeflag?'':'background:#ccc;')+'">补充质押</p>'
							+ '</div>';
					}
				}
				if(typeof(str) == 'undefined' || str == '' || str == null){
					$(_pageId+" .no_data").show();
				}else{
					$(_pageId+" .no_data").hide();
					$(_pageId+" .payments").html(str);
					BindRepayEvent(); 
				}
			}else{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*绑定还款事件*/
	function BindRepayEvent()
	{
		//子订单还款
		appUtils.bindEvent($(_pageId+" .payments .cont .smartbtn"), function(e){
			forbiddenBtnByDateSub(this);
			e.stopPropagation();
		});
	}
	
	/**
	 * 根据日期禁用还款按钮  子订单
	 * @param currDOM 当前记录的 DOM 对象
	 */
	function forbiddenBtnByDateSub(currDOM)
	{
		if($(currDOM).attr("flag")=='true'){
			pageInParam = {
					orderId : $(currDOM).parent().attr("order-id"),
					initMoney : $(currDOM).parent().attr("borrow-money"), //初始金额
					deadline :	$(currDOM).parent().attr("deadline"), // 当前期限
					contract_id : $(currDOM).parent().attr("contract_id")
				};
			var interest = $(currDOM).parent().attr("interest");
			
			switch($(currDOM).attr('id')){
				case 'is_ahead'://提前还款
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/aheadPage",pageInParam); // 跳到提前还款页面
					}, borrowMoney,interest);
					break;
				case 'is_immediate'://到期还款
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
				
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/immediateRepay",pageInParam); // 跳到马上还款页面
					}, borrowMoney,interest);
					break;
				case 'is_addPledge'://补充质押
					appUtils.pageInit("business/repayList", "business/addPledge",pageInParam); // 跳到延期还款页面
					break;
			}
		}else{
			return;
		}
	}
	
	/**
	 * 比较日期，精确到 天
	 * @param date1 待比较的日期1，毫秒值
	 * @param date2 待比较的日期2，毫秒值
	 * @return 1 date1 比 date2 大，0 相等，-1 小
	 */
	function compareDate(date1, date2)
	{
		var compareResult = 1,  // 比较结果
			date1 = new Date(date1),
			date1Year = date1.getFullYear(),
			date1Month = date1.getMonth(),
			date1Date = date1.getDate(),
			date2 = new Date(date2),
			date2Year = date2.getFullYear(),
			date2Month = date2.getMonth(),
			date2Date = date2.getDate();
		if(date1Year > date2Year)
		{
			compareResult = 1;
		}
		else if(date1Year < date2Year)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month > date2Month)
		{
			compareResult = 1;
		}
		else if(date1Year == date2Year && date1Month < date2Month)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date > date2Date)
		{
			compareResult = 1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date < date2Date)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date == date2Date)
		{
			compareResult = 0;
		}
		return compareResult;
	}
	
	
	/**
	 * 查询客户资产
	 * @param funcCallback 查询成功之后的回调函数
	 * @param currBorrMoney 当前订单的借款金额
	 */
	function queryCustAssets(funcCallback, currBorrMoney, interest)
	{
		var queryCustAssetsParam = {
				 "user_id" : userInfoInSession.user_id,   // 客户 id
		};
		
		service.queryStockValue(queryCustAssetsParam, function(data){
			
			if(data.error_no == "0")
			{
				custAvailMoney = data.results[0].current_balance;  // 设置客户的可用余额
				
				if(Number(custAvailMoney) >= Number(currBorrMoney))
				{
					funcCallback ? funcCallback() : "";  // 回调函数不为空，执行回调函数，否则关闭等待层
				}
				else
				{
//					layerUtils.iMsg(-1, "账户可用余额不足，请进行转账操作！");
					pageInParam = {
							"currBorrMoney" : currBorrMoney,//借款金额
							"current_balance" : custAvailMoney,//账户余额
							"interest" : interest//利息
					}
					//跳转到repaymentInsufficient 保证金不足
					appUtils.pageInit("business/repayList", "business/repayInsufficientPage",pageInParam);
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" .payments").html("");
		$(_pageId+" .no_data").show();  // 隐藏暂无数据
	}
	
	/*向外暴露的 JSON 对象*/
	var needRepayOrAdd = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = needRepayOrAdd;
});