/**
 * 新股申购记录
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		Map = require("map"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		buyUnit = "",
		userInfoInSession = "",  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		selectedStockMap = null,  // 已选择的股票 Map
		_pageId = "#account_newStockRecord";
	
	/*页面初始化方法*/
	function init()
	{
		$(_pageId+" .no_data").hide();
		$(_pageId+" section").height(($(window).height()-40)+"px");
		$(_pageId+" section").css("overflow","auto");
		userInfoInSession = utils.getUserInfoInSession();
		fillData();
		
	}
	
	//数据填充
	function  fillData(){
		var a = userInfoInSession.user_id;
		var param = {
			user_id : a
		}
		service.queryNewStockRecord(param,function(data){
			if(data.error_no == 0){
				if(data.results.length!=0){
					var allRepayStr = "";
					for(var i = 0;i<data.results.length;i++){
						allRepayStr += '<div class="cont"  >';
						allRepayStr += '<div class="list">';
						allRepayStr +='<p>证券代码：'+data.results[i].stock_code+'</p>';//质押金额
						allRepayStr +='<p>申购价格：'+Number(data.results[i].stock_price).toFixed(2)+'</p>';//股票名称
						allRepayStr +='<p>申购数量：'+Number(data.results[i].stock_num).toFixed(2)+'</p>';//质押数量
						allRepayStr +='<p>申购日期：'+data.results[i].create_date+'</p>';
						allRepayStr +='<p>股票名称：'+data.results[i].stock_name+'</p>';
						allRepayStr +='<p>申购状态：'+data.results[i].order_status+'</p>';
						allRepayStr +='</div>';
						allRepayStr +='</div>';
					}
				}
				else{
					$(_pageId+" .no_data").show();
				}
		$(_pageId+" .Repurchase .conts").html(allRepayStr);  // 设置表头之后填充股票列表
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/*清除页面元素*/
	function clearPageElements()
	{
		$(_pageId+" .Repurchase .conts").html(""); 
		 $(_pageId+" .no_data").hide();
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		 /*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		appUtils.bindEvent($(_pageId+" #myInfoCenter"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" #myInfoCenter"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/newStockBallot","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
	}
	
	 
	
	/*页面销毁方法*/
	function destroy()
	{
		clearPageElements();
		service.destroy();
	}
 
 	function changeName(num){
 		 var array = ["已报","待报","废单"];
 		return array[num-1];
 	}
	/*向外暴露的 JSON 对象*/
	var newStockRecord = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = newStockRecord;
});