/**
 * 个人中心
 * 信用记录
 * 正常还款页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		formatNum = require("formatNum"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		userInfoInSession = null,  // session 中的 userInfo
		_pageId = "#account_normalRepayInfo";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession(); // session 中的 userInfos
		$(_pageId+" section").height($(window).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		fillNormalRepayInfo();
	}
	
	/*填充正常还款记录*/
	function fillNormalRepayInfo(){
		var param = {
				user_id : userInfoInSession.user_id,
				query_flog : "zc" //正常还款
		}
		service.getCreaditHistory(param, function(data){
			
			if(data.error_no == 0){
				var results = data.results,
					str = '';
				for(var i = 0; i < results.length; i++){
					var oneData = results[i],
						entrust_date = oneData.entrust_date,//借款时间
						borrow_amount = oneData.lave_money+oneData.interest,//还款金额
						contract_id = oneData.contract_id,//借款单号
						back_date = oneData.back_date,//银行名称
						id = oneData.id,
						client_name = userInfoInSession.client_name;//还 款 人
					if(typeof(id) == 'undefined' || id== null || id == '' || id == 0){
						continue;
					}else{
						str += '<div class="cont">'
							+ '<p>借款时间：'+entrust_date+'</p>'
							+ '<p>还款金额：'+formatNum.formatMoney(borrow_amount)+'元</p>'
							+ '<p>借款单号：'+contract_id+'</p>'
							+ '<p>还款时间：'+back_date+'</p>'
							+ '<p>还 款 人：'+client_name+'</p></div>';
					}
				}
				if(typeof(str) == 'undefined' || str == '' || str == null){
					$(_pageId+" .no_data").show();
				}else{
					$(_pageId+" .no_data").hide();
					$(_pageId+" .payments").html(str);
				}
			}else{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" .payments").html("");
		$(_pageId+" .no_data").show();  // 隐藏暂无数据
	}
	
	/*向外暴露的 JSON 对象*/
	var normalRepayInfo = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = normalRepayInfo;
});