/**
 * 个人中心
 * 信用记录
 * 补充质押页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		formatNum = require("formatNum"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		userInfoInSession = null,  // session 中的 userInfo
		_pageId = "#account_supplementaryPledgeIndex";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession(); // session 中的 userInfos
		$(_pageId+" section").height($(window).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		fillSupplementaryPledge();
	}
	
	/*填充补充质押记录*/
	function fillSupplementaryPledge(){
		var param = {
				user_id : userInfoInSession.user_id,
				query_flog : "bxbc" //需要补充质押
		}
		service.getCreaditHistory(param, function(data){
			if(data.error_no == 0){
				var results = data.results,
					str = '';
				for(var i = 0; i < results.length; i++){
					var oneData = results[i],
						entrust_date = oneData.entrust_date,//补充时间
						pledge_money = oneData.pledge_money,//补充金额
						order_no = oneData.join_contract_id,//借款单号
						order_id = oneData.parent_order_id,//合 同 号
						interest = oneData.interest,
						back_date = oneData.back_date,
						id = oneData.id,
						client_name = userInfoInSession.client_name,//协  议  价
						order_type = oneData.order_type,
						apply_status = oneData.apply_status,
						status = oneData.status;
					
					if(typeof(id) == 'undefined' || id== null || id == '' || id == 0){
						continue;
					}else{
						str += '<div class="cont" interest="'+interest+'" borrow-Money="'+pledge_money+'" deadline="'+back_date+'" order-id="'+order_id+'" contract_id="'+order_no+'">'
							+ '<p>补充时间：'+entrust_date+'</p>'
							+ '<p>补充金额：'+formatNum.formatMoney(pledge_money)+'元</p>'
							+ '<p>借款单号：'+order_no+'</p>'
							+ '<p>合 同 号：'+order_id+'</p>'
							+ '<p>协  议  价：'+formatNum.formatMoney(pledge_money)+'</p>'
							+ '<p></p>'
							+ '<p class="smartbtn" id="is_addPledge" style="width:60px;">补充质押</p>'
							+'</div>';
					}
				}
				if(typeof(str) == 'undefined' || str == '' || str == null){
					$(_pageId+" .no_data").show();
				}else{
					$(_pageId+" .no_data").hide();
					$(_pageId+" .payments").html(str);
				}
			}else{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*绑定还款事件*/
	function BindRepayEvent()
	{
		//子订单还款
		appUtils.bindEvent($(_pageId+" .payments .cont .smartbtn"), function(e){
			forbiddenBtnByDateSub(this);
			e.stopPropagation();
		});
	}
	
	/**
	 * 根据日期禁用还款按钮  子订单
	 * @param currDOM 当前记录的 DOM 对象
	 */
	function forbiddenBtnByDateSub(currDOM)
	{
			pageInParam = {
					orderId : $(currDOM).parent().attr("order-id"),
					initMoney : $(currDOM).parent().attr("borrow-money"), //初始金额
					deadline :	$(currDOM).parent().attr("deadline"), // 当前期限
					contract_id : $(currDOM).parent().attr("contract_id")
				};
			var interest = $(currDOM).parent().attr("interest");
			
			switch($(currDOM).attr('id')){
				case 'is_addPledge'://补充质押
					appUtils.pageInit("business/repayList", "business/addPledge",pageInParam); // 跳到延期还款页面
					break;
			}
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" .payments").html("");
		$(_pageId+" .no_data").show();  // 隐藏暂无数据
	}
	
	/*向外暴露的 JSON 对象*/
	var supplementaryPledgeIndex = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = supplementaryPledgeIndex;
});