/**
 * 授信页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		_pageId = "#apply_creditResult";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		queryStockValue();  // 查询股票总市值
		if(appUtils.getSStorageInfo("setLimit") == "true"){
			$(_pageId+" #showInfo").html("您的授信额度调整成功！");
		}
		else{
			$(_pageId+" #showInfo").html("您的易融宝业务权限已开通！<br/>可进行申请借款操作。");
		}
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			 $(this).removeClass("active");
			 appUtils.setSStorageInfo("setLimit","");
			 appUtils.pageInit("apply/creditResult","business/borrowIndex");
			e.stopPropagation();
		},"touchend");
		
		/*确定按钮*/
		appUtils.bindEvent($(_pageId+" .PubBtn"), function(e){
			 appUtils.setSStorageInfo("setLimit","");
			 appUtils.pageInit("apply/creditResult","business/borrowIndex");
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*查询股票总市值*/
	function queryStockValue()
	{
		var queryStockValueParam = {
				"user_id" : utils.getUserInfoInSession().user_id,  // 用户 id
		};
		service.getUserlimit(queryStockValueParam, function(data){
			if(data.error_no == "0")  
			{
				var results = data.results,
		 			marketValue = results[0]["use_money"]+"元",  // 总市值
		 			grantMoney = results[0]["credit_money"],  // 授信额度
		 			grantRate = results[0]["credit_coe"];  // 授信系数
				grantMoney = Number(grantMoney).toFixed(2);
				$(_pageId+" #credit_Money").html(grantMoney);
				$(_pageId+" #creditRate").html(grantRate);
				utils.addDataToUserInfo("credit_money",grantMoney);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/*查询可用额度*/
	function queryAvailMoney()
	{
		var queryAvailMoneyParam = {
			custid : userInfoInSession["custid"]  // 客户 id
		};
		service.queryAvailMoney(queryAvailMoneyParam, function(data){
			if(data.error_no == "0")  
			{
				var results = data.results,
					grantMoney = 0,  // 授信额度
					avilMoney = 0;   // 可用额度
				if(results[0])  // 当有记录时
				{
					grantMoney = results[0].moneyforisk;
					avilMoney = results[0].useamountmoneys;
					utils.addDataToUserInfo("grantMoney", grantMoney);   // 更新授信额度
					utils.addDataToUserInfo("avilMoney", avilMoney);   // 更新可用额度
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/*向外暴露的 JSON 对象*/
	var creditResult = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = creditResult;
});