/**
 * 上一次授信额度页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		formatNum = require("formatNum"),
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		_pageId = "#apply_lastGrantCredit";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		$(_pageId+" #creditResult").html(userInfoInSession.zxscore);
		//查询用户授信系数
		var param = {
				user_id:userInfoInSession.user_id
		}
		service.getUserlimit(param,function(data){
			  if(data.error_no == 0){
				  $(_pageId+" #creditRate").html("授信系数："+data.results[0].credit_coe);
			  }
		});
		$(_pageId+" #creditRate").html(userInfoInSession.zxscore);
		
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("apply/lastGrantCredit","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		/*确定按钮*/
		appUtils.bindEvent($(_pageId+" .btn"), function(e){
			appUtils.pageInit("apply/lastGrantCredit", "apply/creditAssessment");  // 征信评分页面
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*查询股票总市值*/
	function queryStockValue()
	{
		 var param = {
				 user_id: userInfoInSession.user_id
		 };
		 service.getUserlimit(param,function(data){
			 if(data.error_no == 0){
				 $(_pageId+" #grantMoney").html(formatNum.formatMoney(data.results[0].credit_money));
				 $(_pageId+" #marketValue").html(formatNum.formatMoney(data.results[0].use_money)+"元");
				 $(_pageId+" #grantRate").html(formatNum.formatMoney(data.results[0].credit_coe));
			 }
			 else{
				 layerUtils.iAlert(data.error_info);
			 }
		 });
	}
	
	/*向外暴露的 JSON 对象*/
	var lastGrantCredit = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = lastGrantCredit;
});