/**
 * 测评结果
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		_pageId = "#apply_personInfoConfirm";
		var userInfoInSession =null;
		var smsInterval = null;
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		initMessage();
		fillInfoInPage();
		var height = $(document).height();
		$(_pageId+" section").height(height-84+'px').css("overflow","auto");
	}
	
	function initMessage(){
		$(_pageId+" #sendMessage").removeAttr("sent").css("background-color", "#D70B17");  // 移除自定义属性，标识未发送，并恢复按钮颜色
		window.clearInterval(smsInterval);
		smsInterval = null;
		$(_pageId+" #sendMessage").html("获取验证码");
		$(_pageId+" #message").val("");
	}
	
	//填充页面信息
	function fillInfoInPage(){
		//获取数据
		var custName = userInfoInSession.client_name,
			personNo = userInfoInSession.identity_num,
			mobileNo = userInfoInSession.mobile,
			email = userInfoInSession.email,
			urgent_contact = userInfoInSession.urgent_name,
			secondMobileNo = userInfoInSession.urgent_telephone;
		
		//填充数据
		$(_pageId+" #custName em").text(custName);
		$(_pageId+" #personNum em").text(personNo);
		$(_pageId+" #mobileNo em").text(mobileNo).attr("mobile",mobileNo);
		$(_pageId+" #email_val").val(email);
		$(_pageId+" #urgent_contact_val").val(urgent_contact);
		$(_pageId+" #urgentNo_val").val(secondMobileNo);
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("apply/personInfoConfirm","business/borrowIndex");
			e.stopPropagation();
		},"touchend");
		//发送验证码 
		appUtils.bindEvent($(_pageId+" #sendMessage"),function(e){
			if(validateSendCode())  // 校验发送验证码
			{
				getSmsCode();   // 获取短信验证码
			}
			e.stopPropagation();
		});
		 appUtils.bindEvent($(_pageId+" .PubBtn"),function(E){
		 	if(validateInfo()){
//		 		if($(_pageId+" #mobileNo em").attr("mobile")!=userInfoInSession.mobile){
//		 			layerUtils.iConfirm("您是否需要将您接收华安证券相关短信的号码，更新为"+$(_pageId+" #mobileNo em").attr("mobile")+"的这个手机号码？",function(){
//						 nextStep();
//						},null);
//		 		}
//		 		else{
		 		    nextStep();
//		 		}
		 	}
		 });
		 
	}
	
	/*校验发送验证码*/
	function validateSendCode()
	{
		if($(_pageId+" #sendMessage").attr("sent") == "true")  // 如果已发送，不可点击
		{
			return false;
		}
		if(!validatorUtil.isMobile($(_pageId+" #mobileNo em").text())){
			layerUtils.iAlert("请到柜台修改手机号码，再进行开通权限操作");
			return false;
		}
		return true;
	}
	
	/*获取短信验证码*/
	function getSmsCode()
	{
		var getSmsCode = {
			    type : 1,
				phone:$(_pageId+" #mobileNo em").attr("mobile"),
				opdate : ""
			};
		service.sendMobileMessage(getSmsCode, function(data){
			if(data.error_no == 0)
			{
				startSmsInterval();  // 开启计时器
				$(_pageId+" #sendMessage").attr("sent","true");
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert("验证码发送失败");
				clearSmsInterval();   // 清除验证码计时器
			}
		});
	}
	
	function validateInfo(){
		var mobileNo = $(_pageId+" #mobileNo em").attr("mobile"),  //手机号码
 			email    = $(_pageId+" #email_val").val(),  //电子邮箱
 			valiCode = $(_pageId+" #message").val(),
 			urgentName = $(_pageId+" #urgent_contact_val").val()
			urgentTel = $(_pageId+" #urgentNo_val").val();  //紧急联系人电话
		
		//电子邮箱验证正则表达式
//		var testReg = new RegExp("^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$");
		//表达式判断
		if(!validatorUtil.isMobile(mobileNo))
		{
			layerUtils.iAlert("请到柜台修改手机号码，再进行开通权限操作");
			return false;
		}
//		if(email.trim() == ""|| !validatorUtil.isEmail(email))
//		{
//			layerUtils.iAlert("请输入正确的电子邮箱！");
//			return false;
//		}
		if(urgentName == ""){
			layerUtils.iAlert("请输入紧急联系人姓名");
			return false;
		}
		if(!validatorUtil.isMobile(urgentTel))
		{
			layerUtils.iAlert("请输入正确的紧急联系人电话");
			return false;
		}
		if(valiCode == ""){
			layerUtils.iAlert("请输入短信验证码");
			return false;
		}
		
		return true;
	}
	
	
	//下一步  提交信息
	function nextStep(){
		var param = {
			telephone :$(_pageId+" #mobileNo em").attr("mobile"),
			email :$(_pageId+" #email_val").val(),
			urgent_telephone : $(_pageId+" #urgentNo_val").val(),
			phonevalidateCode : $(_pageId+" #message").val(),
			urgent_contact : $(_pageId+" #urgent_contact_val").val()
		}
		
		service.confirmPersonInfo(param,function(data){
			if(data.error_no == 0){
				appUtils.setSStorageInfo("setLimit","");
				appUtils.pageInit("apply/personInfoConfirm","apply/riskDisclosure");
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		})
	}
	
	
	/*启动短信验证码倒计时*/
	function startSmsInterval()
	{
		$(_pageId+" #sendMessage").css("background-color", "#87929E");   // 设置按钮颜色
		var countDownSum = 180;
		$(_pageId+" #sendMessage").html(countDownSum+"秒重发");
		smsInterval = window.setInterval(function(){
			$(_pageId+" #sendMessage").html((--countDownSum)+"秒重发");
			countDownSum <= 0 ? clearSmsInterval() : "";   // 清除验证码计时器
		}, 1000);
	}
	
	/*清除验证码计时器*/
	function clearSmsInterval()
	{
		if(smsInterval)  // 如果 smsInterval 不为空
		{
			$(_pageId+" #sendMessage").removeAttr("sent").css("background-color", "#D70B17");  // 移除自定义属性，标识未发送，并恢复按钮颜色
			window.clearInterval(smsInterval);
			smsInterval = null;
			$(_pageId+" #sendMessage").html("获取验证码");
		}
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*向外暴露的 JSON 对象*/
	var personInfoConfirm = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = personInfoConfirm;
});