/**
 * 查看协议页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
	layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		_pageId = "#apply_rebuyProtocol";
	
	/*页面初始化方法*/
	function init()
	{
		initPageInfo(); //初始化页面信息。获取协议
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		/*确定按钮*/
		appUtils.bindEvent($(_pageId+" .fix_bot .ce_btn"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
	}
	function initPageInfo(){
		var param = {
				"type_ename": "zyzz"
		};
		service.getProtocol(param,function(data){
			if(data.error_no == 0){
				$(_pageId+" .test_main").html(data.results[0].content_txt);
			}else{
				layerUtils.iAlert(data.error_info);
			}
		},{"isLastReq":true,"isShowWait":false,"timeOutFunc":handlePageInfo});
	}
	
	/*******   请求失败，继续发起请求   开始    ********************/
	 /**重新查询协议内容***/
	function handlePageInfo(){
		layerUtils.iAlert("数据加载失败，是否重新加载？",-1, function(){
			initPageInfo();   
		});
	}
	/*******     结束    ********************/
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*向外暴露的 JSON 对象*/
	var rebuyProtocol = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = rebuyProtocol;
});