/**
 * 风险测评页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		userInfoSession = "",
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		protocolArray = "",
		validatorUtil = require("validatorUtil"),
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		imgServerPath = global.actionPath + "/servlet/Image",  // 图片验证码的请求地址
		imgCodeSubPath = global.actionPath + "/servlet/action/ValidateMobCode",  // 图片验证码的提交地址
		proVersion = "",
		
		_pageId = "#apply_riskDisclosure";
	var smsInterval = null;
	var protocolsum = [];//协议书的个数
	
	/*页面初始化方法*/
	function init()
	{
		userInfoSession = utils.getUserInfoInSession();
		$(_pageId+" #nextStep").css({'background':'#ccc'});
		$(_pageId+" #agree").attr("disabled","disabled");
		if($(_pageId+" .cont a").length == 0){
					getProtocol();
		}

		initMessage();
	}
	
	function initMessage(){
		
		
		//判断session里面签署过的协议是否完全。如果完全则将勾选的那个去掉.
		if(appUtils.getSStorageInfo("protocolbtn")){
			var protocolBtn = JSON.parse(appUtils.getSStorageInfo("protocolbtn"));
			if(protocolBtn.length == protocolsum.length){
			$(_pageId+" #agree").removeAttr("disabled");
			}
		}
	}
	
	/*设置图片验证码*/
	function setImgCode()
	{
		$(_pageId+" #imgCode").val("");   // 清除验证码
		randomCode = Math.random();  // 验证码的随机数 MobileImage
		$(_pageId+" #img").attr("src", imgServerPath+"?rand="+randomCode);
	}
	
	//获取协议
	function getProtocol(){
		var param = {
			type_ename:userInfoSession.protocolStr	
		}
		service.getProtocol(param,function(data){
				if(data.error_no == 0){
					var appendHtml = "";
					protocolArray = data.results;
					
					//初始化
					protocolsum = [];
					
					for(var i=0;i<data.results.length;i++){
						appendHtml+="<a href='javascript:void(0);' id="+data.results[i].version+">《"+data.results[i].type_name+"》</a>";
						proVersion += data.results[i].version+",";
						protocolsum[i] = data.results[i].type_name;
					}
					//判断session里面签署过的协议是否完全。如果完全则将勾选的那个去掉.
					if(appUtils.getSStorageInfo("protocolbtn")){
						var protocolBtn = JSON.parse(appUtils.getSStorageInfo("protocolbtn"));
						if(protocolBtn.length == protocolsum.length){
						$(_pageId+" #agree").removeAttr("disabled");
						}
					}
					proVersion = proVersion.substring(0,proVersion.length-1);
					$(_pageId+" .cont").html(appendHtml);
					bindClick();
				}
				else{
					layerUtils.iAlert(data.error_info);
				}
		})
	}
	function bindClick(){
		appUtils.bindEvent($(_pageId+" .cont a"),function(data){
			var name = $(this).html();
			var protocolbtn = [];
			if(appUtils.getSStorageInfo("protocolbtn")){
				var protocolbtn = JSON.parse(appUtils.getSStorageInfo("protocolbtn"));
			}
			for(var i = 0;i<protocolArray.length;i++){
				if(name == "《"+protocolArray[i].type_name+"》"){
					var param = {
							content:protocolArray[i].content_txt,
							title:protocolArray[i].type_name
					};
				if(protocolbtn.indexOf(protocolArray[i].type_name) == -1){
						protocolbtn[protocolbtn.length]=protocolArray[i].type_name;
						appUtils.setSStorageInfo("protocolbtn",JSON.stringify(protocolbtn));
					}
					
					if(protocolbtn.length == protocolsum.length){
						$(_pageId+" #agree").removeAttr("disabled");
					}
					appUtils.pageInit("apply/riskDisclosure","apply/eleAgreement",param);
				}
			}
			
		});
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" #back"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" #back"), function(e){
			$(this).removeClass("active");
			appUtils.clearSStorage("protocolbtn");
			appUtils.pageInit("apply/riskDisclosure","business/borrowIndex");
			e.stopPropagation();
		},"touchend");
		//绑定下一步
		appUtils.bindEvent($(_pageId+" #nextStep"),function(e){
			if(!$(_pageId+" #agree").attr("checked")){
//				layerUtils.iMsg(-1,"您还未同意相关协议")
				return;
			}
			if(validateNext()){
				var param = {
						type_enameStr :userInfoSession.protocolStr,
						user_id : userInfoSession.user_id,
						versionStr : proVersion,
						phonevalidateCode : $(_pageId+" #message").val(),
						phone : $(_pageId+" #phoneNum").val()
						
				};
				service.signMultiProtocol(param,function(data){
					if(data.error_no == 0){
						utils.addDataToUserInfo("signargument",userInfoSession.protocolStr);
						utils.addDataToUserInfo("szzzIsOpen",data.results[0].szzz);
						utils.addDataToUserInfo("shzzIsOpen",data.results[0].shzz);
						//20151008 华安 如果某个 功能 已经开通 就 不提示 开通资质， 如果 没有开通 就一次 把剩下的都开通
						//这里避免 再次让开通权限
						var client_rights = userInfoSession.client_rights;
						if(client_rights.indexOf("a") === -1){
							client_rights += "a";
						}
						if(client_rights.indexOf("b") === -1){
							client_rights += "b";
						}
						if(client_rights.indexOf("o") === -1){
							client_rights += "o";
						}
						utils.addDataToUserInfo("client_rights",client_rights);
						if(userInfoSession.risk_level == ""){
							appUtils.clearSStorage("protocolbtn");
							appUtils.pageInit("apply/riskDisclosure","apply/riskAssessment");
						}
						else{
							appUtils.clearSStorage("protocolbtn");
							appUtils.pageInit("apply/riskDisclosure","apply/riskResult");
						}
						
					}
					else{
						layerUtils.iAlert(data.error_info)
					}
				});

			}
		});
		appUtils.bindEvent($(_pageId+" #changePhoneNum"),function(e){
			var $phone = $(this);
			if($phone.text() == "号码修改"){
				 $(_pageId+" #phoneNum").removeAttr("readonly");
				 $(_pageId+" #phoneNum").css("background","#FFFFFF");
				 $phone.text("确认");
			}else if($phone.text() == "确认"){
				if(validatorUtil.isMobile($(_pageId+" #phoneNum").val())){
					if(userInfoSession.mobile != $(_pageId+" #phoneNum").val()){
						layerUtils.iConfirm("您是否需要将您接收华安证券相关短信的号码，更新为本次修改的这个手机号码？",function(){
						 $(_pageId+" #phoneNum").attr("readonly","readonly");
						 $(_pageId+" #phoneNum").css("background","#999999");
						 $phone.text("号码修改");
						},null);
					}
					else{
						 $(_pageId+" #phoneNum").attr("readonly","readonly");
						 $(_pageId+" #phoneNum").css("background","#999999");
						 $phone.text("号码修改");
					}
				}else{
					layerUtils.iMsg(-1,"请输入正确的手机号码");
				}
				 
			}
				
		});
		
		appUtils.bindEvent($(_pageId+" #sendMessage"),function(e){
			if(validateSendCode())  // 校验发送验证码
			{
				getSmsCode();   // 获取短信验证码
			}
			e.stopPropagation();
		});
		//绑定同意阅读协议单选按钮
		appUtils.bindEvent($(_pageId+" .Already"),function(e){
			if($(_pageId+" #agree").attr("disabled") == "disabled"){
				layerUtils.iMsg(-1,"请阅读完以上所有协议");
				$(_pageId+" #nextStep").css({'background':'#ccc'});
				$('input[id=agree]').prop('checked', false);
			}else{
				if($('input[id=agree]').prop('checked')){
					$('input[id=agree]').prop('checked', true);
					$(_pageId+" #nextStep").css({'background':'#ccc'});
				}else{
					$('input[id=agree]').prop('checked', false);
					$(_pageId+" #nextStep").css({'background':'#D70B17'});
				}
			}
			
			e.stopPropagation();
		});
	}
	
	/*校验发送验证码*/
	function validateSendCode()
	{
		if($(_pageId+" #sendMessage").attr("sent") == "true")  // 如果已发送，不可点击
		{
			return false;
		}
		if(!validatorUtil.isMobile($(_pageId+" #phoneNum").val())){
			layerUtils.iMsg(-1,"请正确的输入手机号码");
			return false;
		}
		return true;
	}
	/*获取短信验证码*/
	function getSmsCode()
	{
		var getSmsCode = {
			    type : 1,
				phone:$(_pageId+" #phoneNum").val(),
				opdate : ""
			};
		service.sendMobileMessage(getSmsCode, function(data){
			if(data.error_no == 0)
			{
				startSmsInterval();  // 开启计时器
				$(_pageId+" #messageCode").val();
				$(_pageId+" #sendMessage").attr("sent","true");
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert("验证码发送失败");
				clearSmsInterval();   // 清除验证码计时器
			}
		});
	}
	//验证下一步
	function validateNext(){
		var  isChecked = true;
		 if($(_pageId+" #agree").attr("checked")){
			 return true;
		 }
		 else{
			 layerUtils.iMsg(-1,"您还未同意相关协议");
			 return false;
		 }
	}
	
	/*启动短信验证码倒计时*/
	function startSmsInterval()
	{
		$(_pageId+" #sendMessage").css("background-color", "#87929E");   // 设置按钮颜色
		var countDownSum = 180;
		$(_pageId+" #sendMessage").html(countDownSum+"秒重发");
		smsInterval = window.setInterval(function(){
			$(_pageId+" #sendMessage").html((--countDownSum)+"秒重发");
			countDownSum == 0 ? clearSmsInterval() : "";   // 清除验证码计时器
		}, 1000);
	}
	
	/*清除验证码计时器*/
	function clearSmsInterval()
	{
		if(smsInterval)  // 如果 smsInterval 不为空
		{
			$(_pageId+" #sendMessage").removeAttr("sent").css("background-color", "#D70B17");  // 移除自定义属性，标识未发送，并恢复按钮颜色
			window.clearInterval(smsInterval);
			smsInterval = null;
			$(_pageId+" #sendMessage").html("发验证码");
		}
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" #agree").attr("checked",false);
		$(_pageId+" #phoneNum").val("");
		$(_pageId+" #message").val("");
	}
	/*向外暴露的 JSON 对象*/
	var riskAssessment = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = riskAssessment;
});