/**
 * 测评结果
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		pageParam = null,//上个页面传的参数
		_pageId = "#apply_riskResult";
		var userInfoInSession =null;
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		$(_pageId+" .openUp").height($(document).height()-41+'px').css("overflow","auto");
		var title = "";
		if(appUtils.getPageParam()){
		pageParam = appUtils.getPageParam();
		title = pageParam.title;
		// 设置标题  风险等级
		if(typeof(title) != "undefined" && title != "" && title != null){
			$(_pageId+" .headerCont h2").html(title);
			$(_pageId+" #back").show();
		}
		}
		showRiskResult();  // 显示测评结果	
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		/*下一步*/
		appUtils.bindEvent($(_pageId+" #nextStep"), function(e){
			if(validateNext())  // 校验下一步条件
			{
				if(userInfoInSession.credit_money == 0){
					appUtils.pageInit("apply/riskResult","apply/creditAssessment");
				}else{
					appUtils.pageInit("apply/riskResult","apply/creditResult");
				}
			}
			e.stopPropagation();
		});
		/*是  返回借款*/
		appUtils.bindEvent($(_pageId+" #yes"), function(e){
			
			if(pageParam != null && pageParam.code != null 
					&& typeof(pageParam.code) != "undefined" && pageParam.code != ""
					&& pageParam.name != null && typeof(pageParam.name) != "undefined" && pageParam.name != ""){
				
				var param = {
						modeCode: pageParam.code,
						modeName: pageParam.name
				};
				appUtils.setSStorageInfo("mode_code",param.modeCode);
				appUtils.setSStorageInfo("mode_name",param.modeName);
				
				appUtils.pageInit("apply/riskResult","business/borrowApply");
			}else{
				//让客户签署协议
				appUtils.pageInit("apply/riskResult","apply/creditAssessment");
			}
			
			e.stopPropagation();
		});
		/*否  返回借款用途*/
		appUtils.bindEvent($(_pageId+" #no"), function(e){
			appUtils.pageInit("apply/riskResult","business/borrowIndex");
			e.stopPropagation();
		});
	}
	
	function validateNext(){
		if($(_pageId+" #nextStep").html() == "重新测评"){
			appUtils.pageInit("apply/riskResult","apply/riskAssessment");
			return false;
		}
		else{
			return true;
		}
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		$(_pageId+" #yes").hide();
		$(_pageId+" #no").hide();
		$(_pageId+" #isGuard").hide();
		$(_pageId+" #nextStep").html("下一步");
	}
	
	 
	/*显示测评结果*/
	function showRiskResult()
	{
		var riskResult = userInfoInSession.risk_level;
		$(_pageId+" #riskResult").html(riskResult);  // 测评结果
		var corp_risk_level = userInfoInSession.corp_risk_level;//客户柜台风险等级
		if(corp_risk_level && corp_risk_level-0 < 3)
		{
				$(_pageId+" #isGuard").show();
				$(_pageId+" #nextStep").html("重新测评");
				$(_pageId+" #yes").show();
				$(_pageId+" #no").show();
		}
		else{
			$(_pageId+" #nextStep").html("下一步");
		}
	}
	/*向外暴露的 JSON 对象*/
	var riskResult = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = riskResult;
});