/**
 * 补充质押页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		formatNum = require("formatNum"),
		stockhelp = require("stockhelp"),
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		orderId = null, 
		contractId = null,
		now_price = 0, //
		lave_money = 0, // 借款金额
		_pageId = "#business_addPledge";
	var external = require("nativePluginService");
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		orderId = appUtils.getPageParam("orderId");
		contractId = appUtils.getPageParam("contract_id");
		$(_pageId + " .MicrofinanceTop ").find("p").eq(1).text('借款单号:'+contractId);
		
		$(_pageId+" section .addPledge").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		queryaddPledge1();
		
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		appUtils.bindEvent($(_pageId+" header .home"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" header .home"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/addPledge","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		
		//确定
		appUtils.bindEvent($(_pageId+" .PubBtn"), function(e){
			//防止重复提交 在提交时弹出一个对话框
			layerUtils.iConfirm("您确定要补充质押吗？",function(){
				queryaddPledge3();
			},function(){},"是","否");
			e.stopPropagation();
		});
	}
	
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		//销毁页面
		$(_pageId+" .total").html("补充后平均履约保障比例:>0%");
		$(_pageId + ' table[class="gp_mxtable"] tbody').html('<tr>'
				+'<th width="35%" class="left">股票名称及代码</th>'
                +'<th width="35%">最大可借金额</th>'
                +'<th width="30%">质押数量</th>'
                +'</tr>'
                +'<tr>'
            	+'<th colspan="3">无</th>'
            	+'</tr>');

		var param = {
			"moduleName":"xdt"
		};
		external.function50211(param);

		//重置
		window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){}, // 键盘完成按钮的事件
				keyBoardInputFunction: function(){}
		}
	}
	
	/*
	 * 补充质押
	 */
	function queryaddPledge1(){
		
		var queryOrderInfoParam = {
 				page : "1",  // 页数	
				size : "1",  // 数据的条数
				user_id : userInfoInSession.user_id,  // 账户密码
 				order_id : appUtils.getPageParam("orderId") // 订单 id
		};
		
		service.queryLoanInfo(queryOrderInfoParam, function(data){
			if(data.error_no == "0")
			{
				var results = data.results[0].data,
					stockList = JSON.parse(results[0].stockList);				
				//获取持仓数据
				stockList ? stockList : {};
				if(stockList == null){
					
				}else{
					for(var j = 0; j < stockList.length; j++){
						
						var stockinfo = stockList[j];
						
						if(!(typeof(stockinfo.contract_id)=="undefined" || stockinfo.contract_id == null) && stockinfo.contract_id == contractId){
							var warnLineMoney = parseFloat((stockinfo.stock_price-0)*(stockinfo.pledge_share-0)*(stockinfo.warn_line-0)).toFixed();
							var paramfill = {
									exchange_type : stockinfo.exchange_type,
									stock_code : stockinfo.stock_code,
									warnLineMoney : warnLineMoney,
									pledge_share : stockinfo.pledge_share,
									cash_type : appUtils.getSStorageInfo("mode_code"),
									contract_id : contractId
							}
							var price_ratio = stockinfo.price_ratio-0;
							now_price = stockinfo.now_price-0;
							lave_money = stockinfo.lave_money-0;
							
							$(_pageId+" .MicrofinanceTop").find("p").eq(0).text('此合约的履约保障比例：'+(Number(price_ratio)*100).toFixed(2)+'%');
							$(_pageId+" .total").attr("total_ratio",(Number(price_ratio)*100).toFixed(2)).html('补充后履约保障比：'+(Number(price_ratio)*100).toFixed(2)+'%');
							filladdPledge(paramfill);
						}
					}
				}
				
				
					var param = {
							type : 'save',
							supplementaryInfo : {
								order_id : orderId,
								order_no : results[0].order_no,
								borrow_amount : results[0].borrow_amount, //借款金额
								loan_day : results[0].max_loan_day,//借款多少天
								product_name : results[0].product_name, //借多少天
								repay_rate : results[0].repay_rate,//利率
								money_date : results[0].money_date, //发放日期
								back_date : results[0].back_date,//回购日期
								interest : results[0].interest,//利息
								trading_fee1 : results[0].trading_fee1,//手续费
								trading_fee2 : results[0].trading_fee2,//手续费
								shouldRepay : results[0].shouldRepay, //要还的总金额
								be_used : results[0].be_used,//资金用途
								isaddone : 1,//1.表示单只股票的质押
								contract_id : contractId
							}
					}
					
					//补充质押
					service.queryaddPledge1(param,function(data){
						if(data.error_no == "0"){
							//{"error_no":"0","results":[{"result":"success"}],"dsName":["results"],"error_info":""} 
							if(data.results[0].result == 'success'){
								//成功
								
							}
							
						}else{
							layerUtils.iAlert(data.error_info);	
						}
					});
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		}, {"isLastReq":false});
		
	}
	
	function queryaddPledge3(){
		
		var suppleOrderInfo = addPledgeStockCallBack();
		
		//如果没有质押 则返回的数组长度为0
		if(suppleOrderInfo && suppleOrderInfo != null){
			var param = {
					type: 'save',
					suppleOrderInfo : JSON.stringify(suppleOrderInfo)
			}
			service.queryaddPledge3(param, function(data){
				if(data.error_no == "0")
				{
					service.queryaddPledge2({},function(data){
							if(data.error_no == "0")
							{
								layerUtils.iAlert("补充质押成功","0",function(){
									appUtils.pageInit("business/addPledge","business/repayList");
								});
							}else{
								layerUtils.iAlert(data.error_info);	
							}
					});
				}else{
					layerUtils.iAlert(data.error_info);	
				}
				
			});
		}else{
			layerUtils.iAlert("您还没有质押股票");
		}
		
	}
	
	
	function filladdPledge(param){
		
		service.queryaddPledgeStock(param, function(data){
			
			if(data.error_no == "0")
			{
				var results = data.results;
				
				//填充股票
				stockhelp.fillStockList(results,$(_pageId + ' table[class="gp_mxtable"] tbody'),"",true);
				
				//绑定事件
				stockhelp.stockNumEvent($(_pageId + ' input[type="range"]'),addPledgeStockCallBack,true);
				
			}else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
		
	}
	
	/**
	 * 股票质押回调事件
	 * @return 返回给下一个页面的参数
	 */
	function addPledgeStockCallBack(){
		
		//
		var loan_stock_arr = [];
		
		//计算预计补充质押金额
		var loanmoney = 0;
		
		//遍历所有股票
		$(_pageId + " div[class='gp_numbox']").each(function(){
			
			//质押股数
			var pledgenum = $(this).attr("pledgenum")-0;
			
			if(pledgenum > 0){
				var stockinfo = {
						stock_code : $(this).attr("stockcode"),//股票代码
						stock_name : $(this).attr("stockname"),//股票名称
						stock_price : $(this).attr("stock_price")-0,//股票价格
						enable_amount : $(this).attr("enable_amount")-0,//可质押数量
						loan_money : $(this).attr("pledgemoney")-0,// 实际质押金额
						loan_money2 : $(this).attr("max_loan_money")-0,// 股票可以质押的金额
						fee : ($(this).attr("djfree")-0),// 交易费用
						exchange_type : $(this).attr("exchange_type")-0,// 市场类别  2沪市A 0 深市A
						exchange_type_name : $(this).attr("exchange_type_name"),//市场名称
						supplyNumber : pledgenum,// 质押股数
						coefficient : $(this).attr("coefficient")-0// 实际质押率
				};
				
				loanmoney += stockinfo.loan_money-0;
					
				loan_stock_arr.push(stockinfo);
			}
		});
		
		//计算补充后履约保障比
		
		//(补充质押的金额+现价*质押数量) / 借款金额
		// 真实的算法
		//{[（质押数量+红股数量）*股票现价+红利金额]+[补充质押的现价*（补充质押的数量+红股数量）+红利金额]}/初始质押的金额
		// 这里可能存在 补充质押 后 在补充质押计算的值偏小
		if(lave_money == null ||lave_money == 0 || now_price == null || now_price == 0){
			
		}else{
			if(loanmoney <= 0){
				$(_pageId+" .total").html('补充后履约保障比：'+$(_pageId+" .total").attr('total_ratio')+'%');
			}else{
				var ratio = (loanmoney + now_price) / lave_money;
				$(_pageId+" .total").html('补充后履约保障比：'+(ratio*100).toFixed(2)+'%');
			}
		}
		
		return loan_stock_arr;
	}
	
	/*向外暴露的 JSON 对象*/
	var addPledge = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = addPledge;
});