/**
 * 补充质押页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		Map = require("map"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		pageInParam = null,
		suppleOrderInfo = null,
		orderId = null, 
		contractId = null,
		selectedStockMap = null,  // 已选择的股票 Map
		customSelFlag = null,  // 自定义选股的标识  true为客户手动选股，false为自动选股
		$choosedStock="",
		maxCanBorrowMoney = 0,
		borrowMoney_deelFee = "",
		currentMode = "",    //当前的模式，auto是自动选股， manual手动
		fundUsePledge = 0,//资金用途质押率
		pledgeMoneyAll = 0, //质押总金额
		now_price = 0,
		lave_money = 0,
		_pageId = "#business_addPledge";
	
	/*页面初始化方法*/
	function init()
	{
		suppleOrderInfo = [];
		clearPageElements();   // 清除页面元素
		userInfoInSession = utils.getUserInfoInSession();
		orderId = appUtils.getPageParam("orderId");
		contractId = appUtils.getPageParam("contract_id");
		selectedStockMap = new Map();
		$(_pageId + " .MicrofinanceTop ").find("p").eq(1).text('借款单号:'+contractId);
		
		$(_pageId+" section .addPledge").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		$(_pageId+" section .stockList").height($(document).height()-$(_pageId+" header").height()-240+'px').css("overflow","auto");
		queryaddPledge1();
//		getBrokeageFee();    //获取经手费
		
	}
	
	/*清除页面元素*/
	function clearPageElements()
	{
		$(_pageId+" .total").html("质押总金额:0元<br/>补充后平均履约保障比例:>0%");
		$(_pageId+" .stockList").html("");
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		appUtils.bindEvent($(_pageId+" header .home"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" header .home"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/addPledge","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		
		BindNext();  // 为下一步按钮绑定事件
	}
	
	/*为下一步按钮绑定事件*/
	function BindNext()
	{
		appUtils.bindEvent($(_pageId+" .PubBtn"), function(e){
			//质押股数不能为0 或者 空
			if(selectedStockMap.elements.length > 0){
				queryaddPledge3();
			}else{
				layerUtils.iAlert("您还没有质押股票");	
			}
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*
	 * 补充质押
	 */
	function queryaddPledge1(){
		//appUtils.getPageParam("orderId")
		
		var queryOrderInfoParam = {
 				page : "1",  // 页数	
				size : "1",  // 数据的条数
				user_id : userInfoInSession.user_id,  // 账户密码
 				order_id : appUtils.getPageParam("orderId") // 订单 id
		};
		
		service.queryLoanInfo(queryOrderInfoParam, function(data){
			if(data.error_no == "0")
			{
				var results = data.results[0].data,
					stockList = JSON.parse(results[0].stockList);				
				//获取持仓数据
				stockList ? stockList : {};
				if(stockList == null){
					
				}else{
					for(var j = 0; j < stockList.length; j++){
						if(!(typeof(stockList[j].contract_id)=="undefined" || stockList[j].contract_id == null) && stockList[j].contract_id == contractId){
							var warnLineMoney = parseFloat(stockList[j].stock_price*stockList[j].pledge_share*stockList[j].warn_line).toFixed();
							var paramfill = {
									exchange_type : stockList[j].exchange_type,
									stock_code : stockList[j].stock_code,
									warnLineMoney : warnLineMoney,
									pledge_share : stockList[j].pledge_share,
									cash_type : appUtils.getSStorageInfo("mode_code"),
									contract_id : contractId
							}
							var warn_line = stockList[j].warn_line,
							price_ratio = stockList[j].price_ratio,
							now_price = stockList[j].now_price,
							warnLine = stockList[j].warn_line,
							lave_money = stockList[j].lave_money;
							
							$(_pageId+" .MicrofinanceTop").find("p").eq(0).text('此合约的履约保障比例：'+(Number(price_ratio)*100).toFixed(2)+'%');
							$(_pageId+" .total").attr("total_ratio",(Number(price_ratio)*100).toFixed(2)).html('补充后履约保障比：'+(Number(price_ratio)*100).toFixed(2)+'%');
							filladdPledge(paramfill);
						}
					}
				}
				
				
					var param = {
							type : 'save',
							supplementaryInfo : {
								order_id : orderId,
								order_no : results[0].order_no,
								borrow_amount : results[0].borrow_amount, //借款金额
								loan_day : results[0].max_loan_day,//借款多少天
								product_name : results[0].product_name, //借多少天
								repay_rate : results[0].repay_rate,//利率
								money_date : results[0].money_date, //发放日期
								back_date : results[0].back_date,//回购日期
								interest : results[0].interest,//利息
								trading_fee1 : results[0].trading_fee1,//手续费
								trading_fee2 : results[0].trading_fee2,//手续费
								shouldRepay : results[0].shouldRepay, //要还的总金额
								be_used : results[0].be_used,//资金用途
								isaddone : 1,//1.表示单只股票的质押
								contract_id : contractId
							}
					}
					
					//补充质押
					service.queryaddPledge1(param,function(data){
						if(data.error_no == "0"){
							//{"error_no":"0","results":[{"result":"success"}],"dsName":["results"],"error_info":""} 
							if(data.results[0].result == 'success'){
								//成功
								
							}
							
						}else{
							layerUtils.iAlert(data.error_info);	
						}
					});
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		}, {"isLastReq":false});
		
	}
	
	function queryaddPledge3(){
		
		suppleOrderInfo = [];
		
		for(var i = 0 ; i < selectedStockMap.elements.length; i++){
			var onestock = {
					stock_code : selectedStockMap.elements[i].value.stock_code, //股票代码
					stock_name : selectedStockMap.elements[i].value.stock_name,//股票名称
					coefficient : selectedStockMap.elements[i].value.coefficient,//折算率
					stock_price : selectedStockMap.elements[i].value.stock_price,//股票价格
					supplyNumber : selectedStockMap.elements[i].value.loan_stock_amount,//质押数量
					enable_amount : selectedStockMap.elements[i].value.enable_amount,//最多可质押数量
					loan_money : selectedStockMap.elements[i].value.loan_money,//质押金额
					exchange_type : selectedStockMap.elements[i].value.exchange_type,//交易市场类别
					fee : selectedStockMap.elements[i].value.loan_fee//交易费用
			}
			suppleOrderInfo.push(onestock);
		}
		
		var param = {
				type: 'save',
				suppleOrderInfo : JSON.stringify(suppleOrderInfo)
		}
		service.queryaddPledge3(param, function(data){
			if(data.error_no == "0")
			{
				service.queryaddPledge2({},function(data){
						if(data.error_no == "0")
						{
							layerUtils.iMsg("-1","补充质押成功");
							appUtils.pageInit("business/addPledge","business/repayList");
						}else{
							layerUtils.iAlert(data.error_info);	
						}
				});
			}else{
				layerUtils.iAlert(data.error_info);	
			}
			
		});
		
	}
	
	
	function filladdPledge(param){
		
		service.queryaddPledgeStock(param, function(data){
			
			if(data.error_no == "0")
			{
				var results = data.results,
					str = '';
				for(var i = 0; i < results.length; i++){
					var stock_name = results[i].stock_name, // 股票名
						market = results[i].exchange_type,  // 市场类别  1 沪市 0 深市
						marketName = results[i].exchange_type_name,
						coefficient = Number(results[i].coefficient),  // 股票自身质押率
						stockCode = results[i].stock_code,  // 股票代码
						lastPrice = Number(results[i].last_price),  // 最新价格
						reality_coefficient =(Number( results[i].coefficient)).toFixed(2), //实际质押率，根据资金用途改变，初始为自身质押率
//						reality_coefficient =(Number( results[i].coefficient)+Number(appUtils.getPageParam("addCofficient"))).toFixed(2), //实际质押率，根据资金用途改变，初始为自身质押率
						stkbal = results[i].enable_amount; // 最大可交易股票数
						
					str += '<div class="stockListCont">'
						+ '<p coefficient='+coefficient+' stock-code='+stockCode+' last-price='+lastPrice+' stkbal='+stkbal+'  market='+market+'  stock-name='+stock_name+' marketName='+marketName+'  reality_coefficient='+reality_coefficient+'><b>股票名称：</b>'+stock_name+'</p>'
						+ '<p><b>折  算  率：</b>'+coefficient+'</p>'
						+ '<p><b>昨  收  盘：</b>'+lastPrice+'</p>'
						+ '<p><b>可质押数量：</b>'+stkbal+'</p>'
						+ '<p><b>补充质押数量：</b></p>'
						+ '<p><b>金         额：</b></p>'
						+ '<p style="width: 100px;line-height: 36px;"><b>添加质押数量：</b></p>'
						+ '<div class="num">'
						+ '<span><a href="javascript:void(0);" class="minus"></a></span>'
						+ '<span class="mid"><input name="" style="width: 100px;" type="tel" placeholder="" value="0"/></span>'
						+ '<span><a href="javascript:void(0);" class="add"></a></span>'
						+ '</div>'
						+ '<div class="clear"></div>'
						+ '</div>'
				}
				
				$(_pageId+" .stockList").html(str);
				
				
				bindStockInput();
				bindStockAddAndMinus();
			}else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
		
	}
	
	function bindStockAddAndMinus(){
		//增加数量 touchstart
			appUtils.bindEvent($(_pageId+" .stockListCont .add"),function(e){
				$(this).addClass("active");
			},"touchstart");
		//增加数量touchend
		appUtils.bindEvent($(_pageId+" .stockListCont .add"),function(e){
			$(this).removeClass("active");
			var $parentStock = $(this).parent().parent().parent();  //获取当前元素的股票父元素
			//获取当前已质押的股数。判断是否超过了最大质押数量。
			var stockNum = Number($parentStock.children(".num").children(".mid").children("input").val());
			var maxStockNum = Number($parentStock.children("p:eq(0)").attr("stkbal"));
			if(stockNum == maxStockNum){
				layerUtils.iMsg(-1,"您当前该只股票最多可质押"+maxStockNum);
				$parentStock.children("p:eq(4)").html("<b>补充质押数量：</b>"+maxStockNum);
				$parentStock.children(".num").children(".mid").children("input").val(maxStockNum);
				return;
			}
			var lastPrice = parseFloat($parentStock.children("p:eq(0)").attr("last-price")).toFixed(2),
			currCoefficientRate = Number($parentStock.children("p:eq(0)").attr("reality_coefficient")),  // 获取当前质押率
			oneNum = 1*lastPrice*currCoefficientRate,  // 每股的金额
			selStockNum = 0;  // 添加的股数
			selStockNum = stockNum  // 选择的股数
			if(selStockNum+100 < maxStockNum){
				selStockNum+=100;
			}else{
				selStockNum = maxStockNum;
			}
			
			if(selStockNum >=maxStockNum){
				selStockNum = maxStockNum;
			}
			$parentStock.children(".num").children(".mid").children("input").val(selStockNum);
			calcuAndShowStock($parentStock,selStockNum);
		},"touchend");
		
		//减少按钮
		appUtils.bindEvent($(_pageId+" .stockListCont .minus"),function(e){
			$(this).addClass("active");
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" .stockListCont .minus"),function(e){
			$(this).removeClass("active");
			var $parentStock = $(this).parent().parent().parent();  //获取当前元素的股票父元素
			var stockNum = Number($parentStock.children(".num").children(".mid").children("input").val());
			var maxStockNum = Number($parentStock.children("p:eq(0)").attr("stkbal"));
			var  oneNum = 1*Number($parentStock.children("p:eq(0)").attr("last-price"))*Number($parentStock.children("p:eq(0)").attr("reality_coefficient"));
			selStockNum = 0;  // 添加的股数
			selStockNum = stockNum  // 选择的股数
			if(stockNum>100){
				stockNum -= 100;
			}else{
				stockNum = 0;
			}
			if(selStockNum >=maxStockNum){
				selStockNum = maxStockNum;
			}
			//获取当前股票的基本数据，方便后面计算。
			var stockCode = $parentStock.children("p:eq(0)").attr("stock-code"),  // 股票代码
				reality_coefficient = $parentStock.children("p:eq(0)").attr("reality_coefficient"),
				last_price = $parentStock.children("p:eq(0)").attr("last-price"),
				stkbal = $parentStock.children("p:eq(0)").attr("stkbal"),
				market = $parentStock.children("p:eq(0)").attr("market"),
				stockName = $parentStock.children("p:eq(0)").attr("stock-name"),
				marketName = $parentStock.children("p:eq(0)").attr("marketname");
			
			//计算数据 
			var pledgeNumber = stockNum,
				borrowMoney = calcPledgeMoney(stockNum,last_price),
				trading_fee2 =  Number(calcRegisterFee(pledgeNumber)).toFixed(2); //质押登记费
			var	currStock = {
					stock_code : stockCode,    //股票代码
					stock_name : stockName,    //股票名称
					stock_price : parseFloat(last_price).toFixed(2),    //股票价格
					enable_amount : parseFloat(stkbal),    //可质押数量
					loan_money : borrowMoney,  // 质押金额
					pledge_fee : trading_fee2,  // 质押登记费
					exchange_type : market,   // 市场类别  1 沪市 0 深市
					exchange_type_name : marketName,  //时长名称
					loan_stock_amount : pledgeNumber,  // 质押股数
					coefficient : Number(reality_coefficient) // 实际质押率
			    };
			//如果当前这支股票的质押数量为0 ，并存在于map中。则移除当前股票从列表里面
			if(pledgeNumber == 0){
				if(selectedStockMap.containsKey(stockCode))  // 如果当前股票已经存在
				{
					selectedStockMap.remove(stockCode);  // 移除 map 中的股票数据
				}
			}else {
				 //将当前股票存放到selectedStockMap中。
				if(selectedStockMap.containsKey(stockCode))  // 如果当前股票已经存在
				{
					selectedStockMap.remove(stockCode);  // 移除 map 中的股票数据
				}
				selectedStockMap.put(stockCode, currStock);  // 添加股数数据到 map 中
			}
			pledgeCount();
			$parentStock.children("p:eq(4)").html("<b>补充质押数量：</b>"+currStock.loan_stock_amount);
			$parentStock.children("p:eq(5)").html('<b>金额：</b>'+currStock.loan_money);
			
			$parentStock.children(".num").children(".mid").children("input").val(currStock.loan_stock_amount);
			
			// 计算总的展示数据   交易费用  预计借款金额  预计到账金额
			/*$(_pageId+" .total").html('质押总金额:'+pledgeMoneyAll+'元<br/>补充后平均履约保障比例:>110%');*/
			if(lave_money == null ||lave_money == 0 || now_price == null || now_price == 0){
			}else{
				if(pledgeMoneyAll == 0){
					$(_pageId+" .total").html('补充后履约保障比：'+$(_pageId+" .total").attr('total_ratio')+'%');
				}else{
					//补充后履约保障比：(nowprice+总的补充额度)/lave_money
					$(_pageId+" .total").html('补充后履约保障比：'+(Number((Number(now_price)+Number(pledgeMoneyAll))/Number(lave_money))*100).toFixed(2)+'%');
				}
			}
			
		},"touchend");
	}
	
	//计算 质押总金额
	function pledgeCount(){
		pledgeMoneyAll = 0;
		for(var i = 0 ; i < selectedStockMap.elements.length; i++){
			var money = selectedStockMap.elements[i].value.loan_money;
			pledgeMoneyAll = pledgeMoneyAll + money;
		}
	}
	
	function bindStockInput(){
		appUtils.bindEvent($(_pageId+" .stockListCont .mid input"),function(e){
			if (this.value.length == 1) {
				   this.value = this.value.replace(/[^0-9]/g, '');
			 }
			 else {
				//去掉第一个 0
				this.value = this.value = this.value.replace(/\b(0+)/gi,"");
			}
			
			var $parentStock = $(this).parent().parent().parent(); //获取当前股票的父元素.
			var maxPledgeNumber = Number($parentStock.children("p:eq(0)").attr("stkbal"));
			var checkNum = /^[0-9]\d*$/;
			if($(this).val()!=""){
				if(!checkNum.test($(this).val())){
					layerUtils.iMsg(-1,"质押股数填写有误");
					$(this).val(0);
					return;
				}
			}
			
			if(Number($(this).val())>maxPledgeNumber){
				layerUtils.iMsg(-1,"质押股数不能大于可质押股数");
				$(this).val(maxPledgeNumber);
				$parentStock.children("p:eq(4)").html("<b>补充质押数量：</b>"+maxPledgeNumber);
				return;
			}
			var pledgeNumber = $(this).val()==""?0:$(this).val();
			//计算当前股票的显示. $parentStock 当前股票 $(this).val()  当前数量.
			calcuAndShowStock($parentStock,pledgeNumber);
		},"keyup");
		 appUtils.bindEvent($(_pageId+" .stockListCont .mid input"),function(e){
			 if (this.value.length == 1) {
				   this.value = this.value.replace(/[^0-9]/g, '');
				} 	
			 else {
					this.value = this.value.replace(/\D/g, '');
				}
		 },"keydown");
	}
	
	/*手动选股计算。
	 * param stock 当前股票对象
	 * number  当前股票质押数量
	 * */
	function calcuAndShowStock(currentStock , number){
		
		//获取当前股票的基本数据，方便后面计算。
		var stockCode = currentStock.children("p:eq(0)").attr("stock-code"),  // 股票代码
			reality_coefficient = currentStock.children("p:eq(0)").attr("reality_coefficient"),
			last_price = currentStock.children("p:eq(0)").attr("last-price"),
			stkbal = currentStock.children("p:eq(0)").attr("stkbal"),
			market = currentStock.children("p:eq(0)").attr("market"),
			stockName = currentStock.children("p:eq(0)").attr("stock-name"),
			marketName = currentStock.children("p:eq(0)").attr("marketname");
		
		//计算数据 
		var pledgeNumber = number,
			borrowMoney = calcPledgeMoney(number,last_price),
			trading_fee2 =  Number(calcRegisterFee(pledgeNumber)).toFixed(2); //质押登记费
//			trading_fee1 = calcBrokerage(borrowMoney,pledgeNumber,market), // 质押经手费
//			loan_fee = Number(trading_fee1)+Number(trading_fee2);
//			loan_fee = loan_fee.toFixed(2);
		var	currStock = {
				stock_code : stockCode,    //股票代码
				stock_name : stockName,    //股票名称
				stock_price : parseFloat(last_price).toFixed(2),    //股票价格
				enable_amount : parseFloat(stkbal),    //可质押数量
				loan_money : borrowMoney,  // 质押金额
//				loan_fee : loan_fee,  // 交易费用
//				brokerage_fee : trading_fee1,  // 质押经手费
				pledge_fee : trading_fee2,  // 质押登记费
				exchange_type : market,   // 市场类别  1 沪市 0 深市
				exchange_type_name : marketName,  //时长名称
				loan_stock_amount : pledgeNumber,  // 质押股数
				coefficient : Number(reality_coefficient) // 实际质押率
		    };
		
		
//		var allPledgeMoney =0;     //当前手动选股列表里面所有的质押金额
//		$(_pageId+" .stockListCont").each(function(e){
//			allPledgeMoney += Number($(this).children("p:eq(5)").children("a").html());
//		});
		
//		allPledgeMoney = allPledgeMoney-Number(currentStock.children("p:eq(5)").children("a").text());
		 
		var selStockNum = 0,// 添加的股数
            oneNum = 1*Number(currStock.stock_price)*Number(currStock.coefficient);
		selStockNum = pledgeNumber;  // 选择的股数
		
		if(selStockNum%100>0){
			var n=parseInt(selStockNum/100);
			selStockNum=(n+1)*100;
		}else{
			selStockNum = selStockNum;
		}
		
		if(selStockNum >=currStock.enable_amount){
			selStockNum = currStock.enable_amount;
		} else{
			if(selStockNum<=currStock.loan_stock_amount){
				currStock.loan_stock_amount = selStockNum;
			}
		}
		
		//如果当前这支股票的质押数量为0 ，并存在于map中。则移除当前股票从列表里面
		if(pledgeNumber == 0){
			if(selectedStockMap.containsKey(stockCode))  // 如果当前股票已经存在
			{
				selectedStockMap.remove(stockCode);  // 移除 map 中的股票数据
			}
		}else {
			 //将当前股票存放到selectedStockMap中。
			if(selectedStockMap.containsKey(stockCode))  // 如果当前股票已经存在
			{
				selectedStockMap.remove(stockCode);  // 移除 map 中的股票数据
			}
			selectedStockMap.put(stockCode, currStock);  // 添加股数数据到 map 中
		}
			pledgeCount();
	     //将计算数据展示在页面上
			currentStock.children("p:eq(4)").html("<b>补充质押数量：</b>"+currStock.loan_stock_amount);
			currentStock.children("p:eq(5)").html('<b>金额：</b>'+currStock.loan_money);
			
			currentStock.children(".num").children(".mid").children("input").val(currStock.loan_stock_amount);
			
			// 计算总的展示数据   交易费用  预计借款金额  预计到账金额
			/*$(_pageId+" .total").html('质押总金额:'+pledgeMoneyAll+'元<br/>补充后平均履约保障比例:>110%');*/
			if(lave_money == null ||lave_money == 0 || now_price == null || now_price == 0){
				
			}else{
				if(pledgeMoneyAll == 0){
					$(_pageId+" .total").html('补充后履约保障比：'+$(_pageId+" .total").attr('total_ratio')+'%');
				}else{
					//补充后履约保障比：(nowprice+总的补充额度)/lave_money
					$(_pageId+" .total").html('补充后履约保障比：'+(Number((Number(now_price)+Number(pledgeMoneyAll))/Number(lave_money))*100).toFixed(2)+'%');
				}
			}
	}
	
	/**
	 * 计算质押金额
	 * @param pledgeNum 质押股数
	 * @param coefficientRate 折算率
	 * @param lastPrice 最新价格
	 */
	function calcPledgeMoney(pledgeNum, lastPrice)
	{
		var currPledgeSum = parseInt(pledgeNum),  // 质押股数
			lastPrice = parseFloat(lastPrice); // 最新价格
        var price = lastPrice*currPledgeSum;
        
		return Number(price.toFixed(2));  // 保留两位小数之后再转换为数字
	}
	
	/**
	 * 计算质押登记费
	 * @param pledgeNum 质押股数
	 */
	function calcRegisterFee(pledgeNum)
	{
		var registerFee = 0,  // 质押登记费
			currPledgeNum = Number(pledgeNum);  // 当前质押股数
		if(currPledgeNum<=borrowMoney_deelFee.critical){
			registerFee = pledgeNum*borrowMoney_deelFee.under_critical;
			if(registerFee<borrowMoney_deelFee.zyfee){
				registerFee = borrowMoney_deelFee.zyfee;
			}
		}else if(currPledgeNum>borrowMoney_deelFee.critical){
			registerFee =Number(pledgeNum-borrowMoney_deelFee.critical)*borrowMoney_deelFee.over_critical+borrowMoney_deelFee.critical*borrowMoney_deelFee.under_critical;
		}
		return registerFee;
	}
	
	/**获取经手费**/
//	function getBrokeageFee(){
//		service.queryBrokeageFee("",function(data){
//			if(data.error_no == 0){
//				borrowMoney_deelFee = data.results[0];
//			}else{
//				layerUtils.iAlert(data.error_info);
//			}
//		});
//	}
	
//	/******** 计算经手费**********/
//	function calcBrokerage(pledgeMoney,pledgeAmount,market){
//		var brokerage = 0;
//		// 0 是深A  2是沪A
//		 if(market == 0){
//			 brokerage = Number(pledgeAmount*borrowMoney_deelFee.under_critical_sz).toFixed(2);
//				if(Number(brokerage)>Number(borrowMoney_deelFee.max_charge_sz)){
//					brokerage = borrowMoney_deelFee.over_critical_sz;
//				}
//				else if(Number(brokerage)<Number(borrowMoney_deelFee.jsfee_sz)){
//					brokerage = borrowMoney_deelFee.jsfee_sz;
//				}
//		 }
//		 else if(market == 2){
//			 brokerage = Number(pledgeMoney*borrowMoney_deelFee.under_critical_sh).toFixed(2);
//				if(Number(brokerage)>Number(borrowMoney_deelFee.max_charge_sh)){
//					brokerage = borrowMoney_deelFee.over_critical_sh;
//				}
//				else if(Number(brokerage)<Number(borrowMoney_deelFee.jsfee_sh)){
//					brokerage = borrowMoney_deelFee.jsfee_sh;
//				}
//		 }
//		return brokerage;
//	}
	
	/*向外暴露的 JSON 对象*/
	var addPledge = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = addPledge;
});