/**
 * 股票质押页面
 * @author fc
 */
define(function(require, exports, module){
	//全局变量
	var _pageId = "#business_borrowApply";
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var service = require("mobileService_xdt");  //业务层接口，请求数据
	var utils = require("utils");
	var formatNum = require("formatNum");
	var stockhelp = require("stockhelp");
	var loanparam = {
			maxCanBorrowMoney:0, 	//最大借款金额
			min_pledge_money:0, 	//单只股票最低的质押金额
			switchBigUserMoney:"",	//0状态为大订单开启，下面的exaltedMoney对应0状态使用，其他参数不管
			maxLoanDay:0,			//最大的借款天数，用于判断是否可以延期
			creditRatingMax:0,		//最大的授信额度，用于征信的时候提示，610008接口现在征信后的授信额度如果超过这个值则取这个值
			minMoney:0,				//单笔订单最低的金额
			minProductDays:0,		//最小的借款产品
			maxMoney:0,				//单笔订单最高的金额
			exaltedMoney:0			//用于大笔订单，借款页面限额，超过这个值则跳到大订单提示页面
	};
	var userInfoInSession = null;  // session 中的 userInfo
	var modeCode = ""; //借款类型 (打新、炒股、取现)
	var external = require("nativePluginService");
	
	/**
	 * 页面初始化
	 */
	function init(){
		
		userInfoInSession = utils.getUserInfoInSession();
		modeCode = appUtils.getSStorageInfo("mode_code");
		serverData = {};
		
		if(appUtils.getSStorageInfo("_prePageCode") != "apply/eleAgreement"){
			showInfo();
		}else{
			//初始化页面数据
			initFillPageData();
		}
		
	}
	
	/**
	 * 绑定事件
	 */
	function bindPageEvent(){
		
		/**
		 * 绑定返回按钮
		 */
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/borrowApply","business/borrowIndex");
			e.stopPropagation();
		},"touchend");
		
		/**
		 * 绑定个人中心按钮
		 */
		appUtils.bindEvent($(_pageId+" .home"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		appUtils.bindEvent($(_pageId+" .home"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/borrowApply","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		
		/**
		 * 绑定借款期限
		 */
		appUtils.bindEvent($(_pageId+" #selCreditTime"), function(e){
			$(_pageId+" #selCreditTime").next("ul").toggle();
			e.stopPropagation();
		});
		
		/**
		 * 点击页面其他地方关闭借款期限下拉
		 */
		appUtils.bindEvent($(_pageId), function(e){
			$(_pageId+" #selCreditTime").next("ul").hide();
		    e.stopPropagation();
		});
		
		/**
		 * 绑定交易费用 查看详情
		 */
		appUtils.bindEvent($(_pageId+" #showfreeinfo"),function(e){
			var content = '<div class="contText" style="padding:10px 0px 0px 0px">'
						+ '<h2 style="color:red;">特别提示</h2>'
			     		+ '<p>根据沪深交易所及沪深登记公司股票质押式回购交易业务相关规定，每笔初始交易的收费标准如下：</p>'
			     		+ '<h6>经手费</h6>'
			     		+ '<p>上海市场按每笔借款金额的0.01‰收取，起点5元人民币，最高不超过100元人民币。</p>'
			     		+ '<p>深圳市场按每笔借款质押标的证券面值1‰收取，最高不超过100元人民币。</p>'
			     		+ '<h6>质押登记费</h6>'
			     		+ '<p>股票500万股以下（含）部分按该部分面值的1‰收取，超500万股的部分按该部分面值的0.1‰收取，起点100元。</p>'
			     		+ '<p>基金500万份以下（含）部分按该部分面值的0.5‰收取，超500万份的部分按该部分面值的0.05‰收取，起点100元。</p>'
			     		+ '<p>债券500万元以下（含）部分按该部分面值的0.5‰收取，超500万元的部分按该部分面值的0.05‰收取，起点100元。</p>'
			     		+ '</div>';
			
			var param = {
					"title" : "交易费用说明",
					"content" : content,
					"isbackflag":"false" //显示协议书 左上角返回按钮 点击返回需要重新加载该页面
			}
			notInit = false;
			appUtils.pageInit("","apply/eleAgreement",param);
			e.stopPropagation();
		});
		
		/**
		 * 绑定所有数字输入框
		 */
		appUtils.bindEvent(_pageId + " #inputLoanMoney",function(e){
			
			if (this.value.match("^0") != null) {
				//去掉第一个 0
				this.value = this.value = this.value.replace(/\b(0+)/gi,"");
			}
			
			var checkNum = /^[0-9]\d*$/;
			if($(this).val()!=""){
				if(!checkNum.test($(this).val())){
					$(this).val(0);
				}
			}
			//借款金额输入框 method
			loanInputEvent($(this));
			e.stopPropagation();
		},"input");

		/**
		 * 绑定订单提交
		 * @desc 因为没有显示借款利息，所以提交的时候重新计算一次借款利息
		 *       不需要在修改完借款期限和利率后 改动数据
		 */
		appUtils.bindEvent(_pageId + " .PubBtn",function(e){
			
			//判断
			var nextPageParam = null;
			
			/**
			 * 提交订单前验证
			 */
			function validateNext(){
				//判断是否选择了借款期限
				var day = $(_pageId+" #selCreditTime").attr("credit-time");
				
				if(!day){
					layerUtils.iMsg(-1, "请先选择借款期限");
					return false;
				}
				
				if(!validateLoanMoney($(_pageId + " #inputLoanMoney"),true)){
					return false;
				};
				
				var flag = true;
				//循环判断 是否有借款金额小于
				$(_pageId + " div[class='gp_numbox']").each(function(){
					
					//质押股数
					var pledgenum = $(this).attr("pledgenum")-0;
					
					if(pledgenum > 0){
						if(($(this).attr("pledgemoney")-0) < (loanparam.min_pledge_money-0)){
							flag = false;
						}
					}
					
				});
				
				if(!flag){
					layerUtils.iMsg(-1,"对不起，单只股票【借款金额】必须大于"+(loanparam.xrz_min_pledge_money-0));
					return false;
				}
				
				return true;
			}

			//验证通过提交订单
			if(validateNext()){
				nextPageParam = pledgeStockCallBack();
				var param = JSON.stringify(nextPageParam);
				service.saveOrReadOrder("save",param,function(data){
					 if(data.error_no == 0){
						 appUtils.pageInit("business/borrowApply","business/borrowConfirm",nextPageParam);
					 }
					 else{
						 layerUtils.iAlert(data.error_info);
					 }
				 });
			}
			
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 页面销毁
	 */
	function destroy(){
		
		//查看详情时 不需要清除页面
		
		//页面销毁时重置借款期限
		//重置交易费用、借款金额、股票列表
		$(_pageId + " .jy_from .jy_input:eq(0) p").text("￥--");
		$(_pageId + " .jy_from .jy_input:eq(1) p").text("￥--");
		$(_pageId + " #selCreditTime").text('请选择借款时间').removeAttr("credit-time").removeAttr("credit-rate");
		$(_pageId + " .jy_from .jy_input:eq(3) p").text("0 元");
		$(_pageId + " #inputLoanMoney").val('0');
		$(_pageId + ' table[class="gp_mxtable"] tbody').html('<tr>'
				+'<th width="35%" class="left">股票名称及代码</th>'
                +'<th width="35%">最大可借金额</th>'
                +'<th width="30%">质押数量</th>'
                +'</tr>'
                +'<tr>'
            	+'<th colspan="3">无</th>'
            	+'</tr>');
		
		//
		$(_pageId + " #inputLoanMoney").attr("stockloanmoney",0);
		//关闭原生键盘
		var param = {
			"moduleName":"xdt"
		};
		external.function50211(param);
		
		//重置
		window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){}, // 键盘完成按钮的事件
				keyBoardInputFunction: function(){}
		}
	}
	
	/*****************private function start*********************/
	/**
	 * 进入页面显示提示信息
	 */
	function showInfo(){
		var param = {
						content:"",
						title:"",
						isbackflag:"true" //显示协议书 左上角返回按钮 点击返回需要重新加载该页面
					};
		
		var riskname;
		
		if(modeCode == "qx"){  // 借钱消费
			
			riskname = "qx_tips";
			
		}else if(modeCode == "cg"){  //借钱炒股
			
			riskname = "cg_tips";
			
		}else{  //借钱打新
			
			riskname = "dx_tips";
			
		}
		
		service.getProtocol({type_ename:riskname},function(data){
			if(data.error_no == 0){
				
				param.content = data.results[0].content_txt;
				param.title   = data.results[0].type_name;
				
				appUtils.pageInit("business/borrowApply","apply/eleAgreement",param);
				
			}else{
				layerUtils.iAlert(data.error_info);
				//初始化页面数据
				initFillPageData();
			}
		});

	}
	
	/**
	 * 初始化页面数据方法
	 * 填充页面数据
	 */
	function initFillPageData(){
		
		//授信额度和最大可借款金额信息
		var param = {
						"user_id":userInfoInSession.user_id,
						"cash_type":modeCode
					};
		//最外层
		service.getUserlimit(param,function(data){
			//借款利率和期限
			queryCreditTimeList();
			
			if(data.error_no == 0){
				var result = data.results[0];
				var credit_money = result.credit_money-0;//授信额度
				var available_amount = result.available_amount-0;//可借款金额
				var residue_balance = result.residue_balance-0;//可用额度  
				
				//剩余授信额度
				$(_pageId + " .jy_from .jy_input:eq(0) p").text("￥" + formatNum.formatMoney(residue_balance));
				
				//取最小值
				loanparam.maxCanBorrowMoney = Math.min.apply(Math, [credit_money,available_amount,residue_balance]); 
				
				//最大借款金额
				$(_pageId + " .jy_from .jy_input:eq(1) p").text("￥" + formatNum.formatMoney(available_amount));
				
			}else{
				 layerUtils.iAlert(data.error_info);
			}
			
		},{"isLastReq":false});
		
		//借款利率和期限
		function queryCreditTimeList()
		{
			var param = {
					tag_type: modeCode      //xrz为打新     cg为可用   qx为可取
			}
			
			service.queryCreditTimeList(param, function(data){
				
				//获取经手费
				getBrokeageFee();
				
				if(data.error_no == "0")
				{
					var results = data.results;
					var allCreditTimeStr = "";  // 所有填充时间字符串
					for(var i = 0; i < results.length; i++)
					{
						var creditRate = results[i].repay_rate, // 借款利率
							days = results[i].days;  //借款天数
							creditTime = results[i].loanperiod;  // 借款期限
							var a = "";
						    a = days+"天期（年利率"+Number(creditRate*100).toFixed(2)+"%）";
							allCreditTimeStr += '<li class="active"><a href="javascript:void(0);" credit-time="'+days+'" credit-rate="'+creditRate+'">'+a+'</a></li>';
					}
					
					$(_pageId + " .jy_from .jy_input:eq(2) ul").html(allCreditTimeStr);
					
					//绑定借款期限
					appUtils.bindEvent($(_pageId+" #selCreditTime").next("ul").find("li a[credit-time]"), function(e){
						var creditDays = $(this).attr("credit-time"),  // 贷款时间
						showVal = $(this).html();   //显示在输入框的内容
						creditRate = $(this).attr("credit-rate");  // 利率
						// 设置选择贷款时间的文本和自定义属性
						$(_pageId + " #selCreditTime").text(showVal).attr({"credit-time":creditDays,"credit-rate" : creditRate});
						$(_pageId+" #selCreditTime").next("ul").slideUp(200);  // 隐藏贷款期限下拉列表
						
						e.stopPropagation();
					});
				}
				else
				{
					layerUtils.iAlert(data.error_info);
				}
				
			},{"isLastReq":false});
		} 
		
		//获取经手费
		function getBrokeageFee(){
			
			//股票持仓
			queryPositionList();
			
			var deelFee = appUtils.getSStorageInfo("deelFee");
			if(!deelFee){
				service.queryBrokeageFee("",function(data){
					if(data.error_no == 0){
						
						//手续费用
						var deelFee = data.results[0];
						//直接丢到缓存里面，登陆后只从服务器下载一次
						appUtils.setSStorageInfo("deelFee",JSON.stringify(deelFee));
						
					}else{
						layerUtils.iAlert(data.error_info);
					}
				},{"isLastReq":false});
			}
		}
		
		//股票持仓
		function queryPositionList()
		{
			
			var param = {
					"entrust_way": userInfoInSession.entrust_way,  // 委托方式
					"branch_no" : userInfoInSession.branch_no,  // 分支机构
					"fund_account" : userInfoInSession.fund_account,  // 资金账号
					"cust_code" : userInfoInSession.cust_code, // 客户编号
					"op_station" :  userInfoInSession.op_station,   // 操作站点
					"user_id" :  userInfoInSession.user_id,   // 操作站点
					"cash_type":modeCode
			};
			service.queryPositionList(param, function(data){
				//获取质押限制数据
				getqueryServerData();
				if(data.error_no == "0")  
				{
					//获取数据
					var results = data.results;
					//深圳资质
					var shzzIsOpen = userInfoInSession.shzzIsOpen;
					//填充股票
					stockhelp.fillStockList(results,$(_pageId + ' table[class="gp_mxtable"] tbody'),shzzIsOpen,false);
					
					//绑定事件
					stockhelp.stockNumEvent($(_pageId + ' input[type="range"]'),pledgeStockCallBack,false);
				}
				else
				{
					layerUtils.iAlert(data.error_info);
				}
			},{"isLastReq":false});
		}
		
		//获取质押限制数据
		function getqueryServerData(){
			
			var param = {
				"tag_type":modeCode
			}
			service.queryServerData(param,function(data){
				
				if(data.error_no == "0"){
					var result = data.results[0];
					loanparam.min_pledge_money = result.xrz_min_pledge_money-0; 	//单只股票最低的质押金额
					loanparam.switchBigUserMoney = result.switchBigUserMoney-0;	//0状态为大订单开启，下面的exaltedMoney对应0状态使用，其他参数不管
					loanparam.maxLoanDay = result.maxLoanDay-0;			//最大的借款天数，用于判断是否可以延期
					loanparam.creditRatingMax = result.creditRatingMax-0;		//最大的授信额度，用于征信的时候提示，610008接口现在征信后的授信额度如果超过这个值则取这个值
					loanparam.minMoney = result.xrz_minMoney-0;				//单笔订单最低的金额
					loanparam.minProductDays = result.minProductDays-0;		//最小的借款产品
					loanparam.maxMoney = result.xrz_maxMoney-0;				//单笔订单最高的金额
					loanparam.exaltedMoney = result.exaltedMoney-0;			//用于大笔订单，借款页面限额，超过这个值则跳到大订单提示页面
				}else{
					layerUtils.iAlert(data.error_info);
				}
			});
		}
	}
	
	/**
	 * 股票质押回调事件
	 * @return 返回给下一个页面的参数
	 */
	function pledgeStockCallBack(){
		
		//
		var nextPageParam = {};
		//
		var loan_stock_arr = [];
		
		//计算预计借款金额
		var loanmoney = 0;
		//利息
		var interest = 0;
		var total_loan_fee = 0;
		
		//借款产品期限
		var day = $(_pageId+" #selCreditTime").attr("credit-time");
		//利率
		var rate = $(_pageId+" #selCreditTime").attr("credit-rate");
		//借款金额(客户填写的借款金额)
		var inputLoanMoney = $(_pageId + " #inputLoanMoney").val();
		//资金用途
		var be_used = modeCode;
		
		//遍历所有股票
		$(_pageId + " .gp_mxbox table .gp_numbox").each(function(){
			
			//质押股数
			var pledgenum = $(this).attr("pledgenum")-0;
			
			if(pledgenum > 0){
				var stockinfo = {
						stock_code : $(this).attr("stockcode"),//股票代码
						stock_name : $(this).attr("stockname"),//股票名称
						stock_price : $(this).attr("stock_price")-0,//股票价格
						enable_amount : $(this).attr("enable_amount")-0,//可质押数量
						loan_money : $(this).attr("pledgemoney")-0,// 实际质押金额
						loan_money2 : $(this).attr("max_loan_money")-0,// 股票可以质押的金额
						loan_fee : (($(this).attr("jsfree")-0)+($(this).attr("djfree")-0)),// 交易费用
						warn_line : $(this).attr("warnline")-0,// 警戒线
						low_line : $(this).attr("lowline")-0,// 最低履约保障比例线
						follow_line : $(this).attr("follow_line"),//关注比例
						brokerage_fee : $(this).attr("jsfree")-0,// 质押经手费
						pledge_fee : $(this).attr("djfree")-0,// 质押登记费
						exchange_type : $(this).attr("exchange_type")-0,// 市场类别  2沪市A 0 深市A
						exchange_type_name : $(this).attr("exchange_type_name"),//市场名称
						loan_stock_amount : pledgenum,// 质押股数
						coefficient : $(this).attr("coefficient")-0// 实际质押率
				};
				loanmoney += stockinfo.loan_money-0;
				//经手费 和 借款费用要重新计算
				stockinfo.brokerage_fee = stockhelp.calcBrokerage(stockinfo.loan_money,pledgenum,stockinfo.exchange_type);
				stockinfo.loan_fee = stockinfo.brokerage_fee + stockinfo.pledge_fee;
				total_loan_fee += stockinfo.loan_fee;
				loan_stock_arr.push(stockinfo);
			}
		});
		
		//保留2小数
		loanmoney = stockhelp.toFixed2(loanmoney,2);
		
		
		interest = stockhelp.calcInteret(day,rate,loanmoney);
		
		total_loan_fee = total_loan_fee.toFixed(2);
		
		nextPageParam["loan_money"] = loanmoney;
		nextPageParam["loan_stock_arr"] = loan_stock_arr;
		nextPageParam["total_loan_fee"] = total_loan_fee;
		nextPageParam["tag_type"] = be_used;
		nextPageParam["dayInterest"] = "1";
		nextPageParam["loan_day"] = day;  // 交易期限
		nextPageParam["interest"] = interest; // 利息
		nextPageParam["loan_rate"] = rate; // 利率
		nextPageParam["jiaoyi_type"] = "初始交易"; // 交易类型
		
		//修改页面上的值
		//交易费用
		$(_pageId + " .jy_from .jy_input:eq(3) p").text(total_loan_fee + "元");
		//预计借款金额
		$(_pageId + " .jy_from .jy_input:eq(4) input").val(loanmoney).attr("stockloanmoney",loanmoney);
		
		return nextPageParam;
	}
	
	/**
	 * 借款金额输入框 事件
	 * @param obj 当前的对象
	 */
	function loanInputEvent(obj){
		
		var stockloanmoney = $(obj).attr("stockloanmoney")-0;
		//当前输入的借款金额
		var inloanmoney = $(obj).val()-0;
		
		if(!validateLoanMoney(obj,false)){
			return false;
		};
		
		//折算 每只选择的股票 按照比例分别选择质押金额
		//遍历所有股票
		$(_pageId + " div[class='gp_numbox']").each(function(){
			
			//质押股数
			var pledgenum = $(this).attr("pledgenum")-0;
			
			if(pledgenum > 0){
				//股票价格
				var stock_price = $(this).attr("stock_price")-0;
				//实际质押率
				var coefficient = $(this).attr("coefficient")-0;
				//实际质押金额
				var loan_money = stockhelp.toFixed2(coefficient*pledgenum*stock_price,2)-0;
				//股票市场
				var exchange_type = $(this).attr("exchange_type")-0;
				//质押经手费
				var brokerage_fee = stockhelp.calcBrokerage(loan_money,pledgenum,exchange_type);
				$(this).attr("jsfree",brokerage_fee);
				var loanmoney2 = stockhelp.toFixed2((loan_money/stockloanmoney)*inloanmoney,2);
				//质押金额按照%比计算
				$(this).attr("pledgemoney",loanmoney2);
				
//				var min_pledge_money = loanparam.min_pledge_money - 0;
//				//如果计算出来的金额小于最小质押金额
//				if(loanmoney2 < min_pledge_money && loan_money > min_pledge_money){
//					loanmoney2 = min_pledge_money;
//				}
			}
		});
	}
	
	/**
	 * 校验借款金额
	 * @param 借款金额输入框的dom
	 */
	function validateLoanMoney(obj,valflag){
		var stockloanmoney = $(obj).attr("stockloanmoney")-0;
		var inputval = $(obj).val()-0;
		if(stockloanmoney <= 0){
			$(obj).val('');
			//提示 请先选择股票质押
			layerUtils.iMsg(-1,"您还未质押股票");
			return false;
		}
		
		//输入金额不能大于实际质押股票的金额
		if(inputval > stockloanmoney){
			//提示
			layerUtils.iMsg(-1,"借款金额不能大于可质押金额"+stockloanmoney+"元");
			return false;
		}
		
		//输入的借款金额 不能小于最小质押金额
		if(valflag && (inputval < (loanparam.minMoney-0))){
			layerUtils.iMsg(-1, "对不起，单只证券单笔借款金额不能低于"+(loanparam.minMoney-0)+"元");
			return false;
		}
		
		//借款金额不能大于可用额度
		if(inputval > (loanparam.maxCanBorrowMoney-0)){
			layerUtils.iMsg(-1, "借款金额不能大于"+(loanparam.maxCanBorrowMoney-0)+"元");
			return false;
		}
		
		//单笔订单最高的金额
		if(inputval > (loanparam.maxMoney-0)){
			layerUtils.iMsg(-1, "单笔订单最高的金额"+(loanparam.maxMoney-0)+"元");
			return false;
		}
		
		return true;
	}
	
	/*****************private function end*********************/
	
	var borrowApply = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	module.exports = borrowApply;
	
});