/**
 * 借款确认页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		formatNum = require("formatNum"),
		pageInParam = "",
		smsInterval = null,  // 短信验证码计时器
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		userInfoInSession = null,  // session 中的 userInfo
		_pageId = "#business_borrowConfirm";
		var zyzzVersion = ""; 
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		pageInParam = appUtils.getPageParam();
		//ios显示heade异常 
		$(_pageId+" section").height($(document).height()-41+'px').css("overflow","auto");
		getOrderInterest();  //获取利息
	}
	
	function getOrderInterest(){
		var param = {
			days :pageInParam.loan_day,
			borrow_account :pageInParam.loan_money,
			cash_type :appUtils.getSStorageInfo("mode_code"),
			interest_rate :pageInParam.loan_rate
		}
		service.queryOrderInterest(param,function(data){
			if(data.error_no == 0){
				pageInParam.interest = data.results[0].interest;
				showInfoByInParam();  // 根据页面入参显示页面信息
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		});
		
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/borrowConfirm","business/borrowApply");
			e.stopPropagation();
		},"touchend");
		
		/*我要借款*/
		appUtils.bindEvent($(_pageId+" .top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
//		/*《股票质押式回购交易风险揭示书》*/
//		appUtils.bindEvent($(_pageId+" .icon_check em:eq(0)"), function(e){
//			appUtils.pageInit("business/borrowConfirm", "apply/rebuyProtocol");
//			e.stopPropagation();
//		});
		
//		/*《电子协议》*/
//		appUtils.bindEvent($(_pageId+" .icon_check em:eq(1)"), function(e){
//			appUtils.pageInit("business/borrowConfirm", "apply/eleAgreement");
//			e.stopPropagation();
//		});
		
		/*下一步*/
		appUtils.bindEvent($(_pageId+" #nextStep"), function(e){
//			if(validateNext())  // 校验下一步条件
//			{
				var pageInParam = appUtils.getPageParam();  // 值为上一个页面的入参
				appUtils.pageInit("business/borrowConfirm", "business/payByPwd", pageInParam);
//			}
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" #iconcheck").removeAttr("checked");   // 取消勾选协议
	}
	
	/*校验下一步条件*/
	function validateNext()
	{
		if(!$(_pageId+" #iconcheck").attr("checked"))
		{
			layerUtils.iMsg(-1, "请勾选阅读并同意签署协议");
			return false;
		}
		return true;
	}
	
	/*根据页面入参显示页面信息*/
	function showInfoByInParam()
	{
		var userDiscount = userInfoInSession.userDiscount,
			tradeMoney = formatNum.formatMoney(pageInParam["total_loan_fee"]),      //交易费用
			tradeDeadline = pageInParam["loan_day"],  // 交易期限
			interestRate = pageInParam["loan_rate"], // 利率
			interest = pageInParam["interest"], // 利息
			creditQuantity =formatNum.formatMoney((Number(pageInParam["loan_money"])*100).toFixed(2)/100),
			stocksSel = pageInParam["loan_stock_arr"];   // 股票的选择情况 
		var getMoney = (Number(pageInParam["loan_money"])*100).toFixed(2)/100;
		$(_pageId+" #brrorowMoney").html("<span>借款金额&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;：</span>"+creditQuantity+"元");  // 填充借款金额
		$(_pageId+" #interestMoney").html("<span>到期还款利息：</span>"+interest+"元");  // 填充利息
		$(_pageId+" #tradeMoney").html("<span>预计手续费 &nbsp;&nbsp;&nbsp;：</span>"+tradeMoney+"元");  // 填充交易费用
		$(_pageId+" #getMoney").html("<span>预计到账金额：</span>"+Number(getMoney).toFixed(2)+"元");  // 填充交易费用
		$(_pageId+" #fundUse").html("<span>资金用途&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;：</span>"+appUtils.getSStorageInfo("mode_name")+"");  // 填充交易费用
		fillStockInfo(tradeDeadline, stocksSel);  // 填充股票信息
	}
	
	/**
	 * 填充股票信息
	 * @param tradeDeadline 贷款期限
	 * @param stocksSel 股票的选择情况
	 */
	function fillStockInfo(tradeDeadline, stocksSel)
	{
		var allStocksStr = '';  // 所有股票的字符串
		
		for(var i = 0; i < stocksSel.length; i++)
		{
			allStocksStr += " <div class='cont'>";
			allStocksStr += "<p stock_code="+stocksSel[i].stock_code+">"+stocksSel[i].stock_name+"</p>";   // 股票名称
			allStocksStr += "<p class='ared' style='width:25%'>2014-05-14</p>";   // 交易日期（借款日期）
			allStocksStr += "<p style='width:15%'>"+tradeDeadline+"</p>";   // 贷款期限
			allStocksStr += "<p>"+stocksSel[i].loan_money+"</p>";   // 质押金额

			allStocksStr += "<p>"+stocksSel[i].loan_stock_amount+"</p>";   // 当前质押股数
			allStocksStr += "</div>";
		}
		$(_pageId+" .list").html(allStocksStr);  // 设置表头信息，设置之后填充股票数据
		queryBorrowDate();  // 查询借款日期
		
		//绑定查看 交易协议书
//		bindtradeEvent();
	}
	
	/*绑定每一列数据  弹出交易协议书*/
	function bindtradeEvent(){
		appUtils.bindEvent($(_pageId+" .list .cont"),function(e){
			var pageInParam = appUtils.getPageParam();  // 值为上一个页面的入参
			var param = {
					"stock_code" : $(this).find("p").eq(0).attr("stock_code"), //股票代码
					"jiaoyi_type" : pageInParam["jiaoyi_type"]//交易类型
			}
			appUtils.pageInit("business/borrowConfirm","business/tradeAgreement",param);
			
			e.stopPropagation();
		});
	}
	
	/*查询借款日期*/
	function queryBorrowDate()
	{
		var creditTime = appUtils.getPageParam("tradeDeadline") == "随借随还" ? "0" : appUtils.getPageParam("tradeDeadline");
			queryBorrowDateParam = {
				days : 0  // 传1过去表示，立即受理.
		};
		service.queryBorrowDate(queryBorrowDateParam, function(data){
			if(data.error_no == "0")
			{
				var borrowDate = data.results[0].trade_date;  // 借款日期
				$(_pageId+" .list .cont").each(function(){
					$(this).find("p:eq(1)").text(borrowDate);  // 设置借款日期
				});
			}
			else
			{
				layerUtils.iLoading(false);
				handleBorrowDate();
			}
		},{"isLastReq":true,"isShowWait":true,"timeOutFunc":handleBorrowDate});
	}
	/*******   请求失败，继续发起请求   开始    ********************/
	 /**重载借款日期***/
	function handleBorrowDate(){
		layerUtils.iAlert("数据加载失败，是否重新加载？",-1, function(){
			queryBorrowDate();   
		});
	}
	/*******     结束    ********************/
	/*向外暴露的 JSON 对象*/
	var borrowConfirm = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = borrowConfirm;
});