/**
 * 借款首页
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		winHeight = null,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		_pageId = "#business_borrowIndex";
	var formatNum = require("formatNum");
	var gconfig = require("gconfig"); 
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		winHeight = $(document).height();
		appUtils.setSStorageInfo("firstLand","false");
		$(_pageId+" .lend").height(winHeight - 40 - 32);
		$(_pageId+" .lend").css("overflow","auto");
		//检查是否显示下面两个菜单 (融资取现 和 融资炒股)
		switchApp();
		
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		//调用原生方法返回一级模块
		appUtils.bindEvent($(_pageId+" #back"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		appUtils.bindEvent($(_pageId+" #back"), function(e){
			$(this).removeClass("active");
			
			var lastModuleName = appUtils.getSStorageInfo("lastModuleName");
			//返回到“我”模块首页 
			//如果 moduleName 不为空 且 为 me
			if(lastModuleName && lastModuleName=="me"){
//				var toPage = "";
//				if(gconfig.platform == "2"){
//					toPage={"prefix":"www/m/ygt","suffix":"me/myIndexYes","ModuleName":"xdt"};
//				}else{
//					toPage = gconfig.seaBaseUrl+"ygt/index.html#!/me/myIndexYes.html?ModuleName=xdt";
//				}
//				var param = {"funcNo":"50101","moduleName":"ygt","params":{"ModuleName":"xdt","toPage":toPage}};
//				require("external").callMessage(param);
				appUtils.pageInit("business/borrowIndex", "me/index");
			}else{
				var param = {
						"moduleName":"home",
						"params":{homeModuleName:"xdt"}
				};
				param["funcNo"] = "50101";
				require("external").callMessage(param);
			}
			
		},"touchend");
		/*个人中心*/
		appUtils.bindEvent($(_pageId+" #infoCenter"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" #infoCenter"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/borrowIndex", "account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		
		//选择产品
		appUtils.bindEvent($(_pageId+" .ha_navlist ul li"), function(e){
			if(utils.getUserInfoInSession() == null){
				layerUtils.iMsg(-1,"数据加载中，请稍候!");
				return false;
			}
			else{
				checkApitudeAndGrant("business/productIndex",$(this).attr("modeCode"),$(this).attr("modeName"));  // 检查是否开通资质和授信
			}
			e.stopPropagation();
		});
	}
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/**
	 * 检查是否开通资质和授信
	 * @param desPageCode 目标页面的 pageCode
	 */
	function checkApitudeAndGrant(desPageCode,modeCode,modeName)
	{
		var credit_money = userInfoInSession["credit_money"] == null? "" :userInfoInSession["credit_money"];
		var param = {
				modeCode: modeCode,
				modeName: modeName
		};
		appUtils.setSStorageInfo("mode_code",modeCode);
		appUtils.setSStorageInfo("mode_name",modeName);
		appUtils.pageInit("business/borrowIndex", desPageCode,param); 
	}
	
	/**
	 * app功能开关控制
	 * && 全能神奇显示信息
	 */
	function switchApp(){
		
		service.appSwitch({},function(data){
			
			getindexInfo();
			
			if(data.error_no == "0"){
				
				var results = data.results[0];
				
				var switchstr = results.app_switch;
				var indexinfo = JSON.parse(results.index_info);
				
				if(typeof switchstr == "string" && switchstr.length > 0){
					
					var str = switchstr.split(","); 
					
					for(var i = 0; i < str.length; i++){
						$(" ul li[modecode='"+str[i]+"']").hide();
					}
					
				}
				
				//填充页面信息
				var tablen = indexinfo.length;
				var tabtitlehtml = [];
				var tabdeschtml = [];
				for(var j = 0; j < tablen; j++){
					tabtitlehtml.push('<li><a href="javascript:void(0);">'+indexinfo[j].title+'</a></li>');
					tabdeschtml.push('<p style="display:none;">'+indexinfo[j].content+'</p>');
				}
				//title
				$(_pageId + " .ha_hmnew ul").html(tabtitlehtml.join(""));
				//desc
				$(_pageId + " .ha_hmnew .cont").html(tabdeschtml.join(""));
				
				//默认第一个 显示 
				$(_pageId + " .ha_hmnew ul li:eq(0)").addClass("active");
				$(_pageId + " .ha_hmnew .cont p:eq(0)").show();
				
				//绑定事件
				bindTabEvent();
			}else{
				layerUtils.iAlert(data.error_info);	
			}
			
		},{isLastReq:false});
		
	}
	
	//绑定选择 首页底部信息 tab事件
	function bindTabEvent(){
		appUtils.bindEvent(_pageId+" .ha_hmnew ul li",function(e){
			//全部去掉样式和隐藏
			$(_pageId+" .ha_hmnew ul li").removeClass("active");
			$(_pageId+" .ha_hmnew .cont p").hide();
			//给选中的添加
			$(this).addClass("active");
			$(_pageId+" .ha_hmnew .cont p").eq($(this).index()).show();
			e.stopPropagation();
		});
	}
	
	//获取首页显示的资金和统计次数信息
	function getindexInfo(){
		service.getindxInfo({},function(data){
			//重新获取授信额度//重新获取资质开通情况
			getUserLimit();
			
			if(data.error_no == 0){
				var results = data.results[0];
				var now_repay = results.now_repay;//now_repay 已借款金额
				var jjdq_repay = results.jjdq_repay;//jjdq_repay 即将到期还款金额
				var jjdq_num = results.jjdq_num;//jjdq_num  即将到期X笔
				var bczy_num = results.bczy_num;//bczy_num 补充质押
				var yjk_num = results.yjk_num;//yjk_num 已借款
				var yhk_num = results.yhk_num;//yhk_num 已还款
				$(_pageId + " .ha_topbox dl:eq(0) dd").text(formatNum.formatMoney(now_repay));
				$(_pageId + " .ha_topbox dl:eq(1) dd").text(formatNum.formatMoney(jjdq_repay));
				$(_pageId + " .ha_hmlist ul li:eq(0) b").text(jjdq_num);
				$(_pageId + " .ha_hmlist ul li:eq(1) b").text(bczy_num);
				$(_pageId + " .ha_hmlist ul li:eq(2) b").text(yjk_num);
				$(_pageId + " .ha_hmlist ul li:eq(3) b").text(yhk_num);
			}else{
				layerUtils.iAlert(data.error_info);
			}
		},{isLastReq:false});
	}
	
	//获取用户授信额度的相关信息
	function getUserLimit(user_id){
		var param = {
				"user_id":user_id
		};
		service.getUserlimit(param,function(data){
			if(data.error_no == 0){
				//把用户的信用额度存储到用户信息中
				appUtils.setSStorageInfo("_isLoginIn","true");
				utils.addDataToUserInfo("credit_money",data.results[0].credit_money);
				//获取开通资质情况
				//如果深圳和上海资质都是开通的 那么就不再查询了
				if(userInfoInSession.shzzIsopen != "Y" || userInfoInSession.szzzIsopen != "Y"){
					service.getzzIsopen("",function(data){
						if(data.error_no == 0){
							utils.addDataToUserInfo("shzzIsOpen",data.results[0].shzzIsopen);
							utils.addDataToUserInfo("szzzIsOpen",data.results[0].szzzIsopen);
						}else{
							layerUtils.iAlert(data.error_info);
						}
					});
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/*******     结束    ********************/
	/*向外暴露的 JSON 对象*/
	var borrowIndex = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = borrowIndex;
});