/**
 * 提前还款页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		pageInParam = null,
		_pageId = "#business_borrowProduct";
	
	/*页面初始化方法*/
	function init()
	{
		fillData(appUtils.getPageParam("borrowProduct"));
	}
	
	/*填充数据*/
	function fillData(data)
	{ 
		var appendHtml = "";
		appendHtml+="<div class='cont'>";
		appendHtml+="<p class='name'>借款天数</p>";
		appendHtml+="<p class='words'>年借款利率（%）</p>";
		appendHtml+="</div>";
		 for(var i=0;i<data.length;i++){
		 	appendHtml+="<div class='cont'>";
		 	appendHtml+="<p class='name'>"+data[i].loanperiod+"</p>";
		 	appendHtml+="<p class='words'>"+Number(data[i].repay_rate*100).toFixed(2)+"</p>";
		 	appendHtml+="</div>";
		 }
		 $(_pageId+" .FdetailCont").html(appendHtml);
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回首页*/
		appUtils.bindEvent($(_pageId+" .PubBtn"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
	}
	
	 
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*向外暴露的 JSON 对象*/
	var borrowProduct = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = borrowProduct;
});