/**
 * 借款记录页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		isCancelOrder="0",
		_status = ["处理中","申报处理中","申报处理中","交易成功","已放款","申报失败","购回处理中","购回处理中","购回处理中","成功","已还款","废单","违约处置"],//status 质押状态-1
		_pageId = "#business_borrowRecord";
		
	/*页面初始化方法*/
	function init()
	{
		$(_pageId+" section").height($(document).height()-80+'px').css("overflow","auto");
		queryBorrowRecord("0");  // 查询借款记录
		//设置默认的底部选择 0
		$(_pageId+" .sel_list ul li").removeClass("active");
		$(_pageId+" .sel_list ul li:eq(0)").addClass("active");
		userInfoInSession = utils.getUserInfoInSession();
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/borrowRecord", "account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
       /*隐藏下拉框*/
       appUtils.bindEvent($(_pageId), function(e){
                          $(_pageId+" .sel_list").hide();
                          e.stopPropagation();
                          });
		//订单期限
		appUtils.bindEvent($(_pageId+" .payBack_sel_input"), function(e){
			$(_pageId+" .sel_list").toggle();
			e.stopPropagation();
		});
		appUtils.bindEvent($(_pageId+" .sel_list ul li"), function(e){
			$(_pageId+" .sel_list ul li").removeClass("active");
			$(this).addClass("active");
			$(_pageId+" #showTime").text($(this).children("a").text());
			$(_pageId+" #showTime").attr("day",$(this).children("a").attr("credit-time"));
			queryBorrowRecord($(this).children("a").attr("credit-time"));
			$(_pageId+" .sel_list").hide();
			e.stopPropagation();
		});
	}
	
	
	/*查询借款记录*/
	function queryBorrowRecord(queryDay)
	{
		var userInfoInSession = utils.getUserInfoInSession(),
			queryBorrowRecordParam = {			
			page : "1",  // 页数
			size : "1000",  // 数据的条数
			user_id : userInfoInSession.user_id,// 账户密码
			"order_status":"1,2,3,4,5,6,8,9,11,12,13,14,15",
			day : queryDay
		};
		service.queryLoanInfo(queryBorrowRecordParam, function(data){
			if(data.error_no == "0")
			{
				if(data.results.length != 0)
				{
					fiilBorrowRecord(data.results[0].data);  // 填充借款记录
					if($(_pageId+" section .Repurchase .cont").length == 0)  // 没数据时显示无数据
					{
						
					}
					else
					{
//						BindRepayEvent(); // 绑定还款事件  lsx 6-15
					}
				}
				else
				{
					$(_pageId+" .no_data").show();  // 显示暂无数据
				}
			}
			else
			{
				layerUtils.iLoading(false);
				handleBorrowRecord();
			}
		},{"isLastReq":true,"isShowWait":true,"timeOutFunc":handleBorrowRecord});
	}
	
	/*绑定还款事件*/
	function BindRepayEvent()
	{
		//订单还款
		appUtils.bindEvent($(_pageId+" .Repurchase .cont a"), function(e){
			forbiddenBtnByDate(this);  // 根据日期禁用还款按钮
			e.stopPropagation();
		});
		
		//子订单还款
		appUtils.bindEvent($(_pageId+" .Repurchase .cont .smartbtn"), function(e){
			forbiddenBtnByDateSub(this);
			e.stopPropagation();
		});
	}
	
	
	/**
	 * 根据日期禁用还款按钮  子订单
	 * @param currDOM 当前记录的 DOM 对象
	 */
	function forbiddenBtnByDateSub(currDOM)
	{
		if($(currDOM).attr("flag")=='true'){
			pageInParam = {
					orderId : $(currDOM).parent().attr("order-id"),
					initMoney : $(currDOM).parent().attr("borrow-money"), //初始金额
					deadline :	$(currDOM).parent().attr("deadline"), // 当前期限
					contract_id : $(currDOM).parent().attr("contract_id")
				};
			var interest = $(currDOM).parent().attr("interest");
			
			switch($(currDOM).attr('id')){
				case 'is_ahead'://提前还款
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/aheadPage",pageInParam); // 跳到提前还款页面
					}, borrowMoney,interest);
					break;
				case 'is_immediate'://到期还款
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
				
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/immediateRepay",pageInParam); // 跳到马上还款页面
					}, borrowMoney,interest);
					break;
				case 'is_addPledge'://补充质押
					appUtils.pageInit("business/repayList", "business/addPledge",pageInParam); // 跳到延期还款页面
					break;
			}
		}else{
			return;
		}
	}
	
	/**
	 * 根据日期禁用还款按钮
	 * @param currDOM 当前记录的 DOM 对象
	 */
	function forbiddenBtnByDate(currDOM)
	{
		var currTime = new Date().getTime(),  // 当前时间
			creditTime = $(currDOM).next().find("p").eq(2).html(),  // 借款期限
			orderId = $(currDOM).attr("order-id"),
			borrowMoney = $(currDOM).attr("borrow-money"),
			deadline = $(currDOM).next().attr("deadline"),
			imsg = $(currDOM).attr("imsg"),
			interest = $(currDOM).attr("interest"),
			isshow = $(currDOM).attr("isshow"),
			yqi = $(currDOM).attr("yqi"),
			repay_type = $(currDOM).attr("repay_type"),
			subrepaydays = $(currDOM).attr("subrepaydays");
		
		if(isshow == "true"){
			//延期还款
			var div_delay = '<li id="delay" interest="'+interest+'" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" id="" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);" style="color: #fff;">延期</a></li>';
			//提前还款
			var div_ahead = '<li id="ahead" interest="'+interest+'" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);"><a href="javascript:void(0);"  style="color: #fff;">提前还款</a></li>';
			//到期还款
			var div_immediate = '<li id="immediate" interest="'+interest+'" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);"><a href="javascript:void(0);" style="color: #fff;">到期还款</a></li>';
			
			var div_repay_nav = '<div class="repay_nav2" style="padding:30px 10px;margin:0 40px"><ul>';
			
			var str = "";
			
			 if(yqi == 'true') 
			 {
				 str+=div_delay;
			 } 
			
			if(repay_type == 1) 
			{
				layerUtils.layerCustom(div_repay_nav+str+div_ahead+'</ul></div>',BindRepayBtn());
				
			}else if(repay_type == 0)
			{
				layerUtils.layerCustom(div_repay_nav+str+div_immediate+'</ul></div>',BindRepayBtn());
			}
			 BindRepayBtn();  // 绑定还款按钮
		}else{
			return;
		}
		
	}
	
	/*绑定还款按钮*/
	function BindRepayBtn()
	{
		/*点击页面隐藏按钮*/
		appUtils.bindEvent($(" .xubox_shade"), function(e){
			$(" .xubox_shade").remove();  // 隐藏还款的按钮
			$(" .xubox_layer").remove();
			e.stopPropagation();
		});
		appUtils.bindEvent($(" .xubox_layer"), function(e){
			$(" .xubox_shade").remove();  // 隐藏还款的按钮
			$(" .xubox_layer").remove();
			e.stopPropagation();
		});
		appUtils.bindEvent($(" .repay_nav2 ul li"), function(e){
			var eleId = $(this).attr("id");
			
			pageInParam = {
				orderId : $(this).attr("order-id"),
				initMoney :	$(this).attr("borrow-money"), //初始金额
				deadline :	$(this).attr("deadline") // 当前期限
			};
				var interest = $(this).attr("interest");
			switch(eleId)
			{
				case "delay" :
					appUtils.pageInit("business/repayList", "business/delayPage",pageInParam); // 跳到延期还款页面
					break;
				case "immediate" : 
					var orderId = pageInParam.orderId,
						borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/immediateRepay",pageInParam); // 跳到马上还款页面
					}, borrowMoney,interest);
					
					break;
				case "ahead" :
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/aheadPage",pageInParam); // 跳到提前还款页面
					}, borrowMoney,interest);
					
					break;
			}
			
			e.stopPropagation();
		});
		
	}
	
  	/*填充借款记录*/
  	function fiilBorrowRecord(results)
  	{
  		var allRepayStr = "";  // 所有股票的字符串
		for(var i = 0; i < results.length; i++)
		{
			var oneData = results[i],  // 一条数据
			stockList = JSON.parse(oneData.stockList),
			order_id = oneData.order_id,//用于查找 的ID
			order_no = oneData.order_no, //产品编号 用于还款的ID
			product_name = oneData.product_name,//借款期限
			create_time = oneData.create_date, //借款日期
			buyback_date2 = oneData.back_date,

			buyback_date = oneData.back_date,  // 还款日期
			repay_type = oneData.repayType, //判断 是否延期的  
//			contract_id = (typeof(oneData.order_id)=="undefined" || oneData.order_id == null)?'--':oneData.order_id,//合同号
//			pledge_money = oneData.borrow_amount,//还款金额shouldRepay
			contract_id = "--",
			pledge_money = 0,
			isRevoke = oneData.isRevoke,
			order_status = oneData.order_status,//
			is_delay = oneData.is_delay,
			
			interest = oneData.interest, //订单的利息
			
//			repay_date = oneData.repay_date;//实际到期时间
			
			subRepayDays = (oneData.subRepayDays == "")?"-  -":oneData.subRepayDays,//还有多少天到期
			
			imsg = "";//提示信息 不为空显示按钮
			
			/*
			 * order_status { 1, 7,8  } imsg
				
				!= 1, 7 ,8
				（is_delay = 2）  ? 延期申请中 ：每一个订单的apply_status=5（所有） 可以还款,显示按钮
			 */
			// 1  合约待报中...
			// 7  交易失败
			// 8 还款审核中...
			
			// 2 延期申请中...
			
			var flag = true
				theYes = 0;
			if(order_status == 1 || order_status == 7 || order_status == 8||order_status == 2 || order_status == 9){
				
				flag = false;
				switch(order_status){
				case "1":
					imsg = "（合约待报中...）";
					break;
				case "2":
					imsg = "（合约待报中...）";
					break;
				case "7":
					imsg = "（交易失败）";
					break;
				case "8":
					imsg = "（还款审核中...）";
					break;
				case "9":
					imsg = "撤单";
					break;
				}
			}else if(is_delay == 2){
				imsg = "（延期申请中...）";
				flag = false;
			}else{
				//all apply_status==5
				stockList ? stockList : {};
				if(stockList == null){
					flag = false;
				}else{
					for(var j = 0; j < stockList.length; j++){
						
						if(stockList[j].apply_status == 5 && stockList[j].status != 0 && stockList[j].status != 1 && stockList[j].order_type !=4){
							flag = true;
							theYes++;
						}
					}
				}
				
			}
			
			var yqi = (theYes>0 && theYes == stockList.length)?true:false;
			
			var imsg2 = "（可以还款）"
				color = "agreen";
			
			if(flag == false){
				imsg = "";
				color = "ared";
			}else if(imsg.length > 0){
				color = "ared";
			}
			
			allRepayStr += '<div class="cont"><a href="javascript:void(0);" class="'+color+'" style="font-size:10px" order-id="'+order_id+'" borrow-money="'
						+oneData.borrow_amount+'" subRepayDays="'+subRepayDays+'" imsg="'+imsg+'" isshow='+flag+' yqi="'+yqi+'" repay_type="'+repay_type+'" interest="'+interest+'">'
						+'借款单号：'+order_no+'</a>';
			
			if(stockList != null){
				for(var m = 0; m < stockList.length; m++){
					if(stockList[m].contract_id){
					contract_id = stockList[m].contract_id;
					pledge_money = stockList[m].pledge_money;
					apply_status = stockList[m].apply_status;
					interest = stockList[m].interest,
					repay_date = stockList[m].repay_date;//实际还款日期
					
					var order_status = stockList[m].order_status,
						status       = stockList[m].status,
						interest_rate = stockList[m].interest_rate,
						sub_type     = stockList[m].cashtypename,
						stock_subId  = stockList[m].sub_id,
						stock_isRevoke = stockList[m].isrevoke,
						order_type = stockList[m].order_type;
					
					/*
					 * 补充质押
					 * price_ratio <= warn_line && contract_id != null && price_ratio != 0
					 * 
					 * price_ratio == 0 说明已经补充质押过了
					 */
					var addPledgeflag = false;//是否补充质押
					
					var tobuyback_date = "";
					
					//是否可以补充质押
					/*is_delay != 2 
					status == 2 还款失败  == null 没有还款*/
					
					addPledgeflag = (is_delay != 2 && order_type != "4" && apply_status == "5"  && status != 0 && status != 1);
					
					var currTime = new Date().getTime(),// 当前时间
						show_ahead = false,//提前还款
						show_immediate = false;//到期还款
//					= 1 提前  = 0 正常 
					if(is_delay != 2){
						if(repay_type == 1) // 当前时间小于当前还款日期
						{
							//提前还款
							show_ahead = (apply_status=='5') && (status==null|| status=='null'||status=='' || status == 2);
							
						}else if(repay_type == 0)  // 当前时间等于当前还款日期
						{
							//到期还款
							show_immediate =  (apply_status=='5') && (status==null|| status=='null'||status=='' || status == 2);
						}else
						{
						}
					}
					 	
					 	tobuyback_date = "还有"+subRepayDays+"天";
						allRepayStr += '<div class="list" interest="'+interest+'" borrow-Money="'+pledge_money+'" deadline="'+((repay_date==null || typeof(repay_date)=='undefined')?buyback_date:repay_date)+'" order-id="'+order_id+'" contract_id="'+contract_id+'"><p>合同号：<f>'+((typeof(contract_id)=="undefined" || contract_id == null)?'--':contract_id)+'</f></p>'//合同号
						allRepayStr += '<p style="width:100%">借款日期：'+create_time+'</p>';//借款金额
						allRepayStr += '<p style="width:100%">借款类型：'+sub_type+'</p>';//融资类型
						allRepayStr += '<p>借款金额：'+formatNum.formatMoney(pledge_money)+'</p>';//借款金额
						allRepayStr	+= '<p>股票名称：'+stockList[m].stock_name+'</p>';//股票名称
						allRepayStr += '<p>质押数量：'+stockList[m].pledge_share+'</p>';//质押数量
						allRepayStr += '<p>还款日期：'+buyback_date+'</p>';
						allRepayStr += '<p>借款状态: '+((stockList[m].apply_status == 0 || stockList[m].apply_status=="null" || typeof(stockList[m].apply_status)=='undefined')?'':_status[stockList[m].apply_status-1])+'</p>';
						allRepayStr +='<p style="width:100%">到期还款预计利息：'+formatNum.formatMoney(stockList[m].interest)+'</p>';
						allRepayStr +='<p >今日还款预计利息：'+formatNum.formatMoney(stockList[m].current_date_interest)+'</p>';
						allRepayStr +='<p >借款利率：'+((interest_rate*100).toFixed(2)+"%")+'</p>';
						allRepayStr += '<p style="width:100%">实际还款日期：'+((repay_date==null || typeof(repay_date)=='undefined')?buyback_date:repay_date)+'</p>';
						allRepayStr += '<p style="width:100%">距离到期：'+tobuyback_date+'</p>';
						if(stock_isRevoke == 1){
						allRepayStr +='<p class="smartbtn"  order_id = "'+stock_subId+'"  parent_id = "'+order_id+'">撤销订单</p>';
						}
						allRepayStr += '<p></p>';
						allRepayStr += '</div>';//距离到期还有多X天
					}

				}
			}
			
			allRepayStr += '</div>';
		
		}
		
		if(allRepayStr != "" && typeof(allRepayStr) != "undefined"){
			$(_pageId+" .no_data").hide();
		}else{
			$(_pageId+" .no_data").show();
		}
		
		$(_pageId+" .Repurchase .conts").html(allRepayStr);  // 设置表头之后填充股票列表
		bindCancleBtn();  //绑定撤销订单。
  	}
  	 
  	 function bindCancleBtn(){	
  	 	//子订单还款
	 	appUtils.bindEvent($(_pageId+" .Repurchase .cont .smartbtn"),function(e){
	 		var sub_id = $(this).attr("order_id");
	 		var parent_id = $(this).attr("parent_id");
	 		layerUtils.iConfirm("是否撤销此订单？",function(){
		  				var param = {
		  	 				order_id:parent_id,
		  	 				sub_ids :sub_id
	 					}	
		  		  		 service.cancelOrder(param,function(data){
		  		  			if(data.error_no == "0"){
		  		  					layerUtils.iAlert("订单撤销成功");
		  		  					queryBorrowRecord($(_pageId+" #showTime").attr("day"));
		  		  			}
		  		  			
		  		  			else{
		  		  				layerUtils.iAlert(data.error_info);
		  		  			}
		  		  		 });
		  			});
	 	});
	 }
	/**
	 * 查询客户资产
	 * @param funcCallback 查询成功之后的回调函数
	 * @param currBorrMoney 当前订单的借款金额
	 */
	function queryCustAssets(funcCallback, currBorrMoney, interest)
	{
		var queryCustAssetsParam = {
				 "user_id" : userInfoInSession.user_id   // 客户 id
		};
		
		service.queryStockValue(queryCustAssetsParam, function(data){
			
			if(data.error_no == "0")
			{
				custAvailMoney = data.results[0].current_balance;  // 设置客户的可用余额
				
				if(Number(custAvailMoney) >= Number(currBorrMoney))
				{
					funcCallback ? funcCallback() : "";  // 回调函数不为空，执行回调函数，否则关闭等待层
				}
				else
				{
//					layerUtils.iMsg(-1, "账户可用余额不足，请进行转账操作！");
					pageInParam = {
							"currBorrMoney" : currBorrMoney,//借款金额
							"current_balance" : custAvailMoney,//账户余额
							"interest" : interest//利息
					}
					//跳转到repaymentInsufficient 保证金不足
					appUtils.pageInit("business/repayList", "business/repayInsufficientPage",pageInParam);
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
  	
  	/******** 重新加载 *************/
  	/*** 重新查询借款记录***/
	function handleBorrowRecord(){
		layerUtils.iAlert("数据加载失败，是否重新加载？",-1, function(){
			queryBorrowRecord();   
		});
	}
  	/********   开始   ************/
  	
  	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" #showTime").text("今日");
		$(_pageId+" .sel_list ul li").removeClass("active");
		$(_pageId+" .sel_list ul li:eq(0)").addClass("active");
		$(_pageId+" .no_data").hide();  // 隐藏暂无数据
		$(_pageId+" .sel_list").hide();
	}
	
	/*向外暴露的 JSON 对象*/
	var borrowRecord = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = borrowRecord;
});