/**
 * 借款确认页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		_pageId = "#business_borrowSucc";
	
	/*页面初始化方法*/
	function init()
	{
		showInfoByInParam();  // 根据入参显示页面信息
		userInfoInSession = utils.getUserInfoInSession();
		$(_pageId+" section").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		$(_pageId+" #telphone").text(userInfoInSession.mobile);
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/borrowSucc","business/borrowIndex");
			e.stopPropagation();
		},"touchend");		
		/*继续借款*/
		appUtils.bindEvent($(_pageId+" .btnLeft"), function(e){
			appUtils.pageInit("business/borrowSucc", "business/borrowIndex");
			e.stopPropagation();
		});
		
		/*借款记录查询*/
		appUtils.bindEvent($(_pageId+" #borrowRecord"), function(e){
			appUtils.pageInit("business/borrowSucc", "business/borrowRecord");
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" .error").remove();
	}
	
	/*根据入参显示页面信息*/
	function showInfoByInParam()
	{
		var pageInParam = appUtils.getPageParam(),
			creditQuantity = pageInParam.loan_money + "元",
			tradeDeadline = pageInParam.loan_day,
			interestRate = pageInParam.loan_rate,
			interest = pageInParam.interest,  // 利息
			interest_rate = (Number(pageInParam.interest_rate)*100).toFixed(2),//借款利率
			end_date = pageInParam.end_date,//还款日期
			error_info = pageInParam.error_list,
			order_no = appUtils.getSStorageInfo("borrowSusscess_order_no"),
			accountNo = utils.getUserInfoInSession().accountNo;
		if(tradeDeadline != "随借随还")
		{
			interestRate = interestRate*100;
			tradeDeadline += "天";
			interestRate += "%";
			interest += "元";
		}
		else  // 随借随还
		{
			if(interestRate<1){
				interest = "--";
			}
			else{
				interest = "--";
				interestRate += "%";
			}
			
		}
		if(error_info != "[]"){
			var showErrorInfo = JSON.parse(error_info);
			var appendHtml = "";
			for(var i=0;i<showErrorInfo.length;i++){
				appendHtml+="<div class='cont error' style='word-wrap: break-word;word-break: break-all;'>";
				appendHtml+="<p class='name'>失败信息"+(i+1)+"</p>";
				appendHtml+="<p class='words' style='text-align:left'>股票名称："+showErrorInfo[i].stock_name+"("+showErrorInfo[i].stock_code+")</br>错误信息："+showErrorInfo[i].error_info+"</p>";
				appendHtml+="</div>";
			}
			$(_pageId+" .FdetailCont").append(appendHtml);
		}
		else{
			$(_pageId+" .error").remove();
		}
		var repayMoney = Number(Number(pageInParam.loan_money)+Number(pageInParam.interest)).toFixed(2)+"元";
		$(_pageId+" #orderNo").html(order_no);   // 账号
		$(_pageId+" #applyDate").html(new Date().format("yyyy/MM/dd"));  // 申请日期
		$(_pageId+" #creditQuantity").html(creditQuantity);  // 借款金额
		$(_pageId+" #tradeDeadline").html(tradeDeadline);   // 交易期限
		$(_pageId+" #interestRate").html(interestRate);   // 利率
		$(_pageId+" #interest").html(interest);   // 利息
		$(_pageId+" #interest_rate").html(interest_rate+"%");//借款利率
		$(_pageId+" #end_date").html(end_date);//还款日期
		$(_pageId+" #repayMoney").html(repayMoney);//还款日期
		
	}
	
	/*向外暴露的 JSON 对象*/
	var borrowSucc = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = borrowSucc;
});