/**
 * 延期还款页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		formatNum = require("formatNum"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		pageInParam = null,
		orderId = null, 
		_pageId = "#business_delayPage";
	var isDelay = true;
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		queryOrderInfo();    // 查询订单信息
		orderId = appUtils.getPageParam("orderId"); // 获取订单Id
		$(_pageId+" section").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		isDelay = true;
	}

	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*点击页面其他地方隐藏转账方式列表*/
		appUtils.bindEvent($(_pageId), function(e){
			$(_pageId+" .sel_list1").slideUp("fast");  // 隐藏转账方式列表
			e.stopPropagation();
		}); 
		
		/*选择时间*/
		appUtils.bindEvent($(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words input"), function(e){
			if(!isDelay){
				layerUtils.iMsg("-1","订单期限已最长，无法延期");
			}else{
				$(_pageId+" .Fdetail .sel_list1").slideToggle(200);  // 显示转账方式列表
				
				e.stopPropagation();
			}
			
		});
		
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		
//		/*返回*/
//		appUtils.bindEvent($(_pageId+" .icon_back2"), function(e){
//			appUtils.pageBack();
//			e.stopPropagation();
//		});
		
		/*绑定确定*/
		appUtils.bindEvent($(_pageId+" .Fdetail .PubBtn a"), function(e){
			var isSel = $(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words input").attr("placeholder");
			if(isSel =="请选择期限")
			{
				layerUtils.iMsg(-1, "请先选择延期期限");
			}
			else
			{
				delayRepay();
			}
			e.stopPropagation();
		});
	}
	
	/*查询订单信息*/
 	function queryOrderInfo()
 	{
 		var queryOrderInfoParam = {
 				page : "1",  // 页数	
				size : "1",  // 数据的条数
				user_id : userInfoInSession.user_id,  // 账户密码
 				order_id :appUtils.getPageParam("orderId") // 订单 id
		};
		
		service.queryLoanInfo(queryOrderInfoParam, function(data){
			if(data.error_no == "0")
			{
				var results = data.results[0].data,
					parent_order_id = results[0].order_no, // 订单
					pledge_money = results[0].borrow_amount, // 填充初始金额
					product_name = results[0].product_name, // 借款期限
					back_date = results[0].back_date,//延期时间
					interest_rate = results[0].interest_rate, // 利率
					
					poundage = results[0].interest, // 利息
					nows = results[0].product_name.slice(0, -1), // 当前天数
					//还款日期 
					rental =pledge_money ; // 总额
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(0) .words").text(parent_order_id);  
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(1) .words").text(formatNum.formatMoney(pledge_money)+'元');	
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(2) .words").text(product_name+'期'); 	
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(4) .words").text(interest_rate*100+'%'); 	
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(5) .words").text(formatNum.formatMoney(poundage)+'元'); 
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(6) .words").text(back_date); 
				
//				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(7) .words i").text(formatNum.formatMoney(rental)+'元');
				queryCreditTimeList(); // 填充期限列表
			}
			else
			{
				layerUtils.iLoading(false);	
				layerUtils.iAlert(data.error_info);	
			}
		}, {"isLastReq":false});
		
 	}
	
	/*绑定选择时间*/
	function BindSelDate()
	{
		appUtils.bindEvent($(_pageId+" .Fdetail .sel_list1 li"), function(e){
			var typeName = $(this).children("a").text(),   // 类型名
				creditTime = $(this).children("a").attr("days"),  // 期限
				creditRate = $(this).children("a").attr("credit-rate");   // 利率
			$(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words input").attr("placeholder", typeName);
			$(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words").attr("credit-time", creditTime);  //期限
			$(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words").attr("credit-rate", creditRate);  // 利率
			$(_pageId+" .Fdetail .sel_list1").slideUp(200);  // 隐藏贷款期限下拉列表   利息=((天数/365)*利率*(金额+费用))/1002
			
			var param = {
					days : creditTime,
					date : $(_pageId+" section .Fdetail .FdetailCont .cont:eq(6) .words").text()
			}
			
			//设置时间 610013接口
			service.queryBorrowDate(param,function(data){
				if(data.error_no == "0")
				{
					var trade_date = data.results[0].trade_date;
					$(_pageId+" section .Fdetail .FdetailCont .cont:eq(6) .words").text(trade_date); 
				}else{
					layerUtils.iLoading(false);	
					layerUtils.iAlert(data.error_info);	
				}
				
			});
			
			e.stopPropagation();
		});
	}
	
	/**
	 * 延期还款
	 * @param bro_order_id 订单 id
	 * @parma client_id 客户 id
	 * @parma yqhkqx 延期期限
	 */
	function delayRepay()
	{
		
//		var pwd = userInfoInSession["password"];
		
		var pwd = appUtils.getSStorageInfo("password");
		
		var delayRepayParam = {
				"pwd" : pwd,
				order_id : orderId,
//				"order_id"   : $(_pageId+" section .Fdetail .FdetailCont .cont:eq(0) .words").text(), // 订单Id
				"user_id"    : userInfoInSession.user_id, // 客户ID
				"delay_days"  : $(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words").attr("credit-time"), // 延期期限  
				"delay_rate" : $(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words").attr("credit-rate")
		};
		
		service.delayRepay(delayRepayParam, function(data){
			if(data.error_no == "0")
			{
				layerUtils.iAlert("延期申请成功", 0, function(){
					appUtils.pageInit("business/delayPage", "business/repayList");
				});
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*查询延期期限列表*/
	function queryCreditTimeList()
	{
		service.queryCreditTimeList({}, function(data){
			if(data.error_no == "0")
			{
				fillCreditTimeList(data.results);  // 填充延期时间列表
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/*填充延期时间列表*/
	function fillCreditTimeList(results)
	{
		var allCreditTimeStr = ""  // 所有填充时间字符串
			deadline = ($(_pageId+" section .Fdetail .FdetailCont .cont:eq(2) .words").text()).replace(/[^0-9]/ig, ""); // 获取当前时间
		for(var i = 0; i < results.length; i++)
		{
			var creditRate = results[i].repay_rate, // 借款利率
			days = results[i].days;  //借款天数
			creditTime = results[i].loanperiod;  // 借款期限
			var a = "";
			if(creditTime == "随借随还"){
				continue;
				a = creditTime+"（日息"+creditRate*100+"%）";
			}
			else{
			    a = creditTime+"（年借款利息"+creditRate*100+"%）";
			}
			if(Number(deadline)+Number(days) < 365)
			{
				allCreditTimeStr += '<li><a href="javascript:void(0);" credit-time="'+creditTime+'" credit-rate="'+creditRate+'"  days="'+days+'"  >'+a+'</a></li>';
//				isDelay = false;//判断是否可以延期。
			}
		}
		$(_pageId+" .Fdetail .sel_list1 ul").html(allCreditTimeStr);
		
		if($(_pageId+" .Fdetail .sel_list1 ul li").length <= 0){
			isDelay = false;//判断是否可以延期。
		}
		
		$(_pageId+" .Fdetail .sel_list1 ul li a[credit-time='随借随还']").html("随借随还");  // 去掉随借随还的天字
		BindSelDate(); // 绑定选择贷款期限
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words input").attr("placeholder", "请选择期限").removeAttr("credit-time").attr("credit-rate");
	}
	
	/*向外暴露的 JSON 对象*/
	var delayPage = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = delayPage;
});