/**
 * 到期还款页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		formatNum = require("formatNum"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		pageInParam = null,
		orderId = null, 
		sublist = [],
		contract_ids = "",
		_pageId = "#business_immediateRepay";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		orderId = appUtils.getPageParam("orderId"); // 获取订单Id
		$(_pageId+" section").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		fillMoney();
		queryTiQianHK();
		var contract_id = appUtils.getPageParam("contract_id");
		if(typeof(contract_id) != "undefined" && contract_id != "null" && contract_id != ""){
			var a = {
					"subid":contract_id
			}
			sublist.push(a);
		}
	}
	
	/*填充*/
	function fillMoney()
	{ 
		var queryOrderInfoParam = {
 				page : "1",  // 页数	
				size : "1",  // 数据的条数
				user_id : userInfoInSession.user_id,  // 账户密码
 				order_id : orderId // 订单 id
		};
		
		service.queryLoanInfo(queryOrderInfoParam, function(data){
			if(data.error_no == "0")
			{
				var results = data.results[0].data,
					parent_order_id = results[0].order_no, // 订单
					create_date = results[0].create_date;//借款申请日期
					pledge_money = results[0].borrow_amount, // 填充初始金额
					money_date = results[0].money_date,//借款日期
					product_name = results[0].product_name, // 借款期限
					back_date = results[0].back_date,//延期时间
					interest_rate = results[0].interest_rate, // 利息
					poundage = results[0].interest, // 利息
					nows = results[0].product_name.slice(0, -1), // 当前天数
					//还款日期 
					rental =results[0].borrow_amount, // 总额
					stockList = JSON.parse(results[0].stockList); //交易费用
					
					if(stockList != null && sublist.length == 0){
						for(var i = 0; i < stockList.length; i++){
							if(stockList[i].contract_id != null){
								var subid = {
										"subid":stockList[i].contract_id
								}
								contract_ids += stockList[i].contract_id+","
								sublist.push(subid);
							}
						}
					}
					
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(0) .words").text(parent_order_id);  
//				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(1) .words").text(formatNum.formatMoney(pledge_money)+'元');	
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(2) .words").text(product_name); 	
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(3) .words").text(interest_rate*100+'%'); 	
//				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(4) .words").text(formatNum.formatMoney(poundage)+'元');
//				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(5) .words i").text(formatNum.formatMoney(rental*1.004)+'元');
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(6) .words").text(new Date().format("yyyy-MM-dd")); 
//				queryCreditTimeList(); // 填充期限列表
				layerUtils.iLoading(false);	
			}
			else
			{
				layerUtils.iLoading(false);	
				layerUtils.iAlert(data.error_info);	
			}
		}, {"isLastReq":false});
	}
	
	/*查询*/
	function queryTiQianHK(){
		var queryOrderInfoParam = {
 				order_id : orderId, // 订单 id
 				contract_ids : contract_ids
		};
		
		
		service.getTiQianHK(queryOrderInfoParam, function(data){
			if(data.error_no == "0")
			{
				var oneData = data.results;
				totalMoney = oneData[0].totalMoney;
				borrow_amount = oneData[0].borrow_amount;
				repay_interest = oneData[0].repay_interest;
				//借款金额
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(1) .words").text(formatNum.formatMoney(borrow_amount)+'元');
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(4) .words").text(formatNum.formatMoney(repay_interest)+'元');
				$(_pageId+" section .Fdetail .FdetailCont .cont:eq(5) .words i").text(formatNum.formatMoney(totalMoney*1.004)+'元');
				layerUtils.iLoading(false);	
			}
			else
			{
				layerUtils.iLoading(false);	
				layerUtils.iAlert(data.error_info);	
			}
		}, {"isLastReq":false});
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		
		/*绑定确定*/
		appUtils.bindEvent($(_pageId+" .Fdetail .PubBtn"), function(e){
			subRepay(orderId); // 确定还款
			e.stopPropagation();
		});
	}
	
	/**
	 * 提交还款数据
	 * @param orderId 订单 id
	 * @parma client_id 客户 id
	 */
	function subRepay(orderId)
	{
		var subRepayParam = {
//				order_id : $(_pageId+" section .Fdetail .FdetailCont .cont:eq(0) .words").text(),
				order_id : orderId,
				user_id : userInfoInSession.user_id,
				sublist : sublist
		};
		service.repayLoan(subRepayParam, function(data){
			if(data.error_no == "0")
			{
				layerUtils.iAlert("还款成功！", 0, function(){
					appUtils.pageInit("business/immediateRepay", "business/repayList");
				});
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/**
	 * 格式化时间
	 * 
	 * alert(new Date().Format("yyyy年MM月dd日")); 
		alert(new Date().Format("MM/dd/yyyy")); 
		alert(new Date().Format("yyyyMMdd")); 
		alert(new Date().Format("yyyy-MM-dd hh:mm:ss"));
	 */
	Date.prototype.format = function(format){ 
		var o = { 
			"M+" : this.getMonth()+1, //month 
			"d+" : this.getDate(), //day 
			"h+" : this.getHours(), //hour 
			"m+" : this.getMinutes(), //minute 
			"s+" : this.getSeconds(), //second 
			"q+" : Math.floor((this.getMonth()+3)/3), //quarter 
			"S" : this.getMilliseconds() //millisecond 
		}

		if(/(y+)/.test(format)) { 
			format = format.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length)); 
		}

		for(var k in o) { 
			if(new RegExp("("+ k +")").test(format)) { 
				format = format.replace(RegExp.$1, RegExp.$1.length==1 ? o[k] : ("00"+ o[k]).substr((""+ o[k]).length)); 
			} 
		} 
		return format; 
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*向外暴露的 JSON 对象*/
	var immediateRepay = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = immediateRepay;
});