/**
 * 我的持仓，
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		custAvailMoney = 0,  // 客户的可用资产
		_pageId = "#business_myHoldingStock";
		var pageInParam = "";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		pageInParam = appUtils.getPageParam();
		HoldingStockOnTimeList();  //加载信息
		$(_pageId+" section").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		appUtils.bindEvent($(_pageId+"  .home"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+"  .home"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("account/limitManage","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
	}
	
	/*查询合约信息*/
	function HoldingStockOnTimeList()
	{
		var HoldingStockOnTimeListParam = {
				page : "1",  // 页数
				size : "1000",  // 数据的条数
				user_id : userInfoInSession.user_id // 账户密码
		};
		
		service.queryHoldingStock(HoldingStockOnTimeListParam, function(data){
			if(data.error_no == "0")
			{
				service.queryStockValue({user_id:userInfoInSession.user_id},function(data2){
					if(data2.error_no == "0"){
						
						var result = data2.results[0];
						
						$(_pageId + " #assert_val").html(result.assert_val);
						$(_pageId + " #current_balance").html(result.current_balance);
						$(_pageId + " #enable_balance").html(result.enable_balance);
						$(_pageId + " #mkt_val").html(result.market_val);
						$(_pageId + " #fetch_balance").html(result.fetch_balance);
						
					}else{
						layerUtils.iAlert(data2.error_info);	
					}
				});
				fillHoldingStockList(data.results);  // 
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
 	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" .conts").html("");
		$(_pageId+" .no_data").hide();  // 隐藏暂无数据
		
	}
	
	/**
	 * 比较日期，精确到 天
	 * @param date1 待比较的日期1，毫秒值
	 * @param date2 待比较的日期2，毫秒值
	 * @return 1 date1 比 date2 大，0 相等，-1 小
	 */
	function compareDate(date1, date2)
	{
		var compareResult = 1,  // 比较结果
			date1 = new Date(date1),
			date1Year = date1.getFullYear(),
			date1Month = date1.getMonth(),
			date1Date = date1.getDate(),
			date2 = new Date(date2),
			date2Year = date2.getFullYear(),
			date2Month = date2.getMonth(),
			date2Date = date2.getDate();
		if(date1Year > date2Year)
		{
			compareResult = 1;
		}
		else if(date1Year < date2Year)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month > date2Month)
		{
			compareResult = 1;
		}
		else if(date1Year == date2Year && date1Month < date2Month)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date > date2Date)
		{
			compareResult = 1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date < date2Date)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date == date2Date)
		{
			compareResult = 0;
		}
		return compareResult;
	}
	
	/**
	 * 填充还款列表
	 * @param results 查询出来的股票结果集
	 */
	function fillHoldingStockList(results)
	{
		var allRepayStr = "";  // 所有股票的字符串
		for(var i = 0; i < results.length; i++)
		{
			var oneData = results[i],  // 一条数据
				stock_code = oneData.stock_code,//证券代码
				stock_name = oneData.stock_name,//证券简称
				current_amount = Number(oneData.current_amount).toFixed(2),//证券数量	（股）
				enable_amount = oneData.enable_amount,//可质押数量 （股）
				y_amount = current_amount-enable_amount,//已质押数量（股）
				last_price = (Number(oneData.last_price)=="NaN")?0:Number(oneData.last_price),//昨收盘（元）
				market_value = (Number(oneData.market_value)=="NaN")?0:Number(oneData.market_value),//证券市值（元）
				coefficient = oneData.coefficient,//质押率
				exchange_type = oneData.exchange_type,//股票市场
				amount_money = Number(enable_amount * last_price * coefficient);//可借金额 （元）
			
			allRepayStr += '<div class="cont"><div class="list">'
						+ '<p style="width:50%;">证券代码：</p><p>'+stock_code+'</p>'
						+ '<p>证券简称：</p><p>'+stock_name+'</p>'
						+ '<p>证券数量（股）：</p><p>'+current_amount+'</p>'
						+ '<p>可质押数量（股）：</p><p>'+((exchange_type == "0" || exchange_type == "2")?enable_amount:0)+'</p>'
						+ '<p>已质押数量（股）：</p><p>'+y_amount+'</p>'
						+ '<p>昨收盘（元）：</p><p>'+formatNum.formatMoney(last_price)+'</p>'
						+ '</div></div>';
		}
		
		if(allRepayStr != "" && typeof(allRepayStr) != "undefined"){
			$(_pageId+" .no_data").hide();
		}else{
			$(_pageId+" .no_data").show();
		}
		$(_pageId+" .Repurchase .conts").html(allRepayStr);  // 设置表头之后填充股票列表
	}
	
	/*向外暴露的 JSON 对象*/
	var myHoldingStock = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = myHoldingStock;
});