/**
 * 个人中心页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		custAvailMoney = 0,  // 客户的可用资产
		_pageId = "#business_needRepay";
		var pageInParam = "";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		fillRepayList(data.results[0].data);  // 填充到期还款列表
		$(_pageId+" .FQuery .conts").height($(document).height()-$(_pageId+" header").height()-$(_pageId+" .FQuery .hd").height()-18+'px').css("overflow","auto");
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		
		/*返回上一页*/
		appUtils.bindEvent($(_pageId+" .bot_nav2>.icon_back2"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		
		/*个人中心pz 2014.09.23*/
		appUtils.bindEvent($(_pageId+" .home"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" .home"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/repayList", "account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" .conts").html("");
		$(_pageId+" .no_data").hide();  // 隐藏暂无数据
		
	}
	
	/*到期还款*/
	function repayOnTimeList()
	{
		var repayOnTimeListParam = {
				page : "1",  // 页数
				size : "1000",  // 数据的条数
				user_id : userInfoInSession.user_id, // 账户密码
				isRepay : "1" //需要还款的
		};
		service.queryLoanInfo(repayOnTimeListParam, function(data){
			if(data.error_no == "0")
			{
				
				if($(_pageId+" section .FQuery .conts h6:eq(0)").length == 0)  // 没数据时显示无数据
				{
					
				}
				else
				{
					BindRepayEvent(); // 绑定还款事件  lsx 6-15
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
 	}
	
	/*提前还款*/
	function repayAheadList()
	{
		var repayAheadListParam = {
				page : "1",  // 页数
				size : "1000",  // 数据的条数
				inputid : userInfoInSession.user_id  // 账户密码
		};
		
		service.repayAheadList(repayAheadListParam, function(data){
			if(data.error_no == "0")
			{
				fillRepayList(data.results);  // 填充到期还款列表
				repayDelayList();  // 延期还款
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);	
			}
		}, {"isLastReq":false});
	}
	
//	/*延期还款*/
//	function repayDelayList()
//	{
//		var repayDelayListParam = {
//				page : "1",  // 页数
//				size : "1000",  // 数据的条数
//				inputid : userInfoInSession.custid,  // 账户密码
//				isRepay: "1"
//		};
//		service.repayDelayList(repayDelayListParam, function(data){
//			if(data.error_no == "0")
//			{
//				fillRepayList(data.results);  // 填充到期还款列表
//				if($(_pageId+" #repayList tr:gt(0)").length == 0)  // 没数据时显示无数据
//				{
//					$(_pageId+" .no_data").show();  // 显示暂无数据
//				}
//				else
//				{
//					BindRepayEvent();   // 绑定还款事件
//				}
//			}
//			else
//			{
//				layerUtils.iAlert(data.error_info);	
//			}
//		});
//	}
	
	/*绑定还款事件*/
	function BindRepayEvent()
	{
		appUtils.bindEvent($(_pageId+" section .FQuery .conts h6"), function(e){
			forbiddenBtnByDate(this);  // 根据日期禁用还款按钮
			e.stopPropagation();
		});
	}
	
	/**
	 * 根据日期禁用还款按钮
	 * @param currDOM 当前记录的 DOM 对象
	 */
	function forbiddenBtnByDate(currDOM)
	{
		var h_time = $(currDOM).next().find("span").eq(4).html(); // 20140922
		var currTime = new Date().getTime(),  // 当前时间
			currRepayDate = Date.parse(h_time.substring(0,4)+"/"+h_time.substring(4,6)+"/"+h_time.substring(6,8)),  // 当前还款日期
			creditTime = $(currDOM).next().find("span").eq(2).html(),  // 借款期限
			orderId = $(currDOM).attr("order-id"),
			borrowMoney = $(currDOM).attr("borrow-money"),
			deadline = $(currDOM).attr("deadline"),
			imsg = $(currDOM).attr("imsg"),
			isshow = $(currDOM).attr("isshow");
		
		if((typeof(imsg)=="undefined"||imsg==="") && isshow == "true"){
			//延期还款
			var div_delay = '<li id="delay" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" id="" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);" style="color: #fff;">延期还款</a></li>';
			//提前还款
			var div_ahead = '<li id="ahead" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);"><a href="javascript:void(0);"  style="color: #fff;">提前还款</a></li>';
			//到期还款
			var div_immediate = '<li id="immediate" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);"><a href="javascript:void(0);" style="color: #fff;">到期还款</a></li>';
			
			var div_repay_nav = '<div class="repay_nav2" style="padding:30px 10px;margin:0 40px"><ul>';
			
			 if(compareDate(currTime, currRepayDate) == 1)  // 当前时间大于当前还款日期
			{
				 layerUtils.layerCustom(div_repay_nav+div_delay+div_immediate+'</ul></div>',BindRepayBtn());
			}
			else if(compareDate(currTime, currRepayDate) == -1) // 当前时间小于当前还款日期
			{
				layerUtils.layerCustom(div_repay_nav+div_delay+div_ahead+'</ul></div>',BindRepayBtn());
			}
			else if(compareDate(currTime, currRepayDate) == 0)  // 当前时间等于当前还款日期
			{
				layerUtils.layerCustom(div_repay_nav+div_delay+div_immediate+'</ul></div>',BindRepayBtn());
			}
			
//			if(is_delay == 2){
//				layerUtils.layerCustom(div_delay+div_immediate);
////				$(_pageId+" .repay_nav #delay").attr("forbidden", "true").children().css("background-color", "#B4B0A5");  // 禁用延期还款
//			}
			 
			 BindRepayBtn();  // 绑定还款按钮
		}else{
//			if(!(typeof(imsg)=="undefined"||imsg==="")){
//				layerUtils.iMsg(-1,imsg,2);
//			}
			return;
		}
		
	}
	
	/**
	 * 比较日期，精确到 天
	 * @param date1 待比较的日期1，毫秒值
	 * @param date2 待比较的日期2，毫秒值
	 * @return 1 date1 比 date2 大，0 相等，-1 小
	 */
	function compareDate(date1, date2)
	{
		var compareResult = 1,  // 比较结果
			date1 = new Date(date1),
			date1Year = date1.getFullYear(),
			date1Month = date1.getMonth(),
			date1Date = date1.getDate(),
			date2 = new Date(date2),
			date2Year = date2.getFullYear(),
			date2Month = date2.getMonth(),
			date2Date = date2.getDate();
		if(date1Year > date2Year)
		{
			compareResult = 1;
		}
		else if(date1Year < date2Year)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month > date2Month)
		{
			compareResult = 1;
		}
		else if(date1Year == date2Year && date1Month < date2Month)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date > date2Date)
		{
			compareResult = 1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date < date2Date)
		{
			compareResult = -1;
		}
		else if(date1Year == date2Year && date1Month == date2Month && date1Date == date2Date)
		{
			compareResult = 0;
		}
		return compareResult;
	}
	
	/*绑定还款按钮*/
	function BindRepayBtn()
	{
		/*点击页面隐藏按钮*/
		appUtils.bindEvent($(" .xubox_shade"), function(e){
			$(" .xubox_shade").remove();  // 隐藏还款的按钮
			$(" .xubox_layer").remove();
			e.stopPropagation();
		});
		appUtils.bindEvent($(" .xubox_layer"), function(e){
			$(" .xubox_shade").remove();  // 隐藏还款的按钮
			$(" .xubox_layer").remove();
			e.stopPropagation();
		});
		appUtils.bindEvent($(" .repay_nav2 ul li"), function(e){
			var eleId = $(this).attr("id");
				pageInParam = {
				orderId : $(this).attr("order-id"),
				initMoney :	$(this).attr("borrow-money"), //初始金额
				deadline :	$(this).attr("deadline") // 当前期限
				};
				
			switch(eleId)
			{
				case "delay" :
					appUtils.pageInit("business/repayList", "business/delayPage",pageInParam); // 跳到延期还款页面
					break;
				case "immediate" : 
					var orderId = pageInParam.orderId,
						borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/immediateRepay",pageInParam); // 跳到马上还款页面
					}, borrowMoney);
					
					break;
				case "ahead" :
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/aheadPage",pageInParam); // 跳到提前还款页面
					}, borrowMoney);
					
					break;
			}
			
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 提交还款数据
	 * @param orderId 订单 id
	 */
	function subRepayData(orderId)
	{
		var subRepayDataParam = {
				order_id : orderId,
				user_id : userInfoInSession.user_id
		};
		service.repayLoan(subRepayDataParam, function(data){
			if(data.error_no == "0")
			{
				layerUtils.iAlert("还款成功！", 0, function(){
					repayOnTimeList();  // 到期还款
				});
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*延期还款*/
	function delayRepay(param)
	{
		var order_id = param.orderId;
		var delayParam = {
				"is_delay":2,
				"user_id":userInfoInSession.user_id,
				"order_id":order_id
		};
		service.delayRepay(delayParam,function(data){
			if(data.error_no == 0){
				layerUtils.iMsg(-1,"订单延期申请成功");
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/**
	 * 填充还款列表
	 * @param results 查询出来的股票结果集
	 * fc 2014.09.22
	 */
	function fillRepayList(results)
	{
		
		var allRepayStr = "";  // 所有股票的字符串
		for(var i = 0; i < results.length; i++)
		{
			var oneData = results[i],  // 一条数据
			stockList = JSON.parse(oneData.stockList),
			order_id = oneData.order_id,//用于查找 的ID
			order_no = oneData.order_no, //产品编号 用于还款的ID
			product_name = oneData.product_name,//借款期限
			create_time = oneData.create_date.split(" ")[0].replaceAll("-",""), //借款日期
			buyback_date = oneData.back_date.split(" ")[0].replaceAll("-",""),  // 还款日期
//			contract_id = (typeof(oneData.order_id)=="undefined" || oneData.order_id == null)?'--':oneData.order_id,//协议编号
//			pledge_money = oneData.borrow_amount,//还款金额shouldRepay
			contract_id = "--",
			pledge_money = 0,
			order_status = oneData.order_status,//
			isdealy = oneData.isdealy,
			imsg = "";//提示信息 不为空显示按钮
			
			/*
			 * order_status { 1, 7,8  } imsg
				
				!= 1, 7 ,8
				（isdealy = 2）  ? 延期申请中 ：每一个订单的apply_status=5（所有） 可以还款,显示按钮
			 */
			// 1  合约待报中...
			// 7  交易失败
			// 8 还款审核中...
			
			// 2 延期申请中...
			
			var flag = true;
			if(order_status == 1 || order_status == 7 || order_status == 8){
				switch(order_status){
				case "1":
					imsg = "合约待报中...";
					break;
				case "7":
					imsg = "交易失败";
					break;
				case "8":
					imsg = "还款审核中...";
					break;
				}
			}else if(isdealy == 2){
				imsg = "延期申请中...";
			}else{
				//all apply_status==5
				stockList ? stockList : {};
				for(var j = 0; j < stockList.length; j++){
					if(stockList[j].apply_status != 5){
						flag = false;
						break;
					}
				}
			}
			
			var imsg2 = "可以还款"
				color = "agreen";
			
			if((imsg == "" || typeof(imsg) == "undefined") && flag == false){
				imsg = "订单异常";
				color = "ared";
			}else if(imsg.length > 0){
				color = "ared";
			}
			//+'<a href="javascript:void();" class="'+color+'">'+(flag==true && imsg.length == 0)?imsg2:imsg+'</a>
			allRepayStr += '<h6 order-id="'+order_id+'" borrow-money="'
						+oneData.borrow_amount+'" deadline="'
						+oneData.borrow_end_day+'" imsg="'+imsg+'" isshow='+flag+'>'
						+order_no+'<a href="javascript:void(0);" class="'+color+'" style="font-size:10px">('+((flag && imsg == "")?imsg2:imsg)+')</a></h6><div class="cont">';
			
			/**
			 * <p>协议编号</p>   stockList[j].contract_id 
				<p>质押金额</p>  stockList[j].pledge_money
				<p>股票名称</p>  stockList[j].stock_name
				<p>质押数量</p>  stockList[j].pledge_share
				<p>还款日期</p>  buyback_date
			 */
			if(stockList != null){
				for(var m = 0; m < stockList.length; m++){
					
					contract_id = stockList[m].contract_id;
					pledge_money = stockList[m].pledge_money;
						allRepayStr += '<span>'+((typeof(contract_id)=="undefined" || contract_id == null)?'--':contract_id)+'</span>'//协议编号
									+ '<span>'+formatNum.formatMoney(pledge_money)+'</span>'//质押金额
									+ '<span>'+stockList[m].stock_name+'</span>'//股票名称
									+ '<span>'+stockList[m].pledge_share+'</span>'//质押数量
									+ '<span>'+buyback_date+'</span>';//还款日期
				}
			}
			
			allRepayStr += '</div>';

		}
		$(_pageId+" section .FQuery .conts").append(allRepayStr);  // 设置表头之后填充股票列表
	}
	/**
	 * 查询客户资产
	 * @param funcCallback 查询成功之后的回调函数
	 * @param currBorrMoney 当前订单的借款金额
	 */
	function queryCustAssets(funcCallback, currBorrMoney)
	{
		var queryCustAssetsParam = {
				 "user_id" : userInfoInSession.cust_id,   // 客户 id
		};
		service.queryStockValue(queryCustAssetsParam, function(data){
			
			if(data.error_no == "0")
			{
				custAvailMoney = data.results[0].current_balance;  // 设置客户的可用余额
				
				if(Number(custAvailMoney) >= Number(currBorrMoney))
				{
					funcCallback ? funcCallback() : "";  // 回调函数不为空，执行回调函数，否则关闭等待层
				}
				else
				{
//					layerUtils.iMsg(-1, "账户可用余额不足，请进行转账操作！");
					pageInParam = {
							"currBorrMoney" : currBorrMoney,//借款金额
							"current_balance" : custAvailMoney,//账户余额
					}
					//跳转到repaymentInsufficient 保证金不足
					appUtils.pageInit("business/repayList", "business/repayInsufficientPage",pageInParam);
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/*向外暴露的 JSON 对象*/
	var needRepay = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = needRepay;
});