/**
 * 补充质押页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		Map = require("map"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		buyUnit = "",
		stock_name = "",
		newStockCode = "",
		exchangeType = "",
		userInfoInSession = "",  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		selectedStockMap = null,  // 已选择的股票 Map
		_pageId = "#business_newStock";
	
	/*页面初始化方法*/
	function init()
	{
		clearPageElements();   // 清除页面元素
		userInfoInSession = utils.getUserInfoInSession();
		exchangeType = appUtils.getPageParam("exchangeType");
		buyUnit = appUtils.getPageParam("buyUnit");
		
		if(!buyUnit){
			if(exchangeType == "2"){
				buyUnit = 1000;
			}else if(exchangeType == "0"){
				buyUnit = 500;
			}
		}
		
		$(_pageId+" section .addPledge").height($(window).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		$(_pageId+" section .stockList").height($(window).height()-$(_pageId+" header").height()-240+'px').css("overflow","auto");
		queryNewStock();
//		getBrokeageFee();    //获取经手费
		
	}
	
	/*清除页面元素*/
	function clearPageElements()
	{
		$(_pageId+" .total").html("质押总金额:0元<br/>补充后平均履约保障比例:>0%");
		$(_pageId+" .stockList").html("");
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		appUtils.bindEvent($(_pageId+" #myInfoCenter"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+"  #myInfoCenter"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/newStock","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		
		/*绑定确定*/
		appUtils.bindEvent($(_pageId+" #nextBtn"), function(e){
			if($(_pageId+" #stockAmount").val() == ""||$(_pageId+" #stockAmount").val() == 0){
				layerUtils.iMsg(-1,"申购数量不能为0");
				return;
			}
			var buyNewStockParam = {
				stockCode:newStockCode,
				stock_name:stock_name,
				entrustAmount:$(_pageId+" #stockAmount").val(),
				entrustPrice:$(_pageId+" #myLastPrice").attr("last-price"),
				entrustBs:"1",
				exchange_type:exchangeType
			}
			service.buyNewStock(buyNewStockParam,function(data){
				if(data.error_no == 0){
					  layerUtils.iMsg("-1","新股申购申请提交成功");
					  appUtils.pageBack();
				}else{
					layerUtils.iAlert(data.error_info);
				}
			});
			
			e.stopPropagation();
		});
	}
	
	 
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	/*
	 * 补充质押
	 */
	function queryNewStock(){
		//查询新股认购信息
		var queryNewStockInfo = {
				entrustPrice : appUtils.getPageParam("lastPrice"),  // 账户密码
   				stockCode : appUtils.getPageParam("stockCode"),
   				exchange_type : appUtils.getPageParam("exchangeType") // 订单 id
		};
		service.getNewStockNumber(queryNewStockInfo, function(data){
			if(data.error_no == "0")
			{
			    fillNewStock(data.results[0]);
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
		
	}
	function fillNewStock(param){
					var stockName = param.stock_name, // 股票名
						stockCode = param.stock_code,  // 股票代码
						lastPrice = Number(param.last_price).toFixed(2),  // 最新价格
						selfBalance = Number(param.self_balance).toFixed(2),//自有资金
						ipoBalance = Number(param.ipo_balance).toFixed(2),//融资申购资金
						exchanage_type = param.exchange_type,//股票市场
						stkbal =  param.enable_amount; // 最大可交易股票数
					var allPositionStr = "";
					stock_name   = param.stock_name;
					newStockCode = param.stock_code;
					exchangeType = param.exchange_type;
				allPositionStr += "<div class='stockListCont'>";
				allPositionStr += "<p stock-code='"+stockCode+"' last-price='"+lastPrice+"' stkbal='"+stkbal+"' stock-name='"+stockName+"' exchanage-type='"+exchanage_type+"'><b>股票名称：</b>"+stockName+"</p>";
				allPositionStr += "<p last-price="+lastPrice+" id='myLastPrice'><b>新股价格：</b>"+lastPrice+"</p>";
				allPositionStr += "<p><b>购买数量：</b></p>";
				allPositionStr += "<p stkbal="+stkbal+"><b>可申购数量：</b>"+stkbal+"</p>";
				allPositionStr += "<p style='width:100%'><b>金         额：</b><a></a></p>";
				allPositionStr += "<p style='width: 100px;line-height: 36px;'><b>申购数量：</b></p>";
				allPositionStr += "<div class='num'>";
				allPositionStr += "<span><a href='javascript:void(0);' class='minus'></a></span>";
				allPositionStr += "<span class='mid'><input style='width: 100px;' type='tel' value='0' id='stockAmount'></span>";
				allPositionStr += "<span><a href='javascript:void(0);' class='add'></a></span>";
				allPositionStr += "</div>";
				allPositionStr += "<div class='clear'></div>";
				
				allPositionStr += "</div>";
				
				$(_pageId+" .stockList").html(allPositionStr);
				$(_pageId+" #enableAmount").html(stkbal);
				$(_pageId+" #selfBalance").html(selfBalance);
				$(_pageId+" #ipoBalance").html(ipoBalance);
				bindStockAddAndMinus();
	}
	
	function bindStockAddAndMinus(){
		
		//增加数量touchstart
		appUtils.bindEvent($(_pageId+" .stockListCont .add"),function(e){
			$(this).addClass("active");
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" .stockListCont .add"),function(e){
			$(this).removeClass("active");
			var $parentStock = $(this).parent().parent().parent();  //获取当前元素的股票父元素
			//获取当前已质押的股数。判断是否超过了最大质押数量。
			var stockNum = Number($parentStock.children(".num").children(".mid").children("input").val());
			var maxStockNum = Number($parentStock.children("p:eq(0)").attr("stkbal"));
			if(stockNum == maxStockNum){
				layerUtils.iMsg(-1,"您当前该只股票最多可购买"+maxStockNum);
				$parentStock.children(".num").children(".mid").children("input").val(maxStockNum);
				$parentStock.children("p:eq(2)").html("<b>购买数量：</b>"+maxStockNum);
				return;
			}
			var lastPrice = parseFloat($parentStock.children("p:eq(0)").attr("last-price")).toFixed(2),
			oneNum = 1*lastPrice,  // 每股的金额
			selStockNum = 0;  // 添加的股数
			selStockNum = stockNum  // 选择的股数
			if(Number(selStockNum)+Number(buyUnit) < maxStockNum){
				selStockNum+=Number(buyUnit);
			}else{
				selStockNum = maxStockNum;
			}
			
			if(selStockNum >=maxStockNum){
				selStockNum = maxStockNum;
			}
			$parentStock.children(".num").children(".mid").children("input").val(selStockNum);
			calcuAndShowStock($parentStock,selStockNum);
		},"touchend");
		
		//减少数量touchstart
		appUtils.bindEvent($(_pageId+" .stockListCont .minus"),function(e){
			$(this).addClass("active");
		},"touchstart");
		appUtils.bindEvent($(_pageId+" .stockListCont .minus"),function(e){
			$(this).removeClass("active");
			var $parentStock = $(this).parent().parent().parent();  //获取当前元素的股票父元素
			var stockNum = Number($parentStock.children(".num").children(".mid").children("input").val());
			var maxStockNum = Number($parentStock.children("p:eq(0)").attr("stkbal"));
			var  oneNum = 1*Number($parentStock.children("p:eq(0)").attr("last-price"))*Number($parentStock.children("p:eq(0)").attr("reality_coefficient"));
			selStockNum = 0;  // 添加的股数
			selStockNum = stockNum  // 选择的股数
			if(stockNum>buyUnit){
				stockNum -= Number(buyUnit);
			}else{
				stockNum = 0;
			}
			if(selStockNum >=maxStockNum){
				selStockNum = maxStockNum;
			}
			//获取当前股票的基本数据，方便后面计算。
			var stockCode = $parentStock.children("p:eq(0)").attr("stock-code"),  // 股票代码
				last_price = $parentStock.children("p:eq(0)").attr("last-price"),
				stkbal = $parentStock.children("p:eq(0)").attr("stkbal"),
				borrowMoney = calcPledgeMoney(stockNum,last_price),
				stockName = $parentStock.children("p:eq(0)").attr("stock-name");
			$parentStock.children("p:eq(2)").html("<b>购买数量：</b>"+stockNum);
			//children("b")
			$parentStock.children("p:eq(4)").html('<b>金额：</b>'+borrowMoney);
			
			$parentStock.children(".num").children(".mid").children("input").val(stockNum);
			// 计算总的展示数据   交易费用  预计借款金额  预计到账金额
//			$(_pageId+" .total").html('质押总金额:'+pledgeMoneyAll+'元<br/>补充后平均履约保障比例:>110%');
		},"touchend");
		
		
		bindStockInput();
	}
	
	//绑定 新股申购输入框
	function bindStockInput(){
		appUtils.bindEvent($(_pageId+" .stockListCont .mid input"),function(e){
			
			if (this.value.length == 1) {
				   this.value = this.value.replace(/[^0-9]/g, '');
			 }
			 else {
				//去掉第一个 0
				this.value = this.value = this.value.replace(/\b(0+)/gi,"");
			}
			
			var $parentStock = $(this).parent().parent().parent(); //获取当前股票的父元素.
			var maxPledgeNumber = Number($parentStock.children("p:eq(0)").attr("stkbal"));
			var checkNum = /^[0-9]\d*$/;
			if($(this).val()!=""){
				if(!checkNum.test($(this).val())){
					$(this).val(0);
//					return;
				}
			}
			if(Number($(this).val())>maxPledgeNumber){
				layerUtils.iMsg(-1,"您当前该只股票最多可质押"+maxPledgeNumber);
				$(this).val(maxPledgeNumber);
				$parentStock.children("p:eq(4)").html("<b>质押数量：</b>"+maxPledgeNumber);
			}
			var pledgeNumber = $(this).val()==""?0:$(this).val();
			//计算当前股票的显示. $parentStock 当前股票 $(this).val()  当前数量.
			calcuAndShowStock($parentStock,pledgeNumber);
		},"keyup");
		
		 appUtils.bindEvent($(_pageId+" .stockListCont .mid input"),function(e){
			 var $parentStock = $(this).parent().parent().parent(); //获取当前股票的父元素.
			 
			 if (this.value.length == 1) {
				   this.value = this.value.replace(/[^0-9]/g, '');
			 }
			 else {
				 	//去掉第一个 0
					this.value = this.value.replace(/\b(0+)/gi,"");
			 }
		 },"keydown");
	}
	
	//计算 质押总金额
	function pledgeCount(){
		pledgeMoneyAll = 0;
		for(var i = 0 ; i < selectedStockMap.elements.length; i++){
			var money = selectedStockMap.elements[i].value.loan_money;
			pledgeMoneyAll = pledgeMoneyAll + money;
		}
	}
	/*手动选股计算。
	 * param stock 当前股票对象
	 * number  当前股票质押数量
	 * */
	function calcuAndShowStock(currentStock , number){
		
		//获取当前股票的基本数据，方便后面计算。
		var stockCode = currentStock.children("p:eq(0)").attr("stock-code"),  // 股票代码
			last_price = currentStock.children("p:eq(0)").attr("last-price"),
			borrowMoney = calcPledgeMoney(number,last_price),
			stkbal = currentStock.children("p:eq(0)").attr("stkbal");
		//如果当前这支股票的质押数量为0 ，并存在于map中。则移除当前股票从列表里
	     //将计算数据展示在页面上
			currentStock.children("p:eq(2)").html("<b>购买数量：</b>"+number);
			currentStock.children("p:eq(4)").html('<b>金额：</b>'+borrowMoney);
			
			currentStock.children(".num").children(".mid").children("input").val(number);
	}
	
	/**
	 * 计算质押金额
	 * @param pledgeNum 质押股数
	 * @param coefficientRate 折算率
	 * @param lastPrice 最新价格
	 */
	function calcPledgeMoney(pledgeNum, lastPrice)
	{
		var currPledgeSum = parseInt(pledgeNum),  // 质押股数
			lastPrice = parseFloat(lastPrice); // 最新价格
        var price = lastPrice*currPledgeSum;
        
		return Number(price.toFixed(2));  // 保留两位小数之后再转换为数字
	}
	
	/**
	 * 计算质押登记费
	 * @param pledgeNum 质押股数
	 */
	function calcRegisterFee(pledgeNum)
	{
		var registerFee = 0,  // 质押登记费
			currPledgeNum = Number(pledgeNum);  // 当前质押股数
		if(currPledgeNum<=borrowMoney_deelFee.critical){
			registerFee = pledgeNum*borrowMoney_deelFee.under_critical;
			if(registerFee<borrowMoney_deelFee.zyfee){
				registerFee = borrowMoney_deelFee.zyfee;
			}
		}else if(currPledgeNum>borrowMoney_deelFee.critical){
			registerFee =Number(pledgeNum-borrowMoney_deelFee.critical)*borrowMoney_deelFee.over_critical+borrowMoney_deelFee.critical*borrowMoney_deelFee.under_critical;
		}
		return registerFee;
	}
	
	/*向外暴露的 JSON 对象*/
	var newStock = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = newStock;
});