/**
 * 补充质押页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		Map = require("map"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		buyUnit = "",
		newStockCode = "",
		userInfoInSession = "",  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		selectedStockMap = null,  // 已选择的股票 Map
		dateUtils = require("dateUtils"),
		_pageId = "#business_newStockBallot";
	
	/*页面初始化方法*/
	function init()
	{
		$(_pageId+" .no_data").hide();
		$(_pageId+" section").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		$(_pageId+" .conts").height($(document).height()-$(_pageId+" header").height()-94+'px').css("overflow","auto");
		newStockCode = appUtils.getPageParam("stock_code");
		
		var now=new Date;
		var ago=new Date;
		ago.setDate(ago.getDate()-7);
		$(_pageId+" #idBeginDate").val(ago.getFullYear()+'-'+(((ago.getMonth()+1+"").length==1)?('0'+(ago.getMonth()+1)):(ago.getMonth()+1))+'-'+(((ago.getDate()+"").length==1)?('0'+(ago.getDate())):(ago.getDate())));
		$(_pageId+" #idEndDate").val(now.getFullYear()+'-'+(((now.getMonth()+1+"").length==1)?('0'+(now.getMonth()+1)):(now.getMonth()+1))+'-'+(((now.getDate()+"").length==1)?('0'+(now.getDate())):(now.getDate())));
		
		fillData();
	}
	
	/* 日历的回调函数 */
	function calendarCallback(data)
	{
		// 回调数据中的 data 是字符串，需解析
		if(typeof(data)=="string"){
			data = JSON.parse(data);
		}
		$(_pageId+" #"+data.selector).val(data.date);
	}
	
	//数据填充
	function  fillData(){
		$(_pageId+" .Repurchase .conts").html("");
		
		var stock = {
			stockCode : newStockCode,
			start_date : $(_pageId+" #idBeginDate").val().replaceAll("-",""), //开始时间 yyyyMMdd
			end_date : $(_pageId+" #idEndDate").val().replaceAll("-","") //结束时间yyyyMMdd
		}
		service.queryNewStockBallot(stock,function(data){
			if(data.error_no == 0){
				if(data.results.length!=0){
					var allRepayStr = "";
					for(var i = 0;i<data.results.length;i++){
						allRepayStr += '<div class="cont"  >';
						allRepayStr += '<div class="list">';
						allRepayStr +='<p>证券代码：'+data.results[i].stock_code+'</p>';//质押金额
						allRepayStr +='<p>成交价格：'+Number(data.results[i].price).toFixed(2)+'</p>';//股票名称
						allRepayStr +='<p>发生数量：'+Number(data.results[i].occur_amount).toFixed(2)+'</p>';//质押数量
						allRepayStr +='<p>发生日期：'+data.results[i].init_date+'</p>';
						allRepayStr +='<p>股票类别：'+data.results[i].exchange_type_name+'</p>';
						allRepayStr +='<p>股票名称：'+data.results[i].stock_name+'</p>';
						allRepayStr +='<p>申购状态：'+data.results[i].remark+'</p>';
						allRepayStr +='</div>';
						allRepayStr +='</div>';
					}
					
					$(_pageId+" .no_data").hide();
				}
				else{
					$(_pageId+" .no_data").show();
				}
		$(_pageId+" .Repurchase .conts").html(allRepayStr);  // 设置表头之后填充股票列表
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/*清除页面元素*/
	function clearPageElements()
	{
		$(_pageId+" .Repurchase .conts").html(""); 
		 $(_pageId+" .no_data").hide();
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		 /*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		
		appUtils.bindEvent($(_pageId+" #myInfoCenter"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" #myInfoCenter"), function(e){
			$(this).removeClass("active");
			 appUtils.pageInit("business/newStockBallot","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		/* 绑定选择日期的事件 */
		dateUtils.initDateUI("business_newStockBallot","date","yyyy-mm-dd");
		/*确定 查询*/
		appUtils.bindEvent($(_pageId+" #querySock"),function(e){
			var begintime = $(_pageId+" #idBeginDate").val().replaceAll("-","");
			var endtime = $(_pageId+" #idEndDate").val().replaceAll("-","");
			if( begintime > endtime ){
				layerUtils.iMsg(-1,"起始时间不能大于结束时间");
			}else{
				fillData();
			}
		});
	}
	
	 
	
	/*页面销毁方法*/
	function destroy()
	{
		clearPageElements();
		service.destroy();
	}
	
 
	/*向外暴露的 JSON 对象*/
	var newStockBallot = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = newStockBallot;
});