/**
 * 补充质押页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		Map = require("map"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		buyUnit = "",
		newStockCode = "",
		userInfoInSession = "",  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		selectedStockMap = null,  // 已选择的股票 Map
		_pageId = "#business_newStockLimit";
	
	/*页面初始化方法*/
	function init()
	{
		$(_pageId+" .no_data").hide();
		fillData();
	}
	
	//数据填充
	function  fillData(){
		var queryNewStockInfo = {
   				exchange_type : "" // 订单 id
		};
		service.confirmNewStock(queryNewStockInfo, function(data){
			if(data.error_no == "0")
			{
			    if(data.results.length!=0){
					var allRepayStr = "";
					for(var i = 0;i<data.results.length;i++){
						allRepayStr += '<div class="cont"  >';
						allRepayStr += '<div class="list">';
						allRepayStr +='<p>市场名称：'+data.results[i].exchange_type_name+'</p>';//质押金额
						allRepayStr +='<p>交易时间：'+data.results[i].init_date+'</p>';//股票名称
						allRepayStr +='<p>可用数量：'+Number(data.results[i].enable_amount).toFixed(2)+'</p>';//质押数量
						allRepayStr +='<p>证券账户：'+data.results[i].stock_account+'</p>';
						allRepayStr +='</div>';
						allRepayStr +='</div>';
					}
						$(_pageId+" .Repurchase .conts").html(allRepayStr);  // 设置表头之后填充股票列表
				}
				else{
					$(_pageId+" .no_data").show();
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);
				
//				appUtils.pageBack();
			}
		});
	}
	
	/*清除页面元素*/
	function clearPageElements()
	{
		 $(_pageId+" .Repurchase .conts").html(""); 
		 $(_pageId+" .no_data").hide();
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		appUtils.bindEvent($(_pageId+" #myInfoCenter"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" #myInfoCenter"), function(e){
			$(this).removeClass("active");
			 appUtils.pageInit("business/newStockLimit","account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
	}
	
	 
	
	/*页面销毁方法*/
	function destroy()
	{
		clearPageElements();
		service.destroy();
	}
	
 
	/*向外暴露的 JSON 对象*/
	var newStockLimit = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = newStockLimit;
});