/**
 * 交易密码支付页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		pageInParam = null,
		imgServerPath = global.actionPath + "/servlet/Image",  // 图片验证码的请求地址
		_pageId = "#business_payByPwd";
	var modulus = "";
	var publicExponent = "";
	var endecryptUtils = require("endecryptUtils");
	var smsInterval = null;
	var external = require("nativePluginService");
	
	/*页面初始化方法*/
	function init()
	{
		pageInParam = appUtils.getPageParam();
		$(_pageId+" #fundUse").html("<span style='text-align: right;'>资金用途：</span>"+appUtils.getSStorageInfo("mode_name")+"");  // 填充交易费用
		showMobileNo();  // 显示手机号
		setFooterPos();  // 设置底部的位置
		getRSA();   //获取RSA密码
		$(_pageId+" .PubBtn").removeAttr("payby");
		
		//显示验证码
		setImgCode();
		
	}
	
	/*设置图片验证码*/
	function setImgCode()
	{
		$(_pageId+" #imgCode").val("");   // 清除验证码
		randomCode = Math.random();  // 验证码的随机数 MobileImage
		$(_pageId+" #img").attr("src", imgServerPath+"?rand="+randomCode);
	}
	
	function getRSA(){
		 var param = {
				 "op_source":gconfig.platform
		 }; 
		service.getRsaKey(param,function(data){
			if(data.error_no == 0){
				modulus = data.results[0].modulus;
				publicExponent = data.results[0].publicExponent;
			}
			else{
				layerUtils.iLoading(false);
				handleGetRsa();
			}
		},{"isLastReq":true,"isShowWait":true,"timeOutFunc":handleGetRsa});
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		
		/*确定提交申请*/
		appUtils.bindEvent($(_pageId+" .PubBtn"), function(e){
			//关闭键盘
			var param = {
					"moduleName":"xdt"
				};
			external.function50211(param);
			
			if(validateNext())   // 校验下一步
			{
				submitSmsCode();   // 提交验证码
			}
			e.stopPropagation();
		});
		
 		//绑定密码输入框
		appUtils.bindEvent($(_pageId+" #trdpwd"),function(e){
			var param = {
				"moduleName":"xdt",
				"pageId":_pageId.replace("#",""),
				"eleId":$(this).attr("id"),
				"doneLable":"done",
				"keyboardType":"5",
			};
			external.function50210(param);
			e.stopPropagation();
		});
		//关闭键盘
		appUtils.bindEvent($(_pageId),function(e){
			var param = {
				"moduleName":"xdt"
			};
			external.function50211(param);
			e.stopPropagation();
		});
 		
 		/*更换验证码*/
		appUtils.bindEvent($(_pageId+" #img"), function(e){
			setImgCode();  // 设置图片验证码	
			e.stopPropagation();
		});
	}
	
//	/*获取短信验证码*/
//	function getSmsCode()
//	{
//		var getSmsCode = {
//			    type : 1,
//				phone:$(_pageId+" #phoneNum").val(),
//				opdate: 1
//			};
//		service.sendMobileMessage(getSmsCode, function(data){
//			if(data.error_no == 0)
//			{
//				startSmsInterval();  // 开启计时器
//				$(_pageId+" #messageCode").val();
//				$(_pageId+" #sendMessage").attr("sent","true");
//			}
//			else
//			{
//				layerUtils.iLoading(false);
//				layerUtils.iAlert("验证码发送失败");
//				clearSmsInterval();   // 清除验证码计时器
//			}
//		});
//	}
	
//	/*启动短信验证码倒计时*/
//	function startSmsInterval()
//	{
//		$(_pageId+" #sendMessage").css("background-color", "#87929E");   // 设置按钮颜色
//		var countDownSum = 180;
//		$(_pageId+" #sendMessage").html(countDownSum+"秒重新获取");
//		smsInterval = window.setInterval(function(){
//			$(_pageId+" #sendMessage").html((--countDownSum)+"秒重新获取");
//			countDownSum == 0 ? clearSmsInterval() : "";   // 清除验证码计时器
//		}, 1000);
//	}
	
//	/*清除验证码计时器*/
//	function clearSmsInterval()
//	{
//		if(smsInterval)  // 如果 smsInterval 不为空
//		{
//			$(_pageId+" #sendMessage").removeAttr("sent").css("background-color", "#D70B17");  // 移除自定义属性，标识未发送，并恢复按钮颜色
//			window.clearInterval(smsInterval);
//			smsInterval = null;
//			$(_pageId+" #sendMessage").html("获取验证码");
//		}
//	}
	
	/*校验下一步*/
	function validateNext()
	{
		var trdpwd = $(_pageId+" #trdpwd").val();  // 交易密码
		if(trdpwd == "")
		{
			layerUtils.iMsg(-1, "请输入交易密码");
			return false;
		}
		//判断验证码是否输入
		var imgcode = $(_pageId + " #imgCode").val();
		if(imgcode == ""){
			layerUtils.iMsg(-1, "请输入验证码");
			return false;
		}
		return true;
	}
	
//	/*校验发送验证码*/
//	function validateSendCode()
//	{
//		if($(_pageId+" #sendMessage").attr("sent") == "true")  // 如果已发送，不可点击
//		{
//			return false;
//		}
//		return true;
//	}
	
	/*提交短信验证码*/
	function submitSmsCode()
	{
		validateTradePwd();  // 校验交易密码
	}
	
	/*提交借款数据*/
	function submitBorrowData()
	{
		if($(_pageId+" .PubBtn").attr("payby")=="true"){
			return false;
		}
		
		$(_pageId+" .PubBtn").attr("payby","true");
		
		var password = $(_pageId+" #trdpwd").val();  
			password = endecryptUtils.rsaEncrypt(modulus,publicExponent,password);
		var param = {
				"pwd" : password,
				"ticket" : $(_pageId+" #imgCode").val()
		};
		
		service.submitBorrowData(param, function(data){
			if(data.error_no == "0")  
			{
				
				var order_no = data.results[0].order_no;
				appUtils.setSStorageInfo("borrowSusscess_order_no",order_no);
				pageInParam.end_date = data.results[0].end_date;
				pageInParam.interest_rate = data.results[0].interest_rate;
				pageInParam.error_list = data.results[0].error_list;
				pageInParam.loan_money = data.results[0].borrow_amount;
				pageInParam.interest = data.results[0].interest;
				appUtils.pageInit("business/payByPwd", "business/borrowSucc", pageInParam);
			}
			else
			{
				layerUtils.iAlert(data.error_info);
				$(_pageId+" .PubBtn").removeAttr("payby");
			}
		});
	}
	/*显示手机号*/
	function showMobileNo()
	{
		var mobileNo = utils.getUserInfoInSession().mobile;  // 电话号码
		$(_pageId+" #phoneNum").val(mobileNo).attr("phone-no", mobileNo);  // 电话号码
	}
	
	/*校验交易密码*/
	function validateTradePwd()
	{
			submitBorrowData();
	}
	
	/*设置底部的位置*/
	function setFooterPos()
	{
		var topOffset = $(window).height()-110;  // 离顶部的距离
		$(_pageId+" .fix_bot").css("top", topOffset+"px");
	}
	
	/*******   请求失败，继续发起请求   开始    ********************/
	 /**重新查询协议内容***/
	function handleGetRsa(){
		layerUtils.iConfirm("数据加载失败，是否重新加载？", function(){
			getRSA();   
		});
	}
	/*******     结束    ********************/
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" #trdpwd").val("");// 清除输入框数据
		$(_pageId+" .PubBtn").removeAttr("payby");
	}
	
	/*向外暴露的 JSON 对象*/
	var payByPwd = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = payByPwd;
});