/**
 * 产品首页
 */
define(function(require, exports, module){
	var _pageId  = "#business_productIndex",
		layerUtils = require("layerUtils"),
		gconfig = require("gconfig"),
		winHeight = null, // 窗口高度
		utils = require("utils"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		appUtils = require("appUtils");
	/*页面初始化方法*/
	function init()
	{
		winHeight = $(window).height();
		if(global.hasBottomNav && (gconfig.platform == '1' || gconfig.platform == '2')) // 原生壳子隐藏底部导航之后，窗口高度会变大
		{
			winHeight += 50;
		}
//		//兼容
//		if(gconfig.platform == 2)
//		{
//			winHeight += 50;
//		}
		userInfoInSession = utils.getUserInfoInSession();
		var mode = appUtils.getSStorageInfo("mode_code");
		$(_pageId+" #title").html(appUtils.getSStorageInfo("mode_name"));
		//如果产品不是新股申购
		if(mode == "qx"){
			$(_pageId+" .artifactTwoMid").hide();
			$(_pageId+" #buyNewStock").hide();
			$(_pageId+" #queryNewStockInfo").hide();
			$(_pageId+" #borrowMoney span").html("借钱消费");
//			$(_pageId+" .artifactTop").height(((winHeight-60 > 120)?winHeight-60:120)+"px");
		}
		else if(mode == "cg"){
			$(_pageId+" .artifactTwoMid").hide();
			$(_pageId+" #buyNewStock").hide();
			$(_pageId+" #queryNewStockInfo").hide();
			$(_pageId+" #borrowMoney span").html("借钱炒股");
//			$(_pageId+" .artifactTop").height(((winHeight-60 > 120)?winHeight-60:120)+"px");
		}
		else{
			$(_pageId+" #buyNewStock").show();
			$(_pageId+" #queryNewStockInfo").show();	
//			$(_pageId+" #queryNewStockInfo").height(((winHeight-266 > 190)?winHeight-266:190)+"px");
//			$(_pageId+" .artifactTop").height("100%");
			$(_pageId+" #borrowMoney span").html("借钱打新");
		}
		var mainHeight = winHeight -40;
		$(_pageId + " section").css({"height": mainHeight,"overflow": "auto"});
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		 appUtils.bindEvent($(_pageId+" .ce_btn"),function(){
			 appUtils.pageInit("business/guide","business/appIndex");
			 appUtils.setLStorageInfo("isGuided","true");
		 });
		 
		 /*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/productIndex","business/borrowIndex");
			e.stopPropagation();
		},"touchend");
		
		appUtils.bindEvent($(_pageId+" #borrowMoney"),function(){
			var code = appUtils.getSStorageInfo("mode_code");
			var name = appUtils.getSStorageInfo("mode_name");
			if(fzp(code,name)){
				appUtils.pageInit("business/productIndex","business/borrowApply");
			}
		 });
		  appUtils.bindEvent($(_pageId+" #payBackMoney"),function(){
			 appUtils.pageInit("business/productIndex","business/repayList");
		 });
		  appUtils.bindEvent($(_pageId+" #buyNewStock"),function(){
			 appUtils.pageInit("business/productIndex","business/todayNewStock");
		 });
		  //查询新股申购记录
		   appUtils.bindEvent($(_pageId+" #queryNewStockRecord"),function(){
		   	 appUtils.pageInit("account/myInfoCenter", "account/newStockRecord");
//			 e.stopPropagation();
		 });
		 //查询新股可申购额度
		   appUtils.bindEvent($(_pageId+" #queryNewStockLimit"),function(){
		   	appUtils.pageInit("business/productIndex","business/newStockLimit");
		 });
		 //查询新股配号
		   appUtils.bindEvent($(_pageId+" #queryNewStockDistribution"),function(){
		   	var stockCode = $(_pageId+" #stockCode").val();
			appUtils.pageInit("business/productIndex","business/newStockDistribution",{stock_code:stockCode});
		 });
		 //查询新股中签
		   appUtils.bindEvent($(_pageId+" #queryNewStockBallot"),function(){
				var stockCode = $(_pageId+" #stockCode").val();
			 	appUtils.pageInit("business/productIndex","business/newStockBallot",{stock_code:stockCode});
		 });
		
	}
	
	/*风险测评*/
	function fzp(code,name){
		
		//新增2015.10.08 
		//老客户 如果 某个 功能 已经开通 就 不提示 开通资质， 如果 没有开通 就一次 把剩下的都开通
		//根据用户点击的功能 判断是否 开通剩下的权限
		var client_rights = userInfoInSession.client_rights;
		var rights = {"xrz":"o","qx":"a","cg":"b"};
		if(client_rights.indexOf(rights[code]) == -1){
			//暂时清空，让客户重新签署协议
			userInfoInSession.signargument = "";
		}
		
		//开通资质 szzzIsOpen shzzIsOpen //开通
		 //授信额度
		 //   风险测评 (那一步没有跳到那个界面)
		
		var protocolStrs = userInfoInSession.protocolStr.split(',');
		var valid_date = userInfoInSession.valid_date;//到期时间
		
		// isoutold  为2 
		//提示机构账户不允许开通易融宝
		if(userInfoInSession.isoutold == "2"){
			layerUtils.iMsg(-1,"目前机构户暂不能办理易融宝业务，请您到开户营业部或当地营业部柜台进行办理");
			return false;
		}
		
		if(userInfoInSession.isoutold != "0"){
			appUtils.setSStorageInfo("firstLand",true);
			appUtils.pageInit("business/borrowIndex","apply/outAge");
			return false;
		} 
		if(userInfoInSession.szzzIsOpen == 'N' || userInfoInSession.shzzIsOpen == 'N'){
			appUtils.setSStorageInfo("firstLand",true);
			layerUtils.iConfirm("您尚未开通易融宝业务权限，是否现在开通？",function(){
				appUtils.pageInit("business/borrowIndex","apply/personInfoConfirm");
			},null,"立即开通");
			return false;
		}
		if(userInfoInSession.valid_flag !=1 ){
			appUtils.setSStorageInfo("firstLand",true);
			if(valid_date == ""){
				//返回的日期为空
				appUtils.pageInit("business/borrowIndex","apply/riskAssessment");
			}else{
				appUtils.pageInit("business/borrowIndex","apply/outTime");
			}
			return false;
		}
		 if(userInfoInSession.signargument == null || userInfoInSession.signargument == ""){
		 	 appUtils.setSStorageInfo("firstLand",true);
			 layerUtils.iConfirm("您还未签署相关协议，请签署! ", function(){
					appUtils.pageInit("business/borrowIndex","apply/personInfoConfirm");
			 },null);	 
			 return;
			 }
		 if(userInfoInSession.credit_money == null || 
				 userInfoInSession.credit_money == "" || 
				 Number(userInfoInSession.credit_money) == 0 || 
				 Number(userInfoInSession.credit_money) == 'NaN'){
			 
			 appUtils.setSStorageInfo("firstLand",true);

			 if(userInfoInSession.risk_level == null || userInfoInSession.risk_level == ""){
				 
				 if(userInfoInSession.signargument == null || userInfoInSession.signargument == ""){
					 layerUtils.iConfirm("您还未签署相关协议，请签署! ", function(){
							appUtils.pageInit("business/borrowIndex","apply/personInfoConfirm");
					 },null);
					 return false;
				 }else{
				 	appUtils.pageInit("business/borrowIndex","apply/riskAssessment");
				 }
			 }else {
			 	 layerUtils.iConfirm("您还未做征信或者交易额度为0，请先完成征信测评!",function(){
						appUtils.pageInit("business/borrowIndex","apply/creditAssessment");
				 },null);
				 return false;
			 } 
		 }
	     else{
				var riskResult = userInfoInSession.corp_risk_level;
				if(riskResult && riskResult-0 < 3)
				{
					var param = {
							"title" : "风险等级",
							"desPageCode" : "business/productIndex",
							"code" : code,
							"name" : name
					}
					appUtils.pageInit("business/borrowIndex","apply/riskResult",param);
					return false;
				}
		}
	     return true;
		 
	}
	/*页面销毁方法*/
	function destroy()
	{
		
	}
	
	/*向外暴露的 JSON 对象*/
	var productIndex = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = productIndex;
});