/**
 * 个人中心页面
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		custAvailMoney = 0,  // 客户的可用资产
		_pageId = "#business_repayList",
		_status = ["处理中","申报处理中","申报处理中","交易成功","已放款","申报失败","购回处理中","购回处理中","购回处理中","成功","已还款","申报失败","违约处置"];//status 质押状态-1
		var pageInParam = "";
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		$(_pageId+" #showTime").text("全部");
		$(_pageId+" #showTime").attr("day","1080");
		//设置默认的底部选择 1080
		$(_pageId+" .sel_list ul li").removeClass("active");
		$(_pageId+" .sel_list ul li:eq(4)").addClass("active");
		repayOnTimeList("1080");  //加载还款数据
		$(_pageId+" section").height($(document).height()-80+'px').css("overflow","auto");
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		
//		/*返回上一页*/
//		appUtils.bindEvent($(_pageId+" .icon_back2"), function(e){
//			appUtils.pageBack();
//			e.stopPropagation();
//		});
       /*隐藏下拉框*/
       appUtils.bindEvent($(_pageId), function(e){
                          $(_pageId+" .sel_list").hide();
                          e.stopPropagation();
       });
		
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			
			//补充质押 返回 
			if(appUtils.getSStorageInfo("_curPageCode") === "business/addPledge"){
				appUtils.pageInit("business/repayList", "business/productIndex");
			}else{
				appUtils.pageBack();
			}
			e.stopPropagation();
		},"touchend");
		/*个人中心pz 2014.09.23*/
		appUtils.bindEvent($(_pageId+" .home"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		
		appUtils.bindEvent($(_pageId+" .home"), function(e){
			$(this).removeClass("active");
			appUtils.pageInit("business/repayList", "account/myInfoCenter");
			e.stopPropagation();
		},"touchend");
		//订单期限
		appUtils.bindEvent($(_pageId+" .payBack_sel_input"), function(e){
			$(_pageId+" .sel_list").toggle();
			e.stopPropagation();
		});
		appUtils.bindEvent($(_pageId+" .sel_list ul li"), function(e){
			$(_pageId+" .sel_list ul li").removeClass("active");
			$(this).addClass("active");
			$(_pageId+" #showTime").text($(this).children("a").text());
			$(_pageId+" #showTime").attr("day",$(this).children("a").attr("credit-time"));
			repayOnTimeList($(this).children("a").attr("credit-time"));
			$(_pageId+" .sel_list").hide();
			e.stopPropagation();
		});
		
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
		$(_pageId+" .conts").html("");
		$(_pageId+" #showTime").text("今日");
		$(_pageId+" .sel_list ul li").removeClass("active");
		$(_pageId+" .sel_list ul li:eq(0)").addClass("active");
		$(_pageId+" .no_data").hide();  // 隐藏暂无数据
		$(_pageId+" .sel_list").hide();  // 隐藏选项
		
	}
	
	/*到期还款*/
	function repayOnTimeList(queryDay)
	{
		var type = appUtils.getSStorageInfo("mode_code");
		var repayOnTimeListParam = {
				page : "1",  // 页数
				size : "1000",  // 数据的条数
				user_id : userInfoInSession.user_id, // 账户密码
				isRepay : "1", //需要还款的
				order_status : "3",
				cash_type : type,
				day : queryDay
		};
		service.queryLoanInfo(repayOnTimeListParam, function(data){
			
			if(data.error_no == "0")
			{
				fillRepayList(data.results[0].data);  // 填充到期还款列表
				if($(_pageId+" section .Repurchase .cont").length == 0)  // 没数据时显示无数据
				{
					
				}
				else
				{
					BindRepayEvent(); // 绑定还款事件  lsx 6-15
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
 	}
	
	/*提前还款*/
	function repayAheadList()
	{
		var repayAheadListParam = {
				page : "1",  // 页数
				size : "1000",  // 数据的条数
				inputid : userInfoInSession.user_id  // 账户密码
		};
		
		service.repayAheadList(repayAheadListParam, function(data){
			if(data.error_no == "0")
			{
				fillRepayList(data.results);  // 填充到期还款列表
				repayDelayList();  // 延期还款
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);	
			}
		}, {"isLastReq":false});
	}
	
	
	/*绑定还款事件*/
	function BindRepayEvent()
	{
		//订单还款
		appUtils.bindEvent($(_pageId+" .Repurchase .cont a"), function(e){
			forbiddenBtnByDate(this);  // 根据日期禁用还款按钮
			e.stopPropagation();
		});
		
		//子订单还款
		appUtils.bindEvent($(_pageId+" .Repurchase .cont .smartbtn"), function(e){
			forbiddenBtnByDateSub(this);
			e.stopPropagation();
		});
	}
	
	/**
	 * 根据日期禁用还款按钮  子订单
	 * @param currDOM 当前记录的 DOM 对象
	 */
	function forbiddenBtnByDateSub(currDOM)
	{
		if($(currDOM).attr("flag")=='true'){
			pageInParam = {
					orderId : $(currDOM).parent().attr("order-id"),
					initMoney : $(currDOM).parent().attr("borrow-money"), //初始金额
					deadline :	$(currDOM).parent().attr("deadline"), // 当前期限
					contract_id : $(currDOM).parent().attr("contract_id")
				};
			var interest = $(currDOM).parent().attr("interest");
			
			switch($(currDOM).attr('id')){
				case 'is_ahead'://提前还款
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/aheadPage",pageInParam); // 跳到提前还款页面
					}, borrowMoney,interest);
					break;
				case 'is_immediate'://到期还款
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
				
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/immediateRepay",pageInParam); // 跳到马上还款页面
					}, borrowMoney,interest);
					break;
				case 'is_addPledge'://补充质押
					appUtils.pageInit("business/repayList", "business/addPledge",pageInParam); // 跳到延期还款页面
					break;
				case 'is_repay': //还款 
					queryTiQianHK(pageInParam.orderId,pageInParam.contract_id);
					break;
			}
		}else{
			return;
		}
	}
	
	/**
	 * 根据日期禁用还款按钮
	 * @param currDOM 当前记录的 DOM 对象
	 */
	function forbiddenBtnByDate(currDOM)
	{
		var currTime = new Date().getTime(),  // 当前时间
			creditTime = $(currDOM).next().find("p").eq(2).html(),  // 借款期限
			orderId = $(currDOM).attr("order-id"),
			borrowMoney = $(currDOM).attr("borrow-money"),
			deadline = $(currDOM).next().attr("deadline"),
			imsg = $(currDOM).attr("imsg"),
			interest = $(currDOM).attr("interest"),
			isshow = $(currDOM).attr("isshow"),
			yqi = $(currDOM).attr("yqi"),
			contractId = $(currDOM).attr("contractId");
			repay_type = $(currDOM).attr("repay_type"),
			subrepaydays = $(currDOM).attr("subrepaydays");
		
		if(isshow == "true"){
//			//提前还款
//			var div_ahead = '<li id="ahead" interest="'+interest+'" contractId="'+contractId+'" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);"><a href="javascript:void(0);"  style="color: #fff;">提前还款</a></li>';
//			//到期还款
//			var div_immediate = '<li id="immediate" interest="'+interest+'" contractId="'+contractId+'" order-id="'+orderId+'" borrow-money="'+borrowMoney+'" deadline="'+deadline+'" style="background: #2C7DD6;padding: 20px 40px;width: 150px;text-align: center;font-size: 16px;margin-bottom: 30px;border-radius: 10px"><a href="javascript:void(0);"><a href="javascript:void(0);" style="color: #fff;">到期还款</a></li>';
//			
//			var div_repay_nav = '<div class="repay_nav2" style="padding:30px 10px;margin:0 40px"><ul>';
//			
//			var str = "";
//			
//			if(repay_type == 1) 
//			{
//				layerUtils.layerCustom(div_repay_nav+str+div_ahead+'</ul></div>',BindRepayBtn());
//				
//			}else if(repay_type == 0)
//			{
//				layerUtils.layerCustom(div_repay_nav+str+div_immediate+'</ul></div>',BindRepayBtn());
//			}
//			 BindRepayBtn();  // 绑定还款按钮
			
			queryTiQianHK(orderId,contractId);
		}else{
			return;
		}
		
	}
	
	/*绑定还款按钮*/
	function BindRepayBtn()
	{
		/*点击页面隐藏按钮*/
		appUtils.bindEvent($(" .xubox_shade"), function(e){
			$(" .xubox_shade").remove();  // 隐藏还款的按钮
			$(" .xubox_layer").remove();
			e.stopPropagation();
		});
		appUtils.bindEvent($(" .xubox_layer"), function(e){
			$(" .xubox_shade").remove();  // 隐藏还款的按钮
			$(" .xubox_layer").remove();
			e.stopPropagation();
		});
		appUtils.bindEvent($(" .repay_nav2 ul li"), function(e){
			var eleId = $(this).attr("id");
			
			pageInParam = {
				orderId : $(this).attr("order-id"),
				initMoney :	$(this).attr("borrow-money"), //初始金额
				deadline :	$(this).attr("deadline"), // 当前期限
				contract_id : $(this).attr("contractId")
			};
				var interest = $(this).attr("interest");
			switch(eleId)
			{
				case "delay" :
					appUtils.pageInit("business/repayList", "business/delayPage",pageInParam); // 跳到延期还款页面
					break;
				case "immediate" : 
					var orderId = pageInParam.orderId,
						borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/immediateRepay",pageInParam); // 跳到马上还款页面
					}, borrowMoney,interest);
					
					break;
				case "ahead" :
					var orderId = pageInParam.orderId,
					borrowMoney = pageInParam.initMoney;  // 借款金额
					
					queryCustAssets(function(){
						appUtils.pageInit("business/repayList", "business/aheadPage",pageInParam); // 跳到提前还款页面
					}, borrowMoney,interest);
					
					break;
			}
			
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 填充还款列表
	 * @param results 查询出来的股票结果集
	 */
	function fillRepayList(results)
	{
		var allRepayStr = "";  // 所有股票的字符串
		for(var i = 0; i < results.length; i++)
		{
			var oneData = results[i],  // 一条数据
			stockList = JSON.parse(oneData.stockList),
			order_id = oneData.order_id,//用于查找 的ID
			order_no = oneData.order_no, //产品编号 用于还款的ID
			product_name = oneData.product_name,//借款期限
			create_time = oneData.create_date, //借款日期
			buyback_date2 = oneData.back_date,
			buyback_date = oneData.back_date,  // 还款日期
			repay_type = oneData.order_type, //判断 是否延期的  
			contract_id = "--",
			pledge_money = 0,
			order_status = oneData.order_status,//
			is_delay = oneData.is_delay,
			
			interest = oneData.interest, //订单的利息
			
			
			subRepayDays = oneData.subRepayDays,//还有多少天到期
			
			imsg = "";//提示信息 不为空显示按钮
			
			/*
			 * order_status { 1, 7,8  } imsg
				
				!= 1, 7 ,8
				（is_delay = 2）  ? 延期申请中 ：每一个订单的apply_status=5（所有） 可以还款,显示按钮
			 */
			// 1  合约待报中...
			// 7  交易失败
			// 8 还款审核中...
			
			// 2 延期申请中...
			
			var flag = true,
				subIdList = "",  //所有子订单可以还的订单编号
				theYes = 0;
			if(order_status == 1 || order_status == 7 || order_status == 8||order_status == 2 || order_status == 9){
				
				flag = false;
				//订单状态
				switch(order_status){
				case "1":
					imsg = "（合约待报中...）";
					break;
				case "2":
					imsg = "（合约待报中...）";
					break;
				case "7":
					imsg = "（交易失败）";
					break;
				case "8":
					imsg = "（还款审核中...）";
					break;
				case "9":
					imsg = "撤单";
					break;
				}
			}else{
				//all apply_status==5
				stockList ? stockList : {};
				if(stockList == null){
					flag = false;
				}else{
					for(var j = 0; j < stockList.length; j++){
						if(stockList[j].apply_status == 5 && stockList[j].order_type !=4){
							subIdList+=stockList[j].contract_id+",";
							flag = true;
							theYes++;
						}
				}
					subIdList = subIdList.substring(0,subIdList.length-1);
				}
				
			}
			
			var yqi = (theYes>0 && theYes == stockList.length)?true:false;
			
			var imsg2 = "（可以还款）"
				color = "agreen";
			
			if(flag == false){
				imsg = "";
				color = "ared";
			}else if(imsg.length > 0){
				color = "ared";
			}
			
			allRepayStr += '<div class="cont"><a href="javascript:void(0);" class="'+color+'" style="font-size:10px" order-id="'+order_id+'" borrow-money="'
						+oneData.borrow_amount+'" subRepayDays="'+subRepayDays+'" imsg="'+imsg+'" isshow='+flag+' yqi="'+yqi+'" repay_type="'+repay_type+'" interest="'+interest+'" contractId="'+subIdList+'">'
						+'借款单号：'+order_no+'</a>';
			
			/**
			 * <p>合同号</p>   stockList[j].contract_id 
				<p>借款金额</p>  stockList[j].pledge_money
				<p>股票名称</p>  stockList[j].stock_name
				<p>质押数量</p>  stockList[j].pledge_share
				<p>还款日期</p>  buyback_date
				interest\order-id\borrowMoney\deadline
			 */
			if(stockList != null){
				for(var m = 0; m < stockList.length; m++){
					if(stockList[m].contract_id){
					contract_id = stockList[m].contract_id;
					var join_contract_id = "";
					if(stockList[m].join_contract_id != null){
						join_contract_id = stockList[m].join_contract_id;
					}
					
				var	pledge_money = stockList[m].pledge_money,
					apply_status = stockList[m].apply_status,
					interest = stockList[m].interest,
					repay_date = stockList[m].repay_date;//实际还款日期
					
					var order_status = stockList[m].order_status,
						status = stockList[m].status,
						interest_rate = stockList[m].interest_rate,
						sub_type     = stockList[m].cashtypename,
						priceRatio = Number(stockList[m].price_ratio).toFixed(2),
						warnLine = Number(stockList[m].warn_line).toFixed(2),
						isenblerepay = stockList[m].isenblerepay,
						order_type = stockList[m].order_type;
					
					/*
					 * 补充质押
					 * price_ratio <= warn_line && contract_id != null && price_ratio != 0
					 * 
					 * price_ratio == 0 说明已经补充质押过了
					 */
					var addPledgeflag = false;//是否补充质押
					
					var tobuyback_date = "";
					
					//是否可以补充质押
					/*is_delay != 2 
					status == 2 还款失败  == null 没有还款*/
					addPledgeflag = (is_delay != 2 && order_type != "4" && apply_status == "5"  && status != 0 && status != 1);
					
					var currTime = new Date().getTime(),// 当前时间
						show_ahead = false,//提前还款
						show_immediate = false;//到期还款
						repay_type = 1;
//					= 1 提前  = 0 正常 
					if(is_delay != 2){
						show_ahead = (apply_status=='5') && (status==null|| status=='null'||status=='' || status == 2);
					}
					 		
					 	tobuyback_date = "还有"+subRepayDays+"天";
						allRepayStr += '<div class="list" interest="'+interest+'" borrow-Money="'+pledge_money+'" deadline="'+((repay_date==null || typeof(repay_date)=='undefined')?buyback_date:repay_date)+'" order-id="'+order_id+'" contract_id="'+contract_id+'" current_date_interest="'+stockList[m].current_date_interest+'">';
						if(join_contract_id !=""){
							allRepayStr +='<p>合同号：<f>'+join_contract_id+'</f></p>';
							allRepayStr +='<p style="width:100%;">补充合同号：<f>'+((typeof(contract_id)=="undefined" || contract_id == null)?'--':contract_id)+'</f></p>';
						}
						else{
							allRepayStr +='<p>合同号：<f>'+((typeof(contract_id)=="undefined" || contract_id == null)?'--':contract_id)+'</f></p>';
						}
                        allRepayStr +='<p style="width:100%">借款日期：'+create_time+'</p>';//借款金额
						allRepayStr +='<p>借款类型：'+sub_type+'</p>';//借款类型
						allRepayStr +='<p>借款金额：'+formatNum.formatMoney(pledge_money)+'</p>';//借款金额
						allRepayStr +='<p>股票名称：'+stockList[m].stock_name+'</p>';//股票名称
						allRepayStr +='<p>质押数量：'+stockList[m].pledge_share+'</p>';//质押数量
						allRepayStr +='<p>还款日期：'+buyback_date+'</p>';
						allRepayStr +='<p>借款状态: '+((stockList[m].apply_status == 0 || stockList[m].apply_status=="null" || typeof(stockList[m].apply_status)=='undefined')?'':_status[stockList[m].apply_status-1])+'</p>';
//						allRepayStr +='<p style="width:100%">实际还款日期：'+((repay_date==null || typeof(repay_date)=='undefined')?buyback_date:repay_date)+'</p>';
						allRepayStr +='<p style="width:100%">到期还款预计利息：'+formatNum.formatMoney(stockList[m].interest)+'</p>';
						allRepayStr +='<p >今日还款预计利息：'+formatNum.formatMoney(stockList[m].current_date_interest)+'</p>';
						allRepayStr +='<p >借款利率：'+((interest_rate*100).toFixed(2)+"%")+'</p>';
						allRepayStr +='<p >履约保障比：'+(Number(stockList[m].price_ratio).toFixed(2))+'</p>';
						allRepayStr +='<p >距离到期：'+((subRepayDays<0)?"":tobuyback_date)+'</p>';
						
						if(join_contract_id !=""){
							 
						}
						else{
//							allRepayStr +='<p class="smartbtn" id="is_ahead" flag='+show_ahead+' style="'+(show_ahead?'':'background:#ccc;')+'">提前还款</p>';
//							allRepayStr +='<p class="smartbtn" id="is_immediate" flag='+show_immediate+' style="'+(show_immediate?'':'background:#ccc;')+'">到期还款</p>';
							if(isenblerepay == 1){
								allRepayStr +='<p class="smartbtn" id="is_repay" flag="'+show_ahead+'" style="'+(show_ahead?'':'background:#ccc;')+'">我要还款</p>';
							}
							allRepayStr +='<p class="smartbtn" id="is_addPledge" flag="'+addPledgeflag+'" style="'+(addPledgeflag?'':'background:#ccc;')+'">补充质押</p>';
						}
						allRepayStr +='</div>';//距离到期还有多X天
					}
				}
			}
			
			allRepayStr += '</div>';

		}
		if(allRepayStr != "" && typeof(allRepayStr) != "undefined"){
			$(_pageId+" .no_data").hide();
		}else{
			$(_pageId+" .no_data").show();
		}
		
		$(_pageId+" .Repurchase .conts").html(allRepayStr);  // 设置表头之后填充股票列表
	}
	
	/*还款信息查询*/
	function queryTiQianHK(orderId,contract_ids){
		var queryOrderInfoParam = {
 				order_id : orderId, // 订单 id
 				contract_ids : contract_ids
		};
		
		service.getTiQianHK(queryOrderInfoParam, function(data){
			if(data.error_no == "0")
			{
				if(data.results.length > 0){
					var oneData = data.results[0],
						contract_ids = oneData.contract_ids,//借款单号
						borrow_amount = Number(oneData.borrow_amount).toFixed(2),//本次归还本金
						repay_interest = Number(oneData.repay_interest).toFixed(2),//本次归还利息
						fetch_balance = Number(oneData.fetch_balance).toFixed(2),//帐户目前可用资金
						is_enough = oneData.is_enough;//客户资金足够(is_enough  0 不足，1充足)
				
					var contarctid = contract_ids.replaceAll(",","<br/>&ensp;&ensp;&ensp;&ensp;&ensp;&ensp;&ensp;&ensp;&ensp;&ensp;");
//					if(is_enough == 1){
						layerUtils.iConfirm('合同编号：'+contarctid+'<br/>本次归还本金：'
								+borrow_amount+'<br/>本次归还利息：'+repay_interest
								+'<br/>帐户目前可用资金：'+fetch_balance+'<br/>您真的想归还本次借款吗？',function(){
							//确定
							var sublist = [];
							var list = contract_ids.split(",");
							for(var i=0;i<list.length;i++){
								var subid = {
										"subid":list[i]
								}
								sublist.push(subid);
							}
							//还款
							subRepay(orderId,sublist);
							
						});
						$(" .pop_tip p span").css({"text-align": "left"});
						
//					}else{
//						
//						layerUtils.iConfirm('借款单号：'+contarctid+'<br/>本次归还本金：'
//								+borrow_amount+'<br/>本次归还利息：'+repay_interest
//								+'<br/>帐户目前可用资金：'+fetch_balance+'<br/>您本次还款可用资金不足，您可以通过银证转账或者卖出股票进行还款！',function(){
//							//确定
//							pageInParam = {
//									"currBorrMoney" : borrow_amount,//借款金额
//									"current_balance" : fetch_balance,//账户余额
//									"interest" : repay_interest//利息
//							}
//							//跳转到repaymentInsufficient 保证金不足
//							appUtils.pageInit("business/repayList", "business/repayInsufficientPage",pageInParam);
//						});
//						$(" .pop_tip p span").css({"text-align": "left"});
//					}
						
				}
				
				layerUtils.iLoading(false);	 
			}
			else
			{
				layerUtils.iLoading(false);	 
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	/**
	 * 提交还款数据
	 * @param orderId 订单 id
	 * @parma client_id 客户 id
	 */
	function subRepay(orderId,sublist)
	{
		var subRepayParam = {
//				order_id : $(_pageId+" section .Fdetail .FdetailCont .cont:eq(0) .words").text(),
				order_id : orderId,
				user_id : userInfoInSession.user_id,
				//"sublist", "[{\"subid\":\"000001\"},{\"subid\":\"000002\"}]"
				sublist : JSON.stringify(sublist),
				cash_type : appUtils.getSStorageInfo("mode_code")
		};
		
		service.repayLoan(subRepayParam, function(data){
			if(data.error_no == "0")
			{
				layerUtils.iAlert("还款成功！", 0, function(){
					repayOnTimeList($(_pageId+" #showTime").attr("day"));
				});
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		});
	}
	
	
	/*向外暴露的 JSON 对象*/
	var repayList = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = repayList;
});