/**
 * 今日新股
 */
define(function(require, exports, module){
	var _pageId  = "#business_todayNewStock",
		layerUtils = require("layerUtils"),
		service = require("mobileService_xdt"),
		appUtils = require("appUtils");
	/*页面初始化方法*/
	function init()
	{
		var date = new Date();
		$(_pageId+" section").height($(document).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		var today = date.toLocaleString();
		$(_pageId+" #showToday").html(today.substring(0,10));
		$(_pageId+" .no_data").hide();
		 queryTodayNewStock();
	}
	
	function queryTodayNewStock(){
		service.queryNewStockList("",function(data){
			if(data.error_no == 0){
				var appendHtml = "";
				$(_pageId+" #showToday").html(data.results[0].date);
				if(data.results[0].stock_detail == null || data.results[0].stock_detail.length <= 0){
					$(_pageId+" .no_data").show();
				}else{
					var stockList  = data.results[0].stock_detail;
					
					if(stockList.length != 0){
						for(var i = 0; i < stockList.length; i++){
							appendHtml+= "<a href='javascript:void(0);' >";
							appendHtml+= "<p class='num' is_applyed='"+stockList[i].is_applyed+"' exchangeType='"+stockList[i].market_code+"' high_amount='"+stockList[i].high_amount+"' low_amount='"+stockList[i].low_amount+"'  stock_code='"+stockList[i].stock_code+"' last_price='"+stockList[i].sellprice+"' stkcode_status='"+stockList[i].stkcode_status+"' >"+stockList[i].stock_name+"</p>";
							appendHtml+= "<p class='num'>"+stockList[i].stock_code+"</p>";
							appendHtml+= "<p class='money'>"+Number(stockList[i].sellprice).toFixed(2)+"</p>";
							appendHtml+= "</a>";
						}
						$(_pageId+" #stockList").html(appendHtml);
						bindStock();   //绑定新股选择。
					}
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	function bindStock(){
		appUtils.bindEvent($(_pageId+" #stockList a"),function(e){
				var status = $(this).children("p:eq(0)").attr("is_applyed");
				if(status == 0){
					var nextPageParam = {
						"buyUnit" : $(this).children("p:eq(0)").attr("buy_unit"),
						"lastPrice" : $(this).children("p:eq(0)").attr("last_price"),
						"stockCode" : $(this).children("p:eq(0)").attr("stock_code"),
						"exchangeType" : $(this).children("p:eq(0)").attr("exchangeType")
					}
					appUtils.pageInit("business/todayNewStock","business/newStock",nextPageParam);
				}
				else{
					layerUtils.iMsg("-1","已申购过此新股");
				}
				
		});
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
	}
	/*页面销毁方法*/
	function destroy()
	{
		
	}
	
	/*向外暴露的 JSON 对象*/
	var todayNewStock = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = todayNewStock;
});