/**
 * 交易协议书
 */
define(function(require, exports, module){
	/*模块内部全局变量*/
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		gconfig = require("gconfig"),
		formatNum = require("formatNum"),
		global = gconfig.global,
		userInfoInSession = null,  // session 中的 userInfo
		service = require("mobileService_xdt"),  //业务层接口，请求数据
		custAvailMoney = 0,  // 客户的可用资产
		_pageId = "#business_tradeAgreement";
		var sockcode = "";
	
	/*页面初始化方法*/
	function init()
	{
		//获取用户信息
		userInfoInSession = utils.getUserInfoInSession();
		sockcode = appUtils.getPageParam("stock_code");
		$(_pageId+" section").height($(window).height()-$(_pageId+" header").height()+'px').css("overflow","auto");
		fillTradAgreement();
		showRiskTips();
	}
	
	function showRiskTips(){
		if(appUtils.getSStorageInfo("mode_code") == "xrz"){
			$(_pageId+" #riskTips").html("易融宝打新风险提示：<br/> "+"易融宝打新所融资金仅可在申请借款成功的次一交易日（含）至还款日期前三个交易日（含）期间，进行网上新股申购。申购新股时，须准备申请新股金额的2%自有资金，如果客户无2%的自有资金，则不能使用借款来进行新股申购。");
		}else if(appUtils.getSStorageInfo("mode_code") == "cg"){
			$(_pageId+" #riskTips").html("易融宝炒股风险提示：<br/> "+"在待购回期间，除应按照双方之间关于履约保障比例的约定外，还应遵守双方关于易融宝炒股特定比例170%和150%的约定；该特定比例达到或低于170%/150%的，视为甲方已触及警戒线/平仓线，乙方有权按照《业务协议》的相关约定采取通知预警、处置等相关措施。");
		}
		else{
			$(_pageId+" #riskTips").html("");
		}
	}
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).addClass("active");
			e.stopPropagation();
		},"touchstart");
		/*返回*/
		appUtils.bindEvent($(_pageId+" .xdt"), function(e){
			$(this).removeClass("active");
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
		
		//确定 btn
		appUtils.bindEvent($(_pageId+" #nextStep"),function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		
	}
	
	/*校验下一步条件*/
	
	/*填充交易协议书	 */
	function fillTradAgreement(){
		
		
		
		service.saveOrReadOrder("read","",function(data){
			//传股票代码 判断和股票一样的
			 if(data.error_no == 0){
				 
				 var loanStockInfo = data.loanStockInfo,
				 	loanMoneyInfo = data.loanMoneyInfo[0],
				 	xieyi_no = "--",//协议书编号： --
				 	jiaoyi_type = appUtils.getPageParam("jiaoyi_type"),//交易类型： //自己控制， 从交易借款跳过来的就是原交易，从补充质押调过来的就是 补充质押
				 	fund_account = loanMoneyInfo.fund_account,//资金账号：
				 	client_name = loanMoneyInfo.client_name,//客户名称： 
				 	rcf_name = loanMoneyInfo.securitiesCompany,//融出方名称：
				 	interest = loanMoneyInfo.interest,//借款利息
				 	jiaoyi_code = "--",//初始交易代码： --
				 	begin_date = loanMoneyInfo.begin_date,//初始交易日
				 	
				 	huigou_code = "--",//回购交易代码： --
				 	back_date = loanMoneyInfo.back_date,//回购交易日：
				 	loan_day = loanMoneyInfo.loan_day,//回购期限 ： 
				 	loan_rate = Number(loanMoneyInfo.loan_rate *100).toFixed(2),//回购价格（每100元)
				 	weiyue_bilv = "--",//违约金比率：--
				 	is_defer = (loanMoneyInfo.is_defer=="1")?'是':'否',//可否提前还款、延期回购：loanMoneyInfo . is_defer  ==1 是
				 	is_penalty = loanMoneyInfo.is_penalty;//提前购回或延期购回违约金 ：
				 
				 var stock_name = "--",//标的证券简称： 
				 	stock_code2 = "--",//标的证券代码:
				 	bz_type = "股票", //标的证券种类 (只是股票)
				 	loan_stock_amount = "--",//标的证券数量：
				 	loan_money = "--",//初始交易成交金额：
				 	stockRefund = "--", //购回交易成交金额：  
				 	ziya = "--",//质押率：
				 	warn_line = 0,//警戒线
				 	low_line = 0;//最低
				 
				 	for(var j = 0; j < loanStockInfo.length; j++){
				 		if(loanStockInfo[j].stock_code == sockcode){
				 			stock_name = loanStockInfo[j].stock_name,
						 	stock_code2 = loanStockInfo[j].stock_code,
						 	stockInterest =Number(loanStockInfo[j].stockInterest).toFixed(2) ,
						 	ziya = Number(loanStockInfo[j].coefficient*100).toFixed(),
						 	loan_stock_amount = loanStockInfo[j].loan_stock_amount; 
				 			loan_money = loanStockInfo[j].loan_money;
				 			stockRefund = Number(loanStockInfo[j].stockRefund*100).toFixed(2)/100;
				 			warn_line = Number(loanStockInfo[j].warn_line*100).toFixed(2),//预警履约保障比例
						 	low_line = Number(loanStockInfo[j].low_line*100).toFixed(2);//最低履约保障比例：
				 			
				 			break;
				 		}
				 		
				 	}
				 	
				 /**基本信息**/
				 $(_pageId + " .TradeAgreement .cont:eq(0)").html('<h6>基本信息</h6>'
						 										+ '<p>协议书编号：'+xieyi_no+'</p>'
						 										+ '<p style="width:100%;">交易类型：'+jiaoyi_type+'</p>'
						 										+ '<p>资金账号：'+fund_account+'</p>'
						 										+ '<p>客户名称：'+client_name+'</p>'
						 										+ '<p style="width:100%">融出方名称：'+rcf_name+'</p>');
				 /**初始交易和购回交易要素**/
				 $(_pageId + " .TradeAgreement .cont:eq(1)").html('<h6>借款和还款要素</h6>'
					       										+ '<p>借款日期：'+begin_date+'</p>'
					       										+ '<p>还款日期：'+back_date+'</p>'
					       										+ '<p>借款期限：'+loan_day+'天</p>'
					       										+ '<p>借款利率：  '+loan_rate+'%</p>'
					       										+ '<p>借款金额：'+formatNum.formatMoney(loan_money)+'元</p>'
					       										+ '<p>借款利息：'+formatNum.formatMoney(stockInterest)+'</p>'
					       										+ '<p>还款本息：'+formatNum.formatMoney(stockRefund)+'元</p>'
					       										+ '<p>质押率：  '+ziya+'%</p>');
				 
				 /**标的证券要素**/
				 $(_pageId + " .TradeAgreement .cont:eq(2)").html('<h6>标的证券要素</h6>'
					       										+ '<p>标的证券简称：'+stock_name+'</p>'
					       										+ '<p>标的证券代码：'+stock_code2+'</p>'
					       										+ '<p>标的证券种类：'+bz_type+'</p>'
					       										+ '<p>质押证券数量：'+loan_stock_amount+'</p>');
				 
				 /**风险及履约要素**/
				 $(_pageId + " .TradeAgreement .cont:eq(3) p:eq(0)").html('预警履约保障比：'+warn_line+'%');
				 $(_pageId + " .TradeAgreement .cont:eq(3) p:eq(1)").html('最低履约保障比：'+low_line+'%');
//				 $(_pageId + " .TradeAgreement .cont:eq(3) p:eq(4)").html('可否提前还款、延期购回：'+is_defer);
//				 $(_pageId + " .TradeAgreement .cont:eq(3) p:eq(5)").html('提前购回或延期购回违约金 ：'+is_penalty+' 元');
			 }
			 else{
				 layerUtils.iAlert(data.error_info);
			 }
		 });
	}
	
	
	/*页面销毁方法*/
	function destroy()
	{
		service.destroy();
	}
	
	
	/*向外暴露的 JSON 对象*/
	var tradeAgreement = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = tradeAgreement;
});