/**
 * xdt模块公用 js
 */
define(function(require, exports, module) {
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig"); 
    var global = gconfig.global;
    var utils = require("utils");
    var service = require("mobileService_xdt");
    var nativePluginService = require("nativePluginService");
	
    /**
     * 首次进入模块的时候，调用
     */
    function firstLoadFunc()
    {
       nativePluginService.function50100({"moduleName":gconfig.projName});
       //获取最优站点 50112
       var param = {"funcNo":"50112","serverName":"XDT_SERVER_URL"};
       var resultVo = require("external").callMessage(param);
       if(resultVo != null && resultVo.error_no >= 0){
    	   var xdtserver = resultVo.results[0].url;
    	   //修改configuration global
    	   gconfig.global.actionPath = xdtserver + "/xdt";
    	   gconfig.global.serverPath = xdtserver + "/xdt/servlet/json";
       }
    }
    
    /* 处理会话失效，长期未登录操作 */
    function filterLoginOut(data)
    {
    }
       
	/**
	 * 每个页面校验
	 */
	function checkPermission(checkInParam)
	{
		var styleHref = gconfig.seaBaseUrl + gconfig.projName+"/css/";
		
		if((checkInParam.pageCode).indexOf("me") == 0){
			//判断是否有
			$("link[href*='" + styleHref + "']").remove();
			appUtils.loadCss(styleHref+"common.css");
			appUtils.loadCss(styleHref+"style.css");
			appUtils.loadCss(styleHref+"animate.css");
			appUtils.loadCss(styleHref+"ui-font.css");
		}else{
			//判断是否有 样式
			$("link[href*='" + styleHref + "']").remove();
			appUtils.loadCss(styleHref+"style_lx.css");
			appUtils.loadCss(styleHref+"style_fz.css");
		}
		return true;
    }
    
    /**
     * 保存用户信息
     */
    function saveSessionUserInfo(userInfo)
    {
//    	appUtils.setSStorageInfo("userInfo", JSON.stringify(userInfo));  // 重新设置 session 中的 userInfo
    	saveDataToSession(userInfo);
    }
    
    /**
     * 删除用户信息
     */
    function clearSessionUserInfo()
    {
        appUtils.clearSStorage();
    }
    
    /**
     *处理模拟登陆失败
     */
	function ssoLoginFailed(data)
    {
       //这里可以加一些逻辑处理，根据返回的错误号，目前，我这里默认处理是：弹出提示信息，跳到登陆页面
       //弹出提示信息，跳到登陆页面
       layerUtils.iAlert(data.error_info,-1,function(){
    	   
    	   //让 sso 重构一次 临时 token
    	   var param = {};
           param["funcNo"] = "60402";
           param["moduleName"] = gconfig.projName;
           require("external").callMessage(param);
    	   
    	   //返回主界面
           var param = {
    				"moduleName":"home",
    				"params":"{}"
    		};
    		param["funcNo"] = "50101";
    		require("external").callMessage(param);
       });
       
//       require.async("sso",function(module){
//            if(module.checkLoginRight())
//            {
//                module.goTologin();
//            }
//       });
    }
    
    
    /*将数据保存到 session 中*/
	function saveDataToSession(loginResults)
	{
		var userInfo = utils.getUserInfoInSession();  // 获取 session 中的用户信息
		userInfo = userInfo ? userInfo : {};  // 取到的 userInfo 为空，就创建一个新对象
		userInfo["entrust_way"] = loginResults[0].entrust_way;  // 客户 id
		userInfo["op_station"] = loginResults[0].op_station;  // 操作站点
		userInfo["branch_no"]  = loginResults[0].branch_no;  // 分支机构
		userInfo["user_id"]    = loginResults[0].user_id;  // 客户名
		userInfo["cust_code"]  = loginResults[0].cust_code;  // 客户编号	
		userInfo["fund_account"] = loginResults[0].fund_account;  // 基金帐号
		userInfo["client_name"] = loginResults[0].client_name;  // 客户姓名
		userInfo["login_id"] = loginResults[0].login_id;  // 登录id
		userInfo["exchange_type_sz"] = loginResults[0].exchange_type_sz;  // 深圳交易类型
		userInfo["exchange_type_sh"] = loginResults[0].exchange_type_sh;  // 上海交易类型
		userInfo["stock_account_sz"] = loginResults[0].stock_account_sz;  // 深圳的帐号
		userInfo["stock_account_sh"] = loginResults[0].stock_account_sh;  // 上海的帐号
		userInfo["risk_level"] = loginResults[0].risk_level;  // 信用等级
		userInfo["corp_risk_level"] = loginResults[0].corp_risk_level;  //客户柜台风险等级
		userInfo["identity_num"] = loginResults[0].identity_num;  // 身份证号码
		userInfo["mobile"] = loginResults[0].mobile;  // 手机号码
		userInfo["client_name"] = loginResults[0].client_name;  // 客户姓名
		userInfo["protocolStr"] = loginResults[0].protocolStr;  //需要签署的协议
		userInfo["signargument"] = loginResults[0].signargument;  //已签署的协议
		userInfo["zxscore"] = loginResults[0].zxscore;  //已签署的协议
		userInfo["szzzIsOpen"] = loginResults[0].szzzIsOpen;  //已签署的协议
		userInfo["shzzIsOpen"] = loginResults[0].shzzIsOpen;  //已签署的协议
		userInfo["valid_flag"] = loginResults[0].valid_flag;  // 0是有效期，1是超出。
		userInfo["valid_date"] = loginResults[0].valid_date;  // 到期时间
		userInfo["email"] = loginResults[0].email;  // 到期时间
		userInfo["urgent_telephone"] = loginResults[0].urgent_telephone;  // 到期时间
		userInfo["urgent_name"] = loginResults[0].urgent_contact;  // 紧急联系人
		userInfo["yearold"] = loginResults[0].yearold;  // 客户年龄
		userInfo["isoutold"] = loginResults[0].isoutold;  // 是否超出年龄。 0是没有超出  1是超出。
		userInfo["create_date"] = loginResults[0].create_date;  // 是否超出年龄。 0是没有超出  1是超出。
		userInfo["client_rights"] = loginResults[0].client_rights;  //客户权限 abo
		//ifs 登陆后就会返回credit_money
		if(loginResults[0].credit_money){
			appUtils.setSStorageInfo("credit_money",loginResults[0].credit_money);
			userInfo["credit_money"] = loginResults[0].credit_money;  //
		}
		appUtils.setSStorageInfo("userInfo", JSON.stringify(userInfo));
		appUtils.setSStorageInfo("jsessionid", loginResults[0].jsessionid);  // jsessionid
//		getUserLimit(loginResults[0].user_id);
		appUtils.setSStorageInfo("_isLoginIn","true");
		////并且设置到安卓缓存里面
		//50040
		require("external").callMessage({"funcNo":"50040","key":"xdt_userInfo","value":JSON.stringify(userInfo)});
		require("external").callMessage({"funcNo":"50040","key":"xdt_jsessionid","value":loginResults[0].jsessionid});
		require("external").callMessage({"funcNo":"50040","key":"xdt_isLoginIn","value":"true"});
	}
	
//	//获取用户授信额度的相关信息
//	function getUserLimit(user_id){
//		var param = {
//				"user_id":user_id
//		};
//		service.getUserlimit(param,function(data){
//			if(data.error_no == 0){
//				//把用户的信用额度存储到用户信息中
//				appUtils.setSStorageInfo("_isLoginIn","true");
//				utils.addDataToUserInfo("credit_money",data.results[0].credit_money); 
//			}
//			else{
//				layerUtils.iLoading(false);
//				layerUtils.iAlert(data.error_info);
//			}
//		});
//	}
       
    var base = {
    	"firstLoadFunc" : firstLoadFunc,
    	"checkPermission":checkPermission,
        "filterLoginOut" :filterLoginOut,
        "saveSessionUserInfo" : saveSessionUserInfo,
        "clearSessionUserInfo": clearSessionUserInfo,
    	"ssoLoginFailed": ssoLoginFailed
    };
    
    module.exports = base;
});