/**
 * 我的易融宝
 */
define(function(require, exports, module){
	var _pageId = "#me_credit";
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var formatNum = require("formatNum");
	
	/*页面初始化方法*/
	function init()
	{
		//获取缓存信息
		var creditinfo  = appUtils.getSStorageInfo("creditinfo");
		creditinfo = (creditinfo)?(JSON.parse(creditinfo)):{};
		
		var xrz = (creditinfo.xrz)?creditinfo.xrz:{}
		var cg = (creditinfo.cg)?creditinfo.cg:{}
		var qx = (creditinfo.qx)?creditinfo.qx:{}
		
		var xrzcredit = xrz.totalamt-0;
		var cgcredit = cg.totalamt-0;
		var qxcredit = qx.totalamt-0;
		var maxcredit = creditinfo.maxcredit-0;
		
		var xrzloan = xrzcredit-(xrz.avlamt-0);
		var cgloan = cgcredit-(cg.avlamt-0);
		var qxloan = qxcredit-(qx.avlamt-0);
		
		var xrzb = xrzloan/maxcredit;
		var cgb = cgloan/maxcredit;
		var qxb = qxloan/maxcredit;
		var bb = 1-xrzb-cgb-qxb;
		
		$(_pageId + " .limit_list ul li .amount:eq(0)").text("￥"+formatNum.formatMoney(xrzloan));
		$(_pageId + " .limit_list ul li .percent:eq(0)").text(((xrzb)*100).toFixed(2)+"%");
		$(_pageId + " .limit_list ul li .amount:eq(1)").text("￥"+formatNum.formatMoney(cgloan));
		$(_pageId + " .limit_list ul li .percent:eq(1)").text(((cgb)*100).toFixed(2)+"%");
		$(_pageId + " .limit_list ul li .amount:eq(2)").text("￥"+formatNum.formatMoney(qxloan));
		$(_pageId + " .limit_list ul li .percent:eq(2)").text(((qxb)*100).toFixed(2)+"%");
		
		myChart("setupProgress",[xrzb,cgb,qxb,bb],["#66bbff","#ff8811","#22aacc","#ff5533"],formatNum.formatMoney(maxcredit));
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		},"touchend");
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		
	}
	
	/*******************私有方法 开始**********************/
	/**
	 * 画饼图 资金分布
	 */
	function myChart(id,percent,color,total) {
		var cxt;  
		var c=document.getElementById(id);
		cxt=c.getContext("2d");
		//白色底
		draw(cxt,0,100,100,100,0,Math.PI*2,true,"#FFFFFF");
		var start = Math.PI*1.5;var percents = 0;
		for(var i = 0; i < percent.length; i++){
			percents = percent[i] < 0 ? 0 : percent[i];
			//彩色圆环
	        draw(cxt,-1,100,100,98,start,Math.PI*2*percents+start,false,color[i]);
	        //圆环白色间隔
//	        drawCircle(cxt,-1,100,100,98,start,Math.PI*2*0.005+start,false,"#FFFFFF");
	        start = Math.PI*2*percents+start;
		}
		//灰色中心外圈 白色
		draw(cxt,0,100,100,80,0,Math.PI*2,true,"#FFFFFF");
		cxt.font="20px 'PFDin',Microsoft YaHei";
		cxt.fillStyle="#ff5533";
		//total为接口查询计算出的账户总资产
		cxt.fillText(total,40,100);
		cxt.font="14px 'PFDin',Microsoft YaHei";
		cxt.fillStyle="#8c8c8c";
		cxt.fillText("信用额度(元)",60,120);
	}
	
	/**
	 * @param cxt 画笔对象
	 * @param type 结束画笔类型
	 * @param x x坐标
	 * @param y y坐标
	 * @param r 半径
	 * @param start 画圆起始位置
	 * @param end 画圆结束位置
	 * @param direction flase 逆时针画 true 顺时针画
	 * @param style 样式
	 */
	function draw(cxt,type,x,y,r,start,end,direction,style){
		cxt.fillStyle=style;
		cxt.beginPath();
		cxt.arc(x,y,r,start,end,direction);
		if(type == 0){
			cxt.closePath();
		}else{
			cxt.lineTo(x,y);
		}
		cxt.fill();
	} 
	
	/*******************私有方法 结束**********************/
	
	/*向外暴露的 JSON 对象*/
	var credit = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = credit;
	
});