/**
 * 我的易融宝
 */
define(function(require, exports, module){
	var _pageId = "#me_index";
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var utils = require("utils");
	var userInfoInSession = null;  // session 中的 userInfo
	var formatNum = require("formatNum");
	var service = require("mobileService_xdt");  //业务层接口，请求数据
	var counter = 3;//网络请求的个数 用来异步请求关闭等待层
	var gconfig = require("gconfig"); 
	
	/*页面初始化方法*/
	function init()
	{
		userInfoInSession = utils.getUserInfoInSession();
		/**
		 * 判断 资质开通情况
		 * 1. 获取缓存用户信息
		 * 2. 用户授信额度
		 * 3. 判断是否调用到 open页面
		 * 
		 * 查询改页面必须信息
		 */
		var result = utils.fzp();
		
		/**
		 * 获取参数
		 * 从我模块
		 */
		var param = appUtils.getPageParam();
		if(param && param["moduleName"]){
			//保存缓存标记 跳到这个模块的上一个模块的 是
			appUtils.setSStorageInfo("lastModuleName",param["moduleName"]);
		}
		
		if(!result.flag){
			//没有开通直接跳到下一个页面
			appUtils.pageInit("me/index","me/open",result);
		}
		
		//初始化页面数据
		initThisPage(userInfoInSession);
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			//appUtils.pageBack();
			//返回到“我”模块首页 
			//如果 moduleName 不为空 且 为 me
//			var lastModuleName = appUtils.setSStorageInfo("lastModuleName");
//			if(lastModuleName){
				//m/ygt/index.html#!/me/myIndexNo.html
				var toPage = "";
				if(gconfig.platform == "2"){
					toPage={"prefix":"www/m/ygt","suffix":"me/myIndexYes","ModuleName":"xdt"};
				}else{
					toPage = gconfig.seaBaseUrl+"ygt/index.html#!/me/myIndexYes.html?ModuleName=xdt";
				}
				var param = {"funcNo":"50101","moduleName":"ygt","params":{"ModuleName":"xdt","toPage":toPage}};
				require("external").callMessage(param);
//			}
			e.stopPropagation();
		},"touchend");
		
		//信用额度
		appUtils.bindEvent($(_pageId + " #credit_money"),function(e){
			appUtils.pageInit("me/index","me/credit");
			e.stopPropagation();
		});
		
		//补充质押
		appUtils.bindEvent($(_pageId + " #addPledge"),function(e){
			appUtils.pageInit("me/index","business/borrowIndex");
			e.stopPropagation();
		});
		
		//我要还款
		appUtils.bindEvent($(_pageId + " #repay"),function(e){
			//分为三种还款方式方式
			appUtils.pageInit("me/index","business/borrowIndex");
			e.stopPropagation();
		});
		
		//我要借款
		appUtils.bindEvent($(_pageId + " #loan"),function(e){
			appUtils.pageInit("me/index","business/borrowIndex");
			e.stopPropagation();
		});
		
		//信用记录
		appUtils.bindEvent($(_pageId + " #credithistory"),function(e){
			appUtils.pageInit("me/index","account/creditHistory");
			e.stopPropagation();
		});
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		
	}
	
	/*******************私有方法 开始**********************/
	function initThisPage(userinfo){
		//formatNum.formatMoney(
		
		//用户名
		$(_pageId + " #acc_name").text(userinfo.client_name);
		//资金账号
		$(_pageId + " #acc_id").text(userinfo.fund_account);
		
		getCreditMoney();
		getindexInfo();
		
		//{isLastReq:false}
		/********************service start*************************/
		//查询三种信用额度  缓存 这里隐藏调用不显示
		function getCreditMoney(){
			service.getAllCredit({},function(data){
				counterClose();
				if(data.error_no == 0){
					var results = data.results[0];
					//replace(/=/g,":")
					var xrz = results.xrz.replace(/=/g,":")
					var cg = results.cg.replace(/=/g,":"); 
					var qx = results.qx.replace(/=/g,":"); 
					xrz = (xrz)?eval("("+xrz+")"):{};
					cg = (cg)?eval("("+cg+")"):{};
					qx = (qx)?eval("("+qx+")"):{};
					
					var maxcredit = 0;
					//判断最大的授信额度
					maxcredit = Math.max.apply(Math, [xrz.totalamt-0,cg.totalamt-0,qx.totalamt-0]);
					//信用额度
					$(_pageId + " #credit_money").text(formatNum.formatMoney(maxcredit));
					//可用额度
					$(_pageId + " #kymoney").text(formatNum.formatMoney(cg.avlamt-0));
					//可取额度
					$(_pageId + " #kqmoney").text(formatNum.formatMoney(qx.avlamt-0));
					
					//存到缓存 下一个页面读取缓存
					var creditinfo = {"xrz":xrz,"cg":cg,"qx":qx,"maxcredit":maxcredit};
					appUtils.setSStorageInfo("creditinfo",JSON.stringify(creditinfo));
				}else{
					layerUtils.iAlert(data.error_info);
				}
			},{isLastReq:false,timeOutFunc:function(){counctionterClose();}});
			
			//查询可质押股票 xrz
			service.getUserlimit({},function(data){
				counterClose();
				if(data.error_no == 0){
					var results = data.results[0];
					var available_amount = results.available_amount-0;
					//可质押股票
					$(_pageId + " #plegestock").text(formatNum.formatMoney(available_amount));
				}else{
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info);
				}
			},{isLastReq:false,timeOutFunc:function(){counctionterClose();}});
		}
		//补充质押
		//多少笔还款
		function getindexInfo(){
			service.getindxInfo({},function(data){
				counterClose();
				if(data.error_no == 0){
					var results = data.results[0];
					var bczy_num = results.bczy_num-0;//bczy_num 补充质押--
					var repay_num = results.repay_num-0;//
					var nowrepay = results.now_repay-0;
					//补充质押 %
					$(_pageId + " #addPledge span").text(bczy_num);
					//我要还款 多少笔
					$(_pageId + " #repay span").text(repay_num+"笔待还");
					//已借款
					$(_pageId + " #loanmoney").text(formatNum.formatMoney(nowrepay));
				}else{
					layerUtils.iAlert(data.error_info);
				}
			},{isLastReq:false,timeOutFunc:function(){counctionterClose();}});
		}
		
		/********************service end*************************/
	}
	
	/**
	 * 计数方法 数量达到最大 则关闭等待层
	 */
	function counterClose(){
		counter--;
		if(counter <= 0){
			layerUtils.iLoading(false);
		}
	}
	
	/*******************私有方法 结束**********************/
	
	/*向外暴露的 JSON 对象*/
	var index = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = index;
	
});