/**
 * 我的易融宝
 */
define(function(require, exports, module){
	var _pageId = "#me_open";
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var utils = require("utils");
	var gconfig = require("gconfig"); 
	
	/*页面初始化方法*/
	function init()
	{
		$(_pageId + " ul li").removeClass().find("span").text("");
		//获取上个页面传过来的值
		var result = appUtils.getPageParam();
		bindOpenListEvent(result);
		
	}
	
	/*绑定页面事件的方法*/
	function bindPageEvent()
	{
		/*返回*/
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			//没有完成只能退回到首页
//			appUtils.pageBack();
			//返回"我"模块首页
			var toPage = "";
			if(gconfig.platform == "2"){
				toPage={"prefix":"www/m/ygt","suffix":"me/myIndexYes","ModuleName":"xdt"};
			}else{
				toPage = gconfig.seaBaseUrl+"ygt/index.html#!/me/myIndexYes.html?ModuleName=xdt";
			}
			var param = {"funcNo":"50101","moduleName":"ygt","params":{"ModuleName":"xdt","toPage":toPage}};
			require("external").callMessage(param);
			e.stopPropagation();
		},"touchend");
		
	}
	
	/*页面销毁方法*/
	function destroy()
	{
		$(_pageId + " ul li").removeClass().find("span").text();
	}
	
	/*******************私有方法 开始**********************/
	
	function bindOpenListEvent(result){
		
		if(!result){
			result = utils.fzp();
		}
		var flag = result.flag; //是否需要跳转到开通页面 me/open
		var isgov= result.isgov;//是否是机构账户
		var isoutold = result.isoutold;//是否超出年龄
		var isouttime = result.isouttime;//风险测评是否超出时间
		var qxy = result.qxy;//是否签署协议
		var fc = result.fc;//风险测评
		var zx = result.zx;//征信评分
		var risk_level = result.risk_level;//风险测评等级
		var valid_date = result.valid_date;//到期时间
		
		//填充页面
		if(isgov){
			//机构账户不允许
			layerUtils.iMsg(-1,"目前机构户暂不能办理易融宝业务，请您到开户营业部或当地营业部柜台进行办理");
		}else if(isoutold){
			//超出年龄 那个页面返回式pageback 所以
			//这里返回应该直接返回到 我的模块里面
			appUtils.pageInit("me/open","apply/outAge");
		}else{
			
			if(isouttime){
				$(_pageId + " #qxy").addClass("over").find("span").text("已签署");
				$(_pageId + " #fc").addClass("lost").find("span").text(valid_date+"过期");
				$(_pageId + " #zx").addClass("over").find("span").text("已通过");
			}
			//没有签署协议
			if(!qxy){
				$(_pageId + " #qxy").addClass("lost").find("span").text("未签署");
				//可能存在旧的账号做过风险测评
				if(!risk_level){
					$(_pageId + " #fc").addClass("lost").find("span").text("未评测");
				}else{
					$(_pageId + " #fc").addClass("over").find("span").text(risk_level);
				}
				$(_pageId + " #zx").addClass("lost").find("span").text("未通过");
			}
			//没有风险测评
			if(!fc){
				$(_pageId + " #qxy").addClass("over").find("span").text("已通过");
				$(_pageId + " #fc").addClass("lost").find("span").text("未评测");
				$(_pageId + " #zx").addClass("lost").find("span").text("未通过");
			}
			//没有征信评分
			if(!zx){
				$(_pageId + " #qxy").addClass("over").find("span").text("已通过");
				$(_pageId + " #fc").addClass("over").find("span").text(risk_level);
				$(_pageId + " #zx").addClass("lost").find("span").text("未通过");
			}
		}
		
		//绑定事件
		appUtils.bindEvent($(_pageId + " ul li"),function(e){
			var id = $(this).attr("id");
			var status = $(this).attr("class");
			switch(id){
			case "qxy":
				switch(status){
				case "over":
					break;
				case "lost":
					appUtils.pageInit("me/open","apply/personInfoConfirm");
					break;
					default:
						break;
				}
				break;
			case "fc":
				switch(status){
				case "over":
					break;
				case "lost":
					if($(this).find("span").text().indexOf("过期") == 0){
						appUtils.pageInit("me/open","apply/outTime");
					}else{
						appUtils.pageInit("me/open","apply/riskAssessment");
					}
					break;
					default:
						break;
				}
				break;
			case "zx":
				switch(status){
				case "over":
					break;
				case "lost":
					appUtils.pageInit("me/open","apply/creditAssessment");
					break;
					default:
						break;
				}
				break;
				default:
					break;
			}
			e.stopPropagation();
		});
	}
	
	/*******************私有方法 结束**********************/
	
	/*向外暴露的 JSON 对象*/
	var open = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
	};
	
	/*对外暴露 JSON 对象*/
	module.exports = open;
	
});