/**
 * 小贷通业务层前端 service 层调用接口
 */
define(function(require, exports, module){
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service = require("service");
//	var layerUtils = require("layerUtils");
	
	var serviceSingleton = new service.Service();
	
	/********************************公共代码部分********************************/
    function commonInvoke(paraMap, callback, ctrlParam, reqParamVo){
		reqParamVo.setReqParam(paraMap);
		ctrlParam = ctrlParam?ctrlParam:{};
		reqParamVo.setIsLastReq(ctrlParam.isLastReq);
		reqParamVo.setIsAsync(ctrlParam.isAsync);
		reqParamVo.setIsShowWait(ctrlParam.isShowWait);
		reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
//		reqParamVo.setErrorFunc(ctrlParam.errorFunc);
		reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
		reqParamVo.setTipsWords(ctrlParam.tipsWords);
		reqParamVo.setDataType(ctrlParam.dataType);
		reqParamVo.setIsGlobal(ctrlParam.isGlobal);
		reqParamVo.setProtocol(ctrlParam.protocol);
//		reqParamVo.setCacheTime(ctrlParam.cacheTime);
//		reqParamVo.setCacheType(ctrlParam.cacheType);
//		if(reqParamVo.getIsLastReq()){
//			layerUtils.iLoading(false);
//		}
//		reqParamVo.setErrorFunc(function(){
//			layerUtils.iLoading(false);
//		});
		serviceSingleton.invoke(reqParamVo, callback);
	}
	function destroy(){
		serviceSingleton.destroy();
	}
	var mobileService = {
		"getInstance": getInstance, //为了避免以前调用getInstance方法报错
		"destroy": destroy
	};
	function getInstance(){
		return mobileService;
	}
	module.exports = mobileService;
	
	/********************************应用接口开始********************************/
	
	/**
	 * 登录
	 * @param type  type = save  保存订单信息    type = read  读取订单信息
	 * @param op_source  来源
	 */
	mobileService.saveOrReadOrder = function(type,param,callback,ctrlParam)
	{
		var paraMap = {};
		paraMap["funcNo"] = "600003";
		paraMap["type"] = type;
		paraMap["orderInfo"] = param;
		paraMap["cash_type"] = appUtils.getSStorageInfo("mode_code");
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
     
	/**
	 * 登录
	 * @param login_id  账号
	 * @param password  密码
	 * @param op_source  来源
	 * @param ticket  验证码
	 */
	mobileService.loginIn = function(param,callback,ctrlParam)
	{
		var paraMap = {};
		paraMap["funcNo"] = "610002";
		paraMap["login_id"] = param.login_id;
		paraMap["password"] = param.password;
		paraMap["op_source"] = param.op_source;
		paraMap["ticket"] = param.ticket;
		paraMap["ip"] = param.ip;
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
     
     /**
      *签署协议
      * @param login_id  账号
      * @param password  密码
      * @param op_source  来源
      * @param ticket  验证码
      */
    mobileService.signProtocol = function(param,callback,ctrlParam)
     {
    	 var paraMap = {};
    	 paraMap["funcNo"] = "610004";
    	 paraMap["user_id"] = param.user_id;
    	 paraMap["version"] = param.version;
    	 paraMap["type_ename"] = param.type_ename;
    	 var reqParamVo = new service.ReqParamVo();
 		 reqParamVo.setUrl(global.serverPath);
 		 commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
     };
     
     /**
  	 * 获取用户授信额度
  	 * @param user_id  账号
  	 */
     mobileService.setUserLimit = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "610008";
		paraMap["user_id"] = param.user_id;
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
	 * 获取用户授信额度
	 * @param user_id  账号
	 */
    mobileService.getUserlimit = function(param,callback,ctrlParam)
 	{
		var paraMap = {};
		paraMap["funcNo"] = "610009";
		paraMap["user_id"] = param.user_id;
		paraMap["cash_type"] = param.cash_type;
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
   	 * * 查询持仓信息
   	 * @param entrust_way  委托方式(登录时后台传过来的字段)
   	 * @param branch_no    分支机构(登录时后台传过来的字段)
   	 * @param fund_account 资金账号(登录时后台传过来的字段)
   	 * @param cust_code    客户编号(登录时后台传过来的字段)
   	 * @param op_station   操作站点(登录时后台传过来的字段)
   	 */
    mobileService.queryPositionList = function(param,callback,ctrlParam)
    {
		var paraMap = {};
		paraMap["funcNo"] = "610064";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["user_id"] = param.user_id;
		paraMap["cash_type"] = param.cash_type;
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 10;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * * 查询交易日期
     * @param day  交易天数
     */
    mobileService.queryBorrowDate = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610013";
    	paraMap["days"] = param.days;
    	paraMap["date"] = (typeof(param.date)=="undefined"||param.date==="")?"":param.date;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * * 提交交易订单
     * @param password  密码
     * @param opdate    验证码
     */
    mobileService.submitBorrowData = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610014";
    	paraMap["password"] = param.pwd;
    	paraMap["ticket"] = param.ticket;//验证码
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 获取借款产品(借款期限以及借款利率)
     */
    mobileService.queryCreditTimeList = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610015";
    	paraMap["tag_type"] = param.tag_type;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 获取借款用途以及其质押率
     * no use
     */
    mobileService.queryPledgeRate = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610016";
    	paraMap["tag_type"] = param.tag_type;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 获取协议
     * @param type_ename 协议的英文名称(暂时后台只有zyzz dzxy两个)
     */
    mobileService.getProtocol = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610003";
    	paraMap["type_ename"] = param.type_ename;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询用户信息
     * @param type_ename 协议的英文名称(暂时后台只有zyzz dzxy两个)
     */
    mobileService.getUserInfo = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610026";
    	paraMap["user_id"] = param.user_id;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 获取rsa加密串
     */
    mobileService.getRsaKey = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "611085";
    	paraMap["op_source"] = param.op_source;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 修改客户信息
     */
    mobileService.modifyContactInfo = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610012";
    	paraMap["name"] = param.name;
    	paraMap["telephone"] = param.telephone;
    	paraMap["email"] = param.email;
    	paraMap["urgent_contact"] = param.urgent_contact;
    	paraMap["urgent_telephone"] = param.urgent_telephone;
		paraMap["op_source"] = param.op_source;
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询转账流水
     * @param entrust_way   委托方式
     * @param branch_no     分支机构
     * @param fund_account  资金账号
     * @param cust_code     客户编号
     * @param op_station    操作站点
     * @param sessionid     会话id
     * @param money_type    币种
     * @param bank_code     银行代码
     * @param begin_time    开始日期
     * @param end_time      截止日期
     */
    mobileService.queryBankList = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610022";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["op_station"] = param.op_station;
    	paraMap["sessionid"] = "";
    	paraMap["money_type"] = "";
    	paraMap["bank_code"] = "";
    	paraMap["begin_time"] = "";
    	paraMap["end_time"] = "";
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询题目列表
     * @param sub_id   题号
     */
    mobileService.queryQuestionList = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610005";
    	paraMap["sub_id"] = param.sub_id;	
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
		ctrlParam = ctrlParam?ctrlParam:{};
		ctrlParam.cacheTime = 60*60*2;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 提交答案
     * @param sub_id   题号
     * @param answer_result   答案列表
     */
    mobileService.postAnswers = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610006";
    	paraMap["sub_id"] = param.sub_id;	
    	paraMap["answer_result"] = param.answer_result;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询合约信息
     * @param sub_id   题号
     */
    mobileService.queryLoanInfo = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610018";
    	paraMap["user_id"] = param.user_id;	
    	paraMap["page"] = param.page;	
    	paraMap["size"] = param.size;	
    	paraMap["day"] = param.day;
    	paraMap["cash_type"] = param.cash_type;	
    	paraMap["order_id"] = (typeof(param.order_id)=="undefined"||param.order_id==="")?"":param.order_id;	
    	paraMap["order_status"] = (typeof(param.order_status)=="undefined"||param.order_status==="")?"":param.order_status;
    	paraMap["isRepay"] = (typeof(param.isRepay)=="undefined"||param.isRepay==="")?"":param.isRepay;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 用户还款
     * @param sub_id   题号
     */
    mobileService.repayLoan = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610020";
    	paraMap["user_id"] = param.user_id;	
    	paraMap["order_id"] = (typeof(param.order_id)=="undefined"||param.order_id==="")?"":param.order_id;
    	//还款 20140930   "sublist", "[{\"subid\":\"000001\"},{\"subid\":\"000002\"}]"
    	paraMap["sublist"] = (typeof(param.sublist)=="undefined"||param.sublist==="")?"":param.sublist;
    	paraMap["cash_type"] = param.cash_type;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 延期还款
     * @param sub_id   题号
     */
    mobileService.delayRepay = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610021";
    	paraMap["password"] = param.pwd;
    	paraMap["user_id"] = param.user_id;		
    	paraMap["delay_days"] = param.delay_days;	
    	paraMap["delay_rate"] = param.delay_rate;	
    	paraMap["order_id"] = (typeof(param.order_id)=="undefined"||param.order_id==="")?"":param.order_id;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询用户授信额度
     * @param user_id   用户编号	
     */
    mobileService.queryStockValue = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610017";
    	paraMap["user_id"] = param.user_id;	
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询银行帐号
     * @param sub_id   题号
     */
    mobileService.queryBankAccount = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610028";
    	paraMap["entrust_way"] = param.entrust_way;	
    	paraMap["branch_no"] = param.branch_no;	
    	paraMap["fund_account"] = param.fund_account;	
    	paraMap["cust_code"] = param.cust_code;	
    	paraMap["user_id"] = param.user_id;	
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询用户可用资金
     * @param sub_id   题号
     */
    mobileService.queryMarketAccount = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610031";
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 银证转账
     *  @param bank_code	        varchar(10)	银行代码    Y
	 *  @param money_type	        varchar(1)	币种类别    Y
	 *  @param transfer_direction	varchar(1)	转账方向    Y
	 *  @param tranamt	            varchar(20)	发生金额    Y
	 *  @param fund_password	    varchar(32)	资金密码    N
	 *  @param bank_password	    varchar(32)	银行密码    N
	 *  @param password  交易密码
     */
    mobileService.transferAccount = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
		paraMap["funcNo"]             = "610019";
        paraMap["bank_code"]          = param.bank_code;
        paraMap["money_type"]         = param.money_type;
        paraMap["transfer_direction"] = param.transfer_direction;
        paraMap["bank_password"]       = param.bank_password;
        paraMap["fund_password"]       = param.fund_password;
        paraMap["password"]       = param.trade_password;
        paraMap["tranamt"]            = param.tranamt;
        var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
            
    /*
     * 银证转账 显示密码
     * 610066
     * 
     * 入参：
			bank_code		银行代码
			transfer_direction	转账类型 0：银行转证券  1：证券转银行 
		
		*注：其他参数未使用，但会验证是否为空
		
		出参：	
				is_trade_pwd	是否需要交易密码 (1:需要  0:不需要)
				is_bank_pwd	是否需要银行密码 (1:需要  0:不需要)
				is_fund_pwd	是否需要资金密码 (1:需要  0:不需要) 
		
		返回类型	List
     */
    mobileService.transferAccountPwdShow = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
		paraMap["funcNo"]             = "610066";
        paraMap["bank_code"]          = param.bank_code;
        paraMap["transfer_direction"] = param.transfer_direction;
        var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
            
    /**
     * 
     * @param bank_code 银行代码
     * @param money_type 币种类别
     * @param transfer_direction  交易方向
     * @param bank_account 银行账号
     * @param fund_account 证券账户
     * @param tranamt 转账金额
     */
    mobileService.queryBorrowHistory = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610038";
    	paraMap["page"] = 1;
    	paraMap["size"] = 10;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 
     *查询交易费用计算参数
     */
    mobileService.queryBrokeageFee = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610027";
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 
     *退出在服务端注销
     */
    mobileService.exitNotifyServer = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "600005";
    	paraMap["exitFlag"] = "exit";
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 
     *一次签署多项协议
     */
    mobileService.signMultiProtocol = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610046";
    	paraMap["user_id"] = param.user_id;
    	paraMap["versionStr"] = param.versionStr;
        paraMap["type_enameStr"] = param.type_enameStr;
        paraMap["phonevalidateCode"] = param.phonevalidateCode;
        paraMap["phone"] = param.phone;
        var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 
     *发送短信验证码
     */
    mobileService.sendMobileMessage = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610057";
    	paraMap["phone"] = param.phone;
    	paraMap["type"] = param.type;
    	paraMap["opdate"] = param.opdate;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
            
    /**
	 * 获取信用记录
	 * @param 必传 user_id
			  可传 query_flog   值：zc (正常还款) tq (提前购回) yq (延期购回) wy (违约) bc （补充质押）
	 * @return 未传入  query_flog
				返回    
					borrowingNumber 借款次数
			     		normalRepay     正常还款次数
			     		advanceNumber   提前还款次数
			     		delayNumber     延期还款次数
			     		defaultNumber   违约次数
			     		replenishNumber 补充质押次数
			
				传入    query_flog
			        返回 
					t_xdt_order 所有字段 
			
			返回类型	List
	 */
    mobileService.getCreaditHistory = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610062";
    	paraMap["user_id"] = param.user_id;
    	//可传
    	(typeof(param.query_flog)=="undefined"||param.query_flog==="")?"":paraMap["query_flog"]=param.query_flog;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
            
    /**
	 * 提前还款 2014.09.29 22：13
	 * @param 必传 user_id
	 * 
	 *  610041 order_id
	 */
    mobileService.getTiQianHK = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610041";
    	paraMap["order_id"] = param.order_id;
    	paraMap["contract_ids"] = param.contract_ids;
    	
    	contract_ids= param.contract_ids;//要还款的协议编号 用,隔开
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 关于富易贷
     * 
     *  610065 
     */
    mobileService.queryFyd = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610065";
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 补充质押
     *  610035  610029  610058
     */
    mobileService.queryaddPledge1 = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610035";
    	paraMap["type"]   = param.type;// save
    	paraMap["supplementaryInfo"]   = JSON.stringify(param.supplementaryInfo);
    	/*
    	 * supplementaryInfo = {
    	 * 		order_id : ,
    	 *      order_no : ,
    	 *      borrow_amount : , //借款金额
    	 *      loan_day : ,//借款多少天
    	 *      product_name : , //借多少天
    	 *      repay_rate :，//利率
    	 *      money_date : , //发放日期
    	 *      back_date : ,//回购日期
    	 *      interest : ,//利息
    	 *      trading_fee1 : ,//手续费
    	 *      trading_fee2 : ,//手续费
    	 *      shouldRepay : , //要还的总金额
    	 *      be_used : ,//资金用途
    	 *      isaddone : ,//1.表示单只股票的质押
    	 *      contract_id : ,
    	 * }
    	 * 
    	 */
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    
    mobileService.queryaddPledge2 = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610058";
    	paraMap["cash_type"] = appUtils.getSStorageInfo("mode_code");
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    
    mobileService.queryaddPledge3 = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610029";
    	paraMap["type"]   = param.type;// save
    	paraMap["suppleOrderInfo"]   = param.suppleOrderInfo;
		paraMap["cash_type"] = appUtils.getSStorageInfo("mode_code");
		var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 补充质押查询持仓
     * 610044
     * @param exchange_type
     * @param stock_code
     * @param warnLineMoney = stock_price*pledge_share*warnLine
     * @param pledge_share
     * 
     * result
     * 
     */
    mobileService.queryaddPledgeStock = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"]   = "610044";
    	paraMap["exchange_type"]   = param.exchange_type;// save
    	paraMap["stock_code"]   = param.stock_code;
    	paraMap["warnLineMoney"]   = param.warnLineMoney;
    	paraMap["pledge_share"]   = param.pledge_share;
    	paraMap["cash_type"] = param.cash_type;
    	paraMap["contract_id"] = param.contract_id;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询持仓
     */
    mobileService.queryHoldingStock = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610076";
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询一些限制数据
     */
    mobileService.queryServerData = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610067";
    	paraMap["tag_type"] = param.tag_type;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 大订单接口
     */
    mobileService.saveBigOrReadOrder = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	//borrow_amount=1000000000&tag_type=xrz&days=7
    	paraMap["funcNo"] = "610042";
    	paraMap["tag_type"] = param.tag_type;
    	paraMap["borrow_amount"] = param.borrow_amount;
    	paraMap["days"] = param.days;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询今日新股。
     */
    mobileService.queryNewStockList = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610056"; //610069
    	paraMap["stock_code"] = param.stockCode == undefined?"":param.stockCode;
    	paraMap["user_id"] = appUtils.getSStorageInfo("user_id");
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 确认股票信息
     */
    mobileService.confirmNewStock = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610078";	
    	paraMap["exchange_type"] = param.exchange_type;	
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 购买新股
     */
    mobileService.buyNewStock = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610070";
    	paraMap["stock_code"] = param.stockCode;
    	paraMap["stock_name"] = param.stock_name;
    	paraMap["entrust_amount"] = param.entrustAmount;		
    	paraMap["entrust_price"] = param.entrustPrice;	
    	paraMap["entrust_bs"] = param.entrustBs;	
    	paraMap["exchange_type"] = param.exchange_type;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 购买新股
     */
    mobileService.getNewStockNumber = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610071";
    	paraMap["entrust_price"] = param.entrustPrice;
    	paraMap["stock_code"] = param.stockCode;
    	paraMap["exchange_type"] = param.exchange_type;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 中签查询
     */
    mobileService.queryNewStockBallot = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610072";
    	paraMap["stock_code"] = param.stockCode;
    	paraMap["start_date"] = param.start_date;
    	paraMap["end_date"] = param.end_date;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 配号查询
     */
    mobileService.queryNewStockDistribution = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610073";
    	paraMap["stock_code"] = param.stockCode;
    	paraMap["start_date"] = param.start_date;
    	paraMap["end_date"] = param.end_date;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 配号查询
     */
    mobileService.queryNewStockRecord = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610074";
    	paraMap["user_id"] = param.user_id;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 订单撤销
     */
    mobileService.cancelOrder = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610075";
    	paraMap["order_id"] = param.order_id;
    	paraMap["sub_ids"] = param.sub_ids;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
     /**
     * 确认个人信息
     */
    mobileService.confirmPersonInfo = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610079";
    	paraMap["phonevalidateCode"] = param.phonevalidateCode;
    	paraMap["email"] = param.email;
    	paraMap["urgent_telephone"] = param.urgent_telephone;
    	paraMap["telephone"] = param.telephone;
    	paraMap["urgent_contact"] = param.urgent_contact;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询订单利息
     */
    mobileService.queryOrderInterest = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610080";
    	paraMap["days"] = param.days;
    	paraMap["cash_type"] = param.cash_type;
    	paraMap["borrow_account"] = param.borrow_account;
    	paraMap["interest_rate"] = param.interest_rate;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 股票质押计算
     */
    mobileService.pledgeCount = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "611083";
    	paraMap["days"] = param.days;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["entrust_amount"] = param.entrust_amount;
    	paraMap["cash_type"] = param.cash_type;
    	paraMap["exchange_type"] = param.exchange_type;
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * APP开关控制，判断 打新 炒股 取现 那些功能不显示
     */
    mobileService.appSwitch = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "611084";
    	var reqParamVo = new service.ReqParamVo();
		reqParamVo.setUrl(global.serverPath);
		//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*60*3;
		commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 获取资质
     * 
     */
    mobileService.getzzIsopen = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "610045";
   	 	var reqParamVo = new service.ReqParamVo();
   	 	reqParamVo.setUrl(global.serverPath);
   	 	//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
   	 	commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 首页数据
     * 借款还信息统计
     */
    mobileService.getindxInfo = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "611086";
   	 	var reqParamVo = new service.ReqParamVo();
   	 	reqParamVo.setUrl(global.serverPath);
   	 	//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60*3;
   	 	commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 获取三种借款方式的 各自的柜台授信额度
     */
    mobileService.getAllCredit = function(param,callback,ctrlParam)
    {
    	var paraMap = {};
    	paraMap["funcNo"] = "611087";
   	 	var reqParamVo = new service.ReqParamVo();
   	 	reqParamVo.setUrl(global.serverPath);
   	 	//设置缓存时间 秒 
//		ctrlParam = ctrlParam?ctrlParam:{};
//		ctrlParam.cacheTime = 60;
   	 	commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    
	/***应用接口......................................................结束*/
	
});