﻿define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        mobileService = require("mobileService"),
        _pageId = "#me_accountManagement";

    var jy_asset_prop,     //普通账户 0 未开通、 1 已开通
        lc_asset_prop,     //理财账户
        xy_asset_prop;     //信用账户
    var client_id = "";

    function init() {
        jy_asset_prop = appUtils.getSStorageInfo("jy_asset_prop");     
        lc_asset_prop = appUtils.getSStorageInfo("lc_asset_prop");              
        xy_asset_prop = appUtils.getSStorageInfo("xy_asset_prop");
        client_id = appUtils.getSStorageInfo("client_id");

        if(jy_asset_prop === "1" || xy_asset_prop === "1"){
            var param = {
                "client_id": appUtils.getSStorageInfo("client_id"),
                "branch_no": appUtils.getSStorageInfo("branch_no")
            }
            mobileService.queryAccountInfo(param, function (data) {
                var error_no = data.error_no;
                var error_info = data.error_info;
                if (error_no == "0") {
                    showAccountInfo(data);   //显示账户信息
                }
                else {
                    layerUtils.iLoading(false);
                    layerUtils.iAlert(error_info);
                }
            });
        }
        else{
            var htmlStr = "<ul class='zh_managelist'><li><span class='tit'>理财账号</span><div class='cont'><p>" + client_id + "</p><span class='status'>正常</span></div></li></ul>";
            // var htmlStr = "<ul class='zh_managelist'><li><span class='tit'>证券账号</span><div class='cont'><p></p><span class='status'>未开通</span></div></li></ul>";
            // htmlStr += "<ul class='zh_managelist'><li><span class='tit'>两融账号</span><div class='cont'><p></p><span class='status'>未开通</span></div></li></ul>";
            // htmlStr += "<ul class='zh_managelist'><li><span class='tit'>理财账号</span><div class='cont'><p>" + client_id + "</p><span class='status'>正常</span></div></li></ul>";
            // htmlStr += "<ul class='zh_managelist'><li><span class='tit'>基金账号</span><div class='cont'><p></p><span class='status'>未开通</span></div></li></ul>";
            $(_pageId + " .zh_managebox").html(htmlStr);
        }
    }

    function showAccountInfo(data) {
        var zj_account = data.zj_account,    //证券账户
            lr_account = data.lr_account,    //两融账户
            lc_account = data.lc_account,    //理财账户
            jj_account = data.jj_account;    //基金账户

        var asset_prop = appUtils.getSStorageInfo("asset_prop");

        var htmlStr = "";
        //证券
        if (zj_account.length > 0) {
            var accountType = {"1": "沪A账户", "2": "深A账户", "D": "沪B账户", "H": "深B账户"};
            var statusType = {"0": "正常", "1": "冻结", "2": "挂失", "3": "销户"};
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>客户号</span><div class='cont'><p>" + zj_account[0].fund_account + "</p><span class='status'>正常</span></div></li>";
            for (var i = 0, len = zj_account.length; i < len; i++) {
                var accType=accountType[zj_account[i].exchange_type];
                if(accType!=undefined&&accType!=null&&accType!=""){
                    htmlStr += "<li><span class='tit'>" + accountType[zj_account[i].exchange_type] + "</span>" +
                                        "<div class='cont'><p>" + zj_account[i].stock_account + "</p>" +
                                        "<span class='status'>" + statusType[zj_account[i].holder_status] + "</span></div></li>";
                }
            }
        }
        else {
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>客户号</span><div class='cont'><p></p><span class='status'>未开通</span></div></li>";
        }
        htmlStr += "</ul>";

        //两融
        if (lr_account.length > 0) {
            var accountType = {"1": "上海信用账户", "2": "深圳信用账户", "D": "沪B账户信用账户", "H": "深B账户信用账户"};
            var statusType = {"0": "正常", "1": "冻结", "2": "挂失", "3": "销户"};
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>两融账号</span><div class='cont'><p>" + lr_account[0].fund_account + "</p><span class='status'>正常</span></div></li>";
            for (var i = 0, len = lr_account.length; i < len; i++) {
                htmlStr += "<li><span class='tit'>" + accountType[lr_account[i].exchange_type] + "</span>" +
                    "<div class='cont'><p>" + lr_account[i].stock_account + "</p>" +
                    "<span class='status'>" + statusType[lr_account[i].holder_status] + "</span></div></li>";
            }
        }
        else {
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>两融账号</span><div class='cont'><p></p><span class='status'>未开通</span></div></li>";
        }
        htmlStr += "</ul>";


        //理财
        if(lc_asset_prop === "1"){
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>理财账号</span><div class='cont'><p>" + client_id + "</p><span class='status'>正常</span></div></li>";
        }
        else {
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>理财账号</span><div class='cont'><p></p><span class='status'>未开通</span></div></li>";
        }
        htmlStr += "</ul>";

        //基金
        if (jj_account.length > 0) {
            var accountType = {"1": "沪A账户", "2": "深A账户", "D": "沪B账户", "H": "深B账户"};
            var statusType = {"0": "正常", "1": "冻结", "2": "挂失", "3": "销户"};
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>基金账号</span><div class='cont'><p></p><span class='status'>正常</span></div></li>";
            for (var i = 0, len = jj_account.length; i < len; i++) {
                htmlStr += "<li><span class='tit'>" + jj_account[i].exchange_name + "</span>" +
                    "<div class='cont'><p>" + jj_account[i].stock_account + "</p>" +
                    "<span class='status'>正常</span></div></li>";
            }
        }
        else {
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>基金账号</span><div class='cont'><p></p><span class='status'>未开通</span></div></li>";
        }
        htmlStr += "</ul>";

        $(_pageId + " .zh_managebox").html(htmlStr);
    }

    function getHtmlStr(data, name) {
        var htmlStr = "";
        if (data.length > 0) {
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>" + name + "</span><div class='cont'><p>data[0].stock_account</p><span class='status'>正常</span></div></li>";
            for (var i = 0, len = data.length; i < data.length; i++) {
                htmlStr += "";
            }
        }
        else {
            htmlStr += "<ul class='zh_managelist'><li><span class='tit'>" + name + "</span><div class='cont'><p></p><span class='status'>未开通</span></div></li>";
        }
        htmlStr += "</ul>";
    }

    function bindPageEvent() {
        // 返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
			//appUtils.pageInit("me/accountManagement", "me/myAccount", {});
        });
    }

    //销毁
    function destroy() {
        mobileService.destroy();
    }

    var accountManagement = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = accountManagement;
});
