define(function (require, exports, module) {
    var appUtils = require("appUtils");
    var gconfig = require("gconfig");
    var global = gconfig.global;
    var validata = require("validatorUtil");
    var layerUtils = require("layerUtils");
    var external = require("external");
    var mobileService = require("mobileService");
    var _pageId = "#me_bankManages";

    var jy_asset_prop,     //普通账户 0 未开通、 1 已开通
        lc_asset_prop,     //理财账户
        xy_asset_prop;     //信用账户

    function init() {
        jy_asset_prop = appUtils.getSStorageInfo("jy_asset_prop");     
        lc_asset_prop = appUtils.getSStorageInfo("lc_asset_prop");              
        xy_asset_prop = appUtils.getSStorageInfo("xy_asset_prop");
    }

    function bindPageEvent() {
        //返回上一个页面
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
            // appUtils.pageInit("me/bankManages", "me/myAccount", {});
        });

        //证券银行卡
        appUtils.bindEvent($(_pageId + " .my_navlist ul li:eq(0)"), function () {
            if (jy_asset_prop === "0") {
                layerUtils.iAlert("您暂未开通证券账户");
                return false;
            }
            appUtils.setSStorageInfo("cardType","stock");
            appUtils.pageInit("me/bankManages", "me/showBankCard");
        });

        //两融银行卡
        appUtils.bindEvent($(_pageId + " .my_navlist ul li:eq(1)"), function () {
            if (xy_asset_prop === "0") {
                layerUtils.iAlert("您暂未开通融资融券账户");
                return false;
            }
            appUtils.setSStorageInfo("cardType","marginTrading");
            appUtils.pageInit("me/bankManages", "me/showBankCard");
        });

        //理财银行卡
        appUtils.bindEvent($(_pageId + " .my_navlist ul li:eq(2)"), function () {
            if(jy_asset_prop === "0" && lc_asset_prop === "0"){
                layerUtils.iAlert("您暂未开通理财账户");
                return false;
            }
            var toPage = "";
            if (gconfig.platform == "2") {
                toPage = {"prefix": "www/m/mall", "suffix": "bankCardOperation/bankCardManagement", "ModuleName": "me"};
            } else {
                toPage = gconfig.seaBaseUrl + "mall/index.html#!/bankCardOperation/bankCardManagement.html?ModuleName=me";
            }
            var param = {"funcNo": "50101", "moduleName": "mall", "params": {"ModuleName": "ygt", "toPage": toPage}};
            external.callMessage(param);
        });
    }

    function destroy() {

    }

    var bankManages = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = bankManages;
});
