define(function (require, exports, module) {
    var appUtils = require("appUtils");
    var gconfig = require("gconfig");
    var global = gconfig.global;
    var validata = require("validatorUtil");
    var layerUtils = require("layerUtils");
    var _pageId = "#me_bills";
    var mobileService = require("mobileService");
    var external = require("external");

    function init() {
        var header_height = $(_pageId + " header").height();
       // var footer_height = $(_pageId + " footer").height();
        var window_height = $("body").height();
        var main_height = window_height + header_height;
        $(_pageId + " .main").height(window_height);
        queryBills();
    }

    /*查询账户账单信息*/
    function queryBills() {
        var param = {
            //改成从session中获取
            "branch_no": appUtils.getSStorageInfo("branch_no"),
            "fund_account": appUtils.getSStorageInfo("fund_account"),
            "client_id": appUtils.getSStorageInfo("client_id")
        };
        mobileService.queryAccountBack(param, function (data) {
            var error_no = data.error_no,
                error_info = data.error_info;
            results = data.results;
            var element = "";
            //某种状态的标记
            var state = 0;
            if (error_no == 0) {
                if (results && results.length > 0) {
                    for (var i = 0; i < results.length; i++) {
                        var business_name = results[i].business_name,      //名称
                            business_time = results[i].business_date,       //成交时间
                            business_balance = results[i].occur_balance,    //金额
                            business_flag = results[i].business_flag,       //成交状态
                            business_no = results[i].serial_no,             //流水序号
                            post_balance = results[i].post_balance;         //余额

                        //1:金额小于0，状态为失败或者已处理   2：金额小于0，状态为已完成  3：金额大于0，状态为失败或者处理中  4：金额大于0，状态为已完成
                        if (business_balance < 0) {
                            element += "<li amount='" + business_balance + "' trade_date='" + business_time + "' description='" + business_name + "' trade_num='" + business_no + "' stateDesc='" + business_flag + "' post_balance='" + post_balance + "'><div class='ui layout base'><span class='row-1 title'>" + business_name + "</span><span class='row-1 amount reduce'>" + business_time + "</span></div><div class='ui layout info'><span class='row-1 time'>" + business_balance + "</span><span class='row-1 status'></span></div></li>";
                        } else {
                            element += "<li amount='" + business_balance + "' trade_date='" + business_time + "' description='" + business_name + "' trade_num='" + business_no + "' stateDesc='" + business_flag + "' post_balance='" + post_balance + "'><div class='ui layout base'><span class='row-1 title'>" + business_name + "</span><span class='row-1 amount add'>+" + business_time + "</span></div><div class='ui layout info'><span class='row-1 time'>" + business_balance + "</span><span class='row-1 status redcol'></span></div></li>";
                        }
                    }
                    $(_pageId + " .bill_list ul").html(element);
                    var questionList = $(_pageId + " .bill_list li .info");  // 获取所有问题的集合
                    // 处理每一个问题
                    questionList.each(function () {
                        if ("失败" == $(this).children("span").eq(1).text() || "处理中" == $(this).children("span").eq(1).text()) {
                            $(this).children("span").eq(1).addClass("redcol");
                        }
                    });
                } else {
                    $(_pageId + " .bill_list ul").html("未查询到相关数据！");
                }
            }
            else {
                layerUtils.iAlert(error_info, -1);
                return false;
            }
        });
    }

    /*格式化金额*/
    function formatMoney(s, n) {
        n = n > 0 && n <= 20 ? n : 2;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        t = "";
        for (i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return t.split("").reverse().join("") + "." + r;
    }

    function bindPageEvent() {
        //返回上一个页面
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
            // appUtils.pageInit("me/bills", "me/bondAccount", {});
        });
        //对账单
        appUtils.bindEvent($(_pageId + " .icon_text"), function () {
            appUtils.pageInit("me/bills", "me/billsChart", {});
        });

        //点击查看详细信息
        appUtils.preBindEvent($(_pageId + " .bill_list"), "li", function () {
            var billsDetails = {
                "amount": $(this).attr("amount"),             //交易金额
                "description": $(this).attr("description"),  //交易类型
                "trade_num": $(this).attr("trade_num"),      //交易编号
                "state": $(this).attr("stateDesc"),          //交易状态
                "trade_date": $(this).attr("trade_date"),    //交易时间
                "fundbal": $(this).attr("post_balance")      //账户余额   问题字段
            };
            appUtils.pageInit("me/bills", "me/billsDetail", billsDetails);
        });

    }

    function destroy() {

    }

    var bills = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = bills;
});
