﻿define(function(require, exports, module) {
	var _pageId ="#me_bondAccount";
	var appUtils = require("appUtils");
    var gconfig = require("gconfig");
    var global = gconfig.global;
    var validata = require("validatorUtil");
    var layerUtils = require("layerUtils");
    var mobileService = require("mobileService");
    var external = require("external");
    var fund_account = null;

	//证券资产
	function init() {
        /* 证券资产 绑定事件开始。。。。。。。。。。。 */
        queryMyAsset();
        /* 证券资产 绑定事件结束。。。。。。。。。。。 */
	}

    /* 证券资产 绑定事件开始。。。。。。。。。。。 */
    function queryMyAsset(){
        $(_pageId+" .header_inner p").text(appUtils.getSStorageInfo("fund_account"));
        $(_pageId+" #userName").text(appUtils.getSStorageInfo("client_name"));
        var param = {
        	"fund_account":appUtils.getSStorageInfo("fund_account"),
            "client_id":appUtils.getSStorageInfo("client_id")
        };
        mobileService.queryStkAccount(param, function(data){
            var error_no = data.error_no,
                error_info = data.error_info;

            var account = data.results;

            if(error_no == 0 && account.length > 0){
                var fund = account[0].opfund_market_per;    //基金 所占比例
                var stock = account[0].market_value_per;    //股票 所占比例


                var fundmoney =account[0].opfund_market_value;   // 基金
                var fundstock =account[0].market_value;  //股票


                $(_pageId+" #userName h2").text(appUtils.getSStorageInfo("nick_name"));
                $(_pageId+" #stkid").text(appUtils.getSStorageInfo("curr_loginid"));

                $(_pageId+" .all_data").text(account[0].assert_val);  //总资产
                $(_pageId+" .totalIncome").text(formatMoneys(account[0].profit_loss));   //参考盈亏
                $(_pageId+" .stkvalue").text(formatMoneys(account[0].check_value));      //总市值
                $(_pageId+" .availableBal").text(formatMoneys(account[0].available_balance));    //可用
                $(_pageId+" .extractionBal").text(formatMoneys(account[0].fetch_balance));  //可取


                $(_pageId+" #amount2").text(formatMoney(fundmoney));
                $(_pageId+" #amount1").text(formatMoney(fundstock));

                $(_pageId+" #percent2").text(fund);
                $(_pageId+" #percent1").text(stock);
            }else{
                layerUtils.iLoading(false);
				layerUtils.iAlert(error_info,-1);
            }
        });
    }

    /*页面 按钮事件 绑定*/
	function bindPageEvent(){
        //绑定返回
        appUtils.bindEvent($(_pageId+" .icon_back"), function(){
            appUtils.pageBack();
//            appUtils.pageInit("me/bondAccount", "me/myIndexYes");
        });

        //资金明细
        appUtils.bindEvent($(_pageId+" #text_bill"), function(){
            appUtils.pageInit("me/bondAccount", "me/bills", {});
        });

        //银证转账
        appUtils.bindEvent($(_pageId+" .my_navlist li"), function(){
            var toPage = "";
            if(gconfig.platform == "2"){
                toPage={"prefix":"www/m/trade","suffix":"banking/transfer","ModuleName":"me"};
            }else{
                toPage = gconfig.seaBaseUrl+"trade/index.html#!/banking/transfer.html?ModuleName=me";
            }
            var param = {"funcNo":"50101","moduleName":"trade","params":{"ModuleName":"ygt","toPage":toPage}};
            external.callMessage(param);
        });

        //股票详情
        appUtils.bindEvent($(_pageId+" .zc_infolist li:eq(0)"), function(){
            if($(this).find(".amount").html()!="￥0.00"){
                appUtils.pageInit("me/bondAccount", "me/takePosition", {"type": "stock"});
            }else{
                layerUtils.iMsg(-1, "您当前资产为0!");
            }
        });

        //场外基金详情
        appUtils.bindEvent($(_pageId+" .zc_infolist li:eq(1)"), function(){
            if($(this).find(".amount").html()!="￥0.00"){
                appUtils.pageInit("me/bondAccount", "me/takePosition", {"type": "otc"});
            }else{
                layerUtils.iMsg(-1, "您当前资产为0!");
            }

        });

        /* 证券资产 绑定事件结束。。。。。。。。。。。 */
	}


    /*格式化金额*/
    function formatMoneys(s, n) {
        n = n > 0 && n <= 20 ? n : 2;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        t = "";
        for (i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return t.split("").reverse().join("") + "." + r;
    }
    /*格式化金额*/
    function formatMoney(s, n) {
        n = n > 0 && n <= 20 ? n : 2;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        t = "";
        for (i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return "￥"+t.split("").reverse().join("") + "." + r;
    }



	function destroy() {
		
	}
	
	var bondAccount = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = bondAccount;
});