define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var mobileService = require("mobileService");
    var _pageId = "#me_modifyNickname";
    var old_nickname = "";

    function init() {
        old_nickname = appUtils.getPageParam("nickname");
        var $inputDom = $(_pageId + " #nickname_input");
        $inputDom.val(old_nickname);
        setTimeout(function () {   // 因为是从上一个页面点击某个元素跳转过来的，
            $inputDom.focus();     // 这个点击事件可能使刚获得焦点的input又失去焦点，通过延长一下可以解决这个问题
        }, 100);
        $(_pageId + " #clear_btn").hide();
    }

    function bindPageEvent() {
        // 返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
        });

        // 提交修改后的昵称
        appUtils.bindEvent($(_pageId + " #submit_btn"), function () {
            var newNickname = $(_pageId + " #nickname_input").val();
            if (!newNickname) {
                layerUtils.iAlert("昵称不能为空！");
                return false;
            } else if (newNickname == old_nickname) {
                layerUtils.iAlert("新昵称与旧昵称相同，请重新输入！");
                return false;
            } else if (newNickname.length > 25) {
                layerUtils.iAlert("昵称的长度不能超过25个字符！");
                return false;
            }
            updateNickname(newNickname);
        });

        // 清空输入框的内容
        appUtils.bindEvent($(_pageId + " #clear_btn"), function () {
            $(_pageId + " #nickname_input").val("");
            $(this).hide();
        });

        appUtils.bindEvent($(_pageId + " #nickname_input"), function () {
            if ($(this).val().length > 0) {
                $(_pageId + " #clear_btn").show();
            } else {
                $(_pageId + " #clear_btn").hide();
            }
        }, "input");
    }

    /* 修改昵称 */
    function updateNickname(newNickname) {
        var param = {
            "user_id": appUtils.getSStorageInfo("client_id"),
            "day_name": newNickname
        };
        mobileService.modifyNickname(param, function (data) {
            if (data.error_no == "0") {
                appUtils.setSStorageInfo("nickname", newNickname);
                appUtils.pageBack();
            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(data.error_info);
            }
        });
    }

    /* 销毁 */
    function destroy() {
        mobileService.destroy();
    }

    var modifyNickname = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = modifyNickname;
});