define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var external = require("external");
    var mobileService = require("mobileService");
    var common = require("common");
    var _pageId = "#me_myIndexNo";
    var ctrlParamLogin = {
        tipsWords: "",
        isLastReq: true, // 是否是最后一次请求，默认为 true，可不传
        isShowWait: false // 是否显示等待层，默认为 true，可不传
    };
    function init() {
          //当从密码页修改密码成功后，跳转到当前页面，然后退出
            if (appUtils.getSStorageInfo("_prePageCode") === "me/updateLodingPwd") {
                appUtils.clearSStorage();
                require("sso").ssoLoginOut();
            }
        var csTelephone = appUtils.getSStorageInfo("csTelephone");  // 客服电话
        if (csTelephone) {
            $(_pageId + " #phone").html(csTelephone);
        } else {
            mobileService.getCustomerServiceTelephone({}, function (data) {
                var results = data.results;
                if (data.error_no == "0" && results.length > 0) {
                    $(_pageId + " #phone").html(results[0].mobile_no);
                    appUtils.setSStorageInfo("csTelephone", results[0].mobile_no);
                } else {
                    layerUtils.iLoading(false);
                    layerUtils.iAlert(data.error_info);
                }
            },ctrlParamLogin);
        }
    }

    function bindPageEvent() {
        // 用户信息页面
        appUtils.bindEvent($(_pageId + " #userIn"), function () {
            appUtils.pageInit("me/myIndexNo", "me/myIndexYes", {});
        });

        appUtils.bindEvent($(_pageId + " .my_navlist li:not(#feedback_li, #phone_li, #set_li, #netHall_li, #serviceHall_li, #zk_li)"), function () {
            appUtils.pageInit("me/myIndexNo", "me/myIndexYes", {});
        });

        // 业务办理
        appUtils.bindEvent($(_pageId + " #netHall_li"), function () {
            common.onEvent("click", "me_business_hall");   // 友盟统计
            var moduleName = "";
            if (gconfig.platform == 1) { //android
                moduleName = "com.cairh.app.sjkh.wt";
            } else if (gconfig.platform == 2) { //ios
                moduleName = "netHallCtrl";
            }
            external.callMessage({
                "funcNo": "50101",
                "moduleName": moduleName
            });
        });

        // 设置
        appUtils.bindEvent($(_pageId + " #set_li"), function () {
            external.callMessage({
                "funcNo": "50101",
                "moduleName": "set"
            });
        });

        // 意见反馈
        appUtils.bindEvent($(_pageId + " #feedback_li"), function () {
            external.callMessage({
                "funcNo": "50101",
                "moduleName": "feedback"
            });
        });

        // 客服电话
        appUtils.bindEvent($(_pageId + " #phone_li"), function () {
            var callType = "";
            if (gconfig.platform == 1) { //android
                callType = "0";
            } else if (gconfig.platform == 2) { //ios
                callType = "1";
            }
            external.callMessage({
                "funcNo": "50220",
                "telNo": $(_pageId + " #phone").text(),
                "callType": callType
            });
        });

        // 服务大厅
        appUtils.bindEvent($(_pageId + " #serviceHall_li"), function () {
            common.onEvent("click", "me_service");   // 友盟统计
            appUtils.pageInit("me/myIndexNo", "me/serviceHall", {});
        });

        //appUtils.bindEvent($(_pageId + " #zk_li"), function () {
        //    appUtils.sendDirect("../zk/index.html#!/account/msgVerify.html");
        //});
    }

    /* 销毁 */
    function destroy() {
        mobileService.destroy();
    }

    var myIndexNo = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = myIndexNo;
});