﻿define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var external = require("external");
    var utils = require("utils");
    var mobileService = require("mobileService");
    var common = require("common");
    var _pageId = "#me_myIndexYes";

    var jy_asset_prop; //普通账户 0 未开通、 1 已开通
    var lc_asset_prop; //理财账户
    var xy_asset_prop; //信用账户

    function init() {
//        //当从密码页修改密码成功后，跳转到当前页面，然后退出
//        if (appUtils.getSStorageInfo("_prePageCode") === "me/updateLodingPwd") {
//            appUtils.clearSStorage();
//            require("sso").ssoLoginOut();
//        }

        // 页面置顶
        $(_pageId + " .content").scrollTop(0);

        // 隐藏弹框
        $(_pageId + " #switch_account_box").hide();

        // 是否显示"我的小贷"   1 显示   0 隐藏
        if (appUtils.getSStorageInfo("isShowXd") === "1") {
            $(_pageId + " .my_navlist li:eq(3)").show();
        }
        else {
            $(_pageId + " .my_navlist li:eq(3)").hide();
        }

        // 绑定账户
        bindAccount();

        // 获取客服电话
        getCSTelephone();

        // 显示头像、客户名、客户id
        if (appUtils.getSStorageInfo("is_img") === "1") {
            $(_pageId + " #photo_div img").attr("src", appUtils.getSStorageInfo("img_data"));
        } else {
            $(_pageId + " #photo_div img").attr("src", "images/default_head.jpg");
        }
        $(_pageId + " .top_userhead h5").text(appUtils.getSStorageInfo("client_name"));
        $(_pageId + " .top_userhead p").text(appUtils.getSStorageInfo("client_id"));

        jy_asset_prop = appUtils.getSStorageInfo("jy_asset_prop");
        lc_asset_prop = appUtils.getSStorageInfo("lc_asset_prop");
        xy_asset_prop = appUtils.getSStorageInfo("xy_asset_prop");
        if (jy_asset_prop === "1" || xy_asset_prop === "1") {
            //查询用户信息
            queryUserInfo();
        } else {
            var infos = [{
                "custname": appUtils.getSStorageInfo("client_name"),
                "client_id": appUtils.getSStorageInfo("client_id"),
                "corp_risk_level": appUtils.getSStorageInfo("risk_level"),
                "usersex": appUtils.getSStorageInfo("client_gender"),
                "addr": appUtils.getSStorageInfo("addr")
            }];
            appUtils.setSStorageInfo("userInfo_results", JSON.stringify(infos));
            //单理财户时，client_id相当于fund_account;
            var client_id = appUtils.getSStorageInfo("client_id");
            appUtils.setSStorageInfo("fund_account", client_id);
        }
    }

    // 查询用户信息
    function queryUserInfo() {
        var param = {
            "fund_account": appUtils.getSStorageInfo("fund_account"),
            "client_id": appUtils.getSStorageInfo("client_id")
        };
        mobileService.userInfo(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            var results = data.results;
            if (error_no == 0) {
                if (results[0].branchno) {
                    appUtils.setSStorageInfo("branch_no", results[0].branchno);
                }
                appUtils.setSStorageInfo("userInfo_results", JSON.stringify(results));
            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(error_info, -1);
            }
        });
    }

    // 获取客户电话
    function getCSTelephone() {
        var csTelephone = appUtils.getSStorageInfo("csTelephone");  // 客服电话
        if (csTelephone) {
            $(_pageId + " #phone").html(csTelephone);
        } else {
            mobileService.getCustomerServiceTelephone({}, function (data) {
                var results = data.results;
                if (data.error_no == "0" && results.length > 0) {
                    $(_pageId + " #phone").html(results[0].mobile_no);
                    appUtils.setSStorageInfo("csTelephone", results[0].mobile_no);
                } else {
                    layerUtils.iLoading(false);
                    layerUtils.iAlert(data.error_info);
                }
            });
        }
    }

    function bindPageEvent() {
        // 隐藏切换账户弹出框
        appUtils.bindEvent($(_pageId + " #switch_account_box"), function (e) {
            if (e.target.id == "switch_account_box") {
                $(this).hide();
            }
        });

        // 切换账户按钮事件
        appUtils.bindEvent($(_pageId + " #switch_account"), function (e) {
            queryBindAccount();   // 查询绑定的账号
            e.stopPropagation();
        });

        // 添加账户
        appUtils.bindEvent($(_pageId + " .addAccount_btn a"), function (e) {
            appUtils.clearSStorage();  // 清空session
            $(_pageId + " #switch_account_box").hide();  // 隐藏弹出框
            // 跳转到登录页面
            var param = {
                "funcNo": "50101",
                "moduleName": "sso",
                "params": {
                    "toPage": gconfig.seaBaseUrl + "ygt/index.html#!/me/myIndexYes.html",
                    "userName": "addAccount"
                }
            };
            external.callMessage(param);
            e.stopPropagation();
        });

        // 长按事件
        bindLongPressEvent($(_pageId + " #acct_list"), function () {
            var $divDoms = $(_pageId + " #switch_account_box>div");
            $divDoms.eq(0).hide();
            $divDoms.eq(1).show();
        });

        // click切换账户
        appUtils.preBindEvent($(_pageId + " #acct_list"), "li", function () {
            if($(this).find("a").hasClass("current")){
                return false;
            }
            var acct = $(this).find("p").text();
            layerUtils.iConfirm("是否切换到【" + acct + "】账户？", function () {
                appUtils.clearSStorage();  // 清空session
                $(_pageId + " #switch_account_box").hide();  // 隐藏弹出框
                // 跳转到登录页面并填充客户号
                var param = {
                    "funcNo": "50101",
                    "moduleName": "sso",
                    "params": {
                        "toPage": gconfig.seaBaseUrl + "ygt/index.html#!/me/myIndexYes.html",
                        "userName": acct
                    }
                };
                external.callMessage(param);
            });
        },"click");

        // 解绑账号事件
        appUtils.preBindEvent($(_pageId + " #acct_list_rem"), "li a", function () {
            var $thisDom = $(this);
            var mobileNo = getMobileNo();
            if (!mobileNo) {
                return false;
            }
            layerUtils.iConfirm("您确定要解绑该账号？", function () {
                var param = {
                    "mobile_no": mobileNo,
                    "client_id": $thisDom.parent().find("p").text()
                };
                mobileService.unbindAccount(param, function (data) {
                    if (data.error_no == "0") {
                        $thisDom.parent().remove();
                    } else {
                        layerUtils.iLoading(false);
                        layerUtils.iAlert(data.error_info);
                    }
                });
            }, function () {
            });
        });

        // 用户信息页面
        appUtils.bindEvent($(_pageId + " #userIn"), function () {
            common.onEvent("click", "me_info");   // 友盟统计
            appUtils.pageInit("me/myIndexYes", "me/myUserInfo", {});
        });
        // 我的股票
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(0)"), function () {
            common.onEvent("click", "me_stock");   // 友盟统计
            if (jy_asset_prop === "0") {
                layerUtils.iAlert("您暂未开通证券账户");
                return false;
            }
            appUtils.pageInit("me/myIndexYes", "me/bondAccount", {});
        });

        // 我的理财
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(1)"), function () {
            common.onEvent("click", "me_financing");   // 友盟统计
            if (lc_asset_prop === "0") {
                layerUtils.iAlert("您暂未开通理财账户");
                return false;
            }
            appUtils.pageInit("me/myIndexYes", "userCenter/index", {});
        });

        // 我的两融
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(2)"), function () {
            common.onEvent("click", "me_rzrq");   // 友盟统计
            if (xy_asset_prop === "0") {
                layerUtils.iAlert("您暂未开通融资融券账户");
                return false;
            }
            appUtils.pageInit("me/myIndexYes", "twoFinancial/twoFinancial", {});
        });

        // 我的小贷
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(3)"), function () {
            common.onEvent("click", "me_loan");   // 友盟统计
            if (jy_asset_prop === "0") {
                layerUtils.iAlert("您暂未开通证券帐户");
                return false;
            }
            var toPage = "";
            if (gconfig.platform == "2") {
                toPage = {
                    "prefix": "www/m/xdt",
                    "suffix": "me/index",
                    "ModuleName": "me"
                };
            } else {
                toPage = gconfig.seaBaseUrl + "xdt/index.html#!/me/index.html?ModuleName=me";
            }
            var param = {
                "funcNo": "50101",
                "moduleName": "xdt",
                "params": {
                    "ModuleName": "ygt",
                    "toPage": toPage
                }
            };
            external.callMessage(param);
        });

        // 我的账户
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(4)"), function () {
            common.onEvent("click", "me_account");   // 友盟统计
            appUtils.pageInit("me/myIndexYes", "me/myAccount", {});
        });

        // 业务办理
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(5)"), function () {
            common.onEvent("click", "me_business_hall");   // 友盟统计
            var moduleName = "";
            if (gconfig.platform == 1) { //android
                moduleName = "com.cairh.app.sjkh.wt";
            } else if (gconfig.platform == 2) { //ios
                moduleName = "netHallCtrl";
            }
            external.callMessage({
                "funcNo": "50101",
                "moduleName": moduleName
            });
        });

        // 设置
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(6)"), function () {
            external.callMessage({
                "funcNo": "50101",
                "moduleName": "set"
            });
        });

        // 意见反馈
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(7)"), function () {
            external.callMessage({
                "funcNo": "50101",
                "moduleName": "feedback"
            });
        });

        // 客服电话
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(8)"), function () {
            var callType = "";
            if (gconfig.platform == 1) { //android
                callType = "0";
            } else if (gconfig.platform == 2) { //ios
                callType = "1";
            }
            external.callMessage({
                "funcNo": "50220",
                "telNo": $(_pageId + " #phone").text(),
                "callType": callType
            });
        });

        // 服务大厅
        appUtils.bindEvent($(_pageId + " .my_navlist li:eq(9)"), function () {
            common.onEvent("click", "me_service");   // 友盟统计
            appUtils.pageInit("me/myIndexNo", "me/serviceHall", {});
        });

        // 退出
        appUtils.bindEvent($(_pageId + " div.exit_btn a"), function () {
            layerUtils.iConfirm("您是否确定退出登录？", function () {
                appUtils.clearSStorage();
                require("sso").ssoLoginOut();
                appUtils.pageInit("", "me/myIndexNo", {});
            }, function () {
            });
        });
    }

    /* 查询所有绑定的账号 */
    function queryBindAccount() {
        var mobileNo = getMobileNo();
        if (!mobileNo) {
            return false;
        }
        mobileService.queryBindAccount({"mobile_no": mobileNo}, function (data) {
            if (data.error_no == "0") {
                var results = data.results;
                if (results.length > 0) {
                    showAccountList(results);
                } else {
                    $(_pageId + " #acct_list").html("");
                    $(_pageId + " #acct_list_rem").html("");
                    $(_pageId + " #switch_account_box").show().find(">div").hide().first().show();
                }
            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(data.error_info);
            }
        });
    }

    /* 显示账户列表 */
    function showAccountList(results) {
        var htmlStr = "";
        for (var i = 0, len = results.length; i < len; i++) {
            if (results[i].client_id == appUtils.getSStorageInfo("client_id")) {  // 选中当前账户
                //htmlStr = "<li><div class='pic'><img src='images/default_head.png'></div><h5>" + results[i].client_name + "</h5><p>" + results[i].client_id + "</p><a class='current' href='javascript:void(0)'></a></li>" + htmlStr;
                htmlStr = "<li><h5>" + results[i].client_name + "</h5><p>" + results[i].client_id + "</p><a class='current' href='javascript:void(0)'></a></li>" + htmlStr;
            } else {
                //htmlStr += "<li><div class='pic'><img src='images/default_head.png'></div><h5>" + results[i].client_name + "</h5><p>" + results[i].client_id + "</p><a href='javascript:void(0)'></a></li>";
                htmlStr += "<li><h5>" + results[i].client_name + "</h5><p>" + results[i].client_id + "</p><a href='javascript:void(0)'></a></li>";
            }
        }

        var $acctListDom = $(_pageId + " #acct_list");
        var $acctListRemDom = $(_pageId + " #acct_list_rem");
        $acctListDom.html(htmlStr);
        $acctListRemDom.html(htmlStr).find("li a").attr("class", "close");
        $(_pageId + " #switch_account_box").show().find(">div").hide().first().show();

        // 当账户列表中的账户超过4个的时候启动滚动条效果
        var $liDoms = $acctListDom.find("li");
        if ($liDoms.length > 4) {
            $liDoms.filter(function (index) {
                return index > 3;
            }).hide();   //只保留四个li计算高度
            var DomHeight = $acctListDom.height();
            $acctListDom.css({
                "height": DomHeight + "px",
                "overflow-y": "scroll"
            });
            $liDoms.show();
        } else {
            $acctListDom.removeAttr("style");
        }

    }

    /* 绑定长按事件 */
    function bindLongPressEvent($dom, func) {
        var timeout = null;
        $dom.bind("touchstart", function () {
            timeout = setTimeout(function () {
                func();
            }, 1000);
        });
        $dom.bind("touchend", function () {
            clearTimeout(timeout);
        });
    }

    /* 获取激活的手机号 */
    function getMobileNo() {
        var mobileNo = appUtils.getSStorageInfo("mobileNo");
        if (mobileNo) {
            return mobileNo;
        } else {
            var data = external.callMessage({
                "funcNo": "50043",
                "key": "mobilePhone"
            });
            if (data.error_no == "0") {
                var results = data.results;
                if (results.length > 0 && results[0].value) {
                    mobileNo = results[0].value;
                    appUtils.setSStorageInfo("mobileNo", mobileNo);
                    return mobileNo;
                } else {
                    layerUtils.iAlert("未获取到激活的手机号");
                    return false;
                }
            } else {
                layerUtils.iAlert(data.error_info);
                return false;
            }
        }
    }

    /* 绑定账号 */
    function bindAccount() {
        var mobileNo = getMobileNo();
        if (!mobileNo) {
            return false;
        }
        var param = {
            "mobile_no": mobileNo,
            "client_id": appUtils.getSStorageInfo("client_id"),
            "client_name": appUtils.getSStorageInfo("client_name")
        };
        mobileService.bindAccount(param, function (data) {
            if (data.error_no == "0") {
            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(data.error_info);
            }
        });
    }

    //销毁
    function destroy() {
	$(_pageId).remove();
        mobileService.destroy();
    }

    var myIndexYes = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = myIndexYes;
});