define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var global = gconfig.global;
    var external = require("external");
    var mobileService = require("mobileService");
    var common = require("common");
    var _pageId = "#me_myUserInfo";

    function init() {
        // 显示头像
        if (appUtils.getSStorageInfo("is_img") == "1") {
            $(_pageId + " #photo span img").attr("src", appUtils.getSStorageInfo("img_data"));
        } else {
            $(_pageId + " #photo span img").attr("src", "images/default_head.jpg");
        }

        var results = JSON.parse(appUtils.getSStorageInfo("userInfo_results"));
        $(_pageId + " .info_list #name").text(results[0].custname);
        $(_pageId + " .info_list #clientNo").text(results[0].client_id);

        var riskLevelParam = {
            "0": "默认型",
            "1": "保守型",
            "2": "稳健型",
            "3": "积极型",
            "4": "进取型",
            "5": "激进型"
        };
        $(_pageId + " .info_list #risk").text(riskLevelParam[results[0].corp_risk_level]);

        if (results[0].usersex == "0") {
            $(_pageId + " .info_list #sex").text("男");
        }
        if (results[0].usersex == "1") {
            $(_pageId + " .info_list #sex").text("女");
        }
        $(_pageId + " .info_list #add").text(results[0].addr);

        if (results[0].sec_relation_name) {
            $(_pageId + " .info_list #twoName").text(results[0].sec_relation_name);
            $(_pageId + " .info_list #twoName").attr("phone", results[0].sec_relation_phone);
        } else {
            $(_pageId + " .info_list #twoName").text("");
            $(_pageId + " .info_list #twoName").attr("phone", "");
        }

        var nickname = appUtils.getSStorageInfo("nickname");  // 昵称
        if (nickname) {
            $(_pageId + " #nickname").html(nickname);
        } else {
            // 查询昵称
            queryNickname();
        }

    }

    function queryNickname() {
        var param = {
            "user_id": appUtils.getSStorageInfo("client_id")
        }
        mobileService.queryNickname(param, function (data) {
            if (data.error_no == "0") {
                var results = data.results;
                if (results.length > 0 && results[0].day_name) {
                    $(_pageId + " #nickname").html(results[0].day_name);
                    appUtils.setSStorageInfo("nickname", results[0].day_name);
                } else {
                    $(_pageId + " #nickname").html(appUtils.getSStorageInfo("client_name"));
                }
            } else {
                if (data.error_no == "-10031602") {
                    $(_pageId + " #nickname").html(appUtils.getSStorageInfo("client_name"));
                } else {
                    layerUtils.iLoading(false);
                    layerUtils.iAlert(data.error_info);
                }
            }
        });
    }

    function bindPageEvent() {

        //返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
            //appUtils.pageInit("me/myUserInfo", "me/myIndexYes", {});
        });

        //上传头像
        appUtils.bindEvent($(_pageId + " #photo_li"), function () {
            common.onEvent("click", "me_photo");   // 友盟统计
            var client_id = appUtils.getSStorageInfo("client_id");
            var param = {
                "funcNo": "50273",
                "moduleName": "ygt",
                "serverAddr": global.serverPath + "?funcNo=100313&img_type=8&client_id=" + client_id,
                "fileName": "img_data"
            };
            external.callMessage(param);
        });

        // 跳转到修改昵称的页面
        appUtils.bindEvent($(_pageId + " #nickname_li"), function () {
            common.onEvent("click", "me_nickname");   // 友盟统计
            appUtils.pageInit("me/myUserInfo", "me/modifyNickname", {"nickname": $(_pageId + " #nickname").text()});
        });
    }

    /**
     *  回调方法：获取拍照或是相册图片的base64数据
     */
    function getBase64(data) {
        var error_no = data.error_no,
            error_info = data.error_info;
        if (error_no == "0") {
            var img_data = "data:image/*;base64," + data.base64Image;
            $(_pageId + " #photo span img").attr("src", img_data);
            appUtils.setSStorageInfo("is_img", "1");
            appUtils.setSStorageInfo("img_data", img_data);
        }
        else {
            layerUtils.iAlert(error_info);
        }
    }

    //销毁
    function destroy() {
        mobileService.destroy();
    }

    var myUserInfo = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
        "getBase64": getBase64
    };
    module.exports = myUserInfo;
});