define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var external = require("external");
    var mobileService = require("mobileService");
    var _pageId = "#me_search";
    var liDoms = null;

    function init() {
        $(_pageId + " #search_input").val("");  // 清空搜索框
        $(_pageId + " #close_btn").hide();

        liDoms = $(_pageId + " #question_list").html(appUtils.getPageParam("quesStr")).find("li").hide();
        var columnVal = appUtils.getPageParam("columnVal");
        liDoms.filter("[column_val='" + columnVal + "']").remove();
        liDoms =  $(_pageId + " #question_list li");
    }

    function bindPageEvent() {
        // 返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
        });

        // 各个问题的预绑定事件
        appUtils.preBindEvent($(_pageId + " #question_list"), "li", function () {
            appUtils.pageInit("me/search", "me/showAnswer", {"quesId": $(this).attr("ques_id")});
        });

        // 取消搜索
        appUtils.bindEvent($(_pageId + " #cancel"), function () {
            appUtils.pageBack();
        });

        // 清空搜索内容
        appUtils.bindEvent($(_pageId + " #close_btn"), function () {
            $(this).hide().prev().val("");
            $(_pageId + " #question_list li").hide();
        });

        // 在搜索框里输入事件
        appUtils.bindEvent($(_pageId + " #search_input"), function () {
            $(_pageId + " #question_list li").hide();
            var searchVal = $.trim($(this).val());
            if (searchVal.length > 0) {
                liDoms.each(function () {
                    var quesName = $(this).find("a").text();
                    if (quesName.indexOf(searchVal) > -1) {
                        $(this).show();
                    }
                });
                $(_pageId + " #close_btn").show();
            } else {
                $(_pageId + " #close_btn").hide();
            }
        }, "input");

        // 提问事件
        appUtils.bindEvent($(_pageId + " #ques_btn"), function () {
            external.callMessage({
                "funcNo": "50101",
                "moduleName": "feedback"
            });
        });
    }

    /* 销毁 */
    function destroy() {
        mobileService.destroy();
    }

    var search = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = search;
});