define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var external = require("external");
    var mobileService = require("mobileService");
    var _pageId = "#me_showAnswer";

    function init() {
        var quesId = appUtils.getPageParam("quesId");
        if (quesId) {
            var param = {
                "ques_id": appUtils.getPageParam("quesId")
            };
            mobileService.queryContentOfQuestion(param, function (data) {
                var results = data.results;
                if (data.error_no == "0" && results.length > 0) {
                    showAnswerToHtml(results[0]);
                } else {
                    layerUtils.iLoading(false);
                    layerUtils.iAlert(data.error_info);
                }
            });
        }
    }

    function showAnswerToHtml(ansResult) {
        $(_pageId + " #ques_name").html(ansResult.question_name);
        $(_pageId + " #ques_content").html(ansResult.content);
    }

    function bindPageEvent() {
        // 返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
        });

        // 联系客服
        appUtils.bindEvent($(_pageId + " #contact_cs"), function () {
            var csTelephone = appUtils.getSStorageInfo("csTelephone");  // 客服电话
            if (csTelephone) {
                var callType = "";
                if (gconfig.platform == 1) { //android
                    callType = "0";
                } else if (gconfig.platform == 2) { //ios
                    callType = "1";
                }
                external.callMessage({
                    "funcNo": "50220",
                    "telNo": csTelephone,
                    "callType": callType
                });
            } else {
                layerUtils.iAlert("客户电话不存在！");
            }
        });
    }

    /* 销毁 */
    function destroy() {
        mobileService.destroy();
    }

    var showAnswer = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = showAnswer;
});