﻿define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        layerUtils = require("layerUtils"),
        gconfig = require("gconfig"),
        global = gconfig.global,
        mobileService = require("mobileService"),
        external = require("external"),
        _pageId = "#me_showBankCard";

    var cardType = "";   //stock 证券银行卡  marginTrading 两融银行卡

    function init() {

        cardType = appUtils.getSStorageInfo("cardType");
        //$(_pageId + " .title").html(cardType === "stock" ? "证券银行卡" : "两融银行卡");  //修改标题
        if (cardType === "stock") {
            queryBanks("fund_account");  //查询证券银行卡信息
            $(_pageId + " .add_cardbtn").show();
            $(_pageId + " .card_tips").show();
            $(_pageId + " .title").html("证券银行卡");
        }
        else if (cardType === "marginTrading") {
            queryBanks("xy_fund_account");  //查询两融银行卡信息
            $(_pageId + " .add_cardbtn").hide();
            $(_pageId + " .card_tips").hide();
            $(_pageId + " .title").html("两融银行卡");
        }

    }

    /* 查询银行卡信息 */
    function queryBanks(str) {
        var param = {
            "fund_account": appUtils.getSStorageInfo(str),
            "client_id": appUtils.getSStorageInfo("client_id")
        };
        mobileService.bankManages(param, function (data) {
            var error_no = data.error_no,
                error_info = data.error_info;
            if (error_no == "0") {
                showCardInfo(data.results);   //显示银行卡信息
            }
            else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(error_info);
            }
        });
    }

    /* 显示银行卡信息 */
    function showCardInfo(results) {
        //根据不同银行显示不同图标   bankbg:保存银行卡背景路径   bankpng:保存银行卡图标路径
        var bankParam = {
            //证券银行
            "1001": {
                "bank_name": "工商银行",
                "bankbg": "'images/bankbg/gsyh.png'",
                "bankpng": "'images/bank/bk02.png'"
            },
            "1002": {
                "bank_name": "中国银行",
                "bankbg": "'images/bankbg/zgyh.png'",
                "bankpng": "'images/bank/bk01.png'"
            },
            "1003": {
                "bank_name": "建设银行",
                "bankbg": "'images/bankbg/jsyh.png'",
                "bankpng": "'images/bank/bk04.png'"
            },
            "1004": {
                "bank_name": "农业银行",
                "bankbg": "'images/bankbg/nyyh.png'",
                "bankpng": "'images/bank/bk03.png'"
            },
            "1005": {
                "bank_name": "交通银行",
                "bankbg": "'images/bankbg/jtyh.png'",
                "bankpng": "'images/bank/bk06.png'"
            },
            "1011": {
                "bank_name": "兴业银行",
                "bankbg": "'images/bankbg/xyyh.png'",
                "bankpng": "'images/bank/bk10.png'"
            },
            "1012": {
                "bank_name": "光大银行",
                "bankbg": "'images/bankbg/gdyh.png'",
                "bankpng": "'images/bank/bk07.png'"
            },
            "1013": {
                "bank_name": "招商银行",
                "bankbg": "'images/bankbg/zsyh.png'",
                "bankpng": "'images/bank/bk05.png'"
            },
            "1014": {
                "bank_name": "浦发银行",
                "bankbg": "'images/bankbg/pfyh.png'",
                "bankpng": "'images/bank/bk13.png'"
            },
            "1015": {
                "bank_name": "中信银行",
                "bankbg": "'images/bankbg/zxyh.png'",
                "bankpng": "'images/bank/bk15.png'"
            },
            "1016": {
                "bank_name": "民生银行",
                "bankbg": "'images/bankbg/msyh.png'",
                "bankpng": "'images/bank/bk16.png'"
            },
            "1017": {
                "bank_name": "平安银行",
                "bankbg": "'images/bankbg/payh.png'",
                "bankpng": "'images/bank/bk08.png'"
            },
            "1018": {
                "bank_name": "邮储银行",
                "bankbg": "'images/bankbg/ycyh.png'",
                "bankpng": "'images/bank/bk18.png'"
            },
            "1019": {
                "bank_name": "徽商银行",
                "bankbg": "'images/bankbg/hsyh.png'",
                "bankpng": "'images/bank/bk22.png'"
            },

            //两融银行
            "8001": {
                "bank_name": "工商银行",
                "bankbg": "'images/bankbg/gsyh.png'",
                "bankpng": "'images/bank/bk02.png'"
            },
            "8002": {
                "bank_name": "中国银行",
                "bankbg": "'images/bankbg/zgyh.png'",
                "bankpng": "'images/bank/bk01.png'"
            },
            "8003": {
                "bank_name": "建设银行",
                "bankbg": "'images/bankbg/jsyh.png'",
                "bankpng": "'images/bank/bk04.png'"
            },
            "8004": {
                "bank_name": "农业银行",
                "bankbg": "'images/bankbg/nyyh.png'",
                "bankpng": "'images/bank/bk03.png'"
            },
            "8005": {"bank_name": "交通银行", "bankbg": "'images/bankbg/jtyh.png'", "bankpng": "'images/bank/bk06.png'"}
        }
        if (results.length > 0) {
            var htmls = "";
            for (var i = 0, len = results.length; i < len; i++) {
                var bankNo = results[i].bank_no,
                    bankbg = "",       // 背景图
                    bankpng = "",      // 银行图标
                    bank_name = "";    // 银行名称

                if (bankParam[bankNo]) {   //上述列表中存在该银行
                    bankbg = bankParam[bankNo].bankbg;
                    bankpng = bankParam[bankNo].bankpng;
                    bank_name = bankParam[bankNo].bank_name;
                }
                else {                      //上述列表中不存在该银行
                    bankbg = bankpng = "";
                    bank_name = results[i].bank_name
                }

                htmls += "<li><div class='card_bg'><img src=" + bankbg + "></div>" +
                    "<div class='card_cont'><dl class='card_info'><dt><img src=" + bankpng + "></dt><dd><h5>" + bank_name + "</h5><p></p></dd></dl>" +
                    "<div class='card_number'></div></div></li>";
            }
            $(_pageId + " ul.sele_card").html(htmls);
        }
        else {   // 未开通三方存管银行
            $(_pageId + " .add_cardbtn a").text("您还未开通三方存管银行");
            $(_pageId + " .card_tips p").text("温馨提示：开通三方存管银行卡需要去银行办理");
        }

    }


    function bindPageEvent() {
        //返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
//            appUtils.pageInit("me/showBankCard", "me/bankManages", {});
        });

        //三方存管事件
        appUtils.bindEvent($(_pageId + " .add_cardbtn"), function () {
            external.callMessage({
                "funcNo": "50101",
                "moduleName": "com.cairh.app.sjkh.gc"
            });
        })
    }

    //销毁
    function destroy() {
        $(_pageId + " ul.sele_card").html("");   //清空银行卡列表
        mobileService.destroy();
    }

    //将银行卡号格式化为**** **** **** 1111
    function set_bank_no(bank_account) {
        var star = "";
        for (var i = 0; i < bank_account.length - 4; i++) {
            star += "*";
            if ((i + 1) % 4 == 0) {
                star += " ";
            }
        }
        bank_account = star + " " + bank_account.substring(bank_account.length - 4, bank_account.length);

        return bank_account;
    }

    var showBankCard = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = showBankCard;
});
