﻿define(function (require, exports, module) {
    var layerUtils = require('layerUtils'),
        appUtils = require("appUtils"),
        validatorUtil = require('validatorUtil');
    var validata = require("validatorUtil");
    var layerUtils = require("layerUtils");
    var mobileService = require("mobileService");

    var _pageId = "#me_updateLodingPwd";
    var gconfig = require("gconfig");
    var global = gconfig.global;
    var external = require("external");

    // 初始化
    function init() {
        $(_pageId + " #oldpwd").val("");
        $(_pageId + " #newpwd").val("");
        $(_pageId + " #checkpwd").val("");
    }

    // 绑定事件
    function bindPageEvent() {
        // 返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
            // appUtils.pageInit("me/updateLodingPwd", "me/accountSecurity");
        });
        // 修改密码
        appUtils.bindEvent($(_pageId + " #ce_btn"), function () {
            if (checkParam()) {
                Alterpwd();    // 修改资金密码密码
            }
        });
    }

    /* 登录前校验密码 */
    function checkParam() {
        var oldPassword = $(_pageId + " #oldpwd").val();
        var newPwd = $(_pageId + " #newpwd").val();
        var checkPwd = $(_pageId + " #checkpwd").val();
        //校验旧密码
        if (validatorUtil.isEmpty(oldPassword)) {
            layerUtils.iAlert("旧密码不能为空");
            return false;
        }
        else if(oldPassword.length != 6){
            layerUtils.iAlert("旧密码必须为6位数");
            return false;
        }
        else if(!validatorUtil.isNumeric(oldPassword)){
            layerUtils.iAlert("旧密码必须为6位数字");
            return false;
        }

        //校验新密码
        if (validatorUtil.isEmpty(newPwd)) {
            layerUtils.iAlert("新密码不能为空");
            return false;
        }
        else if(newPwd.length != 6){
            layerUtils.iAlert("新密码必须为6位数");
            return false;
        }
        else if(!validatorUtil.isNumeric(newPwd)){
            layerUtils.iAlert("新密码必须为6位数字");
            return false;
        }

        //校验重复密码
        if (validatorUtil.isEmpty(checkPwd)) {
            layerUtils.iAlert("重复密码不能为空");
            return false;
        }
        else if(checkPwd.length != 6){
            layerUtils.iAlert("重复密码必须为6位数");
            return false;
        }
        else if(!validatorUtil.isNumeric(checkPwd)){
            layerUtils.iAlert("重复密码必须为6位数字");
            return false;
        }

        if (newPwd != checkPwd) {
            layerUtils.iAlert("两次输入密码不一致！");
            return false;
        }

        return true;
    }

    /* 销毁页面，单页面时候要用 */
    function destroy() {
        $(_pageId + " #oldpwd").val("");
        $(_pageId + " #newpwd").val("");
        $(_pageId + " #checkpwd").val("");
    }

    /* 修改资金密码密码 */
    function Alterpwd() {
        var oldPassword = $(_pageId + " #oldpwd").val();
        var zj_password = $(_pageId + " #newpwd").val();
        var param = {
            "fund_account": appUtils.getSStorageInfo("fund_account"),
            "client_id": appUtils.getSStorageInfo("client_id"),
            "passwords": zj_password,
            "password_old": oldPassword
        }
        mobileService.updateLodingPwd(param, function (data) {
            var errorNo = data.error_no;
            var errorInfo = data.error_info;
            if (errorNo == 0) {
                layerUtils.iAlert("您的密码修改成功！", "0", function () {
                    // appUtils.clearSStorage();
                    // require("sso").ssoLoginOut();    //退出登录
                   appUtils.pageInit("me/updateLodingPwd", "me/myIndexNo");
                });
            }
            else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(errorInfo);
            }
        })
    }

    var updateLodingPwd = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    // --暴露对外的接口
    module.exports = updateLodingPwd;
});