﻿define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var mobileService = require("mobileService");
    var _pageId = "#twoFinancial_detailsOfDebt";

    function init() {
        var password = appUtils.getSStorageInfo("password");
        var param = {
            "client_id": appUtils.getSStorageInfo("client_id"),
            "password": password ? password : ""
        }
        mobileService.queryDetailsOfDebt(param, function (data) {
            var error_no = data.error_no;
            var error_info = data.error_info;
            if (error_no == "0") {
                showInfoToHtml(data.results);
            }
            else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(error_info);
            }
        });
    }

    function showInfoToHtml(results) {
        var htmlStr = "<tr><th width='25%'>证券</th> <th width='25%'>负债/类型</th> <th width='25%'>利息</th> <th width='25%'>参考盈亏</th></tr>";
        for (var i = 0, len = results.length; i < len; i++) {
            var debit_type = results[i].debit_type == "0" ? "融资负债" : "融劵负债";
            var profit = new Number(results[i].finance_compact_profit);
            htmlStr += "<tr><td><h5>" + results[i].stock_name + "</h5><p>" + results[i].stock_code + "</p></td>"
                + "<td><p>" + results[i].real_compact_fare + "</p><p>" + debit_type + "</p></td>"
                + "<td><p>" + results[i].real_compact_interest + "</p></td>"
                + "<td class='" + (profit > 0 ? "profit" : "loss") + "'><p>" + results[i].finance_compact_profit + "</p></td></tr>";
        }
        $(_pageId + " .position_table").html(htmlStr);
    }

    function bindPageEvent() {
        //返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
            // appUtils.pageInit("twoFinancial/detailsOfDebt", "twoFinancial/twoFinancial", {});
        });
    }

    //销毁
    function destroy() {
        mobileService.destroy();
    }

    /*格式化金额*/
    function formatMoney(s, n) {
        if (s == "") return "0.00";

        n = n > 0 && n <= 20 ? n : 2;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        t = "";
        for (i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return t.split("").reverse().join("") + "." + r;
    }

    /*格式  %   */
    function formatscale(s, n) {
        n = n > 0 && n <= 20 ? n : 2;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, ""));
        s = (s * 100).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        t = "";
        for (i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return t.split("").reverse().join("") + "." + r + "%";
    }

    var detailsOfDebt = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = detailsOfDebt;
});
