﻿define(function (require, exports, module) {
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig");
    var external = require("external");
    var validatorUtil = require("validatorUtil");
    var mobileService = require("mobileService");
    var _pageId = "#twoFinancial_showCollateralRatio";

    function init() {
        var total_debit = new Number(appUtils.getSStorageInfo("tf_total_debit"));
        var ratio = new Number(appUtils.getSStorageInfo("tf_ratio"));
        var total_assets = new Number(appUtils.getSStorageInfo("total_assets"));
        var fetch_balance = new Number(appUtils.getSStorageInfo("fetch_balance"));
        $(_pageId + " .num em").text(ratio.toFixed(4));
        ratio=ratio / 100;

        //设置图片的指针位置
        var degVal = (ratio * 100 - 200) <= 125 ? "rotate(" + (ratio * 100 - 200) + "deg)" : "rotate(125deg)";
        var cssParam = {
            "-webkit-transform": degVal,
            "-moz-transform": degVal,
            "transform": degVal
        };
        $(_pageId + " .pointer").css(cssParam);
        if (ratio < 1.30) {

            $(_pageId + " #info").html("您需要在15:30前转入价值不少于<span>" + formatMoney((1.30 - ratio) * total_debit) + "</span>的担保品，否则将有强行平仓危险");
        }
        else if (ratio < 1.50) {
            $(_pageId + " #info").html("您当前担保品比例处于警戒线以下，至少需转入<span>" + formatMoney((1.50 - ratio) * total_debit) + "</span>保证金才能正常开仓");
        }
        else if (ratio <= 3.00) {
            $(_pageId + " #info").html("您的杠杆平衡调节的很好！");
        }
        else {
            $(_pageId + " #info").html("你当前有<span>" + formatMoney(fetch_balance) + "</span>担保品可以取出");
            $(_pageId + " #transferOut").show();
        }

    }

    function bindPageEvent() {
        // 返回
        appUtils.bindEvent($(_pageId + " .icon_back"), function () {
            appUtils.pageBack();
            // appUtils.pageInit("twoFinancial/showCollateralRatio", "twoFinancial/twoFinancial", {});
        });

        // 担保品转入事件
        appUtils.bindEvent($(_pageId + " #transferIn"), function () {
            var toPage = "";
            if (gconfig.platform == "2") {
                toPage = {
                    "prefix": "www/m/trade",
                    "suffix": "credit/transferred/collateralTransferIn",
                    "ModuleName": "me"
                };
            } else {
                toPage = gconfig.seaBaseUrl + "trade/index.html#!/credit/transferred/collateralTransferIn.html?ModuleName=me";
            }
            var param = {"funcNo": "50101", "moduleName": "trade", "params": {"ModuleName": "ygt", "toPage": toPage}};
            external.callMessage(param);
        })

        // 担保品转出事件
        appUtils.bindEvent($(_pageId + " #transferOut"), function () {
            var toPage = "";
            if (gconfig.platform == "2") {
                toPage = {
                    "prefix": "www/m/trade",
                    "suffix": "credit/transferred/collateralTransferOut",
                    "ModuleName": "me"
                };
            } else {
                toPage = gconfig.seaBaseUrl + "trade/index.html#!/credit/transferred/collateralTransferOut.html?ModuleName=me";
            }
            var param = {"funcNo": "50101", "moduleName": "trade", "params": {"ModuleName": "ygt", "toPage": toPage}};
            external.callMessage(param);
        })
    }

    //销毁
    function destroy() {
        mobileService.destroy();
    }

    function formatMoney(s, n) {
        if (s == "") return "0.00";

        n = n > 0 && n <= 20 ? n : 2;
        s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
        var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
        t = "";
        for (i = 0; i < l.length; i++) {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        return "￥" + t.split("").reverse().join("") + "." + r;
    }

    var showCollateralRatio = {
        "init": init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = showCollateralRatio;
});
